SystemOrganization addCategory: #DynamicOwnership!
SystemOrganization addCategory: #'DynamicOwnership-FirstModel'!
SystemOrganization addCategory: #'DynamicOwnership-FirstModel-Test'!
SystemOrganization addCategory: #'DynamicOwnership-SecondModel'!
SystemOrganization addCategory: #'DynamicOwnership-SecondModel-Test'!
SystemOrganization addCategory: #'DynamicOwnership-ThirdModel'!
SystemOrganization addCategory: #'DynamicOwnership-ThirdModel-Test'!
SystemOrganization addCategory: #'DynamicOwnership-Examples-SnakesAndLadders'!
SystemOrganization addCategory: #'DynamicOwnership-Kernel'!
SystemOrganization addCategory: #'DynamicOwnership-Kernel-Test'!
SystemOrganization addCategory: #'DynamicOwnership-TestStuff'!
SystemOrganization addCategory: #'DynamicOwnership-Util'!
SystemOrganization addCategory: #'DynamicOwnership-Traits'!
SystemOrganization addCategory: #'DynamicOwnership-ThirdModel-UseCases'!
SystemOrganization addCategory: #'DynamicOwnership-Web'!

Trait named: #TDeepOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TDeepOwernship methodsFor: 'violation' stamp: 'ewe 4/26/2012 11:31'!
canCrossBoundary: anObject
	<meta> 
	^ false! !

!TDeepOwernship methodsFor: 'violation' stamp: 'ewe 5/1/2012 10:12'!
doCrossBoundary: anObject
	<meta> 
	Error signal: 'No object should pass through'. ! !

!TDeepOwernship methodsFor: 'violation' stamp: 'ewe 5/2/2012 15:33'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!TDeepOwernship methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#none}! !

!TDeepOwernship methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:16'!
outFilters
	^ {#all}
	! !

Trait named: #TDefensiveCopyOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:34'!
canCrossBoundary: anObject
	<meta> 
	^ false.! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:34'!
doCrossBoundary: anObject
	<meta> 
	Error signal: 'No object should pass through'. ! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:36'!
doNotCrossBoundary: anObject
	<meta> 
	( self selectedCopyClass includes: anObject class ) ifTrue: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') copied by ', self printString ) ; cr.
			^ anObject copy.
	]	ifFalse: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
			OwnershipViolation signal: 'Boundary crossed'    
	]
! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:32'!
inFilters
	^ {#none}! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:33'!
outFilters
	^ {#all}
	! !

!TDefensiveCopyOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:35'!
selectedCopyClass 
	^ #()! !

Trait named: #TExceptionAssertion
	uses: {}
	category: 'DynamicOwnership-ThirdModel-Test'!

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: DeepOwnershipViolation ! !

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: DeepOwnershipViolation ! !

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertMessageFilter: aBlock
 	 self should: aBlock  raise: MessageFiltered 
! !

!TExceptionAssertion methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:00'!
assertMessagePass: aBlock
  	 self shouldnt: aBlock  raise: MessageFiltered ! !

Trait named: #TNoOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:11'!
canCrossBoundary: anObject
	<meta> 
	^ true.! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:10'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:12'!
doNotCrossBoundary: anObject
	<meta> 
	Error signal: 'All objects should pass through'. ! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:22'!
inFilters
	^ {#all}! !

!TNoOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:16'!
outFilters
	^ {#all}
	! !

Trait named: #TOwnershipCheck
	uses: {}
	category: 'DynamicOwnership-ThirdModel'!

!TOwnershipCheck methodsFor: 'enforcement' stamp: 'ewe 5/10/2012 11:58'!
checkValidSend3: sender message: selector block: block arguments: arguments
	
	| returnValue argumentsWithSelf |			
	Transcript show: self class printString ; show: ' ' ; show: selector ; cr.
	
	self handleFilters: sender selector: selector.
	self handleViolation: sender arguments: arguments. 
	
	"evaluate the block"
	argumentsWithSelf := OrderedCollection new.
	argumentsWithSelf addAll: arguments. 
	argumentsWithSelf addFirst: self. 
	"TODO temporary hack"
	returnValue := self perform: selector withArguments: arguments. 
	"returnValue:= block valueWithArguments: argumentsWithSelf ."
	
	^ self handleViolation: sender returnValue: returnValue. 
	! !

!TOwnershipCheck methodsFor: 'enforcement' stamp: 'ewe 5/10/2012 11:58'!
computePathFrom: sender to: returnValue
	| senderOwners valueOwners |
	senderOwners:= sender ownersAsList .
	valueOwners := returnValue ownersAsList .
	[valueOwners notEmpty and: [ senderOwners notEmpty and: [valueOwners first == senderOwners first]]] whileTrue: 	[
		valueOwners removeFirst.
		senderOwners removeFirst.
	].
	(valueOwners notEmpty and: [ sender = valueOwners first ]) ifTrue: [ valueOwners removeFirst. ].  
	^valueOwners. 
	! !

!TOwnershipCheck methodsFor: 'enforcement' stamp: 'ewe 5/10/2012 11:58'!
handleFilters: sender selector: selector 

	| receiverOwners senderOwners filters interfaces pragmas |
	
	"find path in ownership tree"
	receiverOwners:= self ownersAsList .
	senderOwners := sender ownersAsList .

	"find the lowest-in-the-tree element that is in both lists"
	[receiverOwners notEmpty and: [ senderOwners notEmpty and: [receiverOwners first == senderOwners first]]] whileTrue: 	[
		receiverOwners removeFirst.
		senderOwners removeFirst.
	].
	
	"Customer can ask anything to its bank" 
 	(senderOwners notEmpty and: [ senderOwners first = self ])
		ifTrue: [ senderOwners removeFirst  ].
		
	"Bank can ask anything to its customer"
	(receiverOwners notEmpty and: [ receiverOwners first = sender ])
		 ifTrue: [ receiverOwners removeFirst ].
	
	"check filters"
	pragmas := (self class lookupSelector: selector) pragmas.
	interfaces := pragmas collect: [ :pragma | pragma keyword ].

	"note: method #matches: handle the special #all filter"
	senderOwners do: [ :out | ( out outFilters matches: interfaces ) ifFalse: [ ^MessageFiltered signal: selector ] ].
	receiverOwners do: [ :in | ( in inFilters matches: interfaces ) ifFalse: [ ^MessageFiltered signal: selector ]  ].
	! !

!TOwnershipCheck methodsFor: 'enforcement' stamp: 'ewe 5/11/2012 11:04'!
handleViolation: sender arguments: arguments 
	
	| rp sp violationOwners |
	
	arguments do: [ :argument | 
		"Let   a//b denotes the out boudnaries between a and b.
		s=sender, r=receiver, v=return value, p=argument 
		We need to trigger boundary violations for r//p - s//p. "
	
		rp := self computePathFrom: self to: argument. "compute r//p"
		sp := self computePathFrom: sender to: argument. "compute s//p"
		violationOwners := rp copy removeAllIfPresent: sp.  "compute r//p - s//p"
	
		"TODO: boundaryCrosse could replace the argument, make sure order is preserved" 
		violationOwners do: [ :boundary |
			( boundary canCrossBoundary: argument ) ifTrue: [
				boundary doCrossBoundary: argument. 
			] ifFalse: [
			
				Transcript show: ( 'r//p ', rp printString ) ; cr.
				Transcript show: ( 's//p ', sp printString ) ; cr. 
				Transcript show: ( 'r//p - s//p ', violationOwners printString ) ; cr.
					
				Transcript show: ( 'sender: ', sender printString  ); cr.
				Transcript show: ( 'receiver: ', self printString) ; cr. 
				Transcript show: ( 'parameter: ', argument printString  ); cr.
			
				 boundary doNotCrossBoundary: argument.
			]
		]
	]! !

!TOwnershipCheck methodsFor: 'enforcement' stamp: 'ewe 5/11/2012 11:04'!
handleViolation: sender returnValue: returnValue 
	
	| sv rv violationOwners |
	
	"Let   a//b denotes the out boudnaries between a and b.
	s=sender, r=receiver, v=return value, p=argument 
	We need to trigger boundary violations for s//v - r//v. "
	
	sv := self computePathFrom: sender to: returnValue. "compute s//v"
	rv := self computePathFrom: self to: returnValue. "compute r//v"
	violationOwners := sv copy removeAllIfPresent: rv.  "compute s//v - r//v"
	
	violationOwners do: [ :boundary |
		( boundary canCrossBoundary: returnValue ) ifTrue: [
			boundary doCrossBoundary: returnValue. 
		] ifFalse: [
		
			Transcript show: ( 's//v ', sv printString ) ; cr.
			Transcript show: ( 'r//v ', rv printString ) ; cr.
			Transcript show: ( 's//v - r//v ', violationOwners printString ) ; cr.
			
			Transcript show: ( 'sender: ', sender printString  ); cr.
			Transcript show: ( 'receiver: ', self printString) ; cr. 
			Transcript show: ( 'value: ', returnValue printString  ); cr.
		
			"TODO should be recursive if mutlipe non crossable barriers are crossed"
			^ boundary doNotCrossBoundary: returnValue.
		]
	].
	^ returnValue. ! !

!TOwnershipCheck methodsFor: '*dynamicownership' stamp: 'pmaer 5/22/2012 14:02'!
thisSender
	"TODO ugly and depends on the rewriting with synthetic closures etc"
	( thisContext sender sender method selector = 
		#checkValidSend3:message:selector:block:arguments: ) ifTrue: [
			^ thisContext sender sender sender receiver.
		] ifFalse: [
			^ thisContext sender sender receiver.
		]
	

	! !

Trait named: #TSelectiveOwernship
	uses: {}
	category: 'DynamicOwnership-Traits'!

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:53'!
canCrossBoundary: anObject
	<meta> 
	^ self selectedClasses includes: anObject class. ! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:45'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:32'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#none}! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ {#all}
	! !

!TSelectiveOwernship methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:54'!
selectedClasses 
	^ #()! !

Trait named: #TWebUtils
	uses: {}
	category: 'DynamicOwnership-Web'!

!TWebUtils methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 11:18'!
decodeMultipartForm: aStream boundary: boundary do: aBlock
	"Parse the contents of a multipart/form-data submission.

	Evaluate aBlock with three parts: The headers, the (parsed) form-data
	arguments and the (undecoded) contents of the part. The sender is
	expected to take care of other issues such as content-transfer-encoding
	and similar headers."

	| skip headers content disposition index params |
	aStream upToAll: '--', boundary.
	[aStream atEnd or:[(skip := aStream next: 2) = '--']] whileFalse:[
		skip = String crlf ifFalse:[self error: 'Error decoding multipart/form-data fields'].
		headers := Dictionary new.
		(self readHeadersFrom: aStream) do:[:hdr| headers add: hdr].
		content := aStream upToAll: String crlf, '--', boundary.
		params := Dictionary new.
		disposition := headers at: 'content-disposition' ifAbsent:[''].
		#(name filename) do:[:arg| | len val |
			len := arg size + 2.
			index := disposition findString: arg,'='.
			index > 0 ifTrue:[
				val := disposition copyFrom: index + len to: (disposition indexOf: $" startingAt: index+len) - 1.
				params at: arg put: val.
			].
		].
		aBlock value: headers value: params value: content.
	].! !

!TWebUtils methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 11:13'!
readHeadersFrom: aStream
	"Parse http headers and answer a collection of key -> value pairs."

	| headers nextLine existing |
	headers := OrderedCollection new.
	[nextLine := aStream upToAll: String crlf.
	nextLine isEmpty] whileFalse:[
		nextLine first isSeparator ifTrue:["Continuation as per HTTP 1.1 spec"
			existing := headers last.
			existing value: (existing value, String space, nextLine withBlanksTrimmed).
		] ifFalse:["Regular header"
			headers add: 
				(nextLine copyUpTo: $:) asLowercase ->
					(nextLine copyAfter: $:) withBlanksTrimmed.
		].
	].
	^headers! !

RBBlockNode subclass: #RBOwnershipBlockNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!RBOwnershipBlockNode methodsFor: 'as yet unclassified' stamp: 'pmaer 11/28/2011 18:58'!
isOwnershipBlockNode 
	^ true! !

Error subclass: #CrossingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

CrossingError subclass: #OwnershipViolation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Traits'!

Error subclass: #MessageFiltered
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!MessageFiltered class methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:32'!
signal: selector
	super signal: ( 'Message ', selector,' was filtered out').! !

Error subclass: #TransferError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!RBMethodNode methodsFor: '*dynamicownership' stamp: 'ewe 4/25/2012 13:15'!
isOwernshipMeta
	^ ( self pragmas collect: [ :pragma | pragma selector ] ) includes: #meta! !

!RBMessageNode methodsFor: '*dynamicownership' stamp: 'ewe 4/25/2012 12:12'!
needsOwnershipRewrite
	"We do not rewrite the check itself, not the synthetic block passed as argument
	  receiver     check: [ :receiver :arg |  receiver originalSelector: arg ] 
				sender: self 
				arguments: { rewrittenArguments }"
	^ ((self selector = #checkValidSend3:message:block:arguments: ) or: [(self parent parent isOwnershipBlockNode)] ) not! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'ewe 5/11/2012 13:26'!
checkValidSend3: sender message: selector block: block arguments: arguments
	
	| returnValue argumentsWithSelf |			
	"Transcript show: self class printString ; show: ' ' ; show: selector ; cr."
	
	"TODO need to behave differentyl whether effectiveSelf is an object or an owned object.
	Also, it's  kind of a hack to use #value, which is defined in Object "
		
	( self effectiveSelf isKindOf: OwnedObject3 ) ifTrue: [
		self effectiveSelf handleFilters: sender selector: #value.
		self effectiveSelf handleViolation: sender arguments: arguments. 
	].
	
	"evaluate the block"
	argumentsWithSelf := OrderedCollection new.
	argumentsWithSelf addAll: arguments. 
	argumentsWithSelf addFirst: self. 
	"TODO temporary hack"
	returnValue := self perform: selector withArguments: arguments. 
	"returnValue:= block valueWithArguments: argumentsWithSelf ."
	
	( self effectiveSelf isKindOf: OwnedObject3 ) ifTrue: [
		^ self effectiveSelf handleViolation: sender returnValue: returnValue. 
	] ifFalse: [
		^ returnValue. 
	]

	
	! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'ewe 5/11/2012 13:28'!
computePathFrom: sender to: returnValue
	| senderOwners valueOwners |
	senderOwners:= sender ownersAsList .
	valueOwners := returnValue ownersAsList .
	[valueOwners notEmpty and: [ senderOwners notEmpty and: [valueOwners first == senderOwners first]]] whileTrue: 	[
		valueOwners removeFirst.
		senderOwners removeFirst.
	].
	(valueOwners notEmpty and: [ sender = valueOwners first ]) ifTrue: [ valueOwners removeFirst. ].  
	^valueOwners. 
	! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'ewe 5/10/2012 15:21'!
effectiveSelf
	^ outerContext receiver. ! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'ewe 5/11/2012 13:28'!
handleFilters: sender selector: selector 

	| receiverOwners senderOwners filters interfaces pragmas |
	
	"find path in ownership tree"
	receiverOwners:= self ownersAsList .
	senderOwners := sender ownersAsList .

	"find the lowest-in-the-tree element that is in both lists"
	[receiverOwners notEmpty and: [ senderOwners notEmpty and: [receiverOwners first == senderOwners first]]] whileTrue: 	[
		receiverOwners removeFirst.
		senderOwners removeFirst.
	].
	
	"Customer can ask anything to its bank" 
 	(senderOwners notEmpty and: [ senderOwners first = self ])
		ifTrue: [ senderOwners removeFirst  ].
		
	"Bank can ask anything to its customer"
	(receiverOwners notEmpty and: [ receiverOwners first = sender ])
		 ifTrue: [ receiverOwners removeFirst ].
	
	"check filters"
	pragmas := (self class lookupSelector: selector) pragmas.
	interfaces := pragmas collect: [ :pragma | pragma keyword ].

	"note: method #matches: handle the special #all filter"
	senderOwners do: [ :out | ( out outFilters matches: interfaces ) ifFalse: [ ^MessageFiltered signal: selector ] ].
	receiverOwners do: [ :in | ( in inFilters matches: interfaces ) ifFalse: [ ^MessageFiltered signal: selector ]  ].
	! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'ewe 5/11/2012 13:28'!
handleViolation: sender arguments: arguments 
	
	| rp sp violationOwners |
	
	arguments do: [ :argument | 
		"Let   a//b denotes the out boudnaries between a and b.
		s=sender, r=receiver, v=return value, p=argument 
		We need to trigger boundary violations for r//p - s//p. "
	
		rp := self computePathFrom: self to: argument. "compute r//p"
		sp := self computePathFrom: sender to: argument. "compute s//p"
		violationOwners := rp copy removeAllIfPresent: sp.  "compute r//p - s//p"
	
		"TODO: boundaryCrosse could replace the argument, make sure order is preserved" 
		violationOwners do: [ :boundary |
			( boundary canCrossBoundary: argument ) ifTrue: [
				boundary doCrossBoundary: argument. 
			] ifFalse: [
			
				Transcript show: ( 'r//p ', rp printString ) ; cr.
				Transcript show: ( 's//p ', sp printString ) ; cr. 
				Transcript show: ( 'r//p - s//p ', violationOwners printString ) ; cr.
					
				Transcript show: ( 'sender: ', sender printString  ); cr.
				Transcript show: ( 'receiver: ', self printString) ; cr. 
				Transcript show: ( 'parameter: ', argument printString  ); cr.
			
				 boundary doNotCrossBoundary: argument.
			]
		]
	]! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'ewe 5/11/2012 13:28'!
handleViolation: sender returnValue: returnValue 
	
	| sv rv violationOwners |
	
	"Let   a//b denotes the out boudnaries between a and b.
	s=sender, r=receiver, v=return value, p=argument 
	We need to trigger boundary violations for s//v - r//v. "
	
	sv := self computePathFrom: sender to: returnValue. "compute s//v"
	rv := self computePathFrom: self to: returnValue. "compute r//v"
	violationOwners := sv copy removeAllIfPresent: rv.  "compute s//v - r//v"
	
	violationOwners do: [ :boundary |
		( boundary canCrossBoundary: returnValue ) ifTrue: [
			boundary doCrossBoundary: returnValue. 
		] ifFalse: [
		
			Transcript show: ( 's//v ', sv printString ) ; cr.
			Transcript show: ( 'r//v ', rv printString ) ; cr.
			Transcript show: ( 's//v - r//v ', violationOwners printString ) ; cr.
			
			Transcript show: ( 'sender: ', sender printString  ); cr.
			Transcript show: ( 'receiver: ', self printString) ; cr. 
			Transcript show: ( 'value: ', returnValue printString  ); cr.
		
			"TODO should be recursive if mutlipe non crossable barriers are crossed"
			^ boundary doNotCrossBoundary: returnValue.
		]
	].
	^ returnValue. ! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'ewe 5/10/2012 15:21'!
owner
	^ self effectiveSelf owner. ! !

!BlockClosure methodsFor: '*dynamicownership' stamp: 'pmaer 5/22/2012 14:02'!
thisSender
	"TODO ugly and depends on the rewriting with synthetic closures etc"
	( thisContext sender sender method selector = 
		#checkValidSend3:message:selector:block:arguments: ) ifTrue: [
			^ thisContext sender sender sender receiver.
		] ifFalse: [
			^ thisContext sender sender receiver.
		]
	

	! !

RBCompiler subclass: #DOTestsCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!DOTestsCompiler methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:01'!
translate: aProgramNode
DOTestsCompilerMessageVisitor new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.! !

RBCompiler subclass: #DebugCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!DebugCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2011 11:41'!
translate: aProgramNode
DebugCompilerVisitor new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!OwnershipCompiler methodsFor: 'as yet unclassified' stamp: 'ewe 11/15/2011 11:35'!
translate: aProgramNode
OwnershipCompilerVisitor new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler2_1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompiler2_1 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
translate: aProgramNode
OwnershipCompilerMessageVisitor2_1 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler2_2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompiler2_2 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:20'!
translate: aProgramNode
OwnershipCompilerMessageVisitor2_2 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

RBCompiler subclass: #OwnershipCompiler3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!OwnershipCompiler3 methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:20'!
translate: aProgramNode
OwnershipCompilerMessageVisitor3 new visitNode: aProgramNode methodNode..
^ super translate: aProgramNode.
! !

!OrderedCollection methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 12:13'!
removeAllIfPresent: aCollection 
	^ self select: [ :each | ( aCollection includes: each ) not ].! !

!Collection methodsFor: '*dynamicownership' stamp: 'ewe 5/1/2012 13:46'!
isOverlapping: aCollection
	^( self intersection: aCollection ) size > 0 ! !

!Collection methodsFor: '*dynamicownership' stamp: 'ewe 5/1/2012 13:50'!
matches: interface
	^( self includes: #all ) or: [ self isOverlapping: interface ].
	! !

ReadStream subclass: #WebChunkedStream
	instanceVariableNames: 'sourceStream chunkSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebChunkedStream commentStamp: 'ar 1/31/2012 14:00' prior: 0!
Can process chunked data.!

!WebChunkedStream methodsFor: 'testing' stamp: 'ar 1/31/2012 14:26'!
atEnd
	^chunkSize = 0 and:[super atEnd]! !

!WebChunkedStream methodsFor: 'accessing' stamp: 'ar 1/31/2012 14:09'!
next
	"Answer the next decompressed object in the Stream represented by the
	receiver."

	<primitive: 65>
	position >= readLimit
		ifTrue: [^self pastEndRead]
		ifFalse: [^collection at: (position := position + 1)]! !

!WebChunkedStream methodsFor: 'accessing' stamp: 'ar 1/31/2012 14:25'!
next: anInteger 
	"Answer the next anInteger elements of my collection.  overriden for simplicity"

	[(position + anInteger >= readLimit) and:[chunkSize ~= 0]] 
		whileTrue:[self nextChunk].

	^super next: anInteger
! !

!WebChunkedStream methodsFor: 'accessing' stamp: 'ar 1/31/2012 16:01'!
nextChunk
	"Answer the next chunk from a message using chunked transfer encoding."

	| chunk |
	chunkSize = 0 ifTrue:[^'']. "read last chunk"
	chunkSize := Integer readFrom: (sourceStream upToAll: String crlf) asString base: 16.
	chunkSize = 0 ifFalse:[chunk := sourceStream next: chunkSize].
	sourceStream skip: 2. "CrLf"
	(chunkSize + readLimit - position) <= collection size ifTrue:[
		collection replaceFrom: 1 to: (readLimit-position) with: collection startingAt: position+1.
		readLimit := readLimit - position.
		position := 0.
		collection replaceFrom: readLimit+1 to: readLimit + chunkSize with: chunk startingAt: 1.
		readLimit := readLimit + chunkSize.
	] ifFalse:[
		collection := collection, chunk.
		readLimit := readLimit + chunkSize.
	].
	^chunk
! !

!WebChunkedStream methodsFor: 'initialize' stamp: 'ar 1/31/2012 14:24'!
on: aStream

	sourceStream := aStream.
	collection := (aStream isBinary ifTrue:[ByteArray] ifFalse:[String]) new.
	position := readLimit := 0.! !

!WebChunkedStream methodsFor: 'accessing' stamp: 'ar 1/31/2012 14:11'!
pastEndRead
	"Need more data"

	self nextChunk.
	^self next! !

RBLiteralArrayNode subclass: #RBOwnershipLiteralArrayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!RBOwnershipLiteralArrayNode methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:44'!
isByteArray: flag
	isByteArray:= flag.! !

!RBOwnershipLiteralArrayNode methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 11:51'!
isOwnershipLiteralArrayNode 
	^ true! !

!Metaclass methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 16:41'!
compilerClass	
	(self theNonMetaClass isOwnershipAware) ifTrue: [ ^OwnershipCompiler3 ]
	ifFalse: [ ^super compilerClass ].! !

RBArrayNode subclass: #RBOwnershipArrayNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!RBOwnershipArrayNode methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 13:48'!
isOwnershipArrayNode 
	^ true! !

ClassTestCase subclass: #DOAssociationTest
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel-Test'!

!DOAssociationTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^DOTestsCompiler! !

!DOAssociationTest methodsFor: 'setup' stamp: 'zz 12/5/2005 18:33'!
setUp

	a := 1 -> 'one'.
	b := 1 -> 'een'.! !

!DOAssociationTest methodsFor: 'tests' stamp: 'ab 12/29/2008 07:59'!
testComparison
	self assert: ((#a -> 'foo') < (#b -> 'zork'))! !

!DOAssociationTest methodsFor: 'tests' stamp: 'md 3/8/2004 16:37'!
testEquality
	
	self 
		assert: (a key = b key);
		deny: (a value = b value);
		deny: (a = b)

! !

!DOAssociationTest methodsFor: 'tests' stamp: 'al 10/13/2008 20:32'!
testHash

	self 
		assert: (a hash = a copy hash);
		assert: (a hash = b hash)! !

!DOAssociationTest methodsFor: 'tests' stamp: 'nice 11/1/2009 22:20'!
testIsSelfEvaluating
	| anotherAssociation |
	self assert: (a isSelfEvaluating).
	
	self assert: (a printString = '1->''one''').
	
	anotherAssociation := Object new -> Object new.
	anotherAssociation isSelfEvaluating ifTrue: [self
		assert: (Compiler evaluate: anotherAssociation printString) = anotherAssociation
		description: 'a self evaluating should evaluate as self'].
! !

ClassTestCase subclass: #DOCollectionRootTest
	uses: TIterateTest + TEmptyTest + TSizeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel-Test'!

!DOCollectionRootTest commentStamp: 'stephane.ducasse 1/12/2009 17:41' prior: 0!
I'm the root of the hierarchy of the collection tests.
!

DOCollectionRootTest class
	uses: TIterateTest classTrait + TEmptyTest classTrait + TSizeTest classTrait
	instanceVariableNames: ''!

DOCollectionRootTest subclass: #DOArrayTest
	uses: TEmptySequenceableTest + TSequencedElementAccessTest + TCloneTest + TIncludesWithIdentityCheckTest + TCopyTest + TSetArithmetic + TCreationWithTest + TPutBasicTest + TConvertTest - {} + TOccurrencesForMultiplinessTest + TIterateSequencedReadableTest + TSequencedConcatenationTest + TReplacementSequencedTest + TAsStringCommaAndDelimiterSequenceableTest + TBeginsEndsWith + TPrintOnSequencedTest + TIndexAccess + TSubCollectionAccess + TConvertAsSetForMultiplinessIdentityTest + TCopyPartOfSequenceable + TCopySequenceableSameContents + TCopySequenceableWithOrWithoutSpecificElements + TCopySequenceableWithReplacement + TIndexAccessForMultipliness + TCopyPartOfSequenceableForMultipliness + TConvertAsSortedTest + TPutTest + TSequencedStructuralEqualityTest + TSortTest
	instanceVariableNames: 'example1 literalArray selfEvaluatingArray otherArray nonSEArray1 nonSEarray2 example2 empty collectResult withoutEqualElements withEqualElements withCharacters unsortedCollection sortedInAscendingOrderCollection sizeCollection collectionNotIncluded removedCollection elementInForCopy elementNotInForCopy firstIndex secondIndex replacementCollection indexArray valueArray nonEmptyMoreThan1Element subCollectionNotIn replacementCollectionSameSize oldSubCollection nonEmpty1Element collectionOfCollection collectionOfFloatWithEqualElements floatCollectionWithSameBeginingAnEnd collectionWithoutNil duplicateElement collection5Elements collectionWith4Elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel-Test'!

!DOArrayTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Array. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- there is a chapter in the PharoByExample book (http://pharobyexample.org/)	
	- the sunit class category!

DOArrayTest class
	uses: TEmptySequenceableTest classTrait + TSequencedElementAccessTest classTrait + TCloneTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TCreationWithTest classTrait + TPutBasicTest classTrait + TConvertTest classTrait + TSortTest classTrait + TIterateSequencedReadableTest classTrait + TSequencedConcatenationTest classTrait + TReplacementSequencedTest classTrait + TAsStringCommaAndDelimiterSequenceableTest classTrait + TBeginsEndsWith classTrait + TPrintOnSequencedTest classTrait + TIndexAccess classTrait + TSubCollectionAccess classTrait + TCopyPartOfSequenceable classTrait + TCopySequenceableSameContents classTrait + TCopySequenceableWithOrWithoutSpecificElements classTrait + TCopySequenceableWithReplacement classTrait + TIndexAccessForMultipliness classTrait + TCopyPartOfSequenceableForMultipliness classTrait + TConvertAsSortedTest classTrait + TPutTest classTrait + TIncludesWithIdentityCheckTest classTrait + TConvertAsSetForMultiplinessIdentityTest classTrait + TSequencedStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait
	instanceVariableNames: ''!

!DOArrayTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:02'!
compilerClass
	^DOTestsCompiler! !

!DOArrayTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:12'!
aValue

	^ 33! !

!DOArrayTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/30/2008 19:02'!
accessCollection

	^ example1! !

!DOArrayTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:13'!
anIndex

	^ 2! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:45'!
anotherElementNotIn
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:05'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection anyOne.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:05'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:19'!
anotherValue

	^ 66! !

!DOArrayTest methodsFor: 'tests - converting' stamp: 'cyrille.delaunay 3/26/2009 12:35'!
assertSameContents: aCollection whenConvertedTo: aClass 
	| result |
	result := aCollection perform: ('as' , aClass name) asSymbol.
	self assert: (result class includesBehavior: aClass).
	result do: 
		[ :each | 
		self assert: (aCollection occurrencesOf: each) = (result occurrencesOf: each) ].
	self assert: result size = aCollection size! !

!DOArrayTest methodsFor: 'initialization' stamp: 'cyrille.delaunay 12/18/2009 12:59'!
collection 

	^ collectionWith4Elements ! !

!DOArrayTest methodsFor: 'test - creation' stamp: 'pmaer 5/14/2012 14:21'!
collectionClass 
	
	^ DOArray! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/9/2009 11:11'!
collectionInForIncluding
	^ self nonEmpty copyWithoutFirst.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 15:16'!
collectionMoreThan1NoDuplicates
	" return a collection of size 5 without equal elements"
	^ withoutEqualElements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 14:01'!
collectionMoreThan5Elements
" return a collection including at least 5 elements"
	
	^ collection5Elements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/30/2009 10:51'!
collectionNotIncluded
	^ collectionNotIncluded.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/15/2009 14:07'!
collectionOfFloat
	^ collectionOfCollection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/17/2009 10:28'!
collectionWith1TimeSubcollection
	^ (self oldSubCollection copyWithoutFirst),self oldSubCollection,(self oldSubCollection copyWithoutFirst). ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/17/2009 10:29'!
collectionWith2TimeSubcollection
	^ (self oldSubCollection copyWithoutFirst),self oldSubCollection,(self oldSubCollection copyWithoutFirst),self oldSubCollection .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 3/26/2009 09:58'!
collectionWithCharacters
	^ withCharacters.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
collectionWithCopy
	"return a collection of type 'self collectionWIithoutEqualsElements clas' containing no elements equals ( with identity equality)
	but  2 elements only equals with classic equality"
	| result collection |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	collection add: collection first copy.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 10:22'!
collectionWithCopyNonIdentical
	" return a collection that include elements for which 'copy' return a different object (this is not the case of SmallInteger)"
	^ collectionOfCollection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/17/2009 15:24'!
collectionWithElementsToRemove
	^ removedCollection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 3/26/2009 09:57'!
collectionWithEqualElements
	^ withEqualElements.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
collectionWithIdentical
	"return a collection of type : 'self collectionWIithoutEqualsElements class containing two elements equals ( with identity equality)"
	| result collection element |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	element := collection first.
	collection add: element.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:17'!
collectionWithNonIdentitySameAtEndAndBegining
	" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingAnEnd ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/22/2009 11:15'!
collectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals .
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingAnEnd ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 10:27'!
collectionWithSortableElements
" return a collection elements that can be sorte ( understanding message ' < '  or ' > ')"
	^ withoutEqualElements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 10:25'!
collectionWithoutEqualElements
	^ withoutEqualElements .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/16/2009 15:49'!
collectionWithoutEqualsElements
	^ withoutEqualElements ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 11:39'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^ collectionWithoutNil  ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damienpollet 1/30/2009 17:27'!
element
	^ 3! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/15/2009 14:22'!
elementInCollectionOfFloat
	^ collectionOfCollection atRandom! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:28'!
elementInForCopy
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:39'!
elementInForElementAccessing
" return an element inculded in 'accessCollection '"
	^ self accessCollection anyOne! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/14/2009 13:55'!
elementInForIncludesTest

	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/10/2009 14:49'!
elementInForIndexAccess
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 15:18'!
elementInForIndexAccessing

	^ withoutEqualElements anyOne! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 11:54'!
elementInForOccurrences
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 10:16'!
elementInForReplacement
	^ elementInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:45'!
elementNotIn
"return an element not included in 'nonEmpty' "

	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
elementNotInForCopy
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:39'!
elementNotInForElementAccessing
" return an element not included in 'accessCollection' "
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/7/2009 11:18'!
elementNotInForIndexAccessing

	^elementNotInForCopy ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:45'!
elementNotInForOccurrences
	^ elementNotInForCopy ! !

!DOArrayTest methodsFor: 'test - copy' stamp: 'delaunay 4/17/2009 15:26'!
elementToAdd
	^ 55! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:13'!
elementTwiceInForOccurrences
" return an element included exactly two time in # collectionWithEqualElements"
^ duplicateElement ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 13:46'!
elementsCopyNonIdenticalWithoutEqualElements
	" return a collection that does niot include equal elements ( classic equality )"
	^ collectionOfCollection! !

!DOArrayTest methodsFor: 'initialization' stamp: 'stephane.ducasse 10/5/2008 15:06'!
empty

	^ empty! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'luc.fabresse 11/29/2008 23:10'!
expectedSizeAfterReject
	^1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 16:41'!
firstCollection
	^example1 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damiencassou 1/27/2009 10:35'!
firstEven
	"Returns the first even number of #collection"
	^ -2! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
firstIndex
	^ firstIndex ! !

!DOArrayTest methodsFor: 'tests - copying with replacement' stamp: 'pmaer 5/14/2012 14:23'!
firstIndexesOf: subCollection in: collection
" return an OrderedCollection with the first indexes of the occurrences of subCollection in  collection "
	| tmp result currentIndex |
	tmp:= collection.
	result:= DOOrderedCollection new.
	currentIndex := 1.
	
	[tmp isEmpty ]whileFalse:
		[
		(tmp beginsWith: subCollection)
			ifTrue: [ 	
				result add: currentIndex.
				1 to: subCollection size do: 
					[:i | 
					tmp := tmp copyWithoutFirst.
					currentIndex := currentIndex + 1]
				]
			ifFalse: [
				tmp := tmp copyWithoutFirst.
				currentIndex := currentIndex +1.
				]
		 ].
	
	^ result.
	! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damiencassou 1/27/2009 10:35'!
firstOdd
	"Returns the first odd number of #collection"
	^ 1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/21/2009 14:00'!
floatCollectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingAnEnd ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 16:00'!
indexArray
	^ indexArray .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/16/2009 15:59'!
indexInForCollectionWithoutDuplicates
	^ 2.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/16/2009 16:56'!
indexInNonEmpty
	^ 2 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/9/2009 15:53'!
integerCollection
	^example1 .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 10:28'!
integerCollectionWithoutEqualElements
	^{1. 2. 6. 5.}! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:53'!
moreThan3Elements
	" return a collection including atLeast 3 elements"
	^ example1 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:53'!
moreThan4Elements

" return a collection including at leat 4 elements"
	^ example1 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 10:16'!
newElement
	^999! !

!DOArrayTest methodsFor: 'initialization' stamp: 'stephane.ducasse 10/5/2008 15:06'!
nonEmpty

	^ example1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/8/2009 11:40'!
nonEmpty1Element

	^ nonEmpty1Element  ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 15:20'!
nonEmptyMoreThan1Element
	^nonEmptyMoreThan1Element .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 11:41'!
oldSubCollection
	^oldSubCollection ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
replacementCollection
	^replacementCollection .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/6/2009 10:32'!
replacementCollectionSameSize
	^replacementCollectionSameSize ! !

!DOArrayTest methodsFor: 'initialization' stamp: 'cyrille.delaunay 12/18/2009 11:59'!
result
	
	^ collectResult! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/2/2009 16:41'!
secondCollection
	^example2 ! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 10:29'!
secondIndex
	^ secondIndex ! !

!DOArrayTest methodsFor: 'parameters' stamp: 'stephane.ducasse 10/5/2008 15:12'!
selectorToAccessValuePutIn
	"return the selector of the method that should be invoked to access an element"
	
	^ #second! !

!DOArrayTest methodsFor: 'initialization' stamp: 'pmaer 5/14/2012 14:21'!
setUp

	
	literalArray := #(1 true 3 #four).
	selfEvaluatingArray := { 1. true. (3/4). Color black. (2 to: 4) . 5 }.
	nonSEArray1 := { 1 . DOSet with: 1 }.
	nonSEarray2 := { Smalltalk globals associationAt: #DOArray }.
	example1 := #(1 2 3 4 5) copy.
	indexArray:= {2. 3. 4.}.
	valueArray:={0. 0. 0.}.
	oldSubCollection:= {2. 3. 4.}.
	nonEmptyMoreThan1Element:= example1.
	subCollectionNotIn:= {1. 8. 3.}.
	collectionNotIncluded:= {7. 8. 9.}.
	removedCollection:=  { 2. 4. }.
	
	example2 := {1. 2. 3/4. 4. 5}.
	collectionWith4Elements := #(1 -2 3 1). 
	collectionWithoutNil := #( 1 2 3 4).
	collectResult := {SmallInteger. SmallInteger. SmallInteger. SmallInteger.}.
	empty := #().
	duplicateElement := 5.2.
	withEqualElements := {1.5. duplicateElement . 6.1. 2.0. duplicateElement .} .
	withoutEqualElements := {1.1. 4.4. 6.5. 2.4. 3.1.}.
	withCharacters := {$a. $x. $d. $c. $m.}.
	unsortedCollection := {1. 2.  8. 5. 6. 7.}.
	sortedInAscendingOrderCollection := {1. 2. 3. 4. 5. 6.}.
	elementInForCopy:= 2.
	elementNotInForCopy:= 9.
	firstIndex:= 2.
	secondIndex:= 4.
	replacementCollection:= {4. 3. 2. 1.}.
	replacementCollectionSameSize := {5. 4. 3.}.	
	nonEmpty1Element:={ 5.}.
	collectionOfCollection:={1.5. 5.5. 6.5.}.
	collectionOfFloatWithEqualElements:={1.5. 5.5. 6.5. 1.5}.
	floatCollectionWithSameBeginingAnEnd := {1.5. 5.5. 1.5 copy}.
	collection5Elements := { 1. 2. 5. 3. 4.}.! !

!DOArrayTest methodsFor: 'requirements' stamp: 'damienpollet 1/13/2009 16:59'!
sizeCollection

	^ self collection! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/31/2009 14:08'!
smallerIndex
	^ firstIndex -1! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/27/2009 15:20'!
sortedInAscendingOrderCollection
	^sortedInAscendingOrderCollection .
	! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'pmaer 5/14/2012 14:21'!
speciesClass
	
	^ DOArray! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/3/2009 11:35'!
subCollectionNotIn

	^subCollectionNotIn ! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/17/2009 15:26'!
test0CopyTest
	self 
		shouldnt: self empty
		raise: Error.
	self assert: self empty size = 0.
	self 
		shouldnt: self nonEmpty
		raise: Error.
	self assert: (self nonEmpty size = 0) not.
	self 
		shouldnt: self collectionWithElementsToRemove
		raise: Error.
	self assert: (self collectionWithElementsToRemove size = 0) not.
	self 
		shouldnt: self elementToAdd
		raise: Error! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/15/2009 14:37'!
test0FixtureIncludeTest
	| elementIn |
	self 
		shouldnt: [ self nonEmpty ]
		raise: Error.
	self deny: self nonEmpty isEmpty.
	self 
		shouldnt: [ self elementNotIn ]
		raise: Error.
	elementIn := true.
	self nonEmpty 
		detect: [ :each | each = self elementNotIn ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	self 
		shouldnt: [ self anotherElementNotIn ]
		raise: Error.
	elementIn := true.
	self nonEmpty 
		detect: [ :each | each = self anotherElementNotIn ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = false.
	self 
		shouldnt: [ self collection ]
		raise: Error.
	"self shouldnt: [self collectionInForIncluding  ] raise: Error."
	"collectionIn:=false.
	index:=1.
	1 to: self nonEmpty size do:
		[:i|
		collectionIn = false
			ifTrue:[(self nonEmpty at:i)=(self collectionInForIncluding at:index)
				ifTrue:[
					index=self collectionInForIncluding 
						ifTrue:[collectionIn := true].					
					index:=index+1.]
				ifFalse:[index:=1].			
				]
		].
	self assert: collectionIn=true."
	self 
		shouldnt: [ self empty ]
		raise: Error.
	self assert: self empty isEmpty.
	self 
		shouldnt: [ self collectionOfFloat ]
		raise: Error.
	self collectionOfFloat do: [ :each | self assert: each class = Float ].
	self 
		shouldnt: [ self elementInForIncludesTest ]
		raise: Error.
	elementIn := true.
	self nonEmpty 
		detect: [ :each | each = self elementInForIncludesTest ]
		ifNone: [ elementIn := false ].
	self assert: elementIn = true! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/2/2009 11:53'!
test0FixtureOccurrencesTest
	self 
		shouldnt: self empty
		raise: Error.
	self assert: self empty isEmpty.
	self 
		shouldnt: self nonEmpty
		raise: Error.
	self deny: self nonEmpty isEmpty.
	self 
		shouldnt: self elementInForOccurrences
		raise: Error.
	self assert: (self nonEmpty includes: self elementInForOccurrences).
	self 
		shouldnt: self elementNotInForOccurrences
		raise: Error.
	self deny: (self nonEmpty includes: self elementNotInForOccurrences)! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/14/2009 11:50'!
test0FixtureSequencedConcatenationTest
	self 
		shouldnt: self empty
		raise: Exception.
	self assert: self empty isEmpty.
	self 
		shouldnt: self firstCollection
		raise: Exception.
	self 
		shouldnt: self secondCollection
		raise: Exception! !

!DOArrayTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/28/2009 14:11'!
test0FixtureTConvertAsSetForMultiplinessTest
	"a collection ofFloat with equal elements:"
	| res |
	self 
		shouldnt: [ self withEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self withEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self withEqualElements 
		detect: [ :each | (self withEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = true.

	"a collection of Float without equal elements:"
	self 
		shouldnt: [ self elementsCopyNonIdenticalWithoutEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self elementsCopyNonIdenticalWithoutEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self elementsCopyNonIdenticalWithoutEqualElements 
		detect: 
			[ :each | 
			(self elementsCopyNonIdenticalWithoutEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testAllButFirstDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButFirstDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i +1))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testAllButLastDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButLastDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i ))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'damienpollet 1/13/2009 16:28'!
testAnySatisfy

	self assert: ( self collection anySatisfy: [:each | each = -2]).
	self deny: (self collection anySatisfy: [:each | each isString]).! !

!DOArrayTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:21'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: DOArray! !

!DOArrayTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:23'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOOrderedCollection! !

!DOArrayTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:10'!
testAsSet
	| |
	"test with a collection without equal elements :"
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOSet.
	! !

!DOArrayTest methodsFor: 'tests - as set tests' stamp: 'pmaer 5/14/2012 14:10'!
testAsSetWithEqualsElements
	| result |
	result := self withEqualElements asSet.
	self withEqualElements do: [ :each | self assert: (result occurrencesOf: each) = 1 ].
	self assert: result class = DOSet! !

!DOArrayTest methodsFor: 'tests - as sorted collection' stamp: 'pmaer 5/14/2012 14:21'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: DOArray).
	self assert: result isSorted.
	self assert: result size = collection size! !

!DOArrayTest methodsFor: 'tests - accessing' stamp: 'delaunay 4/10/2009 16:19'!
testAtWrap2
	| tabTest |
	tabTest := #(5 6 8 ).
	self assert: (tabTest atWrap: 2) = 6.
	self assert: (tabTest atWrap: 7) = 5.
	self assert: (tabTest atWrap: 5) = 6.
	self assert: (tabTest atWrap: 0) = 8.
	self assert: (tabTest atWrap: 1) = 5.
	self assert: (tabTest atWrap: -2) = 5! !

!DOArrayTest methodsFor: 'testing' stamp: 'pmaer 5/7/2012 15:25'!
testComplexIsSelfEvaluating
	"self run: #testComplexIsSelfEvaluating"
	<broken>
	"Compiler evaluate:  creates an Array, not a DOArray"

	| complexArray restoredArray |
	complexArray := {1. true. false. nil. #a. 'a'. $a. Float pi. Float halfPi. 4/5. Float infinity negated. Color red. RunArray new: 5 withAll: #bold. 1@2. (0@0 extent: 1@1) -> 0. Object. Object class}.
	complexArray := complexArray copyWith: complexArray.
	
	self assert: complexArray isSelfEvaluating.
	self shouldnt: [restoredArray := Compiler evaluate: complexArray printString] raise: Error.
	self assert: restoredArray = complexArray! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 3/30/2009 10:33'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!DOArrayTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'pmaer 5/14/2012 14:23'!
testDo

	| res |
	res := DOOrderedCollection new.  
	self collection do: [:each | res add: each class].
	self assert: res asArray = self result.! !

!DOArrayTest methodsFor: 'test - iterate' stamp: 'pmaer 5/14/2012 14:23'!
testDo2

	| res |
	res := DOOrderedCollection new.  
	self collection do: [:each | res add: each class].
	self assert: res asArray = self result. ! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testFromToDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  from: 1 to: (self nonEmptyMoreThan1Element  size -1) do: [:each | result add: each].
	
	1 to: (self nonEmptyMoreThan1Element  size -1) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:i )=(result at:i)].
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOArrayTest methodsFor: 'tests - includes' stamp: 'delaunay 4/28/2009 10:22'!
testIdentityIncludes
	" test the comportement in presence of elements 'includes' but not 'identityIncludes' "
	" can not be used by collections that can't include elements for wich copy doesn't return another instance "
	| collection element |
	self 
		shouldnt: [ self collectionWithCopyNonIdentical ]
		raise: Error.
	collection := self collectionWithCopyNonIdentical.
	element := collection anyOne copy.
	"self assert: (collection includes: element)."
	self deny: (collection identityIncludes: element)! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/15/2009 14:22'!
testIdentityIndexOf
	"self debug: #testIdentityIndexOf"
	| collection element |
	element := self elementInCollectionOfFloat copy.
	self deny: self elementInCollectionOfFloat == element.
	collection := self collectionOfFloat copyWith: element.
	self assert: (collection identityIndexOf: element) = collection size! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/15/2009 14:22'!
testIdentityIndexOfIAbsent
	"self debug: #testIdentityIndexOfIfAbsent"
	| collection element |
	element := self elementInCollectionOfFloat copy.
	self deny: self elementInCollectionOfFloat == element.
	collection := self collectionOfFloat copyWith: element.
	self assert: (collection 
			identityIndexOf: element
			ifAbsent: [ 0 ]) = collection size.
	self assert: (self collectionOfFloat 
			identityIndexOf: element
			ifAbsent: [ 55 ]) = 55! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOf
	"self debug: #testIndexOf"
	| tmp index collection |
	collection := self collectionMoreThan1NoDuplicates.
	tmp := collection size.
	collection reverseDo: 
		[ :each | 
		each = self elementInForIndexAccessing ifTrue: [ index := tmp ].
		tmp := tmp - 1 ].
	self assert: (collection indexOf: self elementInForIndexAccessing) = index! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| collection |
	collection := self collectionMoreThan1NoDuplicates.
	self assert: (collection 
			indexOf: collection first
			ifAbsent: [ 33 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 33 ]) = 33! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			indexOf: element
			startingAt: 2
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			indexOf: element
			startingAt: 1
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			startingAt: 1
			ifAbsent: [ 99 ]) = 99! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAt
	"self debug: #testIndexOfIfAbsent"
	| subcollection index collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1.
	self assert: index = 1.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2.
	self assert: index = 0! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAtIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| index absent subcollection collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1
		ifAbsent: [ absent := true ].
	self assert: absent = false.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2
		ifAbsent: [ absent := true ].
	self assert: absent = true! !

!DOArrayTest methodsFor: 'testing' stamp: 'zz 12/5/2005 17:12'!
testIsArray
	
	self assert: example1 isArray! !

!DOArrayTest methodsFor: 'testing' stamp: 'nice 11/3/2009 21:28'!
testIsLiteral
	"We work with a copy of literalArray, to avoid corrupting the code."
	
	| aLiteralArray |
	aLiteralArray := literalArray copy.
	self assert: aLiteralArray isLiteral.
	aLiteralArray at: 1 put: self class.
	self deny: aLiteralArray isLiteral.
	self deny: (literalArray as: WeakArray) isLiteral description: 'instances of Array subclasses are not literal'.! !

!DOArrayTest methodsFor: 'testing' stamp: 'zz 12/5/2005 17:18'!
testIsSelfEvaluating

	self assert: example1 isSelfEvaluating.
	example1 at: 1 put: Bag new.
	self deny: example1 isSelfEvaluating.
	example1 at: 1 put: 1.! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testKeysAndValuesDo
	"| result |
	result:= OrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	1 to: result size do:
		[:i|
		self assert: (result at:i)=((self nonEmptyMoreThan1Element at:i)+i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	
	! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testKeysAndValuesDoEmpty
	| result |
	result:= DOOrderedCollection new.
	
	self empty  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	self assert: result isEmpty .! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOf
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection lastIndexOf: element) = 1.
	self assert: (collection lastIndexOf: self elementNotInForIndexAccessing) = 0! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			lastIndexOf: element
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 99 ]) = 99! !

!DOArrayTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection last.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size
			ifAbsent: [ 99 ]) = collection size.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size - 1
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			startingAt: collection size
			ifAbsent: [ 99 ]) = 99! !

!DOArrayTest methodsFor: 'testing' stamp: 'StephaneDucasse 1/16/2010 10:07'!
testLiteralEqual

	self deny: (example1 literalEqual: example1 asIntegerArray)! !

!DOArrayTest methodsFor: 'testing' stamp: 'pmaer 5/14/2012 14:21'!
testNewWithSize
	|array|
	array := DOArray new: 5.
	self assert: array size = 5.
	1 to: 5 do: [:index | self assert: (array at: index) isNil]! !

!DOArrayTest methodsFor: 'tests - occurrencesOf' stamp: 'delaunay 4/2/2009 11:52'!
testOccurrencesOf
	| result expected |
	result := self nonEmpty occurrencesOf: self elementInForOccurrences.
	expected := 0.
	self nonEmpty do: [ :each | self elementInForOccurrences = each ifTrue: [ expected := expected + 1 ] ].
	self assert: result = expected! !

!DOArrayTest methodsFor: 'tests - occurrencesOf' stamp: 'delaunay 4/2/2009 11:52'!
testOccurrencesOfEmpty
	| result |
	result := self empty occurrencesOf: self elementInForOccurrences.
	self assert: result = 0! !

!DOArrayTest methodsFor: 'tests - occurrencesOf' stamp: 'delaunay 4/2/2009 11:53'!
testOccurrencesOfNotIn
	| result |
	result := self empty occurrencesOf: self elementNotInForOccurrences.
	self assert: result = 0! !

!DOArrayTest methodsFor: 'testing' stamp: 'pmaer 5/7/2012 15:25'!
testPrinting
	<broken>
	"Compiler evaluate:  creates an Array, not a DOArray"
	self assert: literalArray printString = '#(1 true 3 #four)'.
	self assert: (literalArray = (Compiler evaluate: literalArray printString)).
	self assert: (selfEvaluatingArray = (Compiler evaluate: selfEvaluatingArray printString)).
	self assert: nonSEArray1 printString =  'an Array(1 a Set(1))'.
	self assert: nonSEarray2 printString = '{(#DOArray->DOArray)}'
! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testReverseDo
	| result |
	result:= DOOrderedCollection new.
	self nonEmpty reverseDo: [: each | result add: each].
	
	1 to: result size do:
		[:i|
		self assert: (result at: i)=(self nonEmpty at:(self nonEmpty size-i+1))].! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testReverseDoEmpty
	| result |
	result:= DOOrderedCollection new.
	self empty reverseDo: [: each | result add: each].
	
	self assert: result isEmpty .! !

!DOArrayTest methodsFor: 'tests - puting with indexes' stamp: 'Anonymous 5/24/2010 14:30'!
testSwapWith
	"self debug: #testSwapWith"
	| result index |
	index := self indexArray anyOne.
	result:= self nonEmpty copy .
	result swap: index with: 1.
	self assert: (result at: index) = (self nonEmpty at:1).
	self assert: (result at: 1) = (self nonEmpty at: index).
	! !

!DOArrayTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testWithIndexDo
	
	"| result |
	result:=Array new: self nonEmptyMoreThan1Element size.
	self nonEmptyMoreThan1Element  withIndexDo: [:each :i | result at:i put:(each+i)].
	
	1 to: result size do:[: i | self assert: (result at:i)= ((self nonEmptyMoreThan1Element at: i) + i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  withIndexDo: 
		[:value :i  |
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 3/27/2009 15:20'!
unsortedCollection
	^unsortedCollection .! !

!DOArrayTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:21'!
valueArray
" return a collection (with the same size than 'indexArray' )of values to be put in 'nonEmpty'  at indexes in 'indexArray' "
	| result |
	result := DOArray new: self indexArray size.
	1 to: result size do:
		[:i |
		result at:i put: (self aValue ).
		].
	^ result.! !

!DOArrayTest methodsFor: 'parameters' stamp: 'stephane.ducasse 10/9/2008 18:49'!
valuePutIn
	"the value that we will put in the non empty collection"
	
	^ 2! !

!DOArrayTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 14:11'!
withEqualElements
	" return a collection of float including equal elements (classic equality)"
	^ collectionOfFloatWithEqualElements! !

!DOCollectionRootTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^DOTestsCompiler! !

!DOCollectionRootTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:14'!
isAbstract

	^ self name = #DOCollectionRootTest! !

!DOCollectionRootTest methodsFor: '*dynamicownership' stamp: 'pmaer 5/21/2012 00:24'!
canCrossBoundary: anObject
	<meta> 
	^ true.! !

!DOCollectionRootTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 10:36'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	self subclassResponsibility! !

!DOCollectionRootTest methodsFor: '*dynamicownership' stamp: 'pmaer 5/21/2012 00:24'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!DOCollectionRootTest methodsFor: '*dynamicownership' stamp: 'pmaer 5/21/2012 00:24'!
doNotCrossBoundary: anObject
	<meta> 
	Error signal: 'All objects should pass through'. ! !

!DOCollectionRootTest methodsFor: 'requirements' stamp: 'damienpollet 1/30/2009 17:20'!
doWithoutNumber

	^ 2! !

!DOCollectionRootTest methodsFor: 'requirements' stamp: 'damienpollet 1/30/2009 17:32'!
element
	^ 3! !

!DOCollectionRootTest methodsFor: 'requirements' stamp: 'damienpollet 1/30/2009 17:14'!
elementTwiceIn
	^ 1 "12332312322"! !

!DOCollectionRootTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 10:36'!
empty
	self subclassResponsibility! !

!DOCollectionRootTest methodsFor: 'requirements' stamp: 'damienpollet 1/21/2009 18:25'!
expectedElementByDetect

	^ -2! !

!DOCollectionRootTest methodsFor: '*dynamicownership' stamp: 'pmaer 5/21/2012 00:23'!
inFilters
	^ {#all}! !

!DOCollectionRootTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 10:35'!
nonEmpty

	self subclassResponsibility! !

!DOCollectionRootTest methodsFor: '*dynamicownership' stamp: 'pmaer 5/21/2012 00:24'!
outFilters
	^ {#all}
	! !

!DOCollectionRootTest methodsFor: 'tests - iterating' stamp: 'pmaer 5/14/2012 14:23'!
testDo2
	"dc: Bad test, it assumes that a new instance of #speciesClass allows addition with #add:. This is not the case of Interval for which species is Array."
	"res := self speciesClass new.  
	self collection do: [:each | res add: each class].
	self assert: res = self result. "
	| collection cptElementsViewed cptElementsIn |
	collection := self collectionWithoutNilElements.
	cptElementsViewed := 0.
	cptElementsIn := DOOrderedCollection new.
	collection do: 
		[ :each | 
		cptElementsViewed := cptElementsViewed + 1.
		" #do doesn't iterate with the same objects than those in the collection for FloatArray( I don' t know why ) . That's why I use #includes: and not #identityIncludes:  '"
		(collection includes: each) ifTrue: [
			" the collection used doesn't include equal elements. Therefore each element viewed should not have been viewed before "
			( cptElementsIn includes: each ) ifFalse: [ cptElementsIn add: each ] .
			]. 
		].
	self assert: cptElementsViewed = collection size.
	self assert: cptElementsIn size  = collection size.
	
	! !

!DOCollectionRootTest methodsFor: 'tests - iterate' stamp: 'delaunay 5/14/2009 11:03'!
testDoSeparatedBy
	| string expectedString beforeFirst |
	string := ''.
	self collectionWithoutNilElements  
		do: [ :each | string := string , each asString ]
		separatedBy: [ string := string , '|' ].
	expectedString := ''.
	beforeFirst := true.
	self collectionWithoutNilElements  do: 
		[ :each | 
		beforeFirst = true 
			ifTrue: [ beforeFirst := false ]
			ifFalse: [ expectedString := expectedString , '|' ].
		expectedString := expectedString , each asString ].
	self assert: expectedString = string! !

!DOCollectionRootTest methodsFor: 'tests - iterating' stamp: 'pmaer 5/14/2012 14:23'!
testDoWithout
	"self debug: #testDoWithout"
	
	| res element collection |
	collection := self collectionWithoutNilElements .	
	res := DOOrderedCollection new.  
	element := self collectionWithoutNilElements anyOne .
	collection  do: [:each | res add: each] without: element  .
	" verifying result :"
	self assert: res size = (collection  size - (collection  occurrencesOf: element)).
	res do: [:each | self assert: (collection occurrencesOf: each) = ( res occurrencesOf: each ) ].
	! !

!DOCollectionRootTest methodsFor: 'tests - iterate' stamp: 'delaunay 5/14/2009 11:08'!
testRejectNoReject
	| res collection |
	collection := self collectionWithoutNilElements .
	res := collection  reject: [ :each | each isNil ].
	self assert: res size = collection  size! !

DOCollectionRootTest subclass: #DODictionaryTest
	uses: TIncludesTest + TDictionaryAddingTest + TDictionaryComparingTest + TDictionaryCopyingTest + TDictionaryEnumeratingTest + TDictionaryPrintingTest - {#testPrintElementsOn. #testStoreOn} + TDictionaryRemovingTest + TPutBasicTest - {#testAtPutOutOfBounds} + TAsStringCommaAndDelimiterTest + TPrintTest + TConvertTest + TConvertAsSortedTest + TCopyTest - {#testCopyEmptyWithout. #testCopyNonEmptyWithout. #testCopyNonEmptyWithoutNotIncluded} + TSetArithmetic + TDictionaryIncludesWithIdentityCheckTest + TDictionaryValueAccessTest + TDictionaryKeysValuesAssociationsAccess + TDictionaryKeyAccessTest + TDictionaryAssociationAccessTest + TStructuralEqualityTest + TOccurrencesForMultiplinessTest
	instanceVariableNames: 'emptyDict nonEmptyDict nonEmpty5ElementsNoDuplicates indexArray valueArray nonEmpty1Element collectionNotIncluded collectionIncluded associationNotIn valueNotIn keyNotIn dictionaryNotIncluded nonEmptyWithFloat dictionaryWithDuplicateValues duplicateValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel-Test'!

DODictionaryTest class
	uses: TIncludesTest classTrait + TDictionaryAddingTest classTrait + TDictionaryComparingTest classTrait + TDictionaryCopyingTest classTrait + TDictionaryEnumeratingTest classTrait + TDictionaryPrintingTest classTrait + TDictionaryRemovingTest classTrait + TPutBasicTest classTrait + TAsStringCommaAndDelimiterTest classTrait + TPrintTest classTrait + TConvertTest classTrait + TConvertAsSortedTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TDictionaryValueAccessTest classTrait + TDictionaryKeysValuesAssociationsAccess classTrait + TDictionaryKeyAccessTest classTrait + TDictionaryAssociationAccessTest classTrait + TDictionaryIncludesWithIdentityCheckTest classTrait + TStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait
	instanceVariableNames: 'testToto pt1'!

DODictionaryTest class
	uses: TIncludesTest classTrait + TDictionaryAddingTest classTrait + TDictionaryComparingTest classTrait + TDictionaryCopyingTest classTrait + TDictionaryEnumeratingTest classTrait + TDictionaryPrintingTest classTrait + TDictionaryRemovingTest classTrait + TPutBasicTest classTrait + TAsStringCommaAndDelimiterTest classTrait + TPrintTest classTrait + TConvertTest classTrait + TConvertAsSortedTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TDictionaryValueAccessTest classTrait + TDictionaryKeysValuesAssociationsAccess classTrait + TDictionaryKeyAccessTest classTrait + TDictionaryAssociationAccessTest classTrait + TDictionaryIncludesWithIdentityCheckTest classTrait + TStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait
	instanceVariableNames: 'testToto pt1'!

!DODictionaryTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^DOTestsCompiler! !

!DODictionaryTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:24'!
aValue

	^ 33! !

!DODictionaryTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:25'!
anIndex

	^ #GG! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'stephane.ducasse 11/21/2008 15:05'!
anotherElementNotIn
	^ 42! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 11:56'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection associations anyOne.! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 11:56'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ associationNotIn ! !

!DODictionaryTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:25'!
anotherValue

	^ 66! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'delaunay 5/5/2009 14:16'!
associationWithKeyAlreadyInToAdd
	" return an association that will be used to add to nonEmptyDict (the key of this association is already included in nonEmptyDict)"
	^ (self nonEmptyDict keys anyOne)->valueNotIn .! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'delaunay 5/5/2009 14:15'!
associationWithKeyNotInToAdd
	" return an association that will be used to add to nonEmptyDict"
	^ associationNotIn ! !

!DODictionaryTest methodsFor: 'setup' stamp: 'pmaer 5/14/2012 14:08'!
classToBeTested 

	^ DODictionary! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'damienpollet 1/13/2009 16:15'!
collection
	^ self nonEmptyDict! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:08'!
collectionClass
" return the class to be used to create instances of the class tested"
	^ DODictionary! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 10:16'!
collectionNotIncluded
" return a collection for wich each element is not included in 'nonEmpty' "
	^collectionNotIncluded ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 16:05'!
collectionWithElement
	"Returns a collection that already includes what is returned by #element."
	^ nonEmpty5ElementsNoDuplicates add: self element ;yourself.! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 11:09'!
collectionWithElementsToRemove
" return a collection of elements included in 'nonEmpty'  "
	^ collectionIncluded  ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 15:54'!
collectionWithEqualElements
" return a collecition including atLeast two elements equal"

^ dictionaryWithDuplicateValues ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 10:45'!
collectionWithSortableElements
" return a collection elements that can be sorte ( understanding message ' < '  or ' > ')"
	^ nonEmpty5ElementsNoDuplicates ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 15:52'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^ nonEmpty5ElementsNoDuplicates ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 15:19'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^nonEmpty5ElementsNoDuplicates ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 16:08'!
element
	^ 30! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 14:51'!
elementNotIn
	"return an element not included in 'nonEmpty' "
	^ valueNotIn! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'delaunay 4/2/2009 11:53'!
elementNotInForOccurrences
	^ 666! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 10:17'!
elementToAdd
" return an element of type 'nonEmpy' elements'type'"
	^ #u->5.! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 15:54'!
elementTwiceInForOccurrences
" return an element included exactly two time in # collectionWithEqualElements"
^ duplicateValue ! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'stephane.ducasse 11/21/2008 15:04'!
empty
	^ emptyDict! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'AlexandreBergel 1/6/2009 15:06'!
emptyDict
	^ emptyDict! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'damienpollet 1/21/2009 18:22'!
expectedElementByDetect
	^ 30! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'damienpollet 1/30/2009 17:44'!
expectedSizeAfterReject
	self flag: 'what should this return?'! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 10:12'!
indexInNonEmpty
" return an index between bounds of 'nonEmpty' "

	^ #a! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 15:52'!
integerCollectionWithoutEqualElements
" return a collection of integer without equal elements"
	^ nonEmpty5ElementsNoDuplicates ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/4/2009 16:05'!
keyNotIn
" return a key not included in nonEmpty"
^ keyNotIn ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 15:00'!
keyNotInNonEmpty
	" return a key not included in nonEmpty"
	^ keyNotIn ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/5/2009 15:21'!
keyNotInNonEmptyDict
" return a key not included in nonEmptyDict"
	^ keyNotIn ! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'AlexandreBergel 1/6/2009 15:09'!
newEmptyDict
	^ self emptyDict copy! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'stephane.ducasse 11/21/2008 15:04'!
nonEmpty
	^ nonEmptyDict! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 15:24'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^ nonEmpty1Element ! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'AlexandreBergel 1/6/2009 15:06'!
nonEmptyDict
	^ nonEmptyDict ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/6/2009 10:09'!
nonEmptyDifferentFromNonEmptyDict
" return a dictionary for which all keys are not included in nonEmptyDict"
^ dictionaryNotIncluded ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/12/2009 11:07'!
nonEmptyWithCopyNonIdentical.
" return a collection including elements for wich copy is not identical to the initial element ( this is not the cas of Integer )"
^nonEmptyWithFloat ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/5/2009 10:41'!
nonEmptyWithoutEqualsValues
" return a dictionary that doesn't include equal values'"
^nonEmpty5ElementsNoDuplicates ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 16:04'!
otherCollection
	"Returns a collection that does not include what is returned by #element."
	^ nonEmpty5ElementsNoDuplicates ! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'pmaer 5/14/2012 14:08'!
result
	^ DODictionary newFromPairs: {
		#a . SmallInteger .
		#b . SmallInteger .
		#c . SmallInteger .
		#d . SmallInteger }! !

!DODictionaryTest methodsFor: 'setup' stamp: 'pmaer 5/21/2012 00:04'!
setUp
	emptyDict := self classToBeTested new.
	nonEmptyDict := self classToBeTested new.
	nonEmptyDict
		at: #a
			put: self elementTwiceIn;
		at: #b
			put: 30;
		at: #c
			put: self elementTwiceIn;
		at: #d
			put: -2.
	nonEmpty5ElementsNoDuplicates := self classToBeTested new
		at: #a
			put: 5;
		at: #b
			put: 4;
		at: #c
			put: 7;
		at: #d
			put: 6;
		at: #e
			put: 9;
		yourself.
	valueNotIn := 666.
	keyNotIn := #z .
	associationNotIn := keyNotIn->valueNotIn.
	dictionaryNotIncluded := DODictionary new add: associationNotIn ;yourself.
	collectionNotIncluded := {  valueNotIn. valueNotIn  }.
	collectionIncluded := {  (self elementTwiceIn)  }.
	indexArray := #(2 3 1 ).
	valueArray := #(5 5 5 ).
	nonEmpty1Element := self classToBeTested new
		at: #a
			put: 5;
		yourself.
	nonEmptyWithFloat := DODictionary new add: #A->2.5; add: #b->3.5 ; yourself.
	duplicateValue := 2.5.
	dictionaryWithDuplicateValues := 	DODictionary new add: #A->duplicateValue ; add: #b->3.5 ; add: #C->duplicateValue  ; yourself.

! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'damienpollet 1/13/2009 16:55'!
sizeCollection
	^ nonEmptyDict! !

!DODictionaryTest methodsFor: 'requirement' stamp: 'pmaer 5/14/2012 14:08'!
speciesClass
	^ DODictionary! !

!DODictionaryTest methodsFor: 'tests - fixture' stamp: 'pmaer 5/14/2012 14:23'!
test0FixtureOccurrencesTest
	| tmp |
	self shouldnt: [self empty ]raise: Error.
	self assert: self empty isEmpty.

	self shouldnt: [ self collectionWithoutEqualElements ] raise: Error.
	self deny: self collectionWithoutEqualElements isEmpty.
	
	tmp := DOOrderedCollection new.
	self collectionWithoutEqualElements do: [ 
		:each |
		self deny: (tmp includes: each).
		tmp add: each.
		 ].
	
	
	self shouldnt: [ self elementNotInForOccurrences ] raise: Error.
	self deny: (self collectionWithoutEqualElements includes: self elementNotInForOccurrences)! !

!DODictionaryTest methodsFor: 'test - adding' stamp: 'delaunay 5/5/2009 12:08'!
testAdd
	"| dict |
	dict := self emptyDict.
	dict add: #a -> 1.
	dict add: #b -> 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2"
	| dictionary result |
	dictionary := self nonEmptyDict.
	result := dictionary add: self associationWithKeyNotInToAdd.
	self assert: result = self associationWithKeyNotInToAdd! !

!DODictionaryTest methodsFor: 'test - adding' stamp: 'pmaer 5/14/2012 14:08'!
testAddAll
	
	| collectionToAdd collection result oldSize |
	collection := self nonEmptyDict .
	oldSize := collection size.
	collectionToAdd := DODictionary new add: self associationWithKeyAlreadyInToAdd ; add: self associationWithKeyNotInToAdd ; yourself.
	
	result := collection addAll: collectionToAdd .
	
	self assert: result = collectionToAdd .
	"  the association with the key already in should have replaced the oldest :"
	self assert: collection  size = (oldSize + 1).
	
	result associationsDo: [:assoc | self assert: (collection at:  (assoc key) ) = assoc value].! !

!DODictionaryTest methodsFor: 'test - adding' stamp: 'delaunay 5/5/2009 12:08'!
testAddWithKeyAlreadyIn
	| dictionary result association |
	dictionary := self nonEmptyDict.
	association := self associationWithKeyNotInToAdd.
	result := dictionary add: association.
	self assert: result = association.
	self assert: (dictionary at: association key) = association value! !

!DODictionaryTest methodsFor: 'test - adding' stamp: 'delaunay 5/5/2009 12:08'!
testAddWithKeyNotIn
	| dictionary result association |
	dictionary := self nonEmptyDict.
	association := self associationWithKeyNotInToAdd.
	result := dictionary add: association.
	self assert: result = association.
	self assert: (dictionary at: association key) = association value! !

!DODictionaryTest methodsFor: 'test - integrity' stamp: 'pmaer 5/14/2012 14:08'!
testAllDictionariesAreHealthy
	
	self assert: (DODictionary allSubInstances select: [:dict | dict isHealthy not ]) isEmpty.! !

!DODictionaryTest methodsFor: 'test - integrity' stamp: 'IgorStasenko 3/22/2011 16:16'!
testAllMethodDictionariesAreHealthy
	
	self assert: (MethodDictionary allInstances select: [:dict | dict isHealthy not ]) isEmpty.! !

!DODictionaryTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:21'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: DOArray! !

!DODictionaryTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'pmaer 5/14/2012 14:23'!
testAsCommaStringMore

	| result resultAnd index allElementsAsString tmp |
	result:= self nonEmpty asCommaString .
	resultAnd:= self nonEmpty asCommaStringAnd .
	tmp :=DOOrderedCollection new. 
	self nonEmpty do: [ :each | tmp add: each asString].

	"verifying result  :"
	index := 1.
	allElementsAsString := (result findBetweenSubStrs: ', ' ).
	allElementsAsString do:
		[:each |
		self assert: (tmp occurrencesOf: each)=(allElementsAsString occurrencesOf: each).
		].
	
	"verifying esultAnd :"
	allElementsAsString:=(resultAnd findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 ) | i= allElementsAsString size
			ifTrue: [self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self assert: (allElementsAsString at:i)=('and')].
			].! !

!DODictionaryTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:23'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOOrderedCollection! !

!DODictionaryTest methodsFor: 'tests' stamp: 'pmaer 5/14/2012 14:08'!
testAsSet
	"Non regression test for http://bugs.squeak.org/view.php?id=7258"
	
	| aDictionary aSet assoc0 assoc1 |
	
	"Create a dictionary"
	aDictionary := DODictionary new.
	
	"Convert it to a Set"
	aSet := aDictionary asSet.

	"Add two associations to it"	
	assoc0 := #first -> 0.
	assoc1 := #first -> 1.
	aSet add: assoc0 copy; add: assoc1.
	
	"Check if the two associations were added (that should happen if they are different)"
	self
		assert: (assoc0 copy ~= assoc1) ==> (aSet size > 1)
		description:
  			'When adding two different elements, the set size should be greater than one'! !

!DODictionaryTest methodsFor: 'tests - as sorted collection' stamp: 'pmaer 5/14/2012 14:21'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: DOArray).
	self assert: result isSorted.
	self assert: result size = collection size! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testAssociationsDo

	| collection keys |
	collection := self nonEmptyDict .

	keys := DOOrderedCollection new.
	
	collection associationsDo: [ :assoc | 
		keys add: assoc key.
		self assert: ( collection at: assoc key ) = assoc value.		
		].
	
	collection keys do: [:key | self assert: ( keys occurrencesOf: key ) = (collection keys occurrencesOf: key)].! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testAssociationsSelect
	| collection keys result |
	collection := self nonEmptyDict .
	keys := DOOrderedCollection new.
	result := collection associationsSelect: [ :assoc  | 
		keys add: assoc key.
		true].
	
	collection keys do: [ :key | self assert: (collection keys occurrencesOf: key) = (keys occurrencesOf: key)].
	self assert: result = collection.! !

!DODictionaryTest methodsFor: 'tests' stamp: 'pmaer 5/14/2012 14:08'!
testAtIfPresentIfAbsent
	"Test at:ifPresent:ifAbsent:"
	
	"to move to the corresponding trait"
	| dict present absent |
	dict := DODictionary new.
	present := absent := false.
	dict at: #foo ifPresent: [:v| present := true] ifAbsent: [absent := true].
	self deny: present.
	self assert: absent.

	dict at: #foo put: #bar.
	present := absent := false.
	dict at: #foo ifPresent: [:v| present := true] ifAbsent: [absent := true].
	self assert: present.
	self deny: absent.

	present := absent := false.
	dict at: #foo ifPresent: [:v| present := true. nil] ifAbsent: [absent := true].
	self assert: present.
	self deny: absent.
! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testCollect
	| collection values result |
	collection := self nonEmptyDict .
	values := DOOrderedCollection new.
	result := collection collect: [ :value  | 
		values add: value.
		].
	
	collection values do: [ :value | self assert: (collection values occurrencesOf: value) = (values occurrencesOf: value)].
	self assert: result = collection.! !

!DODictionaryTest methodsFor: 'test - adding' stamp: 'pmaer 5/14/2012 14:08'!
testDeclareFrom
	| newDict v dictionary keyIn associationKeyNotIn |
	dictionary := self nonEmptyDict.
	keyIn := dictionary keys anyOne.
	associationKeyNotIn := self associationWithKeyNotInToAdd .
	newDict := DODictionary new add: associationKeyNotIn   ; yourself.
	
	
	
	"if the key already exist, nothing changes"
	v := dictionary  at: keyIn.
	dictionary  declare: keyIn  from: newDict.
	self assert: (dictionary  at: keyIn ) = v.
	
	"if the key does not exist, then it gets removed from newDict and is added to the receiver"
	self nonEmptyDict declare: associationKeyNotIn key from: newDict.
	self assert: (dictionary  at: associationKeyNotIn key) = associationKeyNotIn value.
	self assert: (newDict size = 0)! !

!DODictionaryTest methodsFor: 'test - copying' stamp: 'delaunay 5/6/2009 10:12'!
testDictionaryConcatenationWithoutCommonKeys
	"self run: #testDictionaryConcatenation"
	"| dict1 dict2 dict3 |
	dict1 := self emptyDict.
	dict1 at: #a put: 'Nicolas' ; at: #b put: 'Damien'. 
	
	dict2 := self emptyDict.
	dict2 at: #a put: 'Christophe' ; at: #c put: 'Anthony'.
	dict3 := dict1, dict2.
	
	self assert: (dict3 at: #a) = 'Christophe'.
	self assert: (dict3 at: #b) = 'Damien'.
	self assert: (dict3 at: #c) = 'Anthony'.
	
"
	| dictionary1 dictionary2 result |
	dictionary1 := self nonEmptyDict.
	dictionary2 := self nonEmptyDifferentFromNonEmptyDict.
	result := dictionary1 , dictionary2.
	self assert: result size = (dictionary1 size + dictionary2 size).
	dictionary1 associationsDo: [ :assoc | self assert: (result at: assoc key) = assoc value ].
	dictionary2 associationsDo: [ :assoc | self assert: (result at: assoc key) = assoc value ]! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testDo
	| t collection |
	collection := self nonEmptyDict .
	t := DOOrderedCollection new.
	collection do: [:
		value | t add: value
		].
	
	t do: [ :each | self assert: (t occurrencesOf: each ) = ( collection values occurrencesOf: each) ].! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'pmaer 5/14/2012 14:08'!
testHasBindingThatBeginsWith
	| newDict |
	newDict := DODictionary new at: #abc put: 10; at: #abcd put: 100; at: #def put: 20; yourself.
	self assert: (newDict hasBindingThatBeginsWith: 'ab').
	self assert: (newDict hasBindingThatBeginsWith: 'def').
	self deny: (newDict hasBindingThatBeginsWith: 'defg').! !

!DODictionaryTest methodsFor: 'test - integrity' stamp: 'pmaer 5/14/2012 14:08'!
testHealthyWorks
	"we use associations as keys on purpose, because they changing
	hash depending on the key"
	| a1 a2 dict |
	dict := DODictionary new.
	[a1 := 1 -> 2.
	a2 := 2 -> 2.
	dict at: a1 put: 2;
		 at: a2 put: 3.
	self assert: dict isHealthy.
	a1 key: 0.
	a2 key: 0.
	self assert: dict isHealthy not]
		ensure: [dict removeAll]! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'damienpollet 1/30/2009 17:55'!
testIncludeAssociation
	self assert: (nonEmptyDict includesAssociation: #a -> self elementTwiceIn).
	self assert: (nonEmptyDict includesAssociation: (nonEmptyDict associations first)).
! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'pmaer 5/14/2012 14:08'!
testIncludes
	| o1 o2 newDict |
	self assert: (nonEmptyDict includes: self element).
	
	o1 := 2 @ 3.
	o2 := 2 @ 3.
	self deny: (o1 == o2).
	self assert: (o1 = o2).
	newDict := DODictionary new.
	newDict at: #a put: o1.
	
	self assert: (newDict includes: o2).
! !

!DODictionaryTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAllOfNoneThere
	"self debug: #testIncludesAllOfNoneThere'"
	self deny: (self empty includesAllOf: self collection).
	self deny: (self nonEmpty includesAllOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DODictionaryTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAnyOfNoneThere
	"self debug: #testIncludesAnyOfNoneThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self deny: (self nonEmpty includesAnyOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'pmaer 5/14/2012 14:08'!
testIncludesAssociationNoValue

	| association dictionary |
	
	association := DOAssociation key: #key.
	
	self assert: association value isNil.
	
	dictionary := DODictionary new.
	
	dictionary add: association.
	
	self assert: (dictionary at: #key) isNil

	
	
	! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'pmaer 5/14/2012 14:08'!
testIncludesAssociationWithValue

	| association dictionary |
	
	association := DOAssociation key: #key value: 1.
	dictionary := DODictionary new.
	dictionary add: association.
	
	self assert: (dictionary at: #key) = 1

	
	
	! !

!DODictionaryTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesElementIsNotThere
	"self debug: #testIncludesElementIsNotThere"
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self assert: (self nonEmpty includes: self nonEmpty anyOne).
	self deny: (self empty includes: self elementNotInForOccurrences)! !

!DODictionaryTest methodsFor: 'tests - includes' stamp: 'delaunay 4/9/2009 10:44'!
testIncludesSubstringAnywhere
	"self debug: #testIncludesSubstringAnywher'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: {  (self nonEmpty anyOne)  }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty)! !

!DODictionaryTest methodsFor: '*dynamicownership' stamp: 'pmaer 5/23/2012 16:35'!
testInternalArrayOwnership 

	| d1 d2 d3 d4 t1 |
	self assert: (nonEmptyDict array owner = nonEmptyDict).
	self assert: (nonEmptyWithFloat array owner = nonEmptyWithFloat).
	
	t1:= self classToBeTested new
		at: #a
			put: 5;
		at: #b
			put: 4;
		at: #c
			put: 7;
		at: #d
			put: 6;
		at: #e
			put: 9;
		yourself.
	
	d1:= self classToBeTested newFrom: t1.
	d2:= self classToBeTested newFromPairs: { #a. 1. #b. 2. #c. 3 }.
	d3:= self classToBeTested new.
	d4:= self classToBeTested new: 5.
	

	self assert: (d1 array owner = d1).
	self assert: (d2 array owner = d2).
	self assert: (d3 array owner = d3).
	self assert: (d4 array owner = d4).! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'AlexandreBergel 1/6/2009 13:48'!
testIsDictionary
	self deny: Object new isDictionary.
	self assert: nonEmptyDict isDictionary.
	self assert: emptyDict isDictionary.! !

!DODictionaryTest methodsFor: 'tests - dictionary key access' stamp: 'GabrielOmarCotelli 5/25/2010 21:22'!
testKeyAtIdentityValueIfAbsent
	"self run: #testKeyAtValue"

	"self debug: #testKeyAtValue"

	| dict value result |
	dict := self nonEmpty.
	value := dict values anyOne.
	result := dict keyAtIdentityValue: value ifAbsent: [ nil ].
	self assert: (dict at: result) = value.
	self assert: (dict keyAtIdentityValue: self valueNotIn ifAbsent: [ nil ]) isNil! !

!DODictionaryTest methodsFor: 'tests - dictionary key access' stamp: 'GabrielOmarCotelli 5/25/2010 21:22'!
testKeyAtValueIfAbsent
	"self run: #testKeyAtValue"

	"self debug: #testKeyAtValue"

	| dict value result |
	dict := self nonEmpty.
	value := dict values anyOne.
	result := dict keyAtValue: value ifAbsent: [ nil ].
	self assert: (dict at: result) = value.
	self assert: (dict keyAtValue: self valueNotIn ifAbsent: [ nil ]) isNil! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'damienpollet 1/30/2009 17:57'!
testKeyForIdentity
	self assert: (nonEmptyDict keyForIdentity: 30) = #b.

	"The value 20 is associated to two different associations"
	self assert: (#(a c) includes: (nonEmptyDict keyForIdentity: self elementTwiceIn))! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testKeysAndValuesDo

	
	| collection keys |
	collection := self nonEmptyDict .
	keys := DOOrderedCollection new.
	collection keysAndValuesDo: [ :key :value | 
		keys add: key.
		self assert: (collection at: key) = value ].
	
	collection keys do: [ :key | self assert: (collection keys occurrencesOf: key) = (keys occurrencesOf: key)]! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testKeysDo
	| collection keys |
	collection := self nonEmptyDict .
	keys := DOOrderedCollection new.
	collection keysDo: [ :key  | 
		keys add: key.
		].
	
	collection keys do: [ :key | self assert: (collection keys occurrencesOf: key) = (keys occurrencesOf: key)]! !

!DODictionaryTest methodsFor: 'test - new' stamp: 'delaunay 5/4/2009 14:24'!
testNew
	| d |
	d := self classToBeTested new: 10.
	self assert: d size = 0.
	
	"Why 14? Mysterious"
	"self assert: d capacity = 14"! !

!DODictionaryTest methodsFor: 'tests' stamp: 'pmaer 5/14/2012 14:08'!
testNilHashCollision
	"Ensures that fixCollisionsFrom: does the right thing in the presence of a nil key"
	| dict key |
	dict := DODictionary new.
	key := nil hash. "any key with same hash as nil"
	dict at: key hash put: 1.
	dict at: nil put: 2.
	self assert: (dict includesKey: nil).
	dict removeKey: key.
	self assert: (dict includesKey: nil).
! !

!DODictionaryTest methodsFor: 'test - testing' stamp: 'pmaer 5/14/2012 14:08'!
testOccurrencesOf
	"self run:#testOccurrencesOf" 
	
	| dict |
	dict := DODictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 1.
	dict at: #d put: 3.
	dict at: nil put: nil.
	dict at: #z put: nil.
	
	
	self assert: (dict occurrencesOf: 1 ) = 2.
	self assert: (dict occurrencesOf: nil ) = 2.
	
	
	
	! !

!DODictionaryTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintElementsOn

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printElementsOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).
			].! !

!DODictionaryTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintOn
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i=1
			ifTrue:[
			self accessCollection class name first isVowel 
				ifTrue:[self assert: (allElementsAsString at:i)='an' ]
				ifFalse:[self assert: (allElementsAsString at:i)='a'].].
		i=2
			ifTrue:[self assert: (allElementsAsString at:i)=self accessCollection class name].
		i>2
			ifTrue:[self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).].	
			].! !

!DODictionaryTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintOnDelimiter
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	
	
	self nonEmpty printOn: aStream delimiter: ', ' .
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i))
			].! !

!DODictionaryTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintOnDelimiterLast

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream delimiter: ', ' last: 'and'.
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 )
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self deny: (allElementsAsString at:i)=('and')asString].
		i=(allElementsAsString size)
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
			].! !

!DODictionaryTest methodsFor: 'tests' stamp: 'pmaer 5/14/2012 14:08'!
testRemoveAll
	"Allows one to remove all elements of a collection" 
	
	| dict1 dict2 s2 |
	dict1 := DODictionary new.
	dict1 at: #a put:1 ; at: #b put: 2. 
	dict2 := dict1 copy.
	s2 := dict2 size.
	
	dict1 removeAll.
	
	self assert: dict1 size = 0.
	self assert: dict2 size = s2 description: 'the copy has not been modified'.! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testSelect
	| collection values result |
	collection := self nonEmptyDict .
	values := DOOrderedCollection new.
	result := collection select: [ :value  | 
		values add: value.
		true].
	
	collection values do: [ :value| self assert: (collection values occurrencesOf: value) = (values occurrencesOf: value)].
	self assert: result = collection.! !

!DODictionaryTest methodsFor: 'tests' stamp: 'pmaer 5/14/2012 14:08'!
testSelectIsNotShallowCopy
	"self debug: #testSelectIsNotShallowCopy"
	
	| original even |
	original := DODictionary new.
	original at: #one put: 1.
	original at: #two put: 2.

	even := original select: [:value |value even].
	even at: #two put: 'deux'.

	self assert: (original at: #two) = 2
 	   description: 'modifying a selection should not modify the original'! !

!DODictionaryTest methodsFor: 'tests - set arithmetic' stamp: 'pmaer 5/21/2012 00:16'!
testUnion
	"self debug: #testUnionOfEmpties"
	
	| union |
	union := self empty union: self nonEmpty.
	self containsAll: union of: self empty andOf: self nonEmpty.
	union := self nonEmpty union: self empty.
	self containsAll: union of: self empty andOf: self nonEmpty.
	union := self collection union: self nonEmpty.
	self containsAll: union of: self collection andOf: self nonEmpty.! !

!DODictionaryTest methodsFor: 'tests - dictionnary enumerating' stamp: 'pmaer 5/14/2012 14:23'!
testValuesDo
	| collection values |
	collection := self nonEmptyDict .
	values := DOOrderedCollection new.
	collection valuesDo: [ :value  | 
		values add: value.
		].
	
	collection values do: [ :value | self assert: (collection values occurrencesOf: value) = (values occurrencesOf: value)]! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 5/5/2009 10:41'!
valueNotIn
" return a value not included in nonEmpty "
^valueNotIn ! !

!DODictionaryTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 15:00'!
valueNotInNonEmpty
	" return a value not included in nonEmpty"
	^ valueNotIn ! !

DODictionaryTest subclass: #DOIdentityDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel-Test'!

!DOIdentityDictionaryTest class methodsFor: 'building suites' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^DOTestsCompiler! !

!DOIdentityDictionaryTest class methodsFor: 'building suites' stamp: 'cyrille.delaunay 6/29/2009 11:41'!
shouldInheritSelectors

^true! !

!DOIdentityDictionaryTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:09'!
classToBeTested

	^ DOIdentityDictionary! !

!DOIdentityDictionaryTest methodsFor: 'tests - identity' stamp: 'cyrille.delaunay 6/29/2009 13:21'!
testIdentity
	| dict key |
	dict := self classToBeTested new.
	key := 'key'.
	dict at: key put: 2.5.
	 
	
	self assert: (dict includesKey: key).
	self deny: (dict includesKey: key copy).
	
"	dict at: 1 put: 'djdh'.
	dict at: 'sksl' put: 1.0.
	self deny: (dict includesKey: 1.0) .
	self assert: (dict includes: 1)"
! !

DOCollectionRootTest subclass: #DOOrderedCollectionTest
	uses: TEmptySequenceableTest + TAddTest + TSequencedElementAccessTest + TIncludesWithIdentityCheckTest + TCloneTest + TSetArithmetic + TRemoveForMultiplenessTest + TCreationWithTest + TCopyTest + TPutBasicTest + TIterateSequencedReadableTest + TSubCollectionAccess + TIndexAccess + TCopySequenceableWithReplacement + TCopyPartOfSequenceable + TCopySequenceableSameContents + TCopySequenceableWithOrWithoutSpecificElements - {#testForceToPaddingWith. #testForceToPaddingStartWith} + TPrintOnSequencedTest + TAsStringCommaAndDelimiterSequenceableTest + TConvertTest + TConvertAsSetForMultiplinessIdentityTest + TSequencedConcatenationTest + TBeginsEndsWith + TReplacementSequencedTest + TIndexAccessForMultipliness + TCopyPartOfSequenceableForMultipliness + TConvertAsSortedTest + TPutTest + TSequencedStructuralEqualityTest + TOccurrencesForMultiplinessTest
	instanceVariableNames: 'empty nonEmpty collectResult emptyButAllocatedWith20 otherCollection indexCollection elementExistsTwice collectionWithElement collectionOfFloat elementNotIn indexArray withoutEqualElements floatCollectionWithSameBeginingEnd duplicateElement collectionWithDuplicateElement collection5Elements collectionWith4Elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel-Test'!

!DOOrderedCollectionTest commentStamp: 'BG 1/10/2004 22:07' prior: 0!
These test cases demonstrate addition of items into an OrderedCollection as well as item removal.

Some of the assertions are quite complicated and use a lot of collection protocol. Such methods do not test one single method, but protocol in general.!

DOOrderedCollectionTest class
	uses: TEmptySequenceableTest classTrait + TAddTest classTrait + TSequencedElementAccessTest classTrait + TCloneTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TCreationWithTest classTrait + TRemoveForMultiplenessTest classTrait + TPutBasicTest classTrait + TIterateSequencedReadableTest classTrait + TSubCollectionAccess classTrait + TIndexAccess classTrait + TCopySequenceableWithReplacement classTrait + TCopyPartOfSequenceable classTrait + TCopySequenceableSameContents classTrait + TCopySequenceableWithOrWithoutSpecificElements classTrait + TPrintOnSequencedTest classTrait + TAsStringCommaAndDelimiterSequenceableTest classTrait + TConvertTest classTrait + TSequencedConcatenationTest classTrait + TBeginsEndsWith classTrait + TReplacementSequencedTest classTrait + TIndexAccessForMultipliness classTrait + TCopyPartOfSequenceableForMultipliness classTrait + TConvertAsSortedTest classTrait + TPutTest classTrait + TIncludesWithIdentityCheckTest classTrait + TConvertAsSetForMultiplinessIdentityTest classTrait + TSequencedStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait
	instanceVariableNames: ''!

!DOOrderedCollectionTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:02'!
compilerClass
	^DOTestsCompiler! !

!DOOrderedCollectionTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:13'!
aValue

	^ 33! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/30/2008 19:03'!
accessCollection

	^ indexCollection! !

!DOOrderedCollectionTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:13'!
anIndex

	^ 2! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'stephane.ducasse 11/21/2008 14:57'!
anotherElementNotIn
	^ 42! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:04'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection  anyOne! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:04'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'helpers' stamp: 'stephane.ducasse 1/12/2009 17:19'!
anotherValue

	^ 66! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'cyrille.delaunay 12/18/2009 13:03'!
collection

	^ collectionWith4Elements! !

!DOOrderedCollectionTest methodsFor: 'test - creation' stamp: 'pmaer 5/14/2012 14:23'!
collectionClass 
	
	^ DOOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:00'!
collectionInForIncluding
	^ self nonEmpty copyWithoutFirst.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 15:16'!
collectionMoreThan1NoDuplicates
	" return a collection of size 5 without equal elements"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 13:59'!
collectionMoreThan5Elements
" return a collection including at least 5 elements"
	
	^collection5Elements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
collectionNotIncluded
	^ DOOrderedCollection new add: elementNotIn ; add: elementNotIn ; yourself.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 10:56'!
collectionOfFloat
	^ collectionOfFloat ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
collectionWith1TimeSubcollection
" return a collection including 'oldSubCollection'  only one time "
	^ ((DOOrderedCollection new add: elementNotIn; yourself),self oldSubCollection) add: elementNotIn;yourself   ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
collectionWith2TimeSubcollection
" return a collection including 'oldSubCollection'  two or many time "
	^ (((DOOrderedCollection new add: elementNotIn; yourself),self oldSubCollection ) add: elementNotIn;yourself),self  oldSubCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/22/2009 10:21'!
collectionWith5Elements
" return a collection of size 5 including 5 elements"
^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
collectionWithCopy
	"return a collection of type 'self collectionWIithoutEqualsElements clas' containing no elements equals ( with identity equality)
	but  2 elements only equals with classic equality"
	| result collection |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	collection add: collection first copy.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 10:22'!
collectionWithCopyNonIdentical
	" return a collection that include elements for which 'copy' return a different object (this is not the case of SmallInteger)"
	^ collectionOfFloat! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'sd 1/28/2009 16:29'!
collectionWithElement
	"Returns a collection that already includes what is returned by #element."
	^ collectionWithElement! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:22'!
collectionWithElementsToRemove
	^ nonEmpty copyWithoutFirst.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:10'!
collectionWithEqualElements
" return a collecition including atLeast two elements equal"

^collectionWithDuplicateElement ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
collectionWithIdentical
	"return a collection of type : 'self collectionWIithoutEqualsElements class containing two elements equals ( with identity equality)"
	| result collection element |
	collection := DOOrderedCollection withAll: self elementsCopyNonIdenticalWithoutEqualElements.
	element := collection first.
	collection add: element.
	result := self elementsCopyNonIdenticalWithoutEqualElements class withAll: collection.
	^ result! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:16'!
collectionWithNonIdentitySameAtEndAndBegining
	" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingEnd ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/22/2009 11:14'!
collectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals .
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingEnd ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 10:24'!
collectionWithSortableElements
" return a collection elements that can be sorte ( understanding message ' < '  or ' > ')"
	^ collectionOfFloat ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:00'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:35'!
collectionWithoutEqualsElements

" return a collection not including equal elements "
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 11:17'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'StephaneDucasse 5/15/2011 17:27'!
element
	"Returns an object that can be added to the collection returned by #collection."
	^ 3! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:03'!
elementInCollectionOfFloat
	^ collectionOfFloat anyOne.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:42'!
elementInForElementAccessing
" return an element inculded in 'accessCollection '"
	^ self accessCollection anyOne! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:03'!
elementInForIncludesTest
" return an element included in nonEmpty "
	^ self nonEmpty anyOne! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 13:27'!
elementInForIndexAccessing

^ self accessCollection  anyOne.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:02'!
elementNotIn
	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:42'!
elementNotInForElementAccessing
" return an element not included in 'accessCollection' "
	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:32'!
elementNotInForIndexAccessing

	^ elementNotIn ! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
elementNotInForOccurrences
	^ 666! !

!DOOrderedCollectionTest methodsFor: 'test - copy' stamp: 'delaunay 4/17/2009 15:26'!
elementToAdd
	^ 55! !

!DOOrderedCollectionTest methodsFor: 'test - remove' stamp: 'damienpollet 1/30/2009 17:16'!
elementTwiceIn
	^ super elementTwiceIn! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:10'!
elementTwiceInForOccurrences
" return an element included exactly two time in # collectionWithEqualElements"
^ duplicateElement ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 13:46'!
elementsCopyNonIdenticalWithoutEqualElements
	" return a collection that does niot incllude equal elements ( classic equality )"
	^ collectionOfFloat! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'stephane.ducasse 10/5/2008 12:10'!
empty
	
	^ empty! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'stephane.ducasse 10/6/2008 16:29'!
emptyButAllocatedWith20 

	^ emptyButAllocatedWith20! !

!DOOrderedCollectionTest methodsFor: 'test - iterate' stamp: 'luc.fabresse 11/29/2008 23:09'!
expectedSizeAfterReject
	^1! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:12'!
firstCollection
" return a collection that will be the first part of the concatenation"
	^ nonEmpty 	! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:41'!
firstIndex
" return an index between 'nonEmpty' bounds that is < to 'second index' "
	^1! !

!DOOrderedCollectionTest methodsFor: 'tests - copying with replacement' stamp: 'pmaer 5/14/2012 14:23'!
firstIndexesOf: subCollection in: collection
" return an OrderedCollection with the first indexes of the occurrences of subCollection in  collection "
	| tmp result currentIndex |
	tmp:= collection.
	result:= DOOrderedCollection new.
	currentIndex := 1.
	
	[tmp isEmpty ]whileFalse:
		[
		(tmp beginsWith: subCollection)
			ifTrue: [ 	
				result add: currentIndex.
				1 to: subCollection size do: 
					[:i | 
					tmp := tmp copyWithoutFirst.
					currentIndex := currentIndex + 1]
				]
			ifFalse: [
				tmp := tmp copyWithoutFirst.
				currentIndex := currentIndex +1.
				]
		 ].
	
	^ result.
	! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/21/2009 13:48'!
floatCollectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals only with classic equality (they are not the same object).
(others elements of the collection are not equal to those elements)"
	^ floatCollectionWithSameBeginingEnd ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:49'!
indexArray
	^ indexArray .! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:35'!
indexInForCollectionWithoutDuplicates
" return an index between 'collectionWithoutEqualsElements'  bounds"
	^ 2! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:44'!
indexInNonEmpty
" return an index between bounds of 'nonEmpty' "

	^ 2! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 14:37'!
integerCollection
" return a collection only including SmallInteger elements"
	^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:01'!
integerCollectionWithoutEqualElements
" return a collection of integer without equal elements"
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:52'!
moreThan3Elements
	" return a collection including atLeast 3 elements"
	^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:52'!
moreThan4Elements

" return a collection including at leat 4 elements"
	^ indexCollection ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:42'!
newElement
"return an element that will be put in the collection in place of another"
	^999! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'stephane.ducasse 10/5/2008 12:10'!
nonEmpty
	
	^ nonEmpty! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^ DOOrderedCollection new add:( self nonEmpty anyOne); yourself.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/23/2009 14:05'!
nonEmptyMoreThan1Element
" return a collection with more than one element"
	^ withoutEqualElements  .! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 11:29'!
nonEmptyWithoutEqualElements
" return a collection without equal elements "
	^ withoutEqualElements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 13:38'!
oldSubCollection
" return a subCollection included in collectionWith1TimeSubcollection .
ex :   subCollection := #( 2 3 4) and collectionWith1TimeSubcollection := #(1 2 3 4 5)"
	^ nonEmpty ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/8/2008 16:04'!
otherCollection
	^ otherCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:09'!
replacementCollection
" return a collection that will be used to replace 'oldSubcollection' in ' collectionWith1TimeSubcollection'  " 
	^ collectionWith4Elements! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:23'!
replacementCollectionSameSize
" return a collection of size (secondIndex - firstIndex + 1)"

| res |
res := DOOrderedCollection new.
1 to: (self secondIndex - self firstIndex + 1) do:
	[
	:i |
	res add: 99.
	].
	^res.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 12:05'!
result

^ collectResult ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:11'!
secondCollection
" return a collection that will be the second part of the concatenation"
	^ collectionWith4Elements ! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 15:42'!
secondIndex
" return an index between 'nonEmpty' bounds that is > to 'second index' "
	^2! !

!DOOrderedCollectionTest methodsFor: 'parameters' stamp: 'stephane.ducasse 10/5/2008 12:38'!
selectorToAccessValuePutIn
	"return the selector of the method that should be invoked to access an element"
	
	^ #first! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'pmaer 5/14/2012 14:23'!
setUp

	
	nonEmpty := DOOrderedCollection new  add: self valuePutIn; add: self elementTwiceIn; add: self elementTwiceIn; yourself.
	empty := DOOrderedCollection new. 
	elementNotIn := 99.
	collectionWith4Elements := DOOrderedCollection new add: 1; add: -2; add: 3; add: 1; yourself.
	indexArray := { 3. 1.}.
	indexCollection := DOOrderedCollection new add: 1; add: 2;add: 3; add: 4; add:5;  yourself.
	otherCollection := DOOrderedCollection new add: 1;add: 20; add: 30; yourself.
	withoutEqualElements := DOOrderedCollection new add: 1;add: 20; add: 30; yourself.
	collectResult := DOOrderedCollection new add: SmallInteger; add: SmallInteger; add: SmallInteger; yourself.
	emptyButAllocatedWith20 := DOOrderedCollection new: 20. 
	collectionWithElement := DOOrderedCollection new add: self element; yourself.
	collectionOfFloat := DOOrderedCollection new add: 4.1; add: 7.2; add: 2.5; yourself.
	floatCollectionWithSameBeginingEnd := DOOrderedCollection new add: 4.1; add: 7.2; add: 4.1 copy ; yourself.
	duplicateElement := 2.
	collectionWithDuplicateElement := DOOrderedCollection new add: duplicateElement ; add: duplicateElement ; add:4 ; yourself.	

	collection5Elements := DOOrderedCollection new add: 1; add: 2;  add: 3;  add: 4;  add: 5; yourself.! !

!DOOrderedCollectionTest methodsFor: 'setup' stamp: 'cyrille.delaunay 12/18/2009 13:09'!
sizeCollection

	^ collectionWith4Elements! !

!DOOrderedCollectionTest methodsFor: 'test - iterate' stamp: 'pmaer 5/14/2012 14:23'!
speciesClass
	
	^ DOOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 11:02'!
subCollectionNotIn

	^ self collectionNotIncluded .! !

!DOOrderedCollectionTest methodsFor: 'tests - fixture' stamp: 'pmaer 5/14/2012 14:23'!
test0FixtureOccurrencesTest
	| tmp |
	self shouldnt: [self empty ]raise: Error.
	self assert: self empty isEmpty.

	self shouldnt: [ self collectionWithoutEqualElements ] raise: Error.
	self deny: self collectionWithoutEqualElements isEmpty.
	
	tmp := DOOrderedCollection new.
	self collectionWithoutEqualElements do: [ 
		:each |
		self deny: (tmp includes: each).
		tmp add: each.
		 ].
	
	
	self shouldnt: [ self elementNotInForOccurrences ] raise: Error.
	self deny: (self collectionWithoutEqualElements includes: self elementNotInForOccurrences)! !

!DOOrderedCollectionTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/28/2009 14:11'!
test0FixtureTConvertAsSetForMultiplinessTest
	"a collection ofFloat with equal elements:"
	| res |
	self 
		shouldnt: [ self withEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self withEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self withEqualElements 
		detect: [ :each | (self withEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = true.

	"a collection of Float without equal elements:"
	self 
		shouldnt: [ self elementsCopyNonIdenticalWithoutEqualElements ]
		raise: Error.
	self 
		shouldnt: 
			[ self elementsCopyNonIdenticalWithoutEqualElements do: [ :each | self assert: each class = Float ] ]
		raise: Error.
	res := true.
	self elementsCopyNonIdenticalWithoutEqualElements 
		detect: 
			[ :each | 
			(self elementsCopyNonIdenticalWithoutEqualElements occurrencesOf: each) > 1 ]
		ifNone: [ res := false ].
	self assert: res = false! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 19:00'!
testAdd
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 88.
	self assert: (l =  #(1 2 3 4 88) asOrderedCollection).
	l add: 99.
	self assert: (l =  #(1 2 3 4 88 99) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:52'!
testAddAfter

	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 88 after: 1.
	self assert: (l =  #(1 88 2 3 4) asOrderedCollection).
	l add: 99 after: 2.
	self assert: (l =  #(1 88 2 99 3 4) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'testing-public methods' stamp: 'StephaneDucasse 3/22/2010 21:18'!
testAddAfterIndex
	"self run: #testAddAfterIndex"
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 77 afterIndex: 0.
	self assert: (l =  #(77 1 2 3 4) asOrderedCollection).
	l add: 88 afterIndex: 2.
	self assert: (l =  #(77 1 88 2 3 4) asOrderedCollection). 
	l add: 99 afterIndex: l size.
	self assert: (l =  #(77 1 88 2 3 4 99) asOrderedCollection). 
	self should:[l add: 666 afterIndex: -1] raise: Error.
	self should:[l add: 666 afterIndex: l size+1] raise: Error.
	
	"Now make room by removing first two and last two elements,
	and see if the illegal bounds test still fails"
	(l first: 2) , (l last: 2) reversed do: [:e | l remove: e].
	self should: [l add: 666 afterIndex: -1] raise: Error.
	self should: [l add: 666 afterIndex: l size+1] raise: Error.! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAll
	"Allows one to add each element of an orderedCollection at the end of another
	orderedCollection "
	"self run:#testAddAll" 
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c1 addAll: c2.
	self assert: c1 = #(1 2 3 4 5 6 7 8 9) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAllFirst
	"Allows one to add each element of an orderedCollection at the beginning of another
	orderedCollection "
	"self run:#testAddAllFirst" 
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c2 addAllFirst: c1.
	self assert: c2 = #(1 2 3 4 5 6 7 8 9) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAllFirstUnlessAlreadyPresent
	"Allows one to add each element of an orderedCollection at the beginning of
	another orderedCollection preserving the order but no duplicate element"
	"self run:#testAddAllFirstUnlessAlreadyPresent" 
	
	| c1 c2 c3 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c3 := #(0 1 ) asOrderedCollection.
	c2 addAllFirstUnlessAlreadyPresent: c1.
	self assert: c2 = #(1 2 3 4 5 6 7 8 9 ) asOrderedCollection.
	c1 addAllFirstUnlessAlreadyPresent: c3.
	self deny: c1 = #(0 1 1 2 3 4 ) asOrderedCollection.
	self assert: c1 = #(0 1 2 3 4 ) asOrderedCollection.
	! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:36'!
testAddAllLast
	"Allows one to add each element of an orderedCollection at the beginning of another
	orderedCollection "
	"self run:#testAddAllLast" 
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := #(5 6 7 8 9 ) asOrderedCollection.
	c1 addAllLast: c2.
	self assert: c1 = #(1 2 3 4 5 6 7 8 9) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:57'!
testAddBefore

	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 88 before: 1.
	self assert: (l =  #(88 1 2 3 4) asOrderedCollection).
	l add: 99 before: 2.
	self assert: (l =  #(88 1 99 2 3 4) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 13:42'!
testAddBeforeAndRemove

	| l initialCollection |
	l := #(1 2 3 4) asOrderedCollection.
	initialCollection := l shallowCopy.
	l add: 88 before: 1.
	self assert: (l =  #(88 1 2 3 4) asOrderedCollection).
	l add: 99 before: 2.
	self assert: (l =  #(88 1 99 2 3 4) asOrderedCollection). 
	l remove: 99.
	l remove: 88.
	self assert: l = initialCollection.

! !

!DOOrderedCollectionTest methodsFor: 'testing-public methods' stamp: 'StephaneDucasse 3/22/2010 21:17'!
testAddBeforeIndex
	"self run: #testAddBeforeIndex"
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l add: 77 beforeIndex: 1.
	self assert: (l =  #(77 1 2 3 4) asOrderedCollection).
	l add: 88 beforeIndex: 3.
	self assert: (l =  #(77 1 88 2 3 4) asOrderedCollection). 
	l add: 99 beforeIndex: l size+1.
	self assert: (l =  #(77 1 88 2 3 4 99) asOrderedCollection). 
	self should:[l add: 666 beforeIndex: 0] raise: Error.
	self should:[l add: 666 beforeIndex: l size+2] raise: Error.
	
	"Now make room by removing first two and last two elements,
	and see if the illegal bounds test still fails"
	(l first: 2) , (l last: 2) reversed do: [:e | l remove: e].
	self should:[l add: 666 beforeIndex: 0] raise: Error.
	self should:[l add: 666 beforeIndex: l size+2] raise: Error.

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 13:43'!
testAddDuplicateItem1
	| collection |
	collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	collection add: 'John' before: 'John'.
	self
		assert: ((collection asBag occurrencesOf: 'John')
					= 2
				and: [(collection at: (collection indexOf: 'John')
							+ 1)
						= (collection
								at: (collection indexOf: 'John'))])! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:58'!
testAddFirst
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l addFirst: 88.
	self assert: (l =  #(88 1 2 3 4) asOrderedCollection).
	l addFirst: 99.
	self assert: (l =  #(99 88 1 2 3 4) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 6/5/2005 09:21'!
testAddItem1

   | collection size |
   collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
   size := collection size.
   collection add: 'James' before: 'Jim'.
   collection add: 'Margaret' before: 'Andrew'.
   self assert: size + 2 = collection size.
! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 19:07'!
testAddItem2
	| collection |
	collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	collection add: 'James' before: 'Jim'.
	collection add: 'Margaret' before: 'Andrew'.
	self assert: (collection indexOf: 'James')
			+ 1
			= (collection indexOf: 'Jim').
	self assert: (collection indexOf: 'Margaret')
			+ 1
			= (collection indexOf: 'Andrew')! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'zz 12/7/2005 18:59'!
testAddLast
	| l |
	l := #(1 2 3 4) asOrderedCollection.
	l addLast: 88.
	self assert: (l =  #(1 2 3 4 88) asOrderedCollection).
	l addLast: 99.
	self assert: (l =  #(1 2 3 4 88 99) asOrderedCollection). 

! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testAllButFirstDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButFirstDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i +1))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testAllButLastDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  allButLastDo: [:each | result add: each].
	
	1 to: (result size) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:(i ))=(result at:i)].
	
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOOrderedCollectionTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:21'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: DOArray! !

!DOOrderedCollectionTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:23'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:10'!
testAsSet
	| |
	"test with a collection without equal elements :"
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOSet.
	! !

!DOOrderedCollectionTest methodsFor: 'tests - as set tests' stamp: 'pmaer 5/14/2012 14:10'!
testAsSetWithEqualsElements
	| result |
	result := self withEqualElements asSet.
	self withEqualElements do: [ :each | self assert: (result occurrencesOf: each) = 1 ].
	self assert: result class = DOSet! !

!DOOrderedCollectionTest methodsFor: 'tests - as sorted collection' stamp: 'pmaer 5/14/2012 14:21'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: DOArray).
	self assert: result isSorted.
	self assert: result size = collection size! !

!DOOrderedCollectionTest methodsFor: 'tests - accessing' stamp: 'zz 12/7/2005 18:50'!
testAt
	| collection |
	collection := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	self assert: (collection at:1) = 'Jim'.
	self assert: (collection at:2) = 'Mary'! !

!DOOrderedCollectionTest methodsFor: 'tests - adding' stamp: 'sd 3/21/2006 22:37'!
testAtIfAbsentPut
	"Allows one to add an element at an index if no element exist at this index"
	"self run:#testAtIfAbsentPut" 
	
	| c |
	c := #(1 2 3 4 ) asOrderedCollection.
	self
		shouldnt: [c at: 2 ifAbsentPut: [5]]
		raise: Error.
	self assert: c = #(1 2 3 4 ) asOrderedCollection.
	c at: 5 ifAbsentPut: [5].
	self assert: c = #(1 2 3 4 5 ) asOrderedCollection.
	c at: 7 ifAbsentPut: [7].
	self assert: c = #(1 2 3 4 5 nil 7 ) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - accessing' stamp: 'sd 3/21/2006 22:38'!
testAtPut
	"Allows one to replace an element but not at an off range index"
	"self run:#testAtPut"
	| c |
	c := #(1 2 3 4 ) asOrderedCollection.
	c at: 2 put: 5.
	self assert: c = #(1 5 3 4 ) asOrderedCollection.
	self
		should: [c at: 5 put: 8]
		raise: Error.
	self deny: c = #(1 5 3 4 8 ) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests begin ' stamp: 'pmaer 5/14/2012 14:23'!
testBeginsWithAnyOf
	"We can't test SequenceableCollection directly. However, we can test a sampling of its descendants."
	"self debug: #testBeginsWithAnyOf"
	
	| la oc |
	la := #(1 2 3 4 5 6).
	oc := DOOrderedCollection new.
	oc add: 1; add: 2; add: 3.
	
	self assert: (la beginsWithAnyOf: #((17) (1) (42))).
	self assert: (la beginsWithAnyOf: #((17) (1 2) (42))).
	self assert: (la beginsWithAnyOf: #((17) (1 2 3) (42))).
	self deny: (la beginsWithAnyOf: #()).
	self deny: (la beginsWithAnyOf: #(())).
	self deny: (la beginsWithAnyOf: #((42))).! !

!DOOrderedCollectionTest methodsFor: 'tests - accessing' stamp: 'pmaer 5/14/2012 14:23'!
testCapacityFromAsOrderedCollection
	"Allows one to check the current capacity of an Ordered collection"
	"self run:#testCapacityFromAsOrderedCollection"
	
	| c1 c2 c3 |
	c1 := #(1 2 ) asOrderedCollection.
	self assert: (c1 capacity =  2).
	c2 := DOOrderedCollection new: 10.
	c2 add: 3.
	self assert: (c2 capacity = 10).	
	c3 := DOOrderedCollection new.
	self deny: (c3 capacity =  0).
	! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'sd 3/21/2006 22:41'!
testCollect
	"Allows one to collect some element of a collection into another collection"
	"self run: #testCollect"
	 
	| c1 c2 res |
	c1 := #(-1 2 -3 4) asOrderedCollection.
	c2 := #(1 2 3 4) asOrderedCollection.
	res := c1 collect: [:each | each abs].
	self assert: (c2 = res).! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'cm 3/8/2006 09:09'!
testCollectFromTo
	"Allows one to collect some element of a collection into another collection between a first index and an end index for the collect"
	"self run: #testCollectFromTo"
	
	| c1 res |
	c1 := #(-1 2 -3 4 -5 6 -7 8) asOrderedCollection.
	res := c1 collect: [:each | each abs] from: 1 to: 3.
	self assert: (res = #(1 2 3) asOrderedCollection).
	self should: [c1 collect: [:each | each abs] from: 10 to: 13] raise: Error.
	self should: [c1 collect: [:each | each abs] from: 5 to: 2] raise: Error.! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'stephane.ducasse 1/12/2009 15:02'!
testCopyEmptyOld
	"Allows one to create a copy of the receiver that contains no elements"
	"self run:#testCopyEmpty"
	
	| c1 c2 |
	c1 := #(1 2 3 4 ) asOrderedCollection.
	c2 := c1 copyEmpty.
	self assert: (c2 size = 0).! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'sd 3/21/2006 22:41'!
testCopyFromTo
	"Allows one to create a copy of the receiver that contains elements from position start to end"
	"self run: #testCopyFromTo"
	
	| c1 c2 c3 | 
	c1 := #(1 2 3 4) asOrderedCollection.
	c2 := (c1 copyFrom: 1 to: 2).
	self assert: c2 = #(1 2) asOrderedCollection.
	self should: [c1 copyFrom: 10 to: 20] raise: Error.
	
	c3 := c1 copyFrom: 4 to: 2.
	self assert: c3 isEmpty.
	
	self should: [c1 copyFrom: 4 to: 5 ] raise: Error.
	
	
	
! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 3/30/2009 10:33'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!DOOrderedCollectionTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'sd 3/21/2006 22:41'!
testCopyReplaceFromToWith
	"Allows one to create a copy from the receiver which elements between start and end of the 	receiver being replace by 	element of the collection after with:"
	"self run:#testCopyReplaceFromToWith"

	| c1 c2 c3 c4 |
	c1 := #(1 2 3 4) asOrderedCollection.
	c2 := #(5 6 7 8 9) asOrderedCollection.
	c3 := (c2 copyReplaceFrom: 1 to: 2 with: c1).
	self assert: c3 = #(1 2 3 4 7 8 9) asOrderedCollection.
	self should: [c2 copyReplaceFrom: 3 to: 1 with: c1] raise: Error.
	
	c4 := (c2 copyReplaceFrom: 10 to: 25 with: c1).
	self assert: c4 = #(5 6 7 8 9 1 2 3 4) asOrderedCollection.
	
	! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'sd 3/21/2006 22:41'!
testCopyWith
	"Allows one to create a copy of the receiver that contains the new element at the end"
	"self run: #testCopyWith"
	
	| c1 | 
	c1 := #(1 2 3 4) asOrderedCollection.
	c1 := c1 copyWith: 6.
	self assert: c1 = #(1 2 3 4 6) asOrderedCollection.
	
	

	
	
	
! !

!DOOrderedCollectionTest methodsFor: 'tests begin ' stamp: 'pmaer 5/14/2012 14:23'!
testEndsWithAnyOf
	"We can't test SequenceableCollection directly. However, we can test a sampling of its descendants."
	"self debug: #testEndsWithAnyOf"
	| la oc |
	la := #(6 5 4 3 2 1).
	oc := DOOrderedCollection new.
	oc add: 3; add: 2; add: 1.
	
	self assert: (la endsWithAnyOf: #((17) (1) (42))).
	self assert: (la endsWithAnyOf: #((17) (2 1) (42))).
	self assert: (la endsWithAnyOf: #((17) (3 2 1) (42))).
	self deny: (la endsWithAnyOf: #()).
	self deny: (la endsWithAnyOf: #(())).
	self deny: (la endsWithAnyOf: #((42))).! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testFromToDo
	
	| result |
	result:= DOOrderedCollection  new.
	
	self nonEmptyMoreThan1Element  from: 1 to: (self nonEmptyMoreThan1Element  size -1) do: [:each | result add: each].
	
	1 to: (self nonEmptyMoreThan1Element  size -1) do:
		[:i|
		self assert: (self nonEmptyMoreThan1Element  at:i )=(result at:i)].
	self assert: result size=(self nonEmptyMoreThan1Element  size-1).! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/28/2009 10:22'!
testIdentityIncludes
	" test the comportement in presence of elements 'includes' but not 'identityIncludes' "
	" can not be used by collections that can't include elements for wich copy doesn't return another instance "
	| collection element |
	self 
		shouldnt: [ self collectionWithCopyNonIdentical ]
		raise: Error.
	collection := self collectionWithCopyNonIdentical.
	element := collection anyOne copy.
	"self assert: (collection includes: element)."
	self deny: (collection identityIncludes: element)! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIdentityIndexOf
	"self debug: #testIdentityIndexOf"
	| collection element |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection identityIndexOf: element) = (collection indexOf: element)! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIdentityIndexOfIAbsent
	| collection element |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			identityIndexOf: element
			ifAbsent: [ 0 ]) = 1.
	self assert: (collection 
			identityIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 55 ]) = 55! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAllOfNoneThere
	"self debug: #testIncludesAllOfNoneThere'"
	self deny: (self empty includesAllOf: self collection).
	self deny: (self nonEmpty includesAllOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAnyOfNoneThere
	"self debug: #testIncludesAnyOfNoneThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self deny: (self nonEmpty includesAnyOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesElementIsNotThere
	"self debug: #testIncludesElementIsNotThere"
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self assert: (self nonEmpty includes: self nonEmpty anyOne).
	self deny: (self empty includes: self elementNotInForOccurrences)! !

!DOOrderedCollectionTest methodsFor: 'tests - includes' stamp: 'delaunay 4/9/2009 10:44'!
testIncludesSubstringAnywhere
	"self debug: #testIncludesSubstringAnywher'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: {  (self nonEmpty anyOne)  }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty)! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOf
	"self debug: #testIndexOf"
	| tmp index collection |
	collection := self collectionMoreThan1NoDuplicates.
	tmp := collection size.
	collection reverseDo: 
		[ :each | 
		each = self elementInForIndexAccessing ifTrue: [ index := tmp ].
		tmp := tmp - 1 ].
	self assert: (collection indexOf: self elementInForIndexAccessing) = index! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| collection |
	collection := self collectionMoreThan1NoDuplicates.
	self assert: (collection 
			indexOf: collection first
			ifAbsent: [ 33 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 33 ]) = 33! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			indexOf: element
			startingAt: 2
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			indexOf: element
			startingAt: 1
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			indexOf: self elementNotInForIndexAccessing
			startingAt: 1
			ifAbsent: [ 99 ]) = 99! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAt
	"self debug: #testIndexOfIfAbsent"
	| subcollection index collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1.
	self assert: index = 1.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2.
	self assert: index = 0! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testIndexOfSubCollectionStartingAtIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| index absent subcollection collection |
	collection := self collectionMoreThan1NoDuplicates.
	subcollection := self collectionMoreThan1NoDuplicates.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 1
		ifAbsent: [ absent := true ].
	self assert: absent = false.
	absent := false.
	index := collection 
		indexOfSubCollection: subcollection
		startingAt: 2
		ifAbsent: [ absent := true ].
	self assert: absent = true! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'sd 6/5/2005 09:21'!
testIndexOfWithDuplicates

   | collection indices bagOfIndices |
   collection := #('Jim' 'Mary' 'John' 'Andrew' 'Mary' 'John' 'Jim' 'Micheal') asOrderedCollection.
   indices := collection collect: [:item | collection indexOf: item].
   self assert: indices asSet size = collection asSet size.
   bagOfIndices := indices asBag.
   self assert: (indices asSet 
                    allSatisfy: [:index | (bagOfIndices occurrencesOf: index)
	                                       = (collection occurrencesOf: (collection at: index))]).

  "  indexOf:  returns the index of the first occurrence of an item.
     For an item with n occurrences, the index of its first occurrence
     is found  n  times. "! !

!DOOrderedCollectionTest methodsFor: '*dynamicownership' stamp: 'pmaer 5/23/2012 16:23'!
testInternalArrayOwnership
	
	| c1 c2 c3 c4 c5 c6 c7 c8 c9 c10 c11 c12 c13 c14 |
	c1:= DOOrderedCollection new.
	c2:= DOOrderedCollection new: 5.
	c3:= DOOrderedCollection new: 5 withAll: collection5Elements.
	c4:= DOOrderedCollection newFrom: collection5Elements.
	c5:= DOOrderedCollection ofSize: 10.
	c6:= DOOrderedCollection with: 2.
	c7:= DOOrderedCollection with: 3 with: 4.
	c8:= DOOrderedCollection with: 3 with: 4.
	c9:= DOOrderedCollection with: 3 with: 4 with: 5.
	c10:= DOOrderedCollection with: 3 with: 4 with: 5 with: 6.
	c11:= DOOrderedCollection with: 3 with: 4 with: 5 with: 6 with: 7.
	c12:= DOOrderedCollection with: 3 with: 4 with: 5 with: 6 with: 7 with: 8.
	c13:= DOOrderedCollection withAll: collection5Elements.
	c14 := DOOrderedCollection  new: collection5Elements size 
						streamContents: [ :stream |
 								collection5Elements do: [ :each | stream nextPut: each ] ].
	
	
	self assert: (c1 array owner = c1).
	self assert: (c2 array owner = c2).
	self assert: (c3 array owner = c3).
	self assert: (c4 array owner = c4).
	self assert: (c5 array owner = c5).
	self assert: (c6 array owner = c6).
	self assert: (c7 array owner = c7).
	self assert: (c8 array owner = c8).
	self assert: (c9 array owner = c9).
	self assert: (c10 array owner = c10).
	self assert: (c11 array owner = c11).
	self assert: (c12 array owner = c12).
	self assert: (c13 array owner = c13).
	self assert: (c14 array owner = c14).! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testKeysAndValuesDo
	"| result |
	result:= OrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	1 to: result size do:
		[:i|
		self assert: (result at:i)=((self nonEmptyMoreThan1Element at:i)+i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  keysAndValuesDo: 
		[:i :value|
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	
	! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testKeysAndValuesDoEmpty
	| result |
	result:= DOOrderedCollection new.
	
	self empty  keysAndValuesDo: 
		[:i :value|
		result add: (value+i)].
	
	self assert: result isEmpty .! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOf
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection lastIndexOf: element) = 1.
	self assert: (collection lastIndexOf: self elementNotInForIndexAccessing) = 0! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfIfAbsent
	"self debug: #testIndexOfIfAbsent"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection first.
	self assert: (collection 
			lastIndexOf: element
			ifAbsent: [ 99 ]) = 1.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			ifAbsent: [ 99 ]) = 99! !

!DOOrderedCollectionTest methodsFor: 'tests - index access' stamp: 'delaunay 4/23/2009 15:14'!
testLastIndexOfStartingAt
	"self debug: #testLastIndexOf"
	| element collection |
	collection := self collectionMoreThan1NoDuplicates.
	element := collection last.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size
			ifAbsent: [ 99 ]) = collection size.
	self assert: (collection 
			lastIndexOf: element
			startingAt: collection size - 1
			ifAbsent: [ 99 ]) = 99.
	self assert: (collection 
			lastIndexOf: self elementNotInForIndexAccessing
			startingAt: collection size
			ifAbsent: [ 99 ]) = 99! !

!DOOrderedCollectionTest methodsFor: 'testsRemoving' stamp: 'nice 9/14/2009 20:57'!
testRemoveAll
	"Allows one to remove all elements of a collection" 
	
	| c1 c2 s2 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 addAll: (1 to: 200).
	c2 := c1 copy.
	s2 := c2 size.
	
	c1 removeAll.
	
	self assert: c1 size = 0.
	self assert: c2 size = s2 description: 'the copy has not been modified'
	! !

!DOOrderedCollectionTest methodsFor: 'tests - remove' stamp: 'nice 1/5/2010 15:59'!
testRemoveAllError
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self elementNotIn.
	subCollection := self nonEmptyWithoutEqualElements copyWith: el.
	self 
		should: [ | res | res := self nonEmptyWithoutEqualElements removeAll: subCollection ]
		raise: Error! !

!DOOrderedCollectionTest methodsFor: 'tests - remove' stamp: 'nice 1/5/2010 15:59'!
testRemoveAllFoundIn
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self nonEmptyWithoutEqualElements anyOne.
	subCollection := (self nonEmptyWithoutEqualElements copyWithout: el) copyWith: self elementNotIn.
	self 
		shouldnt: 
			[ | res | res := self nonEmptyWithoutEqualElements removeAllFoundIn: subCollection ]
		raise: Error.
	self assert: self nonEmptyWithoutEqualElements size = 1.
	self nonEmptyWithoutEqualElements do: [ :each | self assert: each = el ]! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'zz 12/7/2005 19:05'!
testRemoveAllSuchThat
	| collection |
	collection := (1 to: 10) asOrderedCollection.
	collection
		removeAllSuchThat: [:e | e even].
	self assert: collection = (1 to: 10 by: 2) asOrderedCollection! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'sd 3/21/2006 22:39'!
testRemoveAt
	"Allows one to remove an element from a collection at an index"
	"self run:#testRemoveAt" 
	
	| c1 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 removeAt: 2.
	self assert: (c1 = #(2 4 6) asOrderedCollection).
	self should: [c1 removeAt: 10] raise: Error.
	self should: [c1 removeAt: -1] raise: Error.
	! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'sd 3/21/2006 22:39'!
testRemoveFirst
	"Allows one to remove n element of a collection at the first"
	"self run:#testRemoveFirst" 
	
	| c1 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 removeFirst: 1.
	self assert: (c1 = #(3 4 6) asOrderedCollection).
	c1 removeFirst: 2.
	self assert: (c1 = #(6) asOrderedCollection).
	self should: [c1 removeFirst: 10] raise: Error.
	
	! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'pmaer 5/7/2012 15:06'!
testRemoveIfAbsent
	"Allows one to remove an element from a collection and to copy it in another collection."
	"If the element isn't in the first collection, the second collection copy the element after ifAbsent"
	"self run:#testRemoveIfAbsent"
	
	| c1 c2 |
	c1 := #(1 2 3 4) asDOOrderedCollection.
	c2 := DOOrderedCollection new.
	
	c2 add: (c1 remove: 2 ifAbsent: [6]).
	self assert: (c1 = #(1 3 4) asDOOrderedCollection).
	self assert: (c2 = #(2) asOrderedCollection).
	
	c2 add: (c1 remove: 18 ifAbsent: [6]).
	self assert: (c1 = #(1 3 4) asDOOrderedCollection).
	self assert: (c2 = #(2 6) asDOOrderedCollection).! !

!DOOrderedCollectionTest methodsFor: 'tests - removing' stamp: 'sd 3/21/2006 22:39'!
testRemoveLast
	"Allows one to remove n element of a collection at the end"
	"self run:#testRemoveLast" 
	
	| c1 |
	c1 := #(2 3 4 6) asOrderedCollection.
	c1 removeLast: 1.
	self assert: (c1 = #(2 3 4) asOrderedCollection).
	c1 removeLast: 2.
	self assert: (c1 = #(2) asOrderedCollection).
	self should: [c1 removeLast: 10] raise: Error.! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testReverseDo
	| result |
	result:= DOOrderedCollection new.
	self nonEmpty reverseDo: [: each | result add: each].
	
	1 to: result size do:
		[:i|
		self assert: (result at: i)=(self nonEmpty at:(self nonEmpty size-i+1))].! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testReverseDoEmpty
	| result |
	result:= DOOrderedCollection new.
	self empty reverseDo: [: each | result add: each].
	
	self assert: result isEmpty .! !

!DOOrderedCollectionTest methodsFor: 'tests - copying' stamp: 'zz 12/7/2005 13:47'!
testReversed
	| collection1 collection2 |
	collection1 := #('Jim' 'Mary' 'John' 'Andrew' ) asOrderedCollection.
	collection2 := collection1 reversed.
	self assert: collection2 first = 'Andrew'.
	self assert: collection2 last = 'Jim'! !

!DOOrderedCollectionTest methodsFor: 'tests' stamp: 'pmaer 5/14/2012 14:23'!
testSort
	"self run: #testSort"
	
	| ord |
	ord := DOOrderedCollection new addAll: #(2 1 3 6 7 10 6); yourself.
	self assert: ord sort asArray = #(1 2 3 6 6 7 10). 
	self assert: ord sort = (DOOrderedCollection new addAll:#(1 2 3 6 6 7 10); yourself). 
	self assert: (ord sort: [:a :b | a > b]) asArray = #(10 7 6 6 3 2 1).
	ord := DOOrderedCollection new.
	self assert: ord sort asArray = #(). 
! !

!DOOrderedCollectionTest methodsFor: 'tests - puting with indexes' stamp: 'GuillermoPolito 5/24/2010 14:31'!
testSwapWith
	"self debug: #testSwapWith"
	| result index |
	index := self indexArray anyOne.
	result:= self nonEmpty copy .
	result swap: index with: 1.
	self assert: (result at: index) = (self nonEmpty at:1).
	self assert: (result at: 1) = (self nonEmpty at: index).
	! !

!DOOrderedCollectionTest methodsFor: 'tests - enumerating' stamp: 'cm 3/8/2006 10:02'!
testWithCollect
	"Allows one to collect some element of two collections into another collection with element corresponding to the condition in the blocks"
	"self run: #testWithCollect"
	
	| c1 c2 res |
	c1 := #(-1 2 -3 4 -5 6 -7 8) asOrderedCollection.
	c2 := #(-9 10 -11 12 -13 14 -15 16) asOrderedCollection.
	res := c1 with: c2 collect: [:each1 :each2 | each1 < each2
		ifTrue: [each1]
		ifFalse: [each2]].
	self assert: (res = #(-9 2 -11 4 -13 6 -15 8) asOrderedCollection).
	! !

!DOOrderedCollectionTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'pmaer 5/14/2012 14:23'!
testWithIndexDo
	
	"| result |
	result:=Array new: self nonEmptyMoreThan1Element size.
	self nonEmptyMoreThan1Element  withIndexDo: [:each :i | result at:i put:(each+i)].
	
	1 to: result size do:[: i | self assert: (result at:i)= ((self nonEmptyMoreThan1Element at: i) + i)]"
	|  indexes elements |
	indexes:= DOOrderedCollection new.
	elements := DOOrderedCollection new.
	
	self nonEmptyMoreThan1Element  withIndexDo: 
		[:value :i  |
		indexes  add: (i).
		elements add: value].
	
	(1 to: self nonEmptyMoreThan1Element size )do:
		[ :i |
		self assert: (indexes at: i) = i.
		self assert: (elements at: i) = (self nonEmptyMoreThan1Element at: i).	
		].
	
	self assert: indexes size = elements size. 
	self assert: indexes size = self nonEmptyMoreThan1Element size . 
	! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:21'!
valueArray
" return a collection (with the same size than 'indexArray' )of values to be put in 'nonEmpty'  at indexes in 'indexArray' "
	| result |
	result := DOArray new: self indexArray size.
	1 to: result size do:
		[:i |
		result at:i put: (self aValue ).
		].
	^ result.! !

!DOOrderedCollectionTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 14:11'!
withEqualElements
	" return a collection of float including equal elements (classic equality)"
	^ collectionOfFloat , collectionOfFloat! !

DOCollectionRootTest subclass: #DOSetTest
	uses: TAddForUniquenessTest + TIncludesWithIdentityCheckTest + TCloneTest + TCopyTest + TSetArithmetic + TRemoveTest + TCreationWithTest - {#testOfSize} + TGrowableTest + TStructuralEqualityTest + TSizeTest + TPrintTest + TAsStringCommaAndDelimiterTest + TConvertTest + TConvertAsSortedTest + TConcatenationEqualElementsRemovedTest + TOccurrencesTest
	instanceVariableNames: 'full empty collectResult emptyButAllocatedWith20 elementNotIn collectionOfFloat collectionIncluded nonEmpty1element withoutEqualElements collection5Elements collectionWith3Elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel-Test'!

!DOSetTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Set. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- there is a chapter in the PharoByExample book (http://pharobyexample.org/)
	- the sunit class category!

DOSetTest class
	uses: TAddForUniquenessTest classTrait + TCloneTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TRemoveTest classTrait + TCreationWithTest classTrait + TGrowableTest classTrait + TStructuralEqualityTest classTrait + TSizeTest classTrait + TPrintTest classTrait + TAsStringCommaAndDelimiterTest classTrait + TConvertTest classTrait + TConvertAsSortedTest classTrait + TIncludesWithIdentityCheckTest classTrait + TConcatenationEqualElementsRemovedTest classTrait + TOccurrencesTest classTrait
	instanceVariableNames: ''!

!DOSetTest class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^DOTestsCompiler! !

!DOSetTest methodsFor: 'tests - includes' stamp: 'stephane.ducasse 11/21/2008 14:58'!
anotherElementNotIn
	^ 42! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:00'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection  anyOne! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:01'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ elementNotIn ! !

!DOSetTest methodsFor: 'requirements' stamp: 'pmaer 5/14/2012 14:10'!
classToBeTested
^ DOSet.! !

!DOSetTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:14'!
collection

	^ collectionWith3Elements! !

!DOSetTest methodsFor: 'test - creation' stamp: 'pmaer 5/14/2012 14:10'!
collectionClass 
	
	^ DOSet! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 16:54'!
collectionInForIncluding
	^ collectionIncluded ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 14:16'!
collectionMoreThan5Elements
" return a collection including at least 5 elements"
	
	^ collection5Elements ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 11:14'!
collectionNotIncluded
	^ self classToBeTested  with: elementNotIn. ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 16:42'!
collectionOfFloat
	^ collectionOfFloat ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 10:22'!
collectionWithCopyNonIdentical
	" return a collection that include elements for which 'copy' return a different object (this is not the case of SmallInteger)"
	^ collectionOfFloat! !

!DOSetTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/8/2008 15:42'!
collectionWithElement
	^ full! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 16:54'!
collectionWithElementsToRemove
	^ collectionIncluded ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 10:28'!
collectionWithSortableElements
" return a collection elements that can be sorte ( understanding message ' < '  or ' > ')"
	^collectionOfFloat ! !

!DOSetTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:18'!
collectionWithoutElement
	" return a collection that does not include 'element' "
	^ collectionWith3Elements  ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/21/2009 10:04'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^ withoutEqualElements ! !

!DOSetTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:17'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^ collectionWith3Elements  ! !

!DOSetTest methodsFor: 'requirements' stamp: 'stephane.ducasse 10/8/2008 15:42'!
element
	^ 4! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/20/2009 16:40'!
elementInForIncludesTest
" return an element included in nonEmpty "
	^ self nonEmpty anyOne! !

!DOSetTest methodsFor: 'ambiguous' stamp: 'delaunay 4/20/2009 16:42'!
elementNotIn
	^elementNotIn ! !

!DOSetTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
elementNotInForOccurrences
	^ 666! !

!DOSetTest methodsFor: 'test - copy' stamp: 'delaunay 4/17/2009 15:26'!
elementToAdd
	^ 42! !

!DOSetTest methodsFor: 'tests - empty' stamp: 'stephane.ducasse 10/5/2008 13:11'!
empty
	
	^ empty! !

!DOSetTest methodsFor: 'tests - size capacity' stamp: 'stephane.ducasse 10/6/2008 17:09'!
emptyButAllocatedWith20

	^ emptyButAllocatedWith20! !

!DOSetTest methodsFor: 'test - iterate' stamp: 'luc.fabresse 11/29/2008 23:09'!
expectedSizeAfterReject
	^1! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 11:54'!
firstCollection
" return a collection that will be the first part of the concatenation"
	^ nonEmpty1element ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/21/2009 10:05'!
integerCollectionWithoutEqualElements
" return a collection of integer without equal elements"
	^ withoutEqualElements ! !

!DOSetTest methodsFor: 'tests - empty' stamp: 'stephane.ducasse 10/5/2008 13:11'!
nonEmpty
	
	^ full! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 4/21/2009 10:01'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^ nonEmpty1element ! !

!DOSetTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 11:28'!
nonEmptyWithoutEqualElements
" return a collection without equal elements "
	^ withoutEqualElements ! !

!DOSetTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 12:02'!
result

	 ^ collectResult! !

!DOSetTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:18'!
secondCollection
" return a collection that will be the second part of the concatenation"
	^ collectionWith3Elements  ! !

!DOSetTest methodsFor: 'test - iterate' stamp: 'stephane.ducasse 10/6/2008 19:40'!
selectedNumber

	^ 2
	! !

!DOSetTest methodsFor: 'initialize' stamp: 'cyrille.delaunay 12/18/2009 13:14'!
setUp
	empty := self classToBeTested  new.
	full := self classToBeTested  with: 1 with: 2 with: 3 with: 4.
	collectionIncluded := self classToBeTested  with: 2 with: 3 .
	collectionWith3Elements := self classToBeTested  new.
	collectionWith3Elements add: 1; add: -2; add: 3. 
	collectResult := self classToBeTested  new add: SmallInteger ; yourself.
	emptyButAllocatedWith20 := self classToBeTested  new: 20.
	elementNotIn := 99.
	collectionOfFloat := self classToBeTested  with: 2.5 with: 4.6 with: 4.2.
	nonEmpty1element := self classToBeTested  with: 32.
	withoutEqualElements := self classToBeTested  with: 4 with: 5 with: 2.
	collection5Elements := self classToBeTested with: 1 with: 2 with: 3 with: 4 with: 5.! !

!DOSetTest methodsFor: 'tests - size capacity' stamp: 'stephane.ducasse 10/6/2008 19:33'!
sizeCollection

	^ full! !

!DOSetTest methodsFor: 'test - iterate' stamp: 'pmaer 5/14/2012 14:10'!
speciesClass
	
	^ DOSet! !

!DOSetTest methodsFor: 'tests - fixture' stamp: 'delaunay 5/12/2009 15:18'!
test0FixtureAddForUniquenessTest
	self 
		shouldnt: [ self element ]
		raise: Error.
	self 
		shouldnt: [ self collectionWithElement ]
		raise: Error.
	self assert: (self collectionWithElement includes: self element).
	self 
		shouldnt: [ self collectionWithoutElement ]
		raise: Error.
	self assert: (self collectionWithElement includes: self element)! !

!DOSetTest methodsFor: 'tests - fixture' stamp: 'pmaer 5/14/2012 14:23'!
test0FixtureOccurrencesTest
	| tmp |
	self shouldnt: [self empty ]raise: Error.
	self assert: self empty isEmpty.

	self shouldnt: [ self collectionWithoutEqualElements ] raise: Error.
	self deny: self collectionWithoutEqualElements isEmpty.
	
	tmp := DOOrderedCollection new.
	self collectionWithoutEqualElements do: [ 
		:each |
		self deny: (tmp includes: each).
		tmp add: each.
		 ].
	
	
	self shouldnt: [ self elementNotInForOccurrences ] raise: Error.
	self deny: (self collectionWithoutEqualElements includes: self elementNotInForOccurrences)! !

!DOSetTest methodsFor: 'sunit original tests' stamp: 'stephane.ducasse 5/20/2009 18:05'!
testAdd 
	empty add: 5.
	self assert: (empty includes: 5).! !

!DOSetTest methodsFor: 'tests - growable' stamp: 'damiencassou 1/20/2009 10:44'!
testAddEmptyGrows
	"self debug: #testAddEmptyGrows"
	
	| oldSize |
	oldSize := self empty size.
	self empty add: self element.
	self assert: self empty size = (oldSize + 1).! !

!DOSetTest methodsFor: 'tests - adding uniquely' stamp: 'delaunay 5/12/2009 15:18'!
testAddNewElementIncrementsSize
	| added oldSize |
	oldSize := self collectionWithoutElement size.
	self deny: (self collectionWithoutElement includes: self element).
	added := self collectionWithoutElement add: self element.
	self assert: added = self element.
	self assert: (self collectionWithoutElement includes: self element).
	self assert: self collectionWithoutElement size = (oldSize + 1)! !

!DOSetTest methodsFor: 'tests - growable' stamp: 'delaunay 4/2/2009 11:53'!
testAddNonEmptyGrowsWhenNewElement
	"self debug: #testAddNonEmptyGrowsWhenNewElement"
	| oldSize |
	oldSize := self nonEmpty size.
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self nonEmpty add: self elementNotInForOccurrences.
	self assert: self nonEmpty size > oldSize! !

!DOSetTest methodsFor: 'some tests' stamp: 'stephane.ducasse 5/20/2009 18:06'!
testAddWithOccurences
 
	empty add: 2 withOccurrences: 3.
	self assert: (empty includes: 2).
	self assert: ((empty occurrencesOf: 2) = 1).! !

!DOSetTest methodsFor: 'some tests' stamp: 'pmaer 5/22/2012 16:57'!
testAllSetsAreHealthy
	<broken>
	self assert: (DOSet allInstances select: [:badSet | badSet isHealthy not ]) isEmpty.! !

!DOSetTest methodsFor: 'tests - with nil' stamp: 'IgorStasenko 5/30/2011 18:49'!
testAllowInclusionOfNils
	| set |
	
	set := self classToBeTested  new.
	
	self shouldnt: [ set add: nil ] raise: Error.
	
	self assert: ( set includes: nil ).

	self shouldnt: [ set remove: nil ] raise: Error.

	self deny: ( set includes: nil ).
! !

!DOSetTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:21'!
testAsArray
	"self debug: #testAsArray3"
	self 
		assertSameContents: self collectionWithoutEqualElements
		whenConvertedTo: DOArray! !

!DOSetTest methodsFor: 'tests - as string comma delimiter sequenceable' stamp: 'pmaer 5/14/2012 14:23'!
testAsCommaStringMore

	| result resultAnd index allElementsAsString tmp |
	result:= self nonEmpty asCommaString .
	resultAnd:= self nonEmpty asCommaStringAnd .
	tmp :=DOOrderedCollection new. 
	self nonEmpty do: [ :each | tmp add: each asString].

	"verifying result  :"
	index := 1.
	allElementsAsString := (result findBetweenSubStrs: ', ' ).
	allElementsAsString do:
		[:each |
		self assert: (tmp occurrencesOf: each)=(allElementsAsString occurrencesOf: each).
		].
	
	"verifying esultAnd :"
	allElementsAsString:=(resultAnd findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 ) | i= allElementsAsString size
			ifTrue: [self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self assert: (allElementsAsString at:i)=('and')].
			].! !

!DOSetTest methodsFor: 'tests - converting' stamp: 'pmaer 5/14/2012 14:23'!
testAsOrderedCollection
	
	self assertSameContents: self collectionWithoutEqualElements whenConvertedTo: DOOrderedCollection! !

!DOSetTest methodsFor: 'some tests' stamp: 'stephane.ducasse 10/6/2008 19:34'!
testAsSet
	"could be moved in Array or Collection"

	| newFull |
	newFull := #(1 2 3 ) asSet.
	newFull add: 4.
	self assert: (newFull = full).! !

!DOSetTest methodsFor: 'tests - as sorted collection' stamp: 'pmaer 5/14/2012 14:21'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: DOArray).
	self assert: result isSorted.
	self assert: result size = collection size! !

!DOSetTest methodsFor: 'some tests' stamp: 'GL 2/28/2006 09:25'!
testAtRandom
	| rand |
	rand := Random new.
	full add: 3.
	full add: 2.
	full add: 4.
	full add: 1.
	self assert: (full includes: (full atRandom: rand)).
	! !

!DOSetTest methodsFor: 'some tests' stamp: 'pmaer 5/14/2012 14:10'!
testCollect2
	| newFull result |
	newFull := DOSet withAll: (1 to: 10).
	result := newFull collect: [:each | each >= 1 ifTrue: [each] ifFalse: ['no']].
	self assert: (result = newFull).
	result := newFull collect: [:each | each >= 5 ifTrue: [each] ifFalse: ['no']].
	self assert: (result = ((DOSet withAll: (5 to: 10)) add: 'no'; yourself)).! !

!DOSetTest methodsFor: 'some tests' stamp: 'stephane.ducasse 5/20/2009 18:05'!
testCopy
	| newFull |
	full add: 3.
	full add: 2.
	newFull := full copy.
	self assert: (full size = newFull size).
	self assert: ((full select: [:each | (newFull includes: each) not]) isEmpty).
	self assert: ((newFull select: [:each | (full includes: each) not]) isEmpty).! !

!DOSetTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!DOSetTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!DOSetTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!DOSetTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!DOSetTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!DOSetTest methodsFor: 'tests - copy' stamp: 'delaunay 3/30/2009 10:33'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!DOSetTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!DOSetTest methodsFor: 'some tests' stamp: 'pmaer 5/14/2012 14:10'!
testCopyWithout
	| newFull | 
	full add: 3.
	full add: 2.
	newFull := full copyWithout: 3.
	self assert: (newFull size = (full size - 1)).
	self deny: (newFull includes: 3).
	self assert: ((newFull select: [:each | (full includes: each) not]) isEmpty).
	self assert: ((full select: [:each | (newFull includes: each) not]) = (DOSet with: 3)).
	! !

!DOSetTest methodsFor: 'some tests' stamp: 'pmaer 5/14/2012 14:10'!
testDo2
	| newFull result |
	newFull := DOSet withAll: (1 to: 5).
	result := 0.
	newFull do: [:each | result := (result + each)].
	self assert: (result = 15).! !

!DOSetTest methodsFor: 'test - iterate' stamp: 'damienpollet 1/30/2009 18:04'!
testDoWithoutNoDuplicates
	"self debug: #testDoWithoutNoDuplicates"
	| res |
	res := self speciesClass new.  
	self collection do: [:each | res add: each] without: -2.
	self assert: res size = self doWithoutNumber.! !

!DOSetTest methodsFor: 'sunit original tests' stamp: 'stephane.ducasse 5/20/2009 18:05'!
testGrow 
	empty addAll: (1 to: 100).
	self assert: (empty size = 100).
			! !

!DOSetTest methodsFor: 'tests - includes' stamp: 'delaunay 4/28/2009 10:22'!
testIdentityIncludes
	" test the comportement in presence of elements 'includes' but not 'identityIncludes' "
	" can not be used by collections that can't include elements for wich copy doesn't return another instance "
	| collection element |
	self 
		shouldnt: [ self collectionWithCopyNonIdentical ]
		raise: Error.
	collection := self collectionWithCopyNonIdentical.
	element := collection anyOne copy.
	"self assert: (collection includes: element)."
	self deny: (collection identityIncludes: element)! !

!DOSetTest methodsFor: 'sunit original tests' stamp: 'stephane.ducasse 5/20/2009 18:04'!
testIllegal
	self should: [empty at: 5] raise: TestResult error.
	self should: [empty at: 5 put: #abc] raise: TestResult error.
			! !

!DOSetTest methodsFor: 'sunit original tests' stamp: 'stephane.ducasse 10/6/2008 19:35'!
testIncludes
	self assert: (full includes: 4).
	self assert: (full includes: 3).
	self deny: (full includes: 6).
			! !

!DOSetTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAllOfNoneThere
	"self debug: #testIncludesAllOfNoneThere'"
	self deny: (self empty includesAllOf: self collection).
	self deny: (self nonEmpty includesAllOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DOSetTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAnyOfNoneThere
	"self debug: #testIncludesAnyOfNoneThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self deny: (self nonEmpty includesAnyOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!DOSetTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesElementIsNotThere
	"self debug: #testIncludesElementIsNotThere"
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self assert: (self nonEmpty includes: self nonEmpty anyOne).
	self deny: (self empty includes: self elementNotInForOccurrences)! !

!DOSetTest methodsFor: 'tests - includes' stamp: 'delaunay 4/9/2009 10:44'!
testIncludesSubstringAnywhere
	"self debug: #testIncludesSubstringAnywher'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: {  (self nonEmpty anyOne)  }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty)! !

!DOSetTest methodsFor: 'some tests' stamp: 'pmaer 5/14/2012 14:10'!
testIntersection 
	| newFull col |
	full add: 3; add: 2.
	col := full intersection: full.
	self assert: (full = col).

	newFull := DOSet with: 8 with: 9 with: #z.
	col := newFull intersection: full.
	self assert: (col isEmpty).
	
	newFull add: 5; add: #abc; add: 7.
	col := newFull intersection: full.
	self assert: ((full select: [:each | (newFull includes: each)]) = col).
	
	
	! !

!DOSetTest methodsFor: 'some tests' stamp: 'stephane.ducasse 10/6/2008 19:35'!
testLike
	self assert: ((full like: 3) = 3).
	self assert: ((full like: 8) isNil).! !

!DOSetTest methodsFor: 'sunit original tests' stamp: 'stephane.ducasse 10/6/2008 19:39'!
testOccurrences
	self assert: ((empty occurrencesOf: 0) = 0).
	self assert: ((full occurrencesOf: 4) = 1).
	full add: 4.
	self assert: ((full occurrencesOf: 4) = 1).! !

!DOSetTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintElementsOn

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printElementsOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).
			].! !

!DOSetTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintOn
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream .
	allElementsAsString:=(result findBetweenSubStrs: ' ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i=1
			ifTrue:[
			self accessCollection class name first isVowel 
				ifTrue:[self assert: (allElementsAsString at:i)='an' ]
				ifFalse:[self assert: (allElementsAsString at:i)='a'].].
		i=2
			ifTrue:[self assert: (allElementsAsString at:i)=self accessCollection class name].
		i>2
			ifTrue:[self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i)).].	
			].! !

!DOSetTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintOnDelimiter
	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	
	
	self nonEmpty printOn: aStream delimiter: ', ' .
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		self assert: (tmp occurrencesOf:(allElementsAsString at:i))=(allElementsAsString  occurrencesOf:(allElementsAsString at:i))
			].! !

!DOSetTest methodsFor: 'tests - printing' stamp: 'pmaer 5/14/2012 14:23'!
testPrintOnDelimiterLast

	| aStream result allElementsAsString tmp |
	result:=''.
	aStream:= ReadWriteStream on: result.
	tmp:= DOOrderedCollection new.
	self nonEmpty do: [:each | tmp add: each asString].
	
	self nonEmpty printOn: aStream delimiter: ', ' last: 'and'.
	
	allElementsAsString:=(result findBetweenSubStrs: ', ' ).
	1 to: allElementsAsString size do:
		[:i | 
		i<(allElementsAsString size-1 )
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
		i=(allElementsAsString size-1)
			ifTrue:[ self deny: (allElementsAsString at:i)=('and')asString].
		i=(allElementsAsString size)
			ifTrue: [self assert: (tmp occurrencesOf: (allElementsAsString at:i))=(allElementsAsString  occurrencesOf: (allElementsAsString at:i))].
			].! !

!DOSetTest methodsFor: 'sunit original tests' stamp: 'stephane.ducasse 10/6/2008 19:34'!
testRemove
	full remove: 4.
	self assert: (full includes: 3).
	self deny: (full includes: 4).! !

!DOSetTest methodsFor: 'tests' stamp: 'nice 9/14/2009 21:08'!
testRemoveAll
	"Allows one to remove all elements of a collection" 
	
	| c1 c2 s2 |
	c1 := full.
	c2 := c1 copy.
	s2 := c2 size.
	
	c1 removeAll.
	
	self assert: c1 size = 0.
	self assert: c2 size = s2 description: 'the copy has not been modified'.! !

!DOSetTest methodsFor: 'tests - remove' stamp: 'nice 1/5/2010 15:59'!
testRemoveAllError
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self elementNotIn.
	subCollection := self nonEmptyWithoutEqualElements copyWith: el.
	self 
		should: [ | res | res := self nonEmptyWithoutEqualElements removeAll: subCollection ]
		raise: Error! !

!DOSetTest methodsFor: 'tests - remove' stamp: 'nice 1/5/2010 15:59'!
testRemoveAllFoundIn
	"self debug: #testRemoveElementThatExists"
	| el subCollection |
	el := self nonEmptyWithoutEqualElements anyOne.
	subCollection := (self nonEmptyWithoutEqualElements copyWithout: el) copyWith: self elementNotIn.
	self 
		shouldnt: 
			[ | res | res := self nonEmptyWithoutEqualElements removeAllFoundIn: subCollection ]
		raise: Error.
	self assert: self nonEmptyWithoutEqualElements size = 1.
	self nonEmptyWithoutEqualElements do: [ :each | self assert: each = el ]! !

!DOSetTest methodsFor: 'some tests' stamp: 'StephaneDucasse 3/5/2010 14:33'!
testRemoveIfAbsent
	"self debug: #testRemoveIfAbsent"
	
	self assert: (full remove: 8 ifAbsent: [true]).
	self assert: (full remove: 4 ifAbsent: [false]) isNumber.
	
	
	! !

!DOSetTest methodsFor: 'some tests' stamp: 'stephane.ducasse 10/6/2008 19:34'!
testSize2
	self assert: (empty size = 0).
	self assert: (full size = 4).
	empty add: 2.
	empty add: 1.
	full add: 2.
	self assert: (empty size = 2).
	self assert: (full size = 4).
	empty remove: 2.
	self assert: (empty size = 1).! !

!DOSetTest methodsFor: 'tests - adding uniquely' stamp: 'delaunay 5/12/2009 15:18'!
testTAddIfNotPresentWithNewElement
	| added oldSize |
	oldSize := self collectionWithoutElement size.
	self deny: (self collectionWithoutElement includes: self element).
	added := self collectionWithoutElement addIfNotPresent: self element.
	self assert: added = self element.
	self assert: (self collectionWithoutElement includes: self element).
	self assert: self collectionWithoutElement size = (oldSize + 1)! !

!DOSetTest methodsFor: 'some tests' stamp: 'pmaer 5/14/2012 14:10'!
testUnion
	| newFull col newCol |
	full add: 3.
	full add: 2.
	col := full union: full.
	self assert: (full = col).

	newFull := DOSet with: 8 with: 9 with: #z.
	col := newFull union: full.
	self assert: (col size = (full size + newFull size)).
	self assert: ((col select: [:each | (full includes: each) not]) = newFull).
	self assert: ((col select: [:each | (newFull includes: each) not]) = full).

	full add: 9.
	col := newFull union: full.
	newCol := newFull copy.
	newCol remove: 9.
	self assert: (col size = (full size + newFull size - 1)).
	self assert: ((col select: [:each | (full includes: each) not]) = newCol).
	newCol := full copy.
	newCol remove: 9.
	self assert: ((col select: [:each | (newFull includes: each) not]) = newCol).
	
	
	! !

Exception subclass: #WebAuthRequired
	instanceVariableNames: 'client request response authParams message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebAuthRequired commentStamp: 'ar 2/10/2012 12:39' prior: 0!
Exception signaled when authentication is required.!

!WebAuthRequired class methodsFor: 'instance creation' stamp: 'ar 2/10/2012 13:16'!
client: aWebClient request: aWebRequest response: aWebResponse
	"Creates a new exception"

	^(self new)
		client: aWebClient 
		request: aWebRequest 
		response: aWebResponse! !

!WebAuthRequired methodsFor: 'accessing' stamp: 'ar 2/10/2012 13:14'!
client
	"The client causing the exception"

	^client! !

!WebAuthRequired methodsFor: 'initialize' stamp: 'ar 2/10/2012 13:06'!
client: aWebClient request: aWebRequest response: aWebResponse
	"Initializes the exception"

	client := aWebClient.
	request := aWebRequest.
	response := aWebResponse.
! !

!WebAuthRequired methodsFor: 'defaults' stamp: 'ar 2/10/2012 13:14'!
defaultAction

	self resume: false.! !

!WebAuthRequired methodsFor: 'defaults' stamp: 'ar 2/10/2012 13:07'!
defaultResumeValue
	"Resume with false by default"

	^false! !

!WebAuthRequired methodsFor: 'testing' stamp: 'ar 2/10/2012 13:09'!
isProxyAuth
	"Return true if proxy authorization is required"

	^response code = 407! !

!WebAuthRequired methodsFor: 'testing' stamp: 'ar 2/10/2012 13:09'!
isUnauthorized
	"Return true if authorization is required"

	^response code = 401! !

!WebAuthRequired methodsFor: 'accessing' stamp: 'ar 2/10/2012 13:49'!
message
	"Answer a default message for the user to ask for input"

	self isProxyAuth ifTrue:[
		^'The proxy server at "', client proxyServerName, '" requires authentication.'.
	].

	^'The server at "', client serverName, '" requires authentication.'.! !

!WebAuthRequired methodsFor: 'accessing' stamp: 'ar 2/10/2012 13:04'!
request
	"The request object causing the exception"

	^request! !

!WebAuthRequired methodsFor: 'accessing' stamp: 'ar 2/10/2012 13:05'!
response
	"The response object causing the exception"

	^response! !

!WebAuthRequired methodsFor: 'initialize' stamp: 'ar 2/10/2012 13:13'!
username: username password: password
	"Use the given username/password as credentials"

	| params retry |
	params := self isProxyAuth ifTrue:[client proxyParams] ifFalse:[client authParams].
	retry := false.
	(params at: #username ifAbsent:[nil]) = username ifFalse:[
		params at: #username put: username.
		retry := true.
	].
	(params at: #password ifAbsent:[nil]) = password ifFalse:[
		params at: #password put: password.
		retry := true.
	].
	retry ifTrue:[self resume: true].
! !

!RBProgramNode methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 13:48'!
isOwnershipArrayNode
	^false! !

!RBProgramNode methodsFor: '*dynamicownership' stamp: 'pmaer 11/28/2011 18:59'!
isOwnershipBlockNode
	^false! !

!RBProgramNode methodsFor: '*dynamicownership' stamp: 'pmaer 5/7/2012 11:54'!
isOwnershipLiteralArrayNode
	^false! !

RBProgramNodeVisitor subclass: #DOTestsCompilerMessageVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!DOTestsCompilerMessageVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:00'!
acceptArrayNode: arrayNode 

	| newArrayNode newMessageNode |
	(arrayNode isOwnershipArrayNode) ifFalse: [
	
		newArrayNode:= RBOwnershipArrayNode statements: arrayNode statements.
	
		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).
	
		arrayNode replaceWith: newMessageNode.	
		
		^ super visitNode: newMessageNode.
	
	].
	
	^ super acceptArrayNode: arrayNode.! !

!DOTestsCompilerMessageVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:00'!
acceptLiteralArrayNode: literalArrayNode 
	| newArrayNode newMessageNode |

	(literalArrayNode isOwnershipLiteralArrayNode) ifFalse: [

		newArrayNode:= RBOwnershipArrayNode statements: literalArrayNode contents.

		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).

		literalArrayNode replaceWith: newMessageNode.
		
		^ super visitNode: newMessageNode.
	
	].
	^ super acceptLiteralArrayNode: literalArrayNode.! !

!DOTestsCompilerMessageVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 15:00'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

RBProgramNodeVisitor subclass: #DebugCompilerVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!DebugCompilerVisitor methodsFor: 'as yet unclassified' stamp: 'pmaer 11/30/2011 19:23'!
acceptMessageNode: methodNode 
	| newSequenceNode ownershipCheckNode |
	Transcript show: methodNode selector ; cr. 	
	self halt. 
	^ super acceptMessageNode: methodNode.
	
! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor2_1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompilerMessageVisitor2_1 methodsFor: 'as yet unclassified' stamp: 'pmaer 2/3/2012 17:03'!
acceptMessageNode: messageNode 
	"Transcript show: messageNode; cr."
	
	( messageNode selector = #checkValidSend:message:block:  or: [ messageNode parent parent 	isOwnershipBlockNode ]) ifFalse: [
		| block statements collStatements newMessageNode newBlockMessageNode rLitToken1 rVarNode1 rLitToken2 rVarNode2 selectorLitNode selectorLitToken receiver selfVarNode selfLitToken variableValue |
		
		"exclude self and super sends"
		[
			(messageNode receiver isVariable and: [messageNode receiver token isIdentifier and: 
				(messageNode receiver token value = 'super' or: messageNode receiver token value = 'self')])
			
					ifTrue: [ ^super acceptMessageNode: messageNode. ].
		] on: Error do: [ :ex | Transcript show: ex message ].
	
		"exclude printOn"
		[
			(messageNode parent parent selector = #printOn:) ifTrue: [
					^super acceptMessageNode: messageNode.
			].
		] on: Error do: [ :ex | Transcript show: ex message ].

	
		variableValue := 'r', (VariableNameCounter counter asString).

		VariableNameCounter increment.
		
		rLitToken1 := RBLiteralToken value: variableValue.
		rVarNode1 := RBVariableNode identifierToken: rLitToken1.
		
		newBlockMessageNode := RBMessageNode receiver: rVarNode1
			selector: messageNode selector
			arguments: messageNode arguments.
		
		collStatements := OrderedCollection new.
		collStatements add: newBlockMessageNode.
		statements := RBSequenceNode statements: collStatements.
		
		rLitToken2 := RBLiteralToken value: variableValue.
		rVarNode2:= RBVariableNode identifierToken: rLitToken2.
		
		block := RBOwnershipBlockNode arguments: { rVarNode2 }
			body: statements. 
		
		selectorLitToken := RBLiteralToken value: messageNode selector.
		selectorLitNode := RBLiteralValueNode literalToken: selectorLitToken.

		selfLitToken := RBLiteralToken value: 'self'.
		selfVarNode := RBVariableNode identifierToken: selfLitToken.
		
		newMessageNode:= RBMessageNode receiver:  selfVarNode
		 	selector: #checkValidSend:message:block: 
			arguments: { messageNode receiver. selectorLitNode. block }.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor2_2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!OwnershipCompilerMessageVisitor2_2 methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 15:30'!
acceptMessageNode: messageNode 
	"Transcript show: messageNode; cr."
	( messageNode selector = #checkValidSend:message:block:  or: [ messageNode parent parent 	isOwnershipBlockNode ]) ifFalse: [
		| block statements collStatements newMessageNode newBlockMessageNode rLitToken1 rVarNode1 rLitToken2 rVarNode2 selectorLitNode selectorLitToken receiver selfVarNode selfLitToken variableValue temp |
		
		"exclude self and super sends"
		[
			(messageNode receiver isVariable and: [messageNode receiver token isIdentifier and: 
				(messageNode receiver token value = 'super' or: messageNode receiver token value = 'self')])
			
					ifTrue: [ ^super acceptMessageNode: messageNode. ].
		] on: Error do: [ :ex | Transcript show: ex message ].
	
		"exclude printOn"
		[
			temp := messageNode receiver.
			[ temp isMethod or: temp = nil ] whileFalse: [ temp := temp parent ].
		
			Transcript show: temp selectorParts;cr.
			(temp selector = #printOn:) ifTrue: [
					^super acceptMessageNode: messageNode.
			].
		] on: Error do: [ :ex | Transcript show: ex message ].

	
		variableValue := 'r', (VariableNameCounter counter asString).

		VariableNameCounter increment.
		
		rLitToken1 := RBLiteralToken value: variableValue.
		rVarNode1 := RBVariableNode identifierToken: rLitToken1.
		
		newBlockMessageNode := RBMessageNode receiver: rVarNode1
			selector: messageNode selector
			arguments: messageNode arguments.
		
		collStatements := OrderedCollection new.
		collStatements add: newBlockMessageNode.
		statements := RBSequenceNode statements: collStatements.
		
		rLitToken2 := RBLiteralToken value: variableValue.
		rVarNode2:= RBVariableNode identifierToken: rLitToken2.
		
		block := RBOwnershipBlockNode arguments: { rVarNode2 }
			body: statements. 
		
		selectorLitToken := RBLiteralToken value: messageNode selector.
		selectorLitNode := RBLiteralValueNode literalToken: selectorLitToken.

		selfLitToken := RBLiteralToken value: 'self'.
		selfVarNode := RBVariableNode identifierToken: selfLitToken.
		
		newMessageNode:= RBMessageNode receiver:  messageNode receiver
		 	selector: #checkValidSend:message:block: 
			arguments: { selfVarNode. selectorLitNode. block }.

		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

RBProgramNodeVisitor subclass: #OwnershipCompilerMessageVisitor3
	instanceVariableNames: 'skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 5/8/2012 09:21'!
acceptArrayNode: arrayNode 
	| newArrayNode newMessageNode |

	(arrayNode isOwnershipArrayNode) ifFalse: [
	
		newArrayNode:= RBOwnershipArrayNode statements: arrayNode statements.
	
		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).
	
		arrayNode replaceWith: newMessageNode.	
		
		^ super visitNode: newMessageNode.
	
	].
	
	^ super acceptArrayNode: arrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:29'!
acceptLiteralArrayNode: literalArrayNode 
	| newArrayNode newMessageNode |

	(literalArrayNode isOwnershipLiteralArrayNode) ifFalse: [

		newArrayNode:= RBOwnershipArrayNode statements: literalArrayNode contents.

		newMessageNode:= RBMessageNode receiver: (self buildVariableNode: 'DOArray')
			selector: #withAll:
			arguments: (OrderedCollection withAll: newArrayNode).

		literalArrayNode replaceWith: newMessageNode.
		
		^ super visitNode: newMessageNode.
	
	].
	^ super acceptLiteralArrayNode: literalArrayNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 09:47'!
acceptMessageNode: messageNode 

	"Excluse certain methods (see acceptMethodNode)"
	skip ifTrue: [ ^super acceptMessageNode: messageNode. ].
	
	"Exclude self and super sends"
	(messageNode isSelfSend or: [ messageNode isSuperSend ] ) 
		ifTrue: [ ^super acceptMessageNode: messageNode. ].
				
	(messageNode needsOwnershipRewrite) ifTrue: [
		| block selector sender arguments newMessageNode |
			
		"TODO momentary hack "
		block := self buildVariableNode: 'self'. "self buildSyntheticBlock: messageNode ."
		selector := self buildLiteralNode: messageNode selector. 
		sender := self buildVariableNode: 'self'.
		arguments := RBOwnershipArrayNode statements: messageNode arguments.
				
		newMessageNode:= RBMessageNode receiver:  messageNode receiver
		 	selector: #checkValidSend3:message:block:arguments:
			arguments: { sender. selector. block. arguments}.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 13:09'!
acceptMethodNode: aMethod

	skip := (aMethod selector = #printOn: or: [ aMethod isOwernshipMeta ]).
	^ super acceptMethodNode: aMethod.
	! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:58'!
buildLiteralNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBLiteralValueNode literalToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:33'!
buildSyntheticBlock: messageNode 
| blockBodyMessageArguments blockArguments block blockBody collStatements blockBodyMessage  blockBodyReceiver blockBodyReceiverName blockFirstArg |

		"Build a block of the form
		  [ :receiver :arg | receiver selector: arg ]
		"
		
		" Build the message that will be in the synthetic block"
		blockBodyReceiverName := self nextVariableName.
		blockBodyReceiver := self buildVariableNode: blockBodyReceiverName. 
		blockBodyMessageArguments:= OrderedCollection new.
		blockArguments := OrderedCollection new.
		messageNode arguments size timesRepeat: [ 
			| argName |
			argName := self nextVariableName .
			blockBodyMessageArguments addLast: ( self buildVariableNode: argName ).
			blockArguments addLast: ( self buildVariableNode: argName ).
		].
		blockBodyMessage := RBMessageNode receiver: blockBodyReceiver
			selector: messageNode selector
			arguments: blockBodyMessageArguments.
		
		"Now build the synthetic block itself"
		collStatements := OrderedCollection new.
		collStatements add: blockBodyMessage.
		blockBody := RBSequenceNode statements: collStatements.
		
		blockFirstArg := self buildVariableNode: blockBodyReceiverName. 
		blockArguments addFirst: blockFirstArg.
		
		block := RBOwnershipBlockNode 
			arguments: blockArguments
			body: blockBody. 
			
		^ block
		! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:30'!
buildVariableNode: aName
	| literal |
	literal  := RBLiteralToken value: aName.
	^ RBVariableNode identifierToken: literal.! !

!OwnershipCompilerMessageVisitor3 methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:29'!
nextVariableName
	^ VariableNameCounter nextVariableName 
	! !

RBProgramNodeVisitor subclass: #OwnershipCompilerVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!OwnershipCompilerVisitor methodsFor: 'as yet unclassified' stamp: 'ewe 4/3/2012 10:54'!
acceptMessageNode: messageNode 
	Transcript show: messageNode; cr.
	"self halt."
	
	"TODO: message sends to self don't need to be rewritten"
	( messageNode selector = #checkValidSend:message:block:  or: [ messageNode parent parent 	isOwnershipBlockNode ]) ifFalse: [
		| block statements collStatements newMessageNode newBlockMessageNode rLitToken1 rVarNode1 rLitToken2 rVarNode2 selectorLitNode selectorLitToken receiver selfVarNode selfLitToken variableValue |
		
		variableValue := 'r', (VariableNameCounter counter asString).
		Transcript show: VariableNameCounter counter.
		VariableNameCounter increment.
		
		rLitToken1 := RBLiteralToken value: variableValue.
		rVarNode1 := RBVariableNode identifierToken: rLitToken1.
		
		newBlockMessageNode := RBMessageNode receiver: rVarNode1
			selector: messageNode selector
			arguments: messageNode arguments.
		
		collStatements := OrderedCollection new.
		collStatements add: newBlockMessageNode.
		statements := RBSequenceNode statements: collStatements.
		
		rLitToken2 := RBLiteralToken value: variableValue.
		rVarNode2:= RBVariableNode identifierToken: rLitToken2.
		
		block := RBOwnershipBlockNode arguments: { rVarNode2 }
			body: statements. 
		
		selectorLitToken := RBLiteralToken value: messageNode selector.
		selectorLitNode := RBLiteralValueNode literalToken: selectorLitToken.

		selfLitToken := RBLiteralToken value: 'self'.
		selfVarNode := RBVariableNode identifierToken: selfLitToken.
		
		newMessageNode:= RBMessageNode receiver:  selfVarNode
		 	selector: #checkValidSend:message:block: 
			arguments: { messageNode receiver. selectorLitNode. block }.
		
		messageNode replaceWith: newMessageNode.		
		^ super visitNode: newMessageNode.
	].
	^ super acceptMessageNode: messageNode.! !

TestCase subclass: #BasicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!BasicTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:09'!
testDefaultOwner

	| tester |
	tester := BasicTester new. 
	self assert: ( tester testDefaultOwner = tester ). 
! !

!BasicTest methodsFor: 'as yet unclassified' stamp: 'pmaer 4/16/2012 15:56'!
testWorldOwner

	| a b |
	a:= Object new.
	b:= OrderedCollection new.
	
	self assert: (a owner = WorldOwner getInstance).
	self assert: (b owner = WorldOwner getInstance).
	self assert: (a owner = b owner).
	
	b owner: a.
	self assert: (b owner = a).
	self assert: (b owner owner = WorldOwner getInstance).! !

TestCase subclass: #HotelTest
	uses: TExceptionAssertion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

HotelTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!HotelTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!HotelTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!HotelTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:11'!
testInFilters
	| tester |
	
	tester := HotelTester new. 
	self assertMessagePass: [ tester testStatus  ].
	self assertMessageFilter: [ tester testContent ]! !

TestCase subclass: #LessSecureBankCustomerTest
	uses: TExceptionAssertion
	instanceVariableNames: 'bankCS bankUBS customerCS customerUBS'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

LessSecureBankCustomerTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:59'!
performTest
	Transcript show: '* Test ' ; show: testSelector asSymbol ; cr.
	super performTest. ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:02'!
setUp

	Transcript  show: '------' ; cr ; show: 'Set up start.' ; cr.

	Object resetOwners .

	bankCS := LessSecureBank new acronym: #CS.
	bankUBS := LessSecureBank new acronym: #UBS. 
		
	customerCS := bankCS newCustomer identifier: #EWE ; firstname: 'Erwann' ; lastname: 'Wernli' .
	customerUBS := bankUBS newCustomer identifier: #PMA ; firstname: 'Paskal' ; lastname: 'Maerki' .
	customerCS partner: customerUBS. 
	customerUBS partner: customerCS. 
	
	Transcript show: 'Set up completed.' ; cr ;  show: '------' ; cr. ! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:03'!
testBankSize
	
	self assertBoundaryCrossed: [ bankCS hasMoreCustomerThan: bankUBS. ]
	"self assert: ( bankCS customers size = 2 )"
		! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 14:46'!
testCustomerToBank

	self assertMessagePass: [ customerCS promoteFrom: bankCS ].
	self assertMessageFilter: [ customerCS promoteFrom: bankUBS  ] .
	! !

!LessSecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:59'!
testTransfer

	customerUBS amount: 100.
	customerCS amount: 100.
	
	bankCS transferFrom: customerCS to: customerUBS. 
	self assertMessageFilter: [ 	bankUBS transferFrom: customerCS to: customerUBS ].
	customerUBS amount: 100.
	customerCS amount: 100. 
	
	bankCS transferToPartnerOf: customerCS. 
	self assertMessageFilter: [ bankUBS transferToPartnerOf: customerCS. ]! !

TestCase subclass: #MetaclassHierarchyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!MetaclassHierarchyTest commentStamp: 'on 3/19/2006 11:33' prior: 0!
Demonstrate the relationship between classes and metaclasses!

!MetaclassHierarchyTest methodsFor: 'running' stamp: 'on 10/28/2007 15:49'!
testHierarchy
	"The class hierarchy"
	self assert: SnakeSquare superclass = BoardSquare.
	self assert: BoardSquare superclass = Object.
	self assert: Object superclass superclass = nil.
	"The parallel metaclass hierarchy"
	self assert: SnakeSquare class name = 'SnakeSquare class'.
	self assert: SnakeSquare class superclass = BoardSquare class.
	self assert: BoardSquare class superclass = Object class.
	self assert: Object class superclass superclass = Class.
	self assert: Class superclass = ClassDescription.
	self assert: ClassDescription superclass = Behavior.
	self assert: Behavior superclass = Object.
	"The Metaclass hierarchy"
	self assert: SnakeSquare class class = Metaclass.
	self assert: BoardSquare class class = Metaclass.
	self assert: Object class class = Metaclass.
	self assert: Class class class = Metaclass.
	self assert: ClassDescription class class = Metaclass.
	self assert: Behavior class class = Metaclass.
	self assert: Metaclass superclass = ClassDescription.
	"The fixpoint"
	self assert: Metaclass class class = Metaclass! !

TestCase subclass: #OComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OComponentTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:40'!
testNestedReturnCopy
	<broken>
	"Test that mutliple non-crossable nested boundaries are correctly handled"! !

!OComponentTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:40'!
testParamCopy
	<broken>
	"Test that params are also subject to non-crossable boundaries"! !

!OComponentTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:35'!
testReturnCopy
	| tester |
	tester :=  OComponentTester newOwned: WorldOwner getInstance .
	self assert: ( tester testReturnCopy not )! !

TestCase subclass: #OLinkedListTest
	uses: TExceptionAssertion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OLinkedListTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:21'!
testAddRemoveFirst
	self assert: ( OLinkedListTester new testAddRemoveFirst = #1). 
	! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:22'!
testIterator
	self assert: ( OLinkedListTester new testIterator = #1). ! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:33'!
testLeakAddRemoveFirst
	self assertBoundaryCrossed: [ OLinkedListTester new testLeakAddRemoveFirst  ]! !

!OLinkedListTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:36'!
testLeakIterator
	self assertMessageFilter: [ OLinkedListTester new testLeakIterator ]! !

TestCase subclass: #OTreeTest
	uses: TExceptionAssertion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OTreeTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:46'!
testCreation
	self assertMessagePass: [ OTreeTester new testCreation ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:28'!
testCreationFreeze
	self assertMessageFilter: [ OTreeTester new testCreationFreeze ]. ! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:16'!
testSandboxCreation
	self assertMessagePass: [ OTreeTester new testSandboxCreation ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:25'!
testSandboxMutation
	self assertMessageFilter: [ OTreeTester new testSandboxMutation ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:20'!
testSandboxTraversal
	self assertMessagePass: [ OTreeTester new testSandboxTraversal ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:44'!
testSecureCreationBorrow 
	self assertMessagePass: [ OTreeTester new testSecureCreationBorrow ]! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:44'!
testSecureCreationFail
	self assertMessageFilter: [ OTreeTester new testSecureCreationFail ].! !

!OTreeTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:44'!
testSecureCreationImpersonate
	self assertMessageFilter: [ OTreeTester new testSecureCreationImpersonate  ].! !

TestCase subclass: #OwnedObject2Test
	instanceVariableNames: 'student studentOwner externalObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel-Test'!

!OwnedObject2Test methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:21'!
setUp
	student := ObjectWithReadWriteInterface  new.
	student internalInterface: #readWrite.
	student externalInterface: #read.
	
	studentOwner := OwnedObject2 new.
	
	student owner: studentOwner.
	
	externalObject := OwnedObject2 new.! !

!OwnedObject2Test methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:43'!
testInterfaceChange
	"test interface change"

	"try to access a method with a different interface"
	studentOwner checkValidSend: student message: #studentNumberSetterWithDifferentInterface: block: [:t | t studentNumberSetterWithDifferentInterface: 'tom'].
	self deny: ( student studentName = 'tom' ).
	
	self deny: ( (studentOwner checkValidSend: student message: #studentNumberGetterWithDifferentInterface block: [:t | t studentNumberGetterWithDifferentInterface]) = 'john' ).
	
	
	"change interfaces on student and try again"
	student internalInterface: #somethingDifferent.
	student externalInterface: #somethingDifferent.
	
	studentOwner checkValidSend: student message: #studentNumberSetterWithDifferentInterface: block: [:t | t studentNumberSetterWithDifferentInterface: 'tom'].
	self deny: ( student studentName = 'tom' ).
	
	self deny: ( (studentOwner checkValidSend: student message: #studentNumberGetterWithDifferentInterface block: [:t | t studentNumberGetterWithDifferentInterface]) = 'john' ).
	
	! !

!OwnedObject2Test methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:43'!
testValidSendWithInterfaces


	"owner tries to access readWrite method"
	studentOwner checkValidSend: student message: #studentName: block: [:t | t studentName: 'john'].
	self assert: ( student studentName = 'john' ).
	
	"externalObject tries to access readWrite method, should fail"
	externalObject checkValidSend: student message: #studentName: block: [:t | t studentName: 'jim'].
	self deny: ( student studentName = 'jim' ).
	
	"externalObject tries to access read method"
	self assert: ( (externalObject checkValidSend: student message: #studentName block: [:t | t studentName]) = 'john' ).
	
	! !

TestCase subclass: #OwnedObjectTest
	instanceVariableNames: 'ownedObjectA ownedObjectB ownedObjectC ownedObjectD ownedObjectE root studentList lectureList studentA studentB studentC lectureA lectureB addressA addressB addressC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

OwnedObjectTest class
	instanceVariableNames: 'ownedObjectA ownedObjectB ownedObjectC ownedObjectD ownedObjectE'!

OwnedObjectTest class
	instanceVariableNames: 'ownedObjectA ownedObjectB ownedObjectC ownedObjectD ownedObjectE'!

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'ewe 11/8/2011 11:21'!
exampleReflection
	| o aMessageName |
	o := Object new. 
	aMessageName := #name .
	o name "implicit message send" .
	o perform: aMessageName "explicit message send" .
	( Object >> aMessageName ) valueWithReceiver: o arguments: #().
! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:14'!
setUp
	"setUp simple ownership tree
	
	A->B, A->C
	B->D
	D->E"

	ownedObjectA:= OwnedObject new.
	ownedObjectB:= OwnedObject new.
	ownedObjectC:= OwnedObject new.
	ownedObjectD:= OwnedObject new.
	ownedObjectE:= OwnedObject new.
	
	ownedObjectB owner: ownedObjectA.
	ownedObjectC owner: ownedObjectA.
	ownedObjectD owner: ownedObjectB.
	ownedObjectE owner: ownedObjectD.
	

	"root -> studentList, lectureList
	root -> studentA, studentB, studentC, lectureA, lectureB
	
	studentA -> addressA
	studentB -> addressB
	studentC -> adressC
	
	may want to expand test so that studentList and lectureList are actual lists"
	

	root:= OwnedObjectWithPragmas new. 
	studentList:= OwnedObjectWithPragmas new.
	lectureList:= OwnedObjectWithPragmas new.
	
	studentA:= OwnedObjectWithPragmas new.
	studentB:= OwnedObjectWithPragmas new.
	studentC:= OwnedObjectWithPragmas new.
	lectureA:= OwnedObjectWithPragmas new.
	lectureB:= OwnedObjectWithPragmas new.
	
	addressA:= OwnedObjectWithPragmas new.
	addressB:= OwnedObjectWithPragmas new.
	addressC:= OwnedObjectWithPragmas new.
	

	studentList owner: root.
	lectureList owner: root.
	
	studentA owner: root.
	studentB owner: root.
	studentC owner: root.
	lectureA owner: root.
	lectureB owner: root.
	
	addressA owner: studentA.
	addressB owner: studentB.
	addressC owner: studentC.! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:04'!
testValidSendAboveInTree
	"test sends to self and owned objects"

	self deny: ( (addressA checkValidSend: addressA message: #normalMethod block: [:r |^true]) ).
	self assert: ( (addressA checkValidSend: studentA message: #pureMethod block: [:r |^true]) ).
	self assert: ( (addressA checkValidSend: studentA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:04'!
testValidSendBelowInTree
	"test message send to objects below in the tree (not owned)"

	self deny: ( (root checkValidSend: addressA message: #normalMethod block: [:r |^true]) ).
	self deny: ( (root checkValidSend: addressA message: #pureMethod block: [:r |^true]) ).
	self deny: ( (root checkValidSend: addressA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:04'!
testValidSendObjectsInOtherEncapsulationBoundary
	"tests sends to objects in another encabsulation boundary"

	self deny: ( (lectureA checkValidSend: addressA message: #normalMethod block: [:r |^true]) ).
	self deny: ( (lectureA checkValidSend: addressA message: #pureMethod block: [:r |^true]) ).
	self deny: ( (lectureA checkValidSend: addressA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:03'!
testValidSendSelfandChildren
	"test sends to self and owned objects"

	self assert: ( (root checkValidSend: root message: #normalMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: root message: #pureMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: root message: #oneWayMethod block: [:r |^true]) ).
	

	self assert: ( (root checkValidSend: studentA message: #normalMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: studentA message: #pureMethod block: [:r |^true]) ).
	self assert: ( (root checkValidSend: studentA message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 21:14'!
testValidSendSiblings
	"tests message sends to siblings"

	self deny: ( (lectureA checkValidSend: lectureB message: #normalMethod block: [:r |^true]) ).
	self assert: ( (lectureA checkValidSend: lectureB message: #pureMethod block: [:r |^true]) ).
	self assert: ( (lectureA checkValidSend: lectureB message: #oneWayMethod block: [:r |^true]) ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:40'!
testVisibilityAboveInTree
	"tests if an object above in the tree is visible"

	self assert: ( ownedObjectB checkVisibility: ownedObjectA ).
	self assert: ( ownedObjectC checkVisibility: ownedObjectA ).
	self assert: ( ownedObjectD checkVisibility: ownedObjectB ).
	self assert: ( ownedObjectE checkVisibility: ownedObjectD ).
	
	self assert: ( ownedObjectD checkVisibility: ownedObjectA ).
	self assert: ( ownedObjectE checkVisibility: ownedObjectB ).
	
	self assert: ( ownedObjectE checkVisibility: ownedObjectA ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:41'!
testVisibilityBelowInTree
	"tests if objects below in the tree (except children) are not visible"

	self deny: ( ownedObjectA checkVisibility: ownedObjectD ).
	self deny: ( ownedObjectA checkVisibility: ownedObjectE ).
	
	self deny: ( ownedObjectB checkVisibility: ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:42'!
testVisibilityChildren
	"tests if children are visible"
	
	self assert: ( ownedObjectA checkVisibility: ownedObjectB ).
	self assert: ( ownedObjectA checkVisibility: ownedObjectC ).
	self assert: ( ownedObjectB checkVisibility: ownedObjectD ).
	self assert: ( ownedObjectD checkVisibility: ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:41'!
testVisibilityObjectsInOtherEncapsulationBoundary
	"tests that an object in another encabsulation boundary is not visible"

	self deny: ( ownedObjectD checkVisibility: ownedObjectC ).
	self deny: ( ownedObjectE checkVisibility: ownedObjectC ).
	
	self deny: ( ownedObjectC checkVisibility: ownedObjectD ).
	self deny: ( ownedObjectC checkVisibility: ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 18:42'!
testVisibilitySelf
	"check if self is visible"

	self assert: ( ownedObjectA checkVisibility:  ownedObjectA ).
	self assert: ( ownedObjectB checkVisibility:  ownedObjectB ).
	self assert: ( ownedObjectC checkVisibility:  ownedObjectC ).
	self assert: ( ownedObjectD checkVisibility:  ownedObjectD ).
	self assert: ( ownedObjectE checkVisibility:  ownedObjectE ).! !

!OwnedObjectTest methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:51'!
testVisibilitySiblings
	"tests if siblings are visible"

	self assert: ( ownedObjectB checkVisibility: ownedObjectC ).
	self assert: ( ownedObjectC checkVisibility: ownedObjectB ).
	! !

TestCase subclass: #OwnershipCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 16:27'!
assertException: aBlock
 	self should: aBlock raise: Exception ! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 11:34'!
testArray
	| tester |
	tester := OwnershipCompilerTester new.
	self assert: ( tester testArray class name = #DOArray ).
	self assert: ( tester testArray owner = tester  )! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/22/2012 14:56'!
testArrayAndLiteralArray
	| tester c1 c2 |
	tester := OwnershipCompilerTester new.
	
	"{1. 2+3. #(2+3 {3+4}). 4}"
	
	c1:= DOArray withAll: #(2+3 {3+4}). c1 ownerNoCheck: tester. 
	c2:= DOArray withAll: {1. 2+3. c1. 4}. c2 ownerNoCheck: tester. 
	self assert: ( (tester testArrayAndLiteralArray) = c2).
	self assert: ( tester testArray owner = tester  )! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/22/2012 15:00'!
testArrayRecursion
	| tester c3 |
	tester := OwnershipCompilerTester new.
	
	"{ 1. 1+2. 3. {5. 1 } }. "
	c3 := (DOArray withAll: { 1. 1+2. 3. 
	( DOArray withAll: {5. 1 } ) ownerNoCheck: tester  } ) ownerNoCheck: tester . 
	
	self assert: ( (tester testArrayRecursion) = c3).
	self assert: ( tester testArray owner = tester  )! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testCascade
	OwnershipCompilerTester new testCascade .! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testException

	self assertException: [ OwnershipCompilerTester new testException .]! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testExceptionSignal 
	self assertException: [ OwnershipCompilerTester new testExceptionSignal ]! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testExperssionAsArguments 
	| tester |
	tester := OwnershipCompilerTester new .
	 tester testExperssionAsArguments 
	! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 14:21'!
testLiteralArray
	| tester |
	tester := OwnershipCompilerTester new.
	self assert: ( tester testLiteralArray class name = #DOArray )! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'pmaer 5/22/2012 15:01'!
testLiteralArrayRecursion
	| tester c1 c2 c3 c4 |
	tester := OwnershipCompilerTester new.
	
	"#(1 2 (3 4) 5 #(6 7))."
	c1:= (DOArray withAll: #(3 4) ) ownerNoCheck: tester. 
	c2:= (DOArray withAll: #(6 7)  ) ownerNoCheck: tester. .
	c3:= (DOArray withAll: {1. 2. c1. 5. c2}  ) ownerNoCheck: tester. .	
	self assert: ( (tester testLiteralArrayRecursion) = c3).! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testObjectAsArguments 
	| tester |
	tester := OwnershipCompilerTester new .
	self assert: ( tester testObjectAsArguments = 3 ) 
	! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testOrderOfEvaluation
	| tester |
	tester := OwnershipCompilerTester new.
	"if order is wrong, or if evaluated multiple time, result will not be 6"
	self assert: ( tester testOrderOfEvaluation = 6).
	! !

!OwnershipCompilerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 12:06'!
testOrderOfEvaluation2
	| tester |
	tester := OwnershipCompilerTester new.
	"if order is wrong, or if evaluated multiple time, result will not be 6"
	self assert: ( tester testOrderOfEvaluation2 = 6)
	! !

TestCase subclass: #ReturnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:27'!
testException
	
	[ 
		self useBlock:  [ Error signal: 'Error!!' ].
	] on: Error do: [ :ex | Transcript show:  ex messageText ].

	[ 
		self useBlockWithEnsure:  [ Error signal: 'Error!!' ].
	] on: Error do: [ :ex | Transcript show:  ex messageText ].! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:06'!
testNonLocalReturn
	| b v |
	b := [ Transcript show: 'Within the block'. 
		    ^ 42. ].
	v := self useBlock: b. 
	Transcript show: v. ! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:26'!
testNonLocalReturnEnsure
	| b v |
	b := [ Transcript show: 'Within the block'. 
		    ^ 42. ].
	v := self useBlockWithEnsure: b. 
	Transcript show: v. ! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:26'!
testOuter

	| v |
	v := self testNonLocalReturn.
	Transcript show: ('Value from outer ', v asString  ).
	
	v := self testNonLocalReturnEnsure.
	Transcript show: ('Value from outer ', v asString  ).! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:04'!
useBlock: aBlock
 
    aBlock value.
   Transcript show: 'Block was used'.! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:25'!
useBlockWithEnsure: aBlock
  [     aBlock value.
   ] ensure: [ Transcript show: 'Block was used'. ]! !

TestCase subclass: #SecureBankCustomerTest
	uses: TExceptionAssertion
	instanceVariableNames: 'bankCS bankUBS customerCS customerUBS'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

SecureBankCustomerTest class
	uses: TExceptionAssertion classTrait
	instanceVariableNames: ''!

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryCrossed: aBlock
 	 	self should: aBlock raise: OwnershipViolation ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
assertBoundaryOk: aBlock
 	self shouldnt: aBlock raise: OwnershipViolation ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 08:55'!
performTest
	Transcript show: '* Test ' ; show: testSelector asSymbol ; cr.
	super performTest. ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:41'!
setUp

	Transcript  show: '------' ; cr ; show: 'Set up start.' ; cr.

	Object resetOwners .

	bankCS := SecureBank new acronym: #CS.
	bankUBS := SecureBank new acronym: #UBS.
		
	customerCS := bankCS newCustomer identifier: #EWE ; firstname: 'Erwann' ; lastname: 'Wernli' .
	customerUBS := bankUBS newCustomer identifier: #PMA ; firstname: 'Paskal' ; lastname: 'Maerki' .
	customerCS partner: customerUBS. 
	customerUBS partner: customerCS. 
	
	Transcript show: 'Set up completed.' ; cr ;  show: '------' ; cr. ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:53'!
testBankSize
	
	self assertBoundaryCrossed: [ bankCS hasMoreCustomerThan: bankUBS. ]
	"self assert: ( bankCS customers size = 2 )"
		! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 12:05'!
testBankToCustomer

	self assertMessagePass: [ bankCS amountOf: customerCS ].
	self assertMessagePass: [ bankCS identifierOf: customerCS ].
	
	self assertMessageFilter: [ bankCS amountOf: customerUBS  ] .
	self assertMessagePass: [ bankCS identifierOf: customerUBS ].
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 14:43'!
testCustomerAccessBank

	self assertBoundaryOk:  [ customerCS isCustomerOf: bankCS ].
	self assertBoundaryCrossed:  [ customerCS isCustomerOf: bankUBS ].
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 14:46'!
testCustomerToBank

	self assertMessagePass: [ customerCS promoteFrom: bankCS ].
	self assertBoundaryCrossed: [ customerCS promoteFrom: bankUBS  ] .
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:19'!
testCustomerToCustomer
	<broken>
	self assert: ( customerCS canSend: #identifier to: customerCS ).
	self assert: ( customerCS canSend: #identifier to: customerUBS ).
	
	self assert: ( customerCS canSend: #credit: to: customerCS ).
	self assert: ( customerCS canSend: #credit: to: customerUBS ).
	
	self assert: ( customerCS canSend: #amount to: customerCS ).
	self assert: ( customerCS canNotSend: #amount to: customerUBS ).
	
	self assert: ( customerCS canSend: #withdraw: to: customerCS ).
	self assert: ( customerCS canNotSend: #withdraw: to: customerUBS ).
	! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 16:03'!
testPrimitive
	<broken>
	self assert: ( bankCS checkVisibility: #premium )  .
	self assert: ( customerCS checkVisibility: #premium ) not ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 15:52'!
testSetUp

	self assert: bankCS customers size = 1.
	self assert: bankUBS customers size = 1.
	self assert: customerCS identifier = #EWE. 
	self assert: customerUBS identifier = #PMA. ! !

!SecureBankCustomerTest methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 15:09'!
testSuspisiousCustomers
	
	self assertBoundaryOk: [ bankCS hasSuspiciousCustomers. ]

		! !

TestCase subclass: #SnakesAndLaddersTest
	instanceVariableNames: 'eg loadedDie jack jill'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakesAndLaddersTest commentStamp: 'on 3/15/2006 13:24' prior: 0!
Play a rigged game and check the results.!

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'on 3/16/2006 09:58'!
example
	^ SnakesAndLadders example! !

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'on 3/16/2006 09:58'!
setUp
	eg := self example.
	loadedDie := LoadedDie new.
	eg setDie: loadedDie.
	jack := eg players first.
	jill := eg players last.! !

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'on 3/23/2006 09:06'!
testExample
	self assert: eg currentPlayer = jack.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jack position = 6.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jack position = 5.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 4.
	eg playOneMove.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 6.
	eg playOneMove.
	self assert: jack position = 5.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 6.
	eg playOneMove.
	self assert: jill position = 9.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jack position = 10.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 2.
	eg playOneMove.
	self assert: jack position = 12.
	self assert: eg isOver! !

!SnakesAndLaddersTest methodsFor: 'running' stamp: 'pmaer 2/14/2012 01:28'!
testStartPosition
	self assert: eg lastPosition = 12.
	self assert: eg isNotOver.
	self assert: eg currentPlayer = jack.
	self assert: eg firstSquare isFirstSquare.
	self assert: eg firstSquare isLastSquare not.
	self assert: eg firstSquare position = 1.
	self assert: eg firstSquare isOccupied.
	self assert: (eg at: eg lastPosition) isFirstSquare not.
	self assert: (eg at: eg lastPosition) isLastSquare.
	self assert: (eg at: eg lastPosition) position = 12.
	self assert: (eg at: eg lastPosition) isOccupied not.
	self assert: jack name = 'Jack'.
	self assert: jill name = 'Jill'.
	self assert: jack position = 1.
	self assert: jill position = 1! !

SnakesAndLaddersTest subclass: #SnakesAndLaddersTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakesAndLaddersTest2 commentStamp: 'on 3/17/2006 10:50' prior: 0!
Some tests for a second example.!

!SnakesAndLaddersTest2 methodsFor: 'running' stamp: 'on 3/16/2006 09:59'!
example
	^ SnakesAndLadders example2! !

!SnakesAndLaddersTest2 methodsFor: 'running' stamp: 'on 3/18/2006 15:04'!
testExample
	self assert: jack name = 'Jack'.
	self assert: jill name = 'Jill'.
	self assert: jack position = 1.
	self assert: jill position = 1.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jack position = 2.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 2.
	eg playOneMove.
	self assert: jill position = 7.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 3.
	eg playOneMove.
	self assert: jack position = 5.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jill position = 7.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 2.
	eg playOneMove.
	self assert: jack position = 1.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 5.
	eg playOneMove.
	self assert: jill position = 12.
	self assert: eg currentPlayer = jack.
	loadedDie roll: 6.
	eg playOneMove.
	self assert: jack position = 7.
	self assert: eg currentPlayer = jill.
	loadedDie roll: 1.
	eg playOneMove.
	self assert: jill position = 13.
	self assert: eg isOver! !

Object subclass: #AllTouchedClassesCollector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

!AllTouchedClassesCollector methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:31'!
addAllClassNames: classToCheck set: nameSet checkedSet: checkedNameSet 


| methodDict  |

methodDict := classToCheck methodDictionary.

methodDict do: [ :each | 
	
	| literals |
	
	literals := each allLiterals.
	
	literals do: [ :eachLiteral |
		
			| objectName eachLiteralValue |
			objectName := ''.
			
			[
			eachLiteralValue := eachLiteral asString.
			((eachLiteralValue asString) at: 2) isUppercase ifTrue: [
					| n |
					n := 2.
					
					[ n <= ((eachLiteralValue asString) byteSize) and: ((eachLiteralValue at: n) isLetter ) ]
						whileTrue: [ 
							objectName := objectName, ((eachLiteralValue asString) at: n) asString.
							
							n := (n + 1).
							 ].
					
					[
						(Smalltalk at: objectName asSymbol) methodDictionary.
					
						nameSet add: objectName.
					] on: Error do: [].
			]
			] on: Error do: [ ].
		
	]

].
	checkedNameSet add: classToCheck asString.
  ! !

!AllTouchedClassesCollector methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:34'!
collectAllUsedClasses: classToCheck

	| nameSet checkedNameSet |
	nameSet := Set new.
	checkedNameSet := Set new.

	nameSet add: classToCheck asString.
	self addAllClassNames: classToCheck set: nameSet checkedSet: checkedNameSet.
	
	[ nameSet size = checkedNameSet size ] whileFalse: [
	
		nameSet do: [ :each | ((checkedNameSet like: each) = nil) ifTrue: [
					| anotherClassToCheck |
				
					"Transcript show: 'before checking -----------'; cr.
					Transcript show: nameSet; cr.
					Transcript show: checkedNameSet; cr."
			
				
					anotherClassToCheck := Smalltalk at: (each asSymbol).
					self addAllClassNames: anotherClassToCheck set: nameSet checkedSet: checkedNameSet.
			
					"	
					Transcript show: 'after checking -----------'; cr.
					Transcript show: nameSet; cr.
					Transcript show: checkedNameSet; cr."
			
			]	] 	].
		
	Transcript show: nameSet.! !

Object subclass: #AllTouchedMethodsCollector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

!AllTouchedMethodsCollector methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:41'!
addAllClassNames: classToCheck set: nameSet checkedSet: checkedNameSet 


| methodDict  |

methodDict := classToCheck methodDictionary.

methodDict do: [ :each | 
	
	| literals |
	
	literals := each allLiterals.
	
	literals do: [ :eachLiteral |
		
			| objectName eachLiteralValue |
			objectName := ''.
			
			[
			eachLiteralValue := eachLiteral asString.
			((eachLiteralValue asString) at: 2) isUppercase ifTrue: [
					| n |
					n := 2.
					
					[ n <= ((eachLiteralValue asString) byteSize) and: ((eachLiteralValue at: n) isLetter ) ]
						whileTrue: [ 
							objectName := objectName, ((eachLiteralValue asString) at: n) asString.
							
							n := (n + 1).
							 ].
					
					[
						(Smalltalk at: objectName asSymbol) methodDictionary.
					
						nameSet add: objectName.
					] on: Error do: [].
			]
			] on: Error do: [ ].
		
	]

].
	checkedNameSet add: classToCheck asString.
  ! !

!AllTouchedMethodsCollector methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:41'!
collectAllUsedClasses: classToCheck

	| nameSet checkedNameSet |
	nameSet := Set new.
	checkedNameSet := Set new.

	nameSet add: classToCheck asString.
	self addAllClassNames: classToCheck set: nameSet checkedSet: checkedNameSet.
	
	[ nameSet size = checkedNameSet size ] whileFalse: [
	
		nameSet do: [ :each | ((checkedNameSet like: each) = nil) ifTrue: [
					| anotherClassToCheck |
				
					"Transcript show: 'before checking -----------'; cr.
					Transcript show: nameSet; cr.
					Transcript show: checkedNameSet; cr."
			
				
					anotherClassToCheck := Smalltalk at: (each asSymbol).
					self addAllClassNames: anotherClassToCheck set: nameSet checkedSet: checkedNameSet.
			
					"	
					Transcript show: 'after checking -----------'; cr.
					Transcript show: nameSet; cr.
					Transcript show: checkedNameSet; cr."
			
			]	] 	].
		
	Transcript show: nameSet.! !

Object subclass: #BoardSquare
	instanceVariableNames: 'position player board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!BoardSquare commentStamp: 'on 3/14/2006 19:27' prior: 0!
Responsibilities:
- Remember position in the board
- Keep track of any players on this square
- Send on any players passing through
- Displays itself with its position and any player who might be on it, e.g., [7 Jack]!

!BoardSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
backwardBy: squares 
	^ squares = 0 
		ifTrue: [self destination]
		ifFalse: 
			[self isFirstSquare 
				ifTrue: [self nextSquare forwardBy: squares - 1]
				ifFalse: [self previousSquare backwardBy: squares - 1]]! !

!BoardSquare methodsFor: 'printing' stamp: 'on 3/14/2006 17:18'!
contents
	^ self isOccupied
		ifTrue: [ ' ', player asString ]
		ifFalse: [ '' ]! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
destination
	^ self! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/18/2006 11:43'!
forwardBy: squares
	self assert: self invariant.
	^ squares = 0 
		ifTrue: [self destination]
		ifFalse: 
			[self isLastSquare 
				ifFalse: [self nextSquare forwardBy: squares - 1]
				ifTrue: [self previousSquare backwardBy: squares - 1]]! !

!BoardSquare methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
invariant
	^ board notNil
		and: [[ position notNil ]
		and: [[ position >= 0 ]
		and: [[ position <= board lastPosition]]]]! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/14/2006 16:12'!
isFirstSquare
	^ position = 1! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/20/2006 10:17'!
isLastSquare
	^ position = board lastPosition! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/14/2006 16:40'!
isOccupied
	^ player notNil! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:43'!
landHere: aPlayer
	^ self isOccupied
		ifTrue: [ board firstSquare landHere: aPlayer ]
		ifFalse: [ player := aPlayer. self ]! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:32'!
nextSquare
	self assert: self isLastSquare not.
	^ board at: position + 1! !

!BoardSquare methodsFor: 'testing' stamp: 'on 3/14/2006 17:03'!
position
	^ position! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:32'!
previousSquare
	self assert: self isFirstSquare not.
	^ board at: position - 1! !

!BoardSquare methodsFor: 'printing' stamp: 'on 3/14/2006 16:08'!
printOn: aStream
	aStream nextPutAll: '[', position printString, self contents, ']'.! !

!BoardSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:14'!
remove: aPlayer
	self assert: player = aPlayer.
	player := nil.! !

!BoardSquare methodsFor: 'initialize-release' stamp: 'on 3/18/2006 15:13'!
setPosition: aNumber board: aBoard 
	position := aNumber.
	board := aBoard! !

BoardSquare subclass: #FirstSquare
	instanceVariableNames: 'players'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!FirstSquare commentStamp: 'on 3/14/2006 19:06' prior: 0!
Responsibilities:
- Allows multiple players to be added or removed [normal squares can only hold a single player]!

!FirstSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!FirstSquare methodsFor: 'printing' stamp: 'on 3/14/2006 15:35'!
contents
	^ players inject: '' into:
			[ :list :each | list , ' ', each asString ]! !

!FirstSquare methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
initialize
	players := OrderedCollection new.! !

!FirstSquare methodsFor: 'testing' stamp: 'pmaer 2/14/2012 01:36'!
isOccupied
	^ players size > 0! !

!FirstSquare methodsFor: 'initialize-release' stamp: 'on 3/15/2006 15:29'!
landHere: aPlayer
	players add: aPlayer.! !

!FirstSquare methodsFor: 'playing' stamp: 'on 3/14/2006 16:15'!
remove: aPlayer
	self assert: (players includes: aPlayer).
	players remove: aPlayer.! !

BoardSquare subclass: #LadderSquare
	instanceVariableNames: 'forward'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!LadderSquare commentStamp: 'on 3/17/2006 10:36' prior: 0!
Responsibilities:
- If a player lands here, send him or her up the ladder (forward # squares)
- Displays itself as a square with a positive offset, e.g., [6]3+>!

!LadderSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!LadderSquare class methodsFor: 'instance creation' stamp: 'on 3/18/2006 12:50'!
forward: number
	^ self new setForward: number! !

!LadderSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
destination
	^ self forwardBy: forward! !

!LadderSquare methodsFor: 'printing' stamp: 'on 3/16/2006 14:35'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: forward asString, '+>'.! !

!LadderSquare methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:49'!
setForward: aNumber
	forward := aNumber.! !

BoardSquare subclass: #SnakeSquare
	instanceVariableNames: 'back'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakeSquare commentStamp: 'on 3/20/2006 09:14' prior: 0!
Responsibilities:
- If a player lands here, send him or her backwards (back # squares)
- Displays itself as a square with a negative offset, e.g., <-3[5]!

!SnakeSquare class methodsFor: 'instance creation' stamp: 'on 3/18/2006 12:50'!
back: number
	^ self new setBack: number! !

!SnakeSquare class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!SnakeSquare methodsFor: 'playing' stamp: 'on 3/15/2006 15:26'!
destination
	^ self backwardBy: back! !

!SnakeSquare methodsFor: 'printing' stamp: 'on 3/16/2006 14:35'!
printOn: aStream
	aStream nextPutAll: '<-', back asString.
	super printOn: aStream.! !

!SnakeSquare methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:50'!
setBack: aNumber
	back := aNumber.! !

Object subclass: #ClassWithPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!ClassWithPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:54'!
andMoreStuff
	"empty method with a pragma"

	<anotherPragma>! !

!ClassWithPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:54'!
doStuff
	"empty method with two pragmas"

	<hello>
	<world>! !

!ClassWithPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:54'!
moreStuff
	"empty method with a pragma"

	<bye>! !

Object subclass: #CollectPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership'!

!CollectPragmas methodsFor: 'as yet unclassified' stamp: 'PascalMaerki 11/14/2011 22:49'!
collectAllPragmas: aClass
	"collects all Pragmas in aClass and returns them in an orderedCollection"

	| pragmaCollection |

	pragmaCollection:= OrderedCollection new.

	(aClass methodDict do: [:each | pragmaCollection addAll: each pragmas]).
	
	^pragmaCollection.! !

Object subclass: #DOFlag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

DOFlag class
	instanceVariableNames: 'doFlag'!

DOFlag class
	instanceVariableNames: 'doFlag'!

!DOFlag class methodsFor: 'accessing' stamp: 'pmaer 2/15/2012 15:11'!
doFlag
	(doFlag = nil) ifTrue: [ doFlag:= false ].
	^ doFlag! !

!DOFlag class methodsFor: 'accessing' stamp: 'pmaer 2/15/2012 15:10'!
doFlag: anObject
	doFlag := anObject! !

Object subclass: #DOKernelClassesRewriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

!DOKernelClassesRewriter class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/11/2012 16:16'!
buildClassNameCollection

	| t |
	t := OrderedCollection new.
	
	t addLast: 'Association'.
	t addLast: 'Collection'.
	t addLast: 'HashedCollection'.
	t addLast: 'Dictionary'.
	t addLast: 'IdentityDictionary'.
	t addLast: 'Set'.
	t addLast: 'SequenceableCollection'.
	t addLast: 'ArrayedCollection'.
	t addLast: 'Array'.
	t addLast: 'OrderedCollection '.
	t addLast: 'Magnitude'.
	t addLast: 'LookupKey'.
	t addLast: 'Mutex'.


	^t.! !

!DOKernelClassesRewriter class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/11/2012 17:16'!
replaceStrings: string

	| t temp index |
	t := DOKernelClassesRewriter buildClassNameCollection.
	temp := string copy.
		
	t do: [:each |
				
			index := 1.
			
			[index = 0] whileFalse: [
				
				"Transcript show: (temp findString: each startingAt: index)."
				index:= temp findString: each startingAt: index.
							
				(index = 0) ifFalse: [
						"Transcript show: (temp at: index -1);cr.
						Transcript show: ((temp at: index-1) = $) or: [(temp at: index-1) = $^] );cr."
						((temp at: index-1) =($ ) or: [(temp at: index-1) = $^ or: [(temp at: index-1) = $=]]) ifTrue: [
								temp:= temp copyReplaceFrom: index to: (index + each size -1) with: ('DO',each).	
								
								Transcript show: 'replacing ',(temp copyFrom: index to: (index + each size)), '  with ',('DO',each).				
						].
					].
				
				(index = 0) ifFalse: [ index := index + 1. ].
			].
		].
	^temp.

	! !

!DOKernelClassesRewriter class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/11/2012 16:56'!
rewriteClass: classToRewrite
	| methodDic literals source newSource |

	"instance side"
	methodDic := classToRewrite methodDictionary.
	
	methodDic do: [ :each | 
		Transcript show: 'checking ',each selector; cr.
		source:= (each) getSource.
		
		newSource:= DOKernelClassesRewriter replaceStrings: source.
		classToRewrite compile: newSource.
	].
	"class side"
	methodDic := classToRewrite class methodDictionary.
	
	methodDic do: [ :each | 
		Transcript show: 'checking ',each selector; cr.
		source:= (each) getSource.
		
		newSource:= DOKernelClassesRewriter replaceStrings: source.
		classToRewrite class compile: newSource.
	].! !

Object subclass: #DOLogger
	instanceVariableNames: ''
	classVariableNames: 'Instance log'
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

!DOLogger class methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 12:45'!
getInstance
	"returns the Instance, if it doesn't exist yet create it"
	^Instance ifNil: [Instance := self basicNew.
					Instance setLog. ].! !

!DOLogger class methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:27'!
reset
	Instance := nil.! !

!DOLogger methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 12:46'!
add: obj
	log add: obj.! !

!DOLogger methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 12:46'!
getLog
	^log.! !

!DOLogger methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 12:47'!
setLog
	log := Set new.! !

Object subclass: #DOMagnitude
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOMagnitude commentStamp: 'sd 9/4/2005 10:14' prior: 0!
I'm the abstract class Magnitude that provides common protocol for objects that have
the ability to be compared along a linear dimension, such as dates or times.
Subclasses of Magnitude include Date, ArithmeticValue, and Time, as well as
Character and LookupKey.
 
 
My subclasses should implement
  < aMagnitude 
  = aMagnitude 
  hash

Here are some example of my protocol:
     3 > 4
     5 = 6
     100 max: 9
	7 between: 5 and: 10 
!

DOMagnitude subclass: #DOLookupKey
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOLookupKey commentStamp: '<historical>' prior: 0!
I represent a key for looking up entries in a data structure. Subclasses of me, such as Association, typically represent dictionary entries.!

DOLookupKey subclass: #DOAssociation
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOAssociation commentStamp: 'StephaneDucasse 2/13/2010 15:13' prior: 0!
I represent a pair of associated objects--a key and a value. My instances can serve as entries in a dictionary.


Implementation notes: 
Note that hash is not redefined even if the = was redefined because Association>>hash may cause extreme slowdowns in compiling Unicode methods. Association>>hash does not need to hash the value; it's slow and useless.

!

!DOAssociation class methodsFor: 'instance creation' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^OwnershipCompiler3! !

!DOAssociation class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 17:14'!
key: newKey value: newValue
	"Answer an instance of me with the arguments as the key and value of 
	the association."
	<meta>
	| o |
	o := (super key: newKey).
	o ownerNoCheck: self thisSender.
	o value: newValue.
	^o.! !

!DOAssociation methodsFor: 'comparing' stamp: 'md 1/27/2004 17:27'!
= anAssociation

	^ super = anAssociation and: [value = anAssociation value]! !

!DOAssociation methodsFor: 'self evaluating' stamp: 'pmaer 5/14/2012 14:05'!
isSelfEvaluating
	^ self class == DOAssociation and: [self key isSelfEvaluating and: [self value isSelfEvaluating]]! !

!DOAssociation methodsFor: 'accessing' stamp: ''!
key: aKey value: anObject 
	"Store the arguments as the variables of the receiver."

	key := aKey.
	value := anObject! !

!DOAssociation methodsFor: 'printing' stamp: ''!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '->'.
	value printOn: aStream! !

!DOAssociation methodsFor: 'printing' stamp: ''!
storeOn: aStream
	"Store in the format (key->value)"
	aStream nextPut: $(.
	key storeOn: aStream.
	aStream nextPutAll: '->'.
	value storeOn: aStream.
	aStream nextPut: $)! !

!DOAssociation methodsFor: 'accessing' stamp: ''!
value
	"Answer the value of the receiver."

	^value! !

!DOAssociation methodsFor: 'accessing' stamp: ''!
value: anObject 
	"Store the argument, anObject, as the value of the receiver."

	value := anObject! !

!DOLookupKey class methodsFor: 'instance creation' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^OwnershipCompiler3! !

!DOLookupKey class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:35'!
key: aKey 
	"Answer an instance of me with the argument as the lookup up."
	<meta>
	| o |
	o:= self basicNew.
	o ownerNoCheck: self thisSender.
	o key: aKey.
	^o.! !

!DOLookupKey methodsFor: 'comparing' stamp: ''!
< aLookupKey 
	"Refer to the comment in Magnitude|<."

	^key < aLookupKey key! !

!DOLookupKey methodsFor: 'comparing' stamp: ''!
= aLookupKey

	self species = aLookupKey species
		ifTrue: [^key = aLookupKey key]
		ifFalse: [^false]! !

!DOLookupKey methodsFor: 'accessing' stamp: 'ajh 9/12/2002 12:04'!
canAssign

	^ true! !

!DOLookupKey methodsFor: 'comparing' stamp: ''!
hash
	"Hash is reimplemented because = is implemented."

	^key hash! !

!DOLookupKey methodsFor: 'testing' stamp: 'ar 8/14/2003 01:52'!
isSpecialReadBinding
	"Return true if this variable binding is read protected, e.g., should not be accessed primitively but rather by sending #value messages"
	^false! !

!DOLookupKey methodsFor: 'testing' stamp: 'ar 8/14/2001 22:39'!
isVariableBinding
	"Return true if I represent a literal variable binding"
	^true! !

!DOLookupKey methodsFor: 'accessing' stamp: ''!
key
	"Answer the lookup key of the receiver."

	^key! !

!DOLookupKey methodsFor: 'accessing' stamp: ''!
key: anObject 
	"Store the argument, anObject, as the lookup key of the receiver."

	key := anObject! !

!DOLookupKey methodsFor: 'accessing' stamp: 'ajh 3/24/2003 21:14'!
name

	^ self key isString
		ifTrue: [self key]
		ifFalse: [self key printString]! !

!DOLookupKey methodsFor: 'printing' stamp: ''!
printOn: aStream

	key printOn: aStream! !

!DOLookupKey methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 02:35'!
writeOnFilterStream: aStream

	aStream write:key.! !

!DOMagnitude class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^OwnershipCompiler3! !

!DOMagnitude methodsFor: 'testing' stamp: ''!
< aMagnitude 
	"Answer whether the receiver is less than the argument."

	^self subclassResponsibility! !

!DOMagnitude methodsFor: 'testing' stamp: ''!
<= aMagnitude 
	"Answer whether the receiver is less than or equal to the argument."

	^(self > aMagnitude) not! !

!DOMagnitude methodsFor: 'testing' stamp: ''!
= aMagnitude 
	"Compare the receiver with the argument and answer with true if the 
	receiver is equal to the argument. Otherwise answer false."

	^self subclassResponsibility! !

!DOMagnitude methodsFor: 'testing' stamp: ''!
> aMagnitude 
	"Answer whether the receiver is greater than the argument."

	^aMagnitude < self! !

!DOMagnitude methodsFor: 'testing' stamp: 'nice 12/31/2008 04:06'!
>= aMagnitude 
	"Answer whether the receiver is greater than or equal to the argument."

	^aMagnitude <= self! !

!DOMagnitude methodsFor: 'testing' stamp: ''!
between: min and: max 
	"Answer whether the receiver is less than or equal to the argument, max, 
	and greater than or equal to the argument, min."

	^self >= min and: [self <= max]! !

!DOMagnitude methodsFor: 'hash' stamp: ''!
hash
	"Hash must be redefined whenever = is redefined."

	^self subclassResponsibility! !

!DOMagnitude methodsFor: 'comparing' stamp: ''!
max: aMagnitude 
	"Answer the receiver or the argument, whichever has the greater 
	magnitude."

	self > aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!DOMagnitude methodsFor: 'comparing' stamp: ''!
min: aMagnitude 
	"Answer the receiver or the argument, whichever has the lesser 
	magnitude."

	self < aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!DOMagnitude methodsFor: 'comparing' stamp: ''!
min: aMin max: aMax 

	^ (self min: aMin) max: aMax! !

Object subclass: #DOMutex
	instanceVariableNames: 'semaphore owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOMutex commentStamp: '<historical>' prior: 0!
A Mutex is a light-weight MUTual EXclusion object being used when two or more processes need to access a shared resource concurrently. A Mutex grants ownership to a single process and will suspend any other process trying to aquire the mutex while in use. Waiting processes are granted access to the mutex in the order the access was requested.

Instance variables:
	semaphore	<Semaphore>		The (primitive) semaphore used for synchronization.
	owner		<Process>		The process owning the mutex.!

!DOMutex class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:43'!
compilerClass
	^OwnershipCompiler3! !

!DOMutex methodsFor: 'mutual exclusion' stamp: 'das 11/3/2005 22:53'!
critical: aBlock
	"Evaluate aBlock protected by the receiver."
	| activeProcess |
	activeProcess := Processor activeProcess.
	activeProcess == owner ifTrue:[^aBlock value].
	^semaphore critical:[
		owner := activeProcess.
		aBlock ensure:[owner := nil]].! !

!DOMutex methodsFor: 'initialize' stamp: 'alain.plantec 5/28/2009 10:11'!
initialize
	super initialize.
	semaphore := Semaphore forMutualExclusion.! !

Object subclass: #Die
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!Die commentStamp: 'on 3/14/2006 19:06' prior: 0!
Responsibilities:
- Yields a random number from 1 to 6 ;-)!

!Die class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!Die methodsFor: 'playing' stamp: 'on 3/14/2006 15:41'!
roll
	^ (1 to: 6) atRandom! !

Die subclass: #LoadedDie
	instanceVariableNames: 'roll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!LoadedDie commentStamp: 'on 3/17/2006 10:50' prior: 0!
For testing purposes. When rolled, a loaded die returns a fixed value.!

!LoadedDie class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!LoadedDie methodsFor: 'playing' stamp: 'on 3/18/2006 15:24'!
roll
	self assert: roll notNil.
	^ roll! !

!LoadedDie methodsFor: 'playing' stamp: 'on 3/18/2006 15:25'!
roll: aNumber
	self assert: ((1 to: 6) includes: aNumber).
	roll := aNumber.! !

Object subclass: #GamePlayer
	instanceVariableNames: 'name square'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!GamePlayer commentStamp: 'on 3/14/2006 19:07' prior: 0!
Responsibilities:
- Keep track of the square you are on
- Roll the die
- Attempt to move the resulting number of squares!

!GamePlayer class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!GamePlayer class methodsFor: 'instance creation' stamp: 'on 3/18/2006 12:48'!
named: aName
	^ self new setName: aName! !

!GamePlayer methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:08'!
invariant
	^ square notNil
		and: [ name notNil ]! !

!GamePlayer methodsFor: 'private' stamp: 'on 3/14/2006 15:53'!
leaveCurrentSquare
	square notNil ifTrue: [ square remove: self ].! !

!GamePlayer methodsFor: 'playing' stamp: 'on 3/18/2006 15:21'!
moveTo: aSquare
	self leaveCurrentSquare.
	square := aSquare landHere: self.
! !

!GamePlayer methodsFor: 'playing' stamp: 'on 3/23/2006 09:04'!
moveWith: aDie
	| roll destination |
	self assert: self invariant.
	roll := aDie roll.
	destination := square forwardBy: roll.
	self moveTo: destination.
	^ name, ' rolls ', roll asString, ' and lands at ', square asString! !

!GamePlayer methodsFor: 'testing' stamp: 'on 3/15/2006 14:57'!
name
	^ name! !

!GamePlayer methodsFor: 'testing' stamp: 'on 3/14/2006 17:03'!
position
	^ square position! !

!GamePlayer methodsFor: 'printing' stamp: 'on 3/14/2006 15:32'!
printOn: aStream
	aStream nextPutAll: name! !

!GamePlayer methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:49'!
setName: aName
	name := aName.! !

Object subclass: #HtmlWriter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 10:26'!
header: display
	self open: '<h1>' inner: display close: '</h1>'.
	! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 11:01'!
horizontalLine
	stream write: '<hr/>'.
	! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 11:01'!
link: display url: url

	self open: '<a href=''' , url , ''' >' inner: display close: '</a>'.
	! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 10:15'!
newLine
	stream write: '</br>'.
	! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 10:24'!
open: openTag do: aBlock close: closeTag 

	stream write: openTag. 
	aBlock value.
	stream write: closeTag.! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 10:58'!
open: openTag inner: html close: closeTag 

	stream write: openTag. 
	stream write: html. 
	stream write: closeTag.! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 11:58'!
postForm: url do: aBlock
	self open: '<form method=''POST'' action=''', url , '''>' do: aBlock close: '</form>'.	 
		 ! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 10:16'!
raw: html
	stream write: html.
	! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 10:15'!
stream: aStream
	stream := aStream. ! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 11:59'!
submit
	stream write: '<input type=submit value=''submit''/>'! !

!HtmlWriter methodsFor: 'as yet unclassified' stamp: 'ewe 5/9/2012 12:03'!
textArea: display id: id
	self open: '<textarea id=''' , id , ''' name=''' , id , ''' cols=40 rows=6>' inner: display close: '</textarea>' ! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 4/20/2012 16:22'!
isOwnershipAware
	^ self  compilerClass == OwnershipCompiler3 ! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 5/10/2012 15:48'!
newOwned: owner 
	| n |
	n := self new. 
	n ownerNoCheck: owner.
	^ n.! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 4/25/2012 18:17'!
owners
	( Owners = nil) ifTrue: [ Owners := WeakKeyDictionary new. ].
	^ Owners. ! !

!Object class methodsFor: '*dynamicownership' stamp: 'ewe 4/26/2012 09:57'!
resetOwners
	Owners := IdentityDictionary new. ! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/9/2012 16:22'!
acceptOwnee: candidateOwnee
	"TODO: very ugly"
	Transcript show: ( 'Sender is ', thisContext sender sender sender receiver printString  ) ; cr. 
	Transcript show: ( 'Sender of sender is ', thisContext sender sender sender sender sender sender sender receiver printString  ) ; cr. 

	^ (	thisContext sender sender sender receiver = candidateOwnee class )
	   and: [	thisContext sender sender sender sender sender sender sender receiver = self ].! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 2/1/2012 11:10'!
boundaryCrossed: returnValue receiver: receiver
	"hook"
	"TODO: implement behavior for boundary crossing"
	^returnValue! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 6/5/2012 14:56'!
checkValidSend3: sender message: selector block: block arguments: arguments
	| argumentsWithSelf |
	
	"DOLogger getInstance add: self class."
	
	"special case for object instantiation"
	( selector = #new ) ifTrue: [
		^ self new primOwner: sender. 
	].

	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for now)"
	"TODO actual checkValidSend method is on OwnedObject3>>checkValidSend3, move to here when finished"
	
	"Transcript show: self class printString ; show: ' ' ; show: selector ; cr."
	
	argumentsWithSelf := OrderedCollection new.
	argumentsWithSelf addAll: arguments. 
	argumentsWithSelf addFirst: self. 
	
	"TODO temporary hack" 
	"[ ^block valueWithArguments: argumentsWithSelf. ] "
	[ ^self perform: selector withArguments: arguments ] 
	on: Exception 
	do: [ :ex | Transcript show: ( 'Exception', ex printString).  ex pass ]! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 6/5/2012 12:37'!
checkValidSend: receiver message: selector block: block
	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for now)"
	"(DOFlag doFlag) ifTrue: [
		
		[
			^block valueWithArguments: { self }.
		] on: Error do: [  ].
	] ifFalse: [ DOFlag doFlag: true.
				self halt.].
	"
	
	"evaluate the block"
	"DOFlag doFlag: false."
	[
		^block valueWithArguments: { self }.
	] on: Error do: [  ] ! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 17:01'!
checkVisibility: objectToCheck
	"check if objectToCheck is visible to self "

	| tempOwner |
	
	"check self"
	( self == objectToCheck ) ifTrue: [^true].
	
	"check children"
	(objectToCheck owner == self) ifTrue: [^true].
	
	"check sibling"
	(objectToCheck owner == self owner) ifTrue: [^true].
	
	"check above ownership tree"
	tempOwner := self owner.

	[ tempOwner == objectToCheck  or: tempOwner = WorldOwner getInstance ] whileFalse: [
	
		( tempOwner == nil)
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 11:52'!
dynamicOwner
	"returns the owner, if no owner is assinged, return the WorldOwner"
	^Object owners at: self ifAbsent: [ ^ WorldOwner getInstance ] ! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 11:52'!
dynamicOwner: anOwner
	"setter for owner"
	Object owners at: self put: anOwner.! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:16'!
inFilters
	^{#none}! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 4/20/2012 17:08'!
isOwnershipAware
	[^self compilerClass = OwnershipCompiler3] on: MessageNotUnderstood do: [^false].! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:16'!
outFilters
	^{#all}! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 14:57'!
owner
	"returns the owner, if no owner is assinged, return the WorldOwner"
	^Object owners at: self ifAbsent: [ ^ WorldOwner getInstance ] ! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/27/2012 14:57'!
owner: anOwner
	"setter for owner"
	Object owners at: self put: anOwner.! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/10/2012 15:50'!
ownerNoCheck: newOwner
	"TODO this one should ideally never be used. Momentary necessary because of instrumented / not instrumente d code"
	"setter for owner"
	Object owners at: self put: newOwner.! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 4/20/2012 17:03'!
ownersAsList
	|tempOwner owners|
	owners := OrderedCollection new.
	tempOwner:= self owner.
	[ tempOwner ~= WorldOwner getInstance ] whileTrue: [ 
		owners addFirst: tempOwner.
		tempOwner:= tempOwner owner.
	].
	^ owners.! !

!Object methodsFor: '*dynamicownership' stamp: 'ewe 5/2/2012 16:55'!
primOwner: anOwner
	"This method should be used only internaly. It a hack to create object with the sender as owner by default."
	Object owners at: self put: anOwner.! !

!Object methodsFor: '*dynamicownership' stamp: 'pmaer 5/22/2012 14:39'!
thisSender
	"TODO ugly and depends on the rewriting with synthetic closures etc"
	( thisContext sender sender method selector = 
		#checkValidSend3:message:block:arguments: ) ifTrue: [
			^ thisContext sender sender sender sender sender receiver.
		] ifFalse: [
			^ thisContext sender sender receiver.
		]
	

	! !

Object subclass: #OwnedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

OwnedObject subclass: #ObjectWithOwnershipCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!ObjectWithOwnershipCompiler class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 09:31'!
compilerClass
^ OwnershipCompiler! !

!ObjectWithOwnershipCompiler methodsFor: 'as yet unclassified' stamp: 'pmaer 1/23/2012 16:52'!
objectName   
	| a b anObj | 
	self do: a with: b.
	
	anObj doWith: anObj name.     ! !

!ObjectWithOwnershipCompiler methodsFor: 'as yet unclassified' stamp: 'pmaer 1/23/2012 16:55'!
test
	| a |
	^a  ! !

!OwnedObject class methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:44'!
new
	| n |
	n := super new. 
	"n owner: 'the caller'."
	^ n.! !

!OwnedObject class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/23/2012 14:30'!
newOwned: owner 
	| n |
	n := self new. 
	n ownerNoCheck: owner.
	^ n.! !

!OwnedObject class methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:45'!
owners
	( Owners = nil) ifTrue: [ Owners := WeakKeyDictionary new. ].
	^ Owners. ! !

!OwnedObject methodsFor: 'as yet unclassified' stamp: 'ewe 1/24/2012 11:40'!
checkValidSend: receiver message: selector block: block
	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for 	now)"


	| messagePragmas aMethodDict oneWay pure |
	
	oneWay := false.
	pure := false.
	
	aMethodDict:= receiver class methodDict.
	messagePragmas := (aMethodDict at: selector) pragmas.
	
	messagePragmas do: [:each |
			(each keyword = #pure) ifTrue: [
				pure:= true].
			(each keyword = #oneWay) ifTrue: [
				oneWay := true].
		 ].
	
	
	"normal message send, only allowed to self or owned"
	(oneWay or: pure) ifFalse: [

		( (receiver == self) or: (receiver owner == self ) ) ifFalse: [^false]
		
		]
	

	"oneWay or pure message send, allowed to all visible"
	 ifTrue: [

		(self checkVisibility: receiver) ifFalse: [^false].
		
		].
	
	"evaluate the block and return"
	^block valueWithArguments: { receiver }.
		
	"Add a check for the returned value. Inovke the hook if necessary"! !

!OwnedObject methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 16:59'!
checkVisibility: objectToCheck
	"check if objectToCheck is visible to self "

	| tempOwner |
	
	"check self"
	( self == objectToCheck ) ifTrue: [^true].
	
	"check children"
	(objectToCheck owner == self) ifTrue: [^true].
	
	"check sibling"
	(objectToCheck owner == self owner) ifTrue: [^true].
	
	"check above ownership tree"
	tempOwner := self owner.

	[ tempOwner == objectToCheck ] whileFalse: [
	
		( tempOwner == nil or: tempOwner = WorldOwner getInstance )
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

OwnedObject subclass: #OwnedObjectWithPragmas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!OwnedObjectWithPragmas methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:53'!
normalMethod
	Transcript show: 'normal method executed'.! !

!OwnedObjectWithPragmas methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:53'!
oneWayMethod
	<oneWay>
	Transcript show: 'oneWay method executed'.! !

!OwnedObjectWithPragmas methodsFor: 'as yet unclassified' stamp: 'pmaer 12/12/2011 20:54'!
pureMethod
	<pure>
	Transcript show: 'pure method executed'.! !

OwnedObject subclass: #TestLiterals
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel-Test'!

!TestLiterals methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 13:56'!
a
	Object new.
	OwnedObject new.
	"Random Stuff"! !

!TestLiterals methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 15:00'!
b
	| objectName eachLiteral |
			eachLiteral := 'Object->OwnedObject'.
			objectName := ' '.
			[
			(eachLiteral asString at: 2) isUppercase ifTrue: [
				
					
					
					2 to: (eachLiteral length) do: [ :n | ((eachLiteral at: n) isLetter ) 

whileTrue: [ 
							objectName join: (eachLiteral at: n).
								
							
							 ]   ]
					
					Transcript show: objectName.
					
				]]! !

Object subclass: #OwnedObject2
	instanceVariableNames: 'internalInterface externalInterface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

OwnedObject2 subclass: #ObjectWithOwnershipCompiler2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel'!

!ObjectWithOwnershipCompiler2 class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_1! !

!ObjectWithOwnershipCompiler2 methodsFor: 'as yet unclassified' stamp: 'pmaer 1/2/2012 19:18'!
objectName   
	| a b anObj | 
	self do: a with: b.
	
	anObj doWith: anObj name.    ! !

!ObjectWithOwnershipCompiler2 methodsFor: 'as yet unclassified' stamp: 'pmaer 2/3/2012 15:02'!
test
	|a|
	a:= Object new.
	^a do: a.   ! !

OwnedObject2 subclass: #ObjectWithReadWriteInterface
	instanceVariableNames: 'studentNumber studentName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-SecondModel-Test'!

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:00'!
studentName
	<read>
	<readWrite>
	^ studentName! !

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:00'!
studentName: anObject
	<readWrite>
	studentName := anObject! !

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:00'!
studentNumber
	<read>
	<readWrite>
	^ studentNumber! !

!ObjectWithReadWriteInterface methodsFor: 'accessing' stamp: 'pmaer 1/16/2012 23:01'!
studentNumber: anObject
	<readWrite>
	studentNumber := anObject! !

!ObjectWithReadWriteInterface methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:38'!
studentNumberGetterWithDifferentInterface
	<somethingDifferent>
	^studentNumber.
	! !

!ObjectWithReadWriteInterface methodsFor: 'as yet unclassified' stamp: 'pmaer 1/16/2012 23:38'!
studentNumberSetterWithDifferentInterface: anObject
	<somethingDifferent>
	studentNumber := anObject
	! !

!OwnedObject2 methodsFor: 'as yet unclassified' stamp: 'pmaer 1/30/2012 17:39'!
boundaryCrossed: returnValue receiver: receiver
	"hook"
	"TODO: implement behavior for boundary crossing"
	^returnValue! !

!OwnedObject2 methodsFor: 'as yet unclassified' stamp: 'pmaer 1/30/2012 17:40'!
checkValidSend: receiver message: selector block: block
	"checks if the message send is valid. if valid send: evaluate the block, if non valid send: return false (for now)"


	| messagePragmas aMethodDict isInternalInterface isExternalInterface returnValue |
	
	isInternalInterface := false.
	isExternalInterface := false.
	
	aMethodDict:= receiver class methodDict.
	messagePragmas := (aMethodDict at: selector) pragmas.
	
	messagePragmas do: [:each |
			(each keyword = receiver externalInterface ) ifTrue: [
				isExternalInterface:= true].
			(each keyword = receiver internalInterface ) ifTrue: [
				isInternalInterface := true].
		 ].
	
	(isInternalInterface and: isExternalInterface not) ifTrue:[
		( (receiver == self) or: (receiver owner == self ) ) ifFalse: [^false]
		]
		ifFalse: [ (isExternalInterface) ifFalse: [^false] ].
	
	"evaluate the block"
	returnValue:= block valueWithArguments: { receiver }.
	
	"check for boundary crossing"
	(receiver checkVisibility: returnValue) ifTrue: [ ^returnValue ]
		"TODO: decide where to call boundaryCrossed (now on owner)"
		ifFalse: [ ^(returnValue owner boundaryCrossed: returnValue receiver: receiver) ]! !

!OwnedObject2 methodsFor: 'as yet unclassified' stamp: 'pmaer 4/20/2012 17:00'!
checkVisibility: objectToCheck
	"check if objectToCheck is visible to self "

	| tempOwner |
	
	"check self"
	( self == objectToCheck ) ifTrue: [^true].
	
	"check children"
	(objectToCheck owner == self) ifTrue: [^true].
	
	"check sibling"
	(objectToCheck owner == self owner) ifTrue: [^true].
	
	"check above ownership tree"
	tempOwner := self owner.

	[ tempOwner == objectToCheck or: tempOwner = WorldOwner getInstance ] whileFalse: [
	
		( tempOwner == nil)
			ifTrue: [^false]
			ifFalse: [tempOwner := tempOwner owner]
		].
	
	^true! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
externalInterface
	^ externalInterface! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
externalInterface: anObject
	externalInterface := anObject! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
internalInterface
	^ internalInterface! !

!OwnedObject2 methodsFor: 'accessing' stamp: 'pmaer 1/2/2012 22:57'!
internalInterface: anObject
	internalInterface := anObject! !

Object subclass: #OwnedObject3
	uses: TOwnershipCheck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

OwnedObject3 class
	uses: TOwnershipCheck classTrait
	instanceVariableNames: ''!

OwnedObject3 subclass: #BasicTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!BasicTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:09'!
compilerClass 
	^OwnershipCompiler3 ! !

!BasicTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:10'!
testDefaultOwner
	| o |
	o := OwnedObject3 new. 
	^ o owner.! !

OwnedObject3 subclass: #Customer
	instanceVariableNames: 'identifier firstname lastname amount partner type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!Customer class methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 14:42'!
compilerClass
	^ OwnershipCompiler3! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:39'!
amount
	^ amount! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:39'!
amount: anObject
	amount := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 11:06'!
credit: credit
	<anonym>
	amount := amount + credit! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
firstname
	^ firstname! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
firstname: anObject
	firstname := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:43'!
identifier
	<anonym>
	^ identifier! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
identifier: anObject
	identifier := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:02'!
initalize
 	amount := 0.
	type := #economy! !

!Customer methodsFor: 'accessing' stamp: 'ewe 5/10/2012 15:36'!
initialize 
 	amount := 0.
	type := #economy! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 17:04'!
isCustomerOf: aBank

	^ aBank customers includes: self.   ! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
lastname
	^ lastname! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 15:37'!
lastname: anObject
	lastname := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 17:07'!
partner
	^ partner! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/19/2012 17:07'!
partner: anObject
	partner := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 5/10/2012 15:39'!
printString
	 identifier ifNil: [ ^ 'no identifier' ] ifNotNil: [ ^ identifier ]! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:05'!
promoteFrom: aBank
	aBank promoteCustomer: self. ! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:03'!
type
	^ type! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 12:03'!
type: anObject
	type := anObject! !

!Customer methodsFor: 'accessing' stamp: 'ewe 4/20/2012 11:07'!
withdraw: debit
	amount := amount - debit! !

OwnedObject3 subclass: #DOCollection
	uses: TNoOwernship
	instanceVariableNames: ''
	classVariableNames: 'MutexForPicking RandomForPicking'
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOCollection commentStamp: '<historical>' prior: 0!
I am the abstract superclass of all classes that represent a group of elements.!

DOCollection class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!DOCollection class methodsFor: '*dynamicownership' stamp: 'ewe 5/10/2012 09:10'!
compilerClass
	^OwnershipCompiler3 
	! !

!DOCollection class methodsFor: 'private' stamp: 'lr 11/4/2003 12:07'!
initialize
	"Set up a Random number generator to be used by atRandom when the 
	user does not feel like creating his own Random generator."

	RandomForPicking := Random new.
	MutexForPicking := Semaphore forMutualExclusion! !

!DOCollection class methodsFor: 'private' stamp: 'lr 11/4/2003 12:08'!
mutexForPicking
	^ MutexForPicking! !

!DOCollection class methodsFor: 'private' stamp: 'sma 5/12/2000 12:31'!
randomForPicking
	^ RandomForPicking! !

!DOCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:25'!
with: anObject 
	"Answer an instance of me containing anObject."
	<meta>
	| o |
	o := self new.
	o ownerNoCheck: self thisSender.
	o add: anObject;
		yourself.
	^o.! !

!DOCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:26'!
with: firstObject with: secondObject 
	"Answer an instance of me containing the two arguments as elements."
	<meta>
	| o |
	o := self new.
	o ownerNoCheck: self thisSender.
	o add: firstObject;
		add: secondObject;
		yourself.
	^o.! !

!DOCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:28'!
with: firstObject with: secondObject with: thirdObject 
	"Answer an instance of me containing the three arguments as elements."
	<meta>
	| o |
	o := self new.
	o ownerNoCheck: self thisSender.
	o add: firstObject;
		add: secondObject;
		add: thirdObject;
		yourself.
	^o.! !

!DOCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:28'!
with: firstObject with: secondObject with: thirdObject with: fourthObject 
	"Answer an instance of me, containing the four arguments as the elements."
	<meta>
	| o |
	o := self new.
	o ownerNoCheck: self thisSender.
	o add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		yourself.
	^o.! !

!DOCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:28'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject
	"Answer an instance of me, containing the five arguments as the elements."
	<meta>
	| o |
	o := self new.
	o ownerNoCheck: self thisSender.
	o add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		add: fifthObject;
		yourself.
	^o.! !

!DOCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:28'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject with: sixthObject
	"Answer an instance of me, containing the six arguments as the elements."
	<meta>
	| o |
	o := self new.
	o ownerNoCheck: self thisSender.
	o add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		add: fifthObject;
		add: sixthObject;
		yourself.
	^o.! !

!DOCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:29'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."
	<meta>
	| o |
	o :=  (self new: aCollection size).
	o ownerNoCheck: self thisSender.
	o addAll: aCollection;
		yourself.
	^o.! !

!DOCollection methodsFor: 'copying' stamp: 'al 12/12/2003 14:31'!
, aCollection
	^self copy addAll: aCollection; yourself! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/6/1998 13:34'!
adaptToCollection: rcvr andSend: selector
	"If I am involved in arithmetic with another Collection, return a Collection of
	the results of each element combined with the scalar in that expression."

	rcvr isSequenceable & self isSequenceable ifFalse:
		[self error: 'Only sequenceable collections may be combined arithmetically'].
	^ rcvr with: self collect:
		[:rcvrElement :myElement | rcvrElement perform: selector with: myElement]! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/9/1998 12:16'!
adaptToNumber: rcvr andSend: selector
	"If I am involved in arithmetic with a scalar, return a Collection of
	the results of each element combined with the scalar in that expression."

	^ self collect: [:element | rcvr perform: selector with: element]! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/6/1998 13:37'!
adaptToPoint: rcvr andSend: selector
	"If I am involved in arithmetic with a scalar, return a Collection of
	the results of each element combined with the scalar in that expression."

	^ self collect: [:element | rcvr perform: selector with: element]! !

!DOCollection methodsFor: 'adapting' stamp: 'di 11/6/1998 13:37'!
adaptToString: rcvr andSend: selector
	"If I am involved in arithmetic with a String, convert it to a Number."
	^ rcvr asNumber perform: selector with: self! !

!DOCollection methodsFor: 'adding' stamp: ''!
add: newObject 
	"Include newObject as one of the receiver's elements. Answer newObject. 
	ArrayedCollections cannot respond to this message."

	self subclassResponsibility! !

!DOCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 17:21'!
add: newObject withOccurrences: anInteger
	"Add newObject anInteger times to the receiver. Answer newObject."

	anInteger timesRepeat: [self add: newObject].
	^ newObject! !

!DOCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 17:26'!
addAll: aCollection 
	"Include all the elements of aCollection as the receiver's elements. Answer 
	aCollection. Actually, any object responding to #do: can be used as argument."

	aCollection do: [:each | self add: each].
	^ aCollection! !

!DOCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 17:23'!
addIfNotPresent: anObject
	"Include anObject as one of the receiver's elements, but only if there
	is no such element already. Anwser anObject."

	(self includes: anObject) ifFalse: [self add: anObject].
	^ anObject! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 4/30/2000 11:17'!
allSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for any element return false.
	Otherwise return true."

	self do: [:each | (aBlock value: each) ifFalse: [^ false]].
	^ true! !

!DOCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:33'!
anyOne
	"Answer a representative sample of the receiver. This method can
	be helpful when needing to preinfer the nature of the contents of 
	semi-homogeneous collections."

	self emptyCheck.
	self do: [:each | ^ each]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 4/30/2000 11:17'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:21'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := DOArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!DOCollection methodsFor: 'converting' stamp: 'sma 5/6/2000 20:10'!
asBag
	"Answer a Bag whose elements are the elements of the receiver."

	^ Bag withAll: self! !

!DOCollection methodsFor: 'converting' stamp: 'sma 5/6/2000 20:22'!
asByteArray
	"Answer a ByteArray whose elements are the elements of the receiver.
	Implementation note: Cannot use ''ByteArray withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := ByteArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!DOCollection methodsFor: 'converting' stamp: 'sma 5/6/2000 20:26'!
asCharacterSet
	"Answer a CharacterSet whose elements are the unique elements of the receiver.
	The reciever should only contain characters."

	^ CharacterSet newFrom: self! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:19'!
asCommaString
	"Return collection printed as 'a, b, c' "

	^String streamContents: [:s | self asStringOn: s delimiter: ', ']
		! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:20'!
asCommaStringAnd
	"Return collection printed as 'a, b and c' "

	^String streamContents: [:s | self asStringOn: s delimiter: ', ' last: ' and ']
		! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/7/2012 15:14'!
asDOArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := DOArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/7/2012 00:37'!
asDOOrderedCollection
	"Answer an OrderedCollection whose elements are the elements of the
	receiver. The order in which elements are added depends on the order
	in which the receiver enumerates its elements. In the case of unordered
	collections, the ordering is not necessarily the same for multiple 
	requests for the conversion."

	^ self as: DOOrderedCollection! !

!DOCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/14/2012 15:35'!
asDOSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ DOSet withAll: self! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:08'!
asDictionary

	^ self as: DODictionary! !

!DOCollection methodsFor: 'converting' stamp: 'ar 9/22/2000 10:12'!
asIdentitySet
	^(IdentitySet new: self size) addAll: self; yourself! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:23'!
asOrderedCollection
	"Answer an OrderedCollection whose elements are the elements of the
	receiver. The order in which elements are added depends on the order
	in which the receiver enumerates its elements. In the case of unordered
	collections, the ordering is not necessarily the same for multiple 
	requests for the conversion."

	^ self as: DOOrderedCollection! !

!DOCollection methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:10'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ DOSet withAll: self! !

!DOCollection methodsFor: 'converting' stamp: 'StephaneDucasse 3/28/2010 22:39'!
asSortedCollection
	"Answer a SortedCollection whose elements are the elements of the receiver. The sort order is the default less than or equal. Note that you should use #sorted: if you don't really need a SortedCollection, but a sorted collection."

	^ self as: SortedCollection! !

!DOCollection methodsFor: 'converting' stamp: 'StephaneDucasse 3/28/2010 22:41'!
asSortedCollection: aSortBlock 
	"Answer a SortedCollection whose elements are the elements of the receiver. The sort order is defined by the argument, aSortBlock. Note that this is better to use #sorted: if you don't really need a SortedCollection, but a sorted collection!!!!"

	| aSortedCollection |
	aSortedCollection := SortedCollection new: self size.
	aSortedCollection sortBlock: aSortBlock.
	aSortedCollection addAll: self.
	^ aSortedCollection! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:27'!
asStringOn: aStream delimiter: delimString
	"Print elements on a stream separated
	with a delimiter String like: 'a, b, c'
	Uses #asString instead of #print:."

	self do: [:elem | aStream nextPutAll: elem asString]
		separatedBy: [aStream nextPutAll: delimString]! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:27'!
asStringOn: aStream delimiter: delimString last: lastDelimString
	"Print elements on a stream separated
	with a delimiter between all the elements and with
	a special one before the last like: 'a, b and c'.
	Uses #asString instead of #print:

	Note: Feel free to improve the code to detect the last element."

	| n sz |
	n := 1.
	sz := self size.
	self do: [:elem |
		n := n + 1.
		aStream nextPutAll: elem asString]
	separatedBy: [
		aStream nextPutAll: (n = sz ifTrue: [lastDelimString] ifFalse: [delimString])]! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
associationsDo: aBlock
	"Evaluate aBlock for each of the receiver's elements (key/value 
	associations).  If any non-association is within, the error is not caught now,
	but later, when a key or value message is sent to it."

	self do: aBlock! !

!DOCollection methodsFor: 'accessing' stamp: 'sd 11/4/2003 22:05'!
atRandom
	"Answer a random element of the receiver.  Uses a shared random 
	number generator owned by class Collection.  If you use this a lot, 
	define your own instance of Random and use #atRandom:.  Causes 
	an error if self has no elements."

	^ self class mutexForPicking critical: [
		self atRandom: self class randomForPicking ]

"Examples:
	#('one' 'or' 'the' 'other') atRandom
	(1 to: 10) atRandom
	'Just pick one of these letters at random' atRandom
	#(3 7 4 9 21) asSet atRandom		(just to show it also works for Sets)
"! !

!DOCollection methodsFor: 'accessing' stamp: 'nice 4/19/2011 00:26'!
atRandom: aGenerator
	"Answer a random element of the receiver. Uses aGenerator which
should be kept by the user in a variable and used every time. Use
this instead of #atRandom for better uniformity of random numbers because 
	only you use the generator. Causes an error if self has no elements."
	| rand index |

	self emptyCheck.
	rand := aGenerator nextInt: self size.
	index := 1.
	self do: [:each |
		index = rand ifTrue: [^each].
		index := index + 1].
	^ self errorEmptyCollection
! !

!DOCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:41'!
capacity
	"Answer the current capacity of the receiver."

	^ self size! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:45'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!DOCollection methodsFor: 'enumerating' stamp: 'ul 11/21/2009 01:16'!
collect: aBlock as: aClass
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into an instance of aClass. Answer the resulting collection."

	^(aClass new: self size) fillFrom: self with: aBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'ul 11/21/2009 01:16'!
collect: aBlock into: aCollection
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into aCollection. Answer aCollection."

	^aCollection fillFrom: self with: aBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'dgd 9/13/2004 23:42'!
collect: collectBlock thenDo: doBlock 
	"Utility method to improve readability."
	^ (self collect: collectBlock) do: doBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:51'!
collect: collectBlock thenSelect: selectBlock
	"Utility method to improve readability."

	^ (self collect: collectBlock) select: selectBlock! !

!DOCollection methodsFor: 'testing' stamp: ''!
contains: aBlock
	"VW compatibility"
	^self anySatisfy: aBlock! !

!DOCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 12:07'!
contents
	^ self! !

!DOCollection methodsFor: 'copying' stamp: 'sma 5/12/2000 14:41'!
copyWith: newElement
	"Answer a new collection with newElement added (as last
	element if sequenceable)."

	^ self copy
		add: newElement;
		yourself! !

!DOCollection methodsFor: 'copying' stamp: 'ar 2/11/2001 01:55'!
copyWithDependent: newElement
	"Answer a new collection with newElement added (as last
	element if sequenceable)."
	^self copyWith: newElement! !

!DOCollection methodsFor: 'copying' stamp: 'sma 5/12/2000 14:43'!
copyWithout: oldElement 
	"Answer a copy of the receiver that does not contain any
	elements equal to oldElement."

	^ self reject: [:each | each = oldElement]

"Examples:
	'fred the bear' copyWithout: $e
	#(2 3 4 5 5 6) copyWithout: 5
"! !

!DOCollection methodsFor: 'copying' stamp: 'sma 5/12/2000 18:08'!
copyWithoutAll: aCollection
	"Answer a copy of the receiver that does not contain any elements 
	equal to those in aCollection."

	^ self reject: [:each | aCollection includes: each]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:52'!
count: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the number of elements that answered true."

	| sum |
	sum := 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum := sum + 1]].
	^ sum! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:20'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:52'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!DOCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
detectMax: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the highest magnitude.
	If collection empty, return nil.  This method might also be called elect:."

	| maxElement maxValue |
	self do: [:each | | val | 
		maxValue == nil
			ifFalse: [
				(val := aBlock value: each) > maxValue ifTrue: [
					maxElement := each.
					maxValue := val]]
			ifTrue: ["first element"
				maxElement := each.
				maxValue := aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ maxElement! !

!DOCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
detectMin: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the lowest number.
	If collection empty, return nil."

	| minElement minValue |
	self do: [:each | | val | 
		minValue == nil
			ifFalse: [
				(val := aBlock value: each) < minValue ifTrue: [
					minElement := each.
					minValue := val]]
			ifTrue: ["first element"
				minElement := each.
				minValue := aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ minElement! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
detectSum: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Return the sum of the answers."
	| sum |
	sum := 0.
	self do: [:each | 
		sum := (aBlock value: each) + sum].  
	^ sum! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 17:52'!
difference: aCollection
	"Answer the set theoretic difference of two collections."

	^ self reject: [:each | aCollection includes: each]! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument."

	self subclassResponsibility! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 2/4/2010 15:34'!
do: aBlock displayingProgress: aStringOrBlock
	"Enumerate aBlock displaying progress information. 
	If the argument is a string, use a static label for the process. 
	If the argument is a block, evaluate it with the element to retrieve the label.
		Smalltalk allClasses 
			do:[:aClass| (Delay forMilliseconds: 1) wait]
			displayingProgress: 'Processing...'.
		Smalltalk allClasses 
			do:[:aClass| (Delay forMilliseconds: 1) wait]
			displayingProgress:[:aClass| 'Processing ', aClass name].
	"
	^self do: aBlock displayingProgress: aStringOrBlock every: 20! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 4/4/2010 16:14'!
do: aBlock displayingProgress: aStringOrBlock every: msecs
       "Enumerate aBlock displaying progress information.
       If the argument is a string, use a static label for the process.
       If the argument is a block, evaluate it with the element to retrieve the label.
       The msecs argument ensures that updates happen at most every msecs.
       Example:
               Smalltalk allClasses
                       do:[:aClass| (Delay forMilliseconds: 1) wait]
                       displayingProgress:[:aClass| 'Processing ', aClass name]
                       every: 0."

	| size labelBlock count oldLabel lastUpdate |
	labelBlock := aStringOrBlock isString
               ifTrue: [[:item| aStringOrBlock]]
               ifFalse: [aStringOrBlock].
	oldLabel := nil.
	count := lastUpdate := 0.
	size := self size.
	'' displayProgressAt: Sensor cursorPoint from: 0 to: size during: [:bar |
		self do: [:each| | newLabel |
				"Special handling for first and last element"
				(count = 0 or: [count+1 = size
					or: [(Time millisecondsSince: lastUpdate) >= msecs]]) 
						ifTrue:
							[bar value: count.
							oldLabel = (newLabel := (labelBlock value: each) ifNil: [oldLabel]) 
								ifFalse: [ProgressNotification signal: '' extra: (oldLabel := newLabel)].
				lastUpdate := Time millisecondClockValue ].
                       aBlock value: each.
                       count := count + 1]]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:57'!
do: elementBlock separatedBy: separatorBlock
	"Evaluate the elementBlock for all elements in the receiver,
	and evaluate the separatorBlock between."

	| beforeFirst | 
	beforeFirst := true.
	self do:
		[:each |
		beforeFirst
			ifTrue: [beforeFirst := false]
			ifFalse: [separatorBlock value].
		elementBlock value: each]! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:59'!
do: aBlock without: anItem 
	"Enumerate all elements in the receiver. 
	Execute aBlock for those elements that are not equal to the given item"

	^ self do: [:each | anItem = each ifFalse: [aBlock value: each]]! !

!DOCollection methodsFor: 'private' stamp: ''!
emptyCheck

	self isEmpty ifTrue: [self errorEmptyCollection]! !

!DOCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/18/2011 14:59'!
errorEmptyCollection
	"Signal a CollectionIsEmpty exception"

	CollectionIsEmpty signalWith: self! !

!DOCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/18/2011 14:58'!
errorNoMatch
	"Signal a SizeMismatch exception"

	SizeMismatch signal! !

!DOCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/18/2011 14:37'!
errorNotFound: anObject
	"Raise a NotFound exception."

	NotFound signalFor: anObject! !

!DOCollection methodsFor: 'private' stamp: 'yo 6/29/2004 13:14'!
errorNotKeyed

	self error: ('Instances of {1} do not respond to keyed accessing messages.' translated format: {self class name})
! !

!DOCollection methodsFor: 'private' stamp: 'ul 11/21/2009 01:14'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection do: [ :each |
		self add: (aBlock value: each) ]! !

!DOCollection methodsFor: 'enumerating' stamp: 'nice 12/9/2009 15:37'!
findFirstInByteString: aByteString startingAt: start
	"Find the index of first character starting at start in aByteString that is included in the receiver.
	Default is to use a naive algorithm.
	Subclasses might want to implement a more efficient scheme"

	start to: aByteString size do:
		[:index |
		(self includes: (aByteString at: index)) ifTrue: [^ index]].
	^ 0! !

!DOCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 12:08'!
flattenOnStream: aStream 
	^ aStream writeCollection: self! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 2/1/2011 07:34'!
fold: binaryBlock
	"Evaluate the block with the first two elements of the receiver,
	then with the result of the first evaluation and the next element,
	and so on.  Answer the result of the final evaluation. If the receiver
	is empty, raise an error. If the receiver has a single element, answer
	that element."
	"#('if' 'it' 'is' 'to' 'be' 'it' 'is' 'up' 'to' 'me') fold: [:a :b | a, ' ', b]"

	^self reduce: binaryBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'pmaer 5/14/2012 14:21'!
gather: aBlock
	^ DOArray streamContents:
		[:stream |
		self do: [:ea | stream nextPutAll: (aBlock value: ea)]]! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 1/3/2010 20:15'!
groupBy: keyBlock having: selectBlock 
	"This message is deprecated. Please use groupedBy:having:. 
	But we let it right now without warning because we are not sure to 
	remove in the next iteration."

	^ self groupedBy: keyBlock having: selectBlock ! !

!DOCollection methodsFor: 'enumerating' stamp: 'pmaer 5/14/2012 14:23'!
groupedBy: aBlock
	"Answer a dictionary whose keys are the result of evaluating aBlock
	for all my elements, and the value for each key is the selection of 
	my elements that evaluated to that key. Uses species."
	| groups |
	groups := PluggableDictionary integerDictionary.
	self do: [ :each |
		(groups at: (aBlock value: each) ifAbsentPut: [ DOOrderedCollection new ]) add: each ].
	self species ~~ DOOrderedCollection ifTrue: [
		groups associationsDo: [ :association |
			association value: (self species withAll: association value) ]].
	^ groups
! !

!DOCollection methodsFor: 'enumerating' stamp: 'AdrianKuhn 12/30/2009 09:37'!
groupedBy: aBlock having: aSelectionBlock
	"Like in SQL operation - Split the recievers contents into collections of 
	elements for which keyBlock returns the same results, and return those 
	collections allowed by selectBlock."
	^ (self groupedBy: aBlock) select: aSelectionBlock
! !

!DOCollection methodsFor: 'comparing' stamp: 'SqR 8/3/2000 13:36'!
hash
	"Answer an integer hash value for the receiver such that,
	  -- the hash value of an unchanged object is constant over time, and
	  -- two equal objects have equal hash values"

	| hash |

	hash := self species hash.
	self size <= 10 ifTrue:
		[self do: [:elem | hash := hash bitXor: elem hash]].
	^hash bitXor: self size hash! !

!DOCollection methodsFor: 'testing' stamp: 'ls 3/27/2000 17:25'!
identityIncludes: anObject 
	"Answer whether anObject is one of the receiver's elements."

	self do: [:each | anObject == each ifTrue: [^true]].
	^false! !

!DOCollection methodsFor: 'testing' stamp: 'StephaneDucasse 7/3/2010 22:15'!
ifEmpty: aBlock
	"Evaluate the given block with the receiver as argument, answering its value if the receiver is empty, otherwise answer the receiver."
	
	"Note that the fact that this method returns its argument in case the receiver is not empty allows one to write expressions like the following ones: self classifyMethodAs: (myProtocol ifEmpty: ['As yet unclassified'])"

	^ self isEmpty 
		ifTrue: [ ^aBlock value ]
		ifFalse: [ self ]! !

!DOCollection methodsFor: 'testing' stamp: 'HenrikSperreJohansen 6/28/2010 12:13'!
ifEmpty: emptyBlock ifNotEmpty: notEmptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise"
	" If the notEmptyBlock has an argument, eval with the receiver as its argument"

	self isEmpty ifTrue: [ ^emptyBlock value ].
	^notEmptyBlock cull: self! !

!DOCollection methodsFor: 'testing' stamp: 'ul 11/11/2009 16:24'!
ifEmpty: emptyBlock ifNotEmptyDo: notEmptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise"
	"Evaluate the notEmptyBlock with the receiver as its argument"

	self isEmpty ifTrue: [ ^emptyBlock value ].
	^notEmptyBlock value: self! !

!DOCollection methodsFor: 'testing' stamp: 'StephaneDucasse 7/3/2010 22:10'!
ifNotEmpty: aBlock
	"Evaluate the given block with the receiver as argument, answering its value
      unless the receiver is empty, in which case answer the receiver

      If the block has an argument, eval with the receiver as its argument,
      but it might be better to use ifNotEmptyDo: to make the code easier to
      understand"
	"Note that the fact that this method returns its argument in case the receiver is empty
	allows one to write expressions like the following ones:
		self classifyMethodAs: (myProtocol ifEmpty: ['As yet unclassified']"
	
    ^self isEmpty
          ifTrue: [self]
          ifFalse: [aBlock cull: self]
! !

!DOCollection methodsFor: 'testing' stamp: 'HenrikSperreJohansen 6/28/2010 12:14'!
ifNotEmpty: notEmptyBlock ifEmpty: emptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise
	 If the notEmptyBlock has an argument, eval with the receiver as its argument"

	self isEmpty ifFalse: [ ^notEmptyBlock cull: self ].
	^emptyBlock value! !

!DOCollection methodsFor: 'testing' stamp: 'ar 11/21/2009 00:36'!
ifNotEmptyDo: aBlock
	"Evaluate the given block with the receiver as its argument."

	self isEmpty ifFalse: [^ aBlock value: self].
! !

!DOCollection methodsFor: 'testing' stamp: 'ul 11/11/2009 16:25'!
ifNotEmptyDo: notEmptyBlock ifEmpty: emptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise
	Evaluate the notEmptyBlock with the receiver as its argument"

	self isEmpty ifFalse: [ ^notEmptyBlock value: self ].
	^emptyBlock value! !

!DOCollection methodsFor: 'testing' stamp: 'sma 5/12/2000 14:07'!
includes: anObject 
	"Answer whether anObject is one of the receiver's elements."

	^ self anySatisfy: [:each | each = anObject]! !

!DOCollection methodsFor: 'testing' stamp: ''!
includesAllOf: aCollection 
	"Answer whether all the elements of aCollection are in the receiver."
	aCollection do: [:elem | (self includes: elem) ifFalse: [^ false]].
	^ true! !

!DOCollection methodsFor: 'testing' stamp: ''!
includesAnyOf: aCollection 
	"Answer whether any element of aCollection is one of the receiver's elements."
	aCollection do: [:elem | (self includes: elem) ifTrue: [^ true]].
	^ false! !

!DOCollection methodsFor: 'testing' stamp: 'nk 8/30/2004 07:49'!
includesSubstringAnywhere: testString
	"Answer whether the receiver includes, anywhere in its nested structure, a string that has testString as a substring"
	self do:
		[:element |
			(element isString)
				ifTrue:
					[(element includesSubString: testString) ifTrue: [^ true]].
			(element isCollection)
				ifTrue:
					[(element includesSubstringAnywhere: testString) ifTrue: [^ true]]].
	^ false

"#(first (second third) ((allSentMessages ('Elvis' includes:)))) includesSubstringAnywhere:  'lvi'"! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."

	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 17:52'!
intersection: aCollection
	"Answer the set theoretic intersection of two collections."

	^ self select: [:each | aCollection includes: each]! !

!DOCollection methodsFor: 'testing' stamp: 'ar 8/17/1999 19:43'!
isCollection
	"Return true if the receiver is some sort of Collection and responds to basic collection messages such as #size and #do:"
	^true! !

!DOCollection methodsFor: 'testing' stamp: ''!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!DOCollection methodsFor: 'testing' stamp: 'bf 3/10/2000 09:29'!
isEmptyOrNil
	"Answer whether the receiver contains any elements, or is nil.  Useful in numerous situations where one wishes the same reaction to an empty collection or to nil"

	^ self isEmpty! !

!DOCollection methodsFor: '*dynamicownership' stamp: 'ewe 5/9/2012 16:36'!
isOverlapping: aCollection
	^( self intersection: aCollection ) size > 0 ! !

!DOCollection methodsFor: 'testing' stamp: 'di 11/6/1998 09:16'!
isSequenceable
	^ false! !

!DOCollection methodsFor: '*dynamicownership' stamp: 'ewe 5/9/2012 14:43'!
matches: interface
	^( self includes: #all ) or: [ self isOverlapping: interface ].
	! !

!DOCollection methodsFor: 'math functions' stamp: 'TAG 11/6/1998 16:00'!
median
	^ self asSortedCollection median! !

!DOCollection methodsFor: 'enumerating' stamp: 'gh 9/18/2001 15:59'!
noneSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for all elements return true.
	Otherwise return false"

	self do: [:item | (aBlock value: item) ifTrue: [^ false]].
	^ true! !

!DOCollection methodsFor: 'testing' stamp: 'sma 5/12/2000 17:49'!
notEmpty
	"Answer whether the receiver contains any elements."

	^ self isEmpty not! !

!DOCollection methodsFor: 'testing' stamp: ''!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| tally |
	tally := 0.
	self do: [:each | anObject = each ifTrue: [tally := tally + 1]].
	^tally! !

!DOCollection methodsFor: 'printing' stamp: 'apb 4/21/2006 09:37'!
printElementsOn: aStream
	"The original code used #skip:, but some streams do not support that,
	 and we don't really need it."

	aStream nextPut: $(.
	self do: [:element | aStream print: element] separatedBy: [aStream space].
	aStream nextPut: $)! !

!DOCollection methodsFor: 'printing' stamp: 'sma 6/1/2000 09:41'!
printNameOn: aStream
	super printOn: aStream! !

!DOCollection methodsFor: 'printing' stamp: 'sma 6/1/2000 09:41'!
printOn: aStream 
	"Append a sequence of characters that identify the receiver to aStream."

	self printNameOn: aStream.
	self printElementsOn: aStream! !

!DOCollection methodsFor: 'printing' stamp: 'gk 1/14/2005 08:01'!
printOn: aStream delimiter: delimString
	"Print elements on a stream separated
	with a delimiter String like: 'a, b, c' "

	self do: [:elem | aStream print: elem] separatedBy: [aStream print: delimString]
		! !

!DOCollection methodsFor: 'printing' stamp: 'fbs 1/14/2005 10:54'!
printOn: aStream delimiter: delimString last: lastDelimString
	"Print elements on a stream separated
	with a delimiter between all the elements and with
	a special one before the last like: 'a, b and c'

	Note: Feel free to improve the code to detect the last element."

	| n sz |
	n := 1.
	sz := self size.
	self do: [:elem |
		n := n + 1.
		aStream print: elem]
	separatedBy: [
		n = sz
			ifTrue: [aStream print: lastDelimString]
			ifFalse: [aStream print: delimString]]! !

!DOCollection methodsFor: 'enumerating' stamp: 'ThomasHolzer 4/15/2011 14:52'!
reduce: aBlock
	"Convert the collection to an ordered collection (sequenceable collection)"
	^self asOrderedCollection reduce: aBlock! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!DOCollection methodsFor: 'enumerating' stamp: 'dgd 9/13/2004 23:42'!
reject: rejectBlock thenDo: doBlock 
	"Utility method to improve readability."
	^ (self reject: rejectBlock) do: doBlock! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:22'!
remove: oldObject 
	"Remove oldObject from the receiver's elements. Answer oldObject 
	unless no element is equal to oldObject, in which case, raise an error.
	ArrayedCollections cannot respond to this message."

	^ self remove: oldObject ifAbsent: [self errorNotFound: oldObject]! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:14'!
remove: oldObject ifAbsent: anExceptionBlock 
	"Remove oldObject from the receiver's elements. If several of the 
	elements are equal to oldObject, only one is removed. If no element is 
	equal to oldObject, answer the result of evaluating anExceptionBlock. 
	Otherwise, answer the argument, oldObject. ArrayedCollections cannot 
	respond to this message."

	self subclassResponsibility! !

!DOCollection methodsFor: 'removing' stamp: 'nice 9/14/2009 20:30'!
removeAll
	"Remove each element from the receiver and leave it empty.
	ArrayedCollections cannot respond to this message.
	There are two good reasons why a subclass should override this message:
	1) the subclass does not support being modified while being iterated
	2) the subclass provides a much faster way than iterating through each element"

	self do: [:each | self remove: each].! !

!DOCollection methodsFor: 'removing' stamp: 'nice 1/10/2009 00:01'!
removeAll: aCollection 
	"Remove each element of aCollection from the receiver. If successful for 
	each, answer aCollection. Otherwise create an error notification.
	ArrayedCollections cannot respond to this message."

	aCollection == self ifTrue: [^self removeAll].
	aCollection do: [:each | self remove: each].
	^ aCollection! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:16'!
removeAllFoundIn: aCollection 
	"Remove each element of aCollection which is present in the receiver 
	from the receiver. Answer aCollection. No error is raised if an element
	isn't found. ArrayedCollections cannot respond to this message."

	aCollection do: [:each | self remove: each ifAbsent: []].
	^ aCollection! !

!DOCollection methodsFor: 'removing' stamp: 'sma 5/12/2000 11:19'!
removeAllSuchThat: aBlock 
	"Evaluate aBlock for each element and remove all that elements from
	the receiver for that aBlock evaluates to true.  Use a copy to enumerate 
	collections whose order changes when an element is removed (i.e. Sets)."

	self copy do: [:each | (aBlock value: each) ifTrue: [self remove: each]]! !

!DOCollection methodsFor: 'enumerating' stamp: ''!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:59'!
select: selectBlock thenCollect: collectBlock
	"Utility method to improve readability."

	^ (self select: selectBlock) collect: collectBlock! !

!DOCollection methodsFor: 'enumerating' stamp: 'hfm 2/12/2009 13:38'!
select: selectBlock thenDo: doBlock
    "Utility method to improve readability.
	Do not create the intermediate collection."

    self do: [: each |
        ( selectBlock value: each ) 
			ifTrue: [ doBlock value: each ]
    ].! !

!DOCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:34'!
size
	"Answer how many elements the receiver contains."

	| tally |
	tally := 0.
	self do: [:each | tally := tally + 1].
	^ tally! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 3/28/2010 22:44'!
sorted
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted in ascending order using the #'<=' operator."
	
	^self sorted: nil! !

!DOCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 3/28/2010 22:42'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if 
the first element should preceed the second one. If aSortBlock is nil then <= is used for 
comparison."
	
	^self asArray sort: aSortBlockOrNil! !

!DOCollection methodsFor: 'math functions' stamp: 'MarcusDenker 8/15/2010 11:01'!
stdev
	| avg sample sum |
	avg := self average. 
	"see comment in self sum"
	sample := self anyOne.
	sum := self inject: sample into: [:accum :each | accum + (each - avg) squared].
	sum := sum - sample.
	^ (sum / (self size - 1)) sqrt! !

!DOCollection methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	"Refer to the comment in Object|storeOn:."

	| noneYet |
	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new)'.
	noneYet := true.
	self do: 
		[:each | 
		noneYet
			ifTrue: [noneYet := false]
			ifFalse: [aStream nextPut: $;].
		aStream nextPutAll: ' add: '.
		aStream store: each].
	noneYet ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DOCollection methodsFor: 'math functions' stamp: 'JuanVuletich 10/11/2010 20:15'!
sum: aBlock
	"This is implemented using a variant of the normal inject:into: pattern. 
	The reason for this is that it is not known whether we're in the normal 
	number line, i.e. whether 0 is a good initial value for the sum. 
	Consider a collection of measurement objects, 0 would be the unitless 
	value and would not be appropriate to add with the unit-ed objects."
	| sum sample |
	sample := aBlock value: self anyOne.
	sum := self inject: sample into: [ :previousValue :each |  previousValue + (aBlock value: each) ].
	^ sum - sample! !

!DOCollection methodsFor: 'private' stamp: ''!
toBraceStack: itsSize 
	"Push receiver's elements onto the stack of thisContext sender.  Error if receiver does
	 not have itsSize elements or if receiver is unordered.
	 Do not call directly: this is called by {a. b} := ... constructs."

	self size ~= itsSize ifTrue:
		[self error: 'Trying to store ', self size printString,
					' values into ', itsSize printString, ' variables.'].
	thisContext sender push: itsSize fromIndexable: self! !

!DOCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 17:54'!
union: aCollection
	"Answer the set theoretic union of two collections."

	^ self asSet addAll: aCollection; yourself! !

!DOCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 12:07'!
write: anObject 
	^ self add: anObject! !

DOCollection subclass: #DOHashedCollection
	instanceVariableNames: 'tally array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

DOHashedCollection subclass: #DODictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DODictionary commentStamp: '<historical>' prior: 0!
I represent a set of elements that can be viewed from one of two perspectives: a set of associations, or a container of values that are externally named where the name can be any object that responds to =. The external name is referred to as the key.  I inherit many operations from Set.!

!DODictionary class methodsFor: 'instance creation' stamp: 'pmaer 5/14/2012 14:42'!
compilerClass
	^OwnershipCompiler3! !

!DODictionary class methodsFor: 'instance creation' stamp: 'pmaer 5/23/2012 16:34'!
newFrom: aDict 
	"Answer an instance of me containing the same associations as aDict.
	 Error if any key appears twice."
	<meta>
	| newDictionary |
	newDictionary := self new: aDict size.
	newDictionary ownerNoCheck: self thisSender.	
	aDict associationsDo:
		[:x |
		(newDictionary includesKey: x key)
			ifTrue: [self error: 'Duplicate key: ', x key printString]
			ifFalse: [newDictionary add: x.
				]].
	^ newDictionary

"	NewDictionary newFrom: {1->#a. 2->#b. 3->#c}
	{1->#a. 2->#b. 3->#c} as: NewDictionary
	NewDictionary newFrom: {1->#a. 2->#b. 1->#c}
	{1->#a. 2->#b. 1->#c} as: NewDictionary
"! !

!DODictionary class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:30'!
newFromPairs: anArray 

	"Answer an instance of me associating (anArray at:i) to (anArray at: i+i)
	 for each odd i.  anArray must have an even number of entries."
	<meta>
	| newDictionary |

	newDictionary := self new: (anArray size/2).
	newDictionary ownerNoCheck: self thisSender.
	1 to: (anArray size-1) by: 2 do: [ :i|
		newDictionary at: (anArray at: i) put: (anArray at: i+1).
	].
	^ newDictionary

	"  Dictionary newFromPairs: {'Red' . Color red . 'Blue' . Color blue . 'Green' . Color green}. "! !

!DODictionary methodsFor: 'comparing' stamp: 'cyrille.delaunay 7/17/2009 15:45'!
= aDictionary
	"Two dictionaries are equal if
	 (a) they are the same 'kind' of thing.
	 (b) they have the same set of keys.
	 (c) for each (common) key, they have the same value"

	self == aDictionary ifTrue: [ ^ true ].
	(aDictionary isDictionary) ifFalse: [^false].
	self size = aDictionary size ifFalse: [^false].
	self associationsDo: [:assoc|
		(aDictionary at: assoc key ifAbsent: [^false]) = assoc value
			ifFalse: [^false]].
	^true

! !

!DODictionary methodsFor: 'adding' stamp: ''!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element value: anAssociation value].
	^ anAssociation! !

!DODictionary methodsFor: 'adding' stamp: 'raok 12/17/2003 16:01'!
addAll: aKeyedCollection
	aKeyedCollection == self ifFalse: [
		aKeyedCollection keysAndValuesDo: [:key :value |
			self at: key put: value]].
	^aKeyedCollection! !

!DODictionary methodsFor: 'accessing' stamp: 'CamilloBruni 4/11/2011 13:30'!
associationAt: key 
	^ self associationAt: key ifAbsent: [self errorKeyNotFound: key]! !

!DODictionary methodsFor: 'accessing' stamp: ''!
associationAt: key ifAbsent: aBlock 
	"Answer the association with the given key.
	If key is not found, return the result of evaluating aBlock."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	nil == assoc ifTrue: [ ^ aBlock value ].
	^ assoc! !

!DODictionary methodsFor: 'accessing' stamp: 'nice 12/26/2009 01:32'!
associationDeclareAt: aKey
	"Return an existing association, or create and return a new one.  Needed as a single message by ImageSegment.prepareToBeSaved."

	^ self associationAt: aKey ifAbsent: [
		| existing |
		(Undeclared includesKey: aKey)
			ifTrue: 
				[existing := Undeclared associationAt: aKey.
				Undeclared removeKey: aKey.
				self add: existing]
			ifFalse: 
				[self add: aKey -> false]]! !

!DODictionary methodsFor: 'accessing' stamp: 'pmaer 5/14/2012 14:21'!
associations
	"Answer a Collection containing the receiver's associations."
	"Suggested by l. Uzonyi"
	
	^DOArray new: self size streamContents: [ :stream |
		self associationsDo: [ :each | stream nextPut: each ] ]! !

!DODictionary methodsFor: 'enumerating' stamp: 'TristanBourgois 5/10/2010 10:41'!
associationsDo: aBlock 
	"Evaluate aBlock for each of the receiver's elements (key/value 
	associations)."

	tally = 0 ifTrue: [^ self].
	array do:
		[:each |
		each ifNotNil: [aBlock value: each]]! !

!DODictionary methodsFor: 'enumerating' stamp: 'dtl 2/17/2003 09:40'!
associationsSelect: aBlock 
	"Evaluate aBlock with each of my associations as the argument. Collect
	into a new dictionary, only those associations for which aBlock evaluates
	to true."

	| newCollection |
	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!DODictionary methodsFor: 'accessing' stamp: 'CamilloBruni 4/11/2011 13:30'!
at: key 
	"Answer the value associated with the key."

	^ self at: key ifAbsent: [self errorKeyNotFound: key]! !

!DODictionary methodsFor: 'accessing' stamp: 'MarcusDenker 8/18/2010 19:17'!
at: key ifAbsent: aBlock 
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."

	^((array at: (self findElementOrNil: key)) 
			ifNil: [aBlock] 
			ifNotNil: [:assoc | assoc]) value.! !

!DODictionary methodsFor: 'accessing' stamp: 'sma 5/12/2000 15:01'!
at: key ifAbsentPut: aBlock 
	"Return the value at the given key. 
	If key is not included in the receiver store the result 
	of evaluating aBlock as new value."

	^ self at: key ifAbsent: [self at: key put: aBlock value]! !

!DODictionary methodsFor: 'accessing' stamp: 'nice 5/1/2011 18:29'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	^(array at: (self findElementOrNil: key))
		ifNotNil: [:assoc | aBlock cull: assoc value]! !

!DODictionary methodsFor: 'accessing' stamp: 'StephaneDucasse 5/13/2010 11:37'!
at: key ifPresent: oneArgBlock ifAbsent: absentBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the oneArgBlock with the value associated with the key, otherwise answer the value of absentBlock."
	
	self at: key ifPresent: [ :v | ^oneArgBlock value: v ].
	^absentBlock value! !

!DODictionary methodsFor: 'accessing' stamp: 'pmaer 5/14/2012 14:05'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (DOAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!DODictionary methodsFor: 'enumerating' stamp: 'ar 6/13/2008 00:16'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := self species new.
	self associationsDo:[:each |
		newCollection at: each key put: (aBlock value: each value).
	].
	^newCollection! !

!DODictionary methodsFor: 'adding' stamp: ''!
declare: key from: aDictionary 
	"Add key to the receiver. If key already exists, do nothing. If aDictionary 
	includes key, then remove it from aDictionary and use its association as 
	the element of the receiver."

	(self includesKey: key) ifTrue: [^ self].
	(aDictionary includesKey: key)
		ifTrue: 
			[self add: (aDictionary associationAt: key).
			aDictionary removeKey: key]
		ifFalse: 
			[self add: key -> nil]! !

!DODictionary methodsFor: 'enumerating' stamp: 'MarcusDenker 7/2/2010 13:02'!
do: aBlock

	^self valuesDo: aBlock! !

!DODictionary methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/19/2011 19:41'!
errorKeyNotFound: aKey

	KeyNotFound signalFor: aKey! !

!DODictionary methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/19/2011 20:30'!
errorValueNotFound: value

	ValueNotFound signalFor: value! !

!DODictionary methodsFor: 'private' stamp: 'ul 11/21/2009 01:15'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DODictionary methodsFor: 'private' stamp: 'nice 11/14/2009 16:33'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self findElementOrNil: element key) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!DODictionary methodsFor: 'printing' stamp: 'MPW 1/4/1901 08:33'!
flattenOnStream:aStream
	^aStream writeDictionary:self.
! !

!DODictionary methodsFor: 'testing' stamp: 'tween 9/13/2004 10:11'!
hasBindingThatBeginsWith: aString
	"Answer true if the receiver has a key that begins with aString, false otherwise"
	
	self keysDo:[:each | 
		(each beginsWith: aString)
			ifTrue:[^true]].
	^false! !

!DODictionary methodsFor: 'testing' stamp: ''!
includes: anObject

	self do: [:each | anObject = each ifTrue: [^true]].
	^false! !

!DODictionary methodsFor: 'testing' stamp: 'ab 9/17/2004 00:39'!
includesAssociation: anAssociation
  ^ (self   
      associationAt: anAssociation key
      ifAbsent: [ ^ false ]) value = anAssociation value
! !

!DODictionary methodsFor: 'testing' stamp: 'sw 2/14/2000 14:34'!
includesIdentity: anObject
	"Answer whether anObject is one of the values of the receiver.  Contrast #includes: in which there is only an equality check, here there is an identity check"

	self do: [:each | anObject == each ifTrue: [^ true]].
	^ false! !

!DODictionary methodsFor: 'testing' stamp: 'RAA 8/23/2001 12:56'!
includesKey: key 
	"Answer whether the receiver has a key equal to the argument, key."
	
	self at: key ifAbsent: [^false].
	^true! !

!DODictionary methodsFor: 'testing' stamp: 'md 8/11/2005 16:49'!
isDictionary
	^true! !

!DODictionary methodsFor: 'testing' stamp: 'StephaneDucasse 5/28/2011 14:01'!
isHealthy
	"Test that object hashes match their positions stored in set's array,
	answer true if everything ok, false otherwise
	
	Dictionary allInstances select: [:dict |
		dict isHealthy not ]
	Dictionary allSubInstances select: [:dict |
		dict isHealthy not ]
	"
	array withIndexDo: [:elem :i |
		elem ifNotNil: [
			(self scanFor: elem key) == i ifFalse: [ ^ false ]
			]
	].
	^ true! !

!DODictionary methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 4/19/2011 20:31'!
keyAtIdentityValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer nil.
	Note: There can be multiple keys with the same value. Only one is returned."

	^self keyAtIdentityValue: value ifAbsent: [self errorValueNotFound: value]! !

!DODictionary methodsFor: 'accessing' stamp: 'ar 2/13/1999 21:16'!
keyAtIdentityValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	Note: There can be multiple keys with the same value. Only one is returned."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^association key]].
	^exceptionBlock value! !

!DODictionary methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 4/19/2011 20:31'!
keyAtValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, signal an error."

	^self keyAtValue: value ifAbsent: [self errorValueNotFound: value]! !

!DODictionary methodsFor: 'accessing' stamp: 'tk 2/18/97'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	: Use =, not ==, so stings like 'this' can be found.  Note that MethodDictionary continues to use == so it will be fast."
 
	self associationsDo: 
		[:association | value = association value ifTrue: [^association key]].
	^exceptionBlock value! !

!DODictionary methodsFor: 'testing' stamp: 'sw 3/23/2000 01:12'!
keyForIdentity: anObject
	"If anObject is one of the values of the receive, return its key, else return nil.  Contrast #keyAtValue: in which there is only an equality check, here there is an identity check"

	self associationsDo: [:assoc | assoc value == anObject ifTrue: [^ assoc key]].
	^ nil! !

!DODictionary methodsFor: 'accessing' stamp: 'pmaer 5/14/2012 14:21'!
keys
	"Answer an Array containing the receiver's keys."
	
	^DOArray new: self size streamContents: [:s| self keysDo: [:key| s nextPut: key]]! !

!DODictionary methodsFor: 'enumerating' stamp: ''!
keysAndValuesDo: aBlock
	^self associationsDo:[:assoc|
		aBlock value: assoc key value: assoc value].! !

!DODictionary methodsFor: 'removing' stamp: 'pmaer 5/14/2012 14:23'!
keysAndValuesRemove: keyValueBlock
	"Removes all entries for which keyValueBlock returns true."
	"When removing many items, you must not do it while iterating over the dictionary, since it may be changing.  This method takes care of tallying the removals in a first pass, and then performing all the deletions afterward.  Many places in the sytem could be simplified by using this method."

	| removals |
	removals := DOOrderedCollection new.
	self associationsDo:
		[:assoc | (keyValueBlock value: assoc key value: assoc value)
			ifTrue: [removals add: assoc key]].
 	removals do:
		[:aKey | self removeKey: aKey]! !

!DODictionary methodsFor: 'enumerating' stamp: ''!
keysDo: aBlock 
	"Evaluate aBlock for each of the receiver's keys."

	self associationsDo: [:association | aBlock value: association key]! !

!DODictionary methodsFor: 'accessing' stamp: 'pmaer 5/23/2012 14:40'!
keysSortedSafely
	"Answer an Array containing the receiver's keys."
 	"Suggested by l. Uzonyi"
 	| sortedKeys |
 	sortedKeys := DOArray 
						new: self size 
						streamContents: [ :stream |
 								self keysDo: [ :each | stream nextPut: each ] ].
 	sortedKeys sort: [ :x :y |
 		"Should really be use <obj, string, num> compareSafely..."
 		((x isString and: [ y isString ])
 			or: [ x isNumber and: [ y isNumber ] ])
 			ifTrue: [ x < y ]
 			ifFalse: [ x class == y class
 				ifTrue: [ x printString < y printString ]
 				ifFalse: [ x class name < y class name ] ] ].
 	^sortedKeys! !

!DODictionary methodsFor: 'private' stamp: ''!
noCheckAdd: anObject
	"Must be defined separately for Dictionary because (self findElementOrNil:) expects a key, not an association.  9/7/96 tk"

	array at: (self findElementOrNil: anObject key) put: anObject.
	tally := tally + 1! !

!DODictionary methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 23:17'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :association |
			array
				at: (self scanForEmptySlotFor: association key)
				put: association ] ]! !

!DODictionary methodsFor: 'copying' stamp: 'ul 9/22/2009 04:51'!
postCopy
	"Must copy the associations, or later store will affect both the
original and the copy"

	array := array collect: [ :association |
		association ifNotNil: [ association copy ] ]! !

!DODictionary methodsFor: 'printing' stamp: 'pmaer 5/23/2012 15:03'!
printElementsOn: aStream 
	aStream nextPut: $(.
	self size > 100
		ifTrue: [aStream nextPutAll: 'size '.
			self size printOn: aStream]
		ifFalse: [self keysSortedSafely
				do: [:key | aStream print: key;
						 nextPutAll: '->';				
						 print: (self at: key);
						 space]].
	aStream nextPut: $)! !

!DODictionary methodsFor: 'private' stamp: ''!
rehash
	"Smalltalk rehash."
	| newSelf |
	newSelf := self species new: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!DODictionary methodsFor: 'removing' stamp: ''!
remove: anObject

	self shouldNotImplement! !

!DODictionary methodsFor: 'removing' stamp: ''!
remove: anObject ifAbsent: exceptionBlock

	self shouldNotImplement! !

!DODictionary methodsFor: 'removing' stamp: 'CamilloBruni 4/11/2011 13:30'!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."

	^ self removeKey: key ifAbsent: [self errorKeyNotFound: key]! !

!DODictionary methodsFor: 'removing' stamp: ''!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ assoc value! !

!DODictionary methodsFor: 'removing' stamp: ''!
removeUnreferencedKeys   "Undeclared removeUnreferencedKeys"

	^ self unreferencedKeys do: [:key | self removeKey: key].! !

!DODictionary methodsFor: 'private' stamp: 'md 10/5/2005 15:42'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	finish := array size.
	start := (anObject hash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!DODictionary methodsFor: 'enumerating' stamp: 'nice 10/5/2009 10:16'!
select: aBlock 
	"Evaluate aBlock with each of my values as the argument. Collect into a new dictionary, only those associations for which aBlock evaluates to true."

	| newCollection |
	newCollection := self copyEmpty.
	self associationsDo: [ :each |
		(aBlock value: each value) ifTrue: [
			newCollection add: each copy ] ].
	^newCollection! !

!DODictionary methodsFor: 'printing' stamp: ''!
storeOn: aStream
	| noneYet |
	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new)'.
	noneYet := true.
	self associationsDo: 
			[:each | 
			noneYet
				ifTrue: [noneYet := false]
				ifFalse: [aStream nextPut: $;].
			aStream nextPutAll: ' add: '.
			aStream store: each].
	noneYet ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DODictionary methodsFor: 'removing' stamp: 'StephaneDucasse 7/2/2010 15:53'!
unreferencedKeys
	"| uk | (Time millisecondsToRun: [uk := TextConstants unreferencedKeys]) -> uk"

	^'Scanning for references . . .' 
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: Smalltalk globals classNames size * 2
		during: 
			[:bar | | currentClass n associations referencedAssociations |
			currentClass := nil.
			n := 0.
			associations := self associations asIdentitySet.
			referencedAssociations := IdentitySet new: associations size.
			self systemNavigation allSelect:
				[:m|
				m methodClass ~~ currentClass ifTrue:
					[currentClass := m methodClass.
					 bar value: (n := n + 1)].
				m literalsDo:
					[:l|
					(l isVariableBinding and: [associations includes: l]) ifTrue:
						[referencedAssociations add: l]].
				false].
			((associations reject: [:assoc | referencedAssociations includes: assoc]) collect: [:assoc| assoc key]) asSet]! !

!DODictionary methodsFor: 'private' stamp: 'pmaer 5/14/2012 14:05'!
valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary 
	"Support for coordinating class variable and global declarations
	with variables that have been put in Undeclared so as to
	redirect all references to the undeclared variable."

	(aDictionary includesKey: aKey)
		ifTrue: 
			[self atNewIndex: index 
				put: ((aDictionary associationAt: aKey) value: anObject).
			aDictionary removeKey: aKey]
		ifFalse: 
			[self atNewIndex: index put: (DOAssociation key: aKey value: anObject)]! !

!DODictionary methodsFor: 'accessing' stamp: 'pmaer 5/14/2012 14:21'!
values
	"Answer a Collection containing the receiver's values."
	| out |
	out := (DOArray new: self size) writeStream.
	self valuesDo: [:value | out nextPut: value].
	^ out contents! !

!DODictionary methodsFor: 'enumerating' stamp: 'dtl 2/17/2003 09:48'!
valuesDo: aBlock 
	"Evaluate aBlock for each of the receiver's values."

	self associationsDo: [:association | aBlock value: association value]! !

DODictionary subclass: #DOIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOIdentityDictionary commentStamp: 'ls 06/15/02 22:35' prior: 0!
Like a Dictionary, except that keys are compared with #== instead of #= .

See the comment of IdentitySet for more information.!

!DOIdentityDictionary class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/14/2012 14:42'!
compilerClass
	^OwnershipCompiler3! !

!DOIdentityDictionary methodsFor: 'private' stamp: 'di 12/1/1999 20:54'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock."
 
	self associationsDo: 
		[:association | value == association value ifTrue: [^ association key]].
	^ exceptionBlock value! !

!DOIdentityDictionary methodsFor: 'private' stamp: 'MartinMcClure 1/16/2010 18:19'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	finish := array size.
	start := (anObject identityHash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!DOIdentityDictionary methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 22:50'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey identityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!DOHashedCollection class methodsFor: 'cleanup' stamp: 'HenrikSperreJohansen 9/1/2010 23:40'!
cleanUp: aggressive
	"Rehash all instances when cleaning aggressively"

	aggressive ifTrue: [self compactAll].
! !

!DOHashedCollection class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 9/1/2010 23:39'!
compactAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #compactAllInstances! !

!DOHashedCollection class methodsFor: 'initialization' stamp: 'StephaneDucasse 10/18/2010 14:48'!
compactAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each compact ]! !

!DOHashedCollection class methodsFor: 'cleanup' stamp: 'pmaer 5/14/2012 14:42'!
compilerClass
	^OwnershipCompiler3 
	! !

!DOHashedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 15:39'!
new
	<meta>
	| t |
	t:= self basicNew
		initialize: 5.
	t ownerNoCheck: self thisSender.
	^t.! !

!DOHashedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 15:39'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	<meta>
	| t |
	t:= self basicNew initialize: (self sizeFor: nElements).
	t ownerNoCheck: self thisSender.
	^t.! !

!DOHashedCollection class methodsFor: 'instance creation' stamp: 'HenrikSperreJohansen 9/1/2010 22:27'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	^self subclassResponsibility! !

!DOHashedCollection class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 9/1/2010 22:31'!
rehashAll
	"HashedCollection rehashAll"	
		
	self allSubclassesDo: #rehashAllInstances! !

!DOHashedCollection class methodsFor: 'initialization' stamp: 'StephaneDucasse 10/18/2010 14:49'!
rehashAllInstances
	"Do not use #allInstancesDo: because rehash may create new instances."
	
	self allInstances do: [ :each | each rehash ]! !

!DOHashedCollection class methodsFor: 'instance creation' stamp: 'HenrikSperreJohansen 9/1/2010 22:18'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"
	
	nElements < 4 ifTrue: [ ^5 ].
	^ HashTableSizes atLeast: nElements +1 * 4 // 3! !

!DOHashedCollection methodsFor: 'adding' stamp: 'HenrikSperreJohansen 9/1/2010 22:00'!
add: newObject withOccurrences: anInteger
	"Add newObject anInteger times to the receiver. Do nothing if anInteger is less than one. Answer newObject."
	
	anInteger < 1 ifTrue: [ ^newObject ].
	"I can only store an object once."
	^ self add: newObject! !

!DOHashedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 23:46'!
array
	^array! !

!DOHashedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 23:46'!
array: anObject
	array:= anObject! !

!DOHashedCollection methodsFor: 'private' stamp: 'TristanBourgois 4/30/2010 16:13'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck! !

!DOHashedCollection methodsFor: 'accessing' stamp: 'TristanBourgois 4/30/2010 16:13'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!DOHashedCollection methodsFor: 'objects from disk' stamp: 'StephaneDucasse 10/18/2010 14:54'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self  compact.
	"^ self"
! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 22:24'!
compact
	"Reduce the size of array so that the load factor will be ~75%."
	
	| newCapacity |
	newCapacity := HashTableSizes atLeast: tally * 4 // 3.
	self growTo: newCapacity! !

!DOHashedCollection methodsFor: 'copying' stamp: 'TristanBourgois 4/30/2010 16:13'!
copyEmpty
	"Answer an empty copy of this collection"
	
	"Note: this code could be moved to super"
	
	^self species new! !

!DOHashedCollection methodsFor: 'enumerating' stamp: 'TristanBourgois 4/30/2010 16:13'!
doWithIndex: aBlock2
	"Support Set enumeration with a counter, even though not ordered"
	| index |
	index := 0.
	self do: [:item | aBlock2 value: item value: (index := index+1)]! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 21:58'!
errorNoFreeSpace

	self error: 'There is no free space in this collection!!'! !

!DOHashedCollection methodsFor: 'private' stamp: 'TristanBourgois 4/30/2010 16:13'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 22:06'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one."
	
	self subclassResponsibility! !

!DOHashedCollection methodsFor: 'private' stamp: 'TristanBourgois 4/30/2010 16:13'!
fullCheck
	"Keep array at least 1/4 free for decent hash behavior"
	array size - tally < (array size // 4 max: 1)
		ifTrue: [self grow]! !

!DOHashedCollection methodsFor: 'private' stamp: 'pmaer 5/14/2012 14:21'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := DOArray new: (HashTableSizes atLeast: oldElements size * 2).
	tally := 0.
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 22:20'!
growSize
	"Answer what my next higher table size should be"

	^HashTableSizes atLeast: self capacity * 3 // 2 + 2
	! !

!DOHashedCollection methodsFor: 'private' stamp: 'pmaer 5/14/2012 14:21'!
growTo: anInteger
	"Grow the elements array and reinsert the old elements"
	
	| oldElements |
	oldElements := array.
	array := DOArray new: anInteger.
	self noCheckNoGrowFillFrom: oldElements! !

!DOHashedCollection methodsFor: 'explorer' stamp: 'TristanBourgois 4/30/2010 16:13'!
hasContentsInExplorer

	^self notEmpty! !

!DOHashedCollection methodsFor: 'private' stamp: 'pmaer 5/14/2012 14:21'!
initialize: n
	"Initialize array to an array size of n"
	array := DOArray new: n.
	tally := 0! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 22:20'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."
	
	self subclassResponsibility! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 23:21'!
rehash
	self growTo: self capacity! !

!DOHashedCollection methodsFor: 'removing' stamp: 'TristanBourgois 4/30/2010 16:13'!
removeAll
	"remove all elements from this collection.
	Preserve the capacity"
	
	self initialize: self capacity! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 22:43'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or raise an error if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	self subclassResponsibility! !

!DOHashedCollection methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 22:49'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey hash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!DOHashedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/21/2012 00:17'!
shallowCopy
	| t |
	<meta>
	t := super shallowCopy.
	t array: (DOArray withAll: self array).
	t array ownerNoCheck: t.
	^t.! !

!DOHashedCollection methodsFor: 'accessing' stamp: 'TristanBourgois 4/30/2010 16:13'!
size
	^ tally! !

!DOHashedCollection methodsFor: 'accessing' stamp: 'TristanBourgois 4/30/2010 16:13'!
someElement
	"Deprecated. Use anyOne."

	^ self anyOne! !

!DOHashedCollection methodsFor: 'enumerating' stamp: 'TristanBourgois 4/30/2010 16:13'!
union: aCollection
	"Answer the set theoretic union of the receiver and aCollection, using the receiver's notion of equality and not side effecting the receiver at all."

	^ self copy addAll: aCollection; yourself

! !

DOHashedCollection subclass: #DOSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOSet commentStamp: '<historical>' prior: 0!
I represent a set of objects without duplicates.  I can hold anything that responds to
#hash and #=, except for nil.  My instances will automatically grow, if necessary,
Note that I rely on #=, not #==.  If you want a set using #==, use IdentitySet.

Instance structure:

  array	An array whose non-nil elements are the elements of the set,
		and whose nil elements are empty slots.  There is always at least one nil.
		In fact I try to keep my "load" at 75% or less so that hashing will work well.

  tally	The number of elements in the set.  The array size is always greater than this.

The core operation is #findElementOrNil:, which either finds the position where an
object is stored in array, if it is present, or finds a suitable position holding nil, if
its argument is not present in array,!

!DOSet class methodsFor: 'instance creation' stamp: 'pmaer 5/14/2012 14:42'!
compilerClass
	^OwnershipCompiler3! !

!DOSet class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 15:47'!
new
	<meta>
	| t |
	t:= self basicNew
		initialize: 5;
		yourself.
	t ownerNoCheck: self thisSender.
	^t.! !

!DOSet class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:30'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	<meta>
	| newCollection |
	newCollection := self new: aCollection size.
	newCollection ownerNoCheck: self thisSender.
	newCollection addAll: aCollection.
	^ newCollection
"
	Set newFrom: {1. 2. 3}
	{1. 2. 3} as: Set
"! !

!DOSet class methodsFor: 'instance creation' stamp: 'MartinMcClure 3/18/2010 22:08'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"

	^ HashTableSizes atLeast: nElements * 4 // 3! !

!DOSet methodsFor: 'testing' stamp: 'pmaer 5/14/2012 14:10'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: DOSet) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!DOSet methodsFor: 'adding' stamp: 'Igor.Stasenko 11/13/2009 06:59'!
add: newObject
	"Include newObject as one of the receiver's elements, but only if
	not already present. Answer newObject."

	| index |
	index := self scanFor: newObject.
	(array at: index) ifNil: [self atNewIndex: index put: newObject asSetElement].
	^ newObject! !

!DOSet methodsFor: 'adding' stamp: 'sma 5/12/2000 17:29'!
add: newObject withOccurrences: anInteger
	^ self add: newObject! !

!DOSet methodsFor: '*dynamicownership' stamp: 'pmaer 5/14/2012 15:34'!
asDOSet
	^self! !

!DOSet methodsFor: 'converting' stamp: 'ar 11/20/1998 16:34'!
asSet
	^self! !

!DOSet methodsFor: 'accessing' stamp: 'md 7/31/2005 08:56'!
atRandom: aGenerator
	"Answer a random element of the receiver. Uses aGenerator which
should be kept by the user in a variable and used every time. Use
this instead of #atRandom for better uniformity of random numbers because 
	only you use the generator. Causes an error if self has no elements."
	| rand |

	self emptyCheck.
	rand := aGenerator nextInt: self size.
	self doWithIndex:[:each :ind |
		ind == rand ifTrue:[^each]].
	^ self errorEmptyCollection
! !

!DOSet methodsFor: 'enumerating' stamp: 'pmaer 5/14/2012 14:10'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newSet |
	newSet := DOSet new: self size.
	array do: [:each | each ifNotNil: [newSet add: (aBlock value: each enclosedSetElement)]].
	^ newSet! !

!DOSet methodsFor: 'objects from disk' stamp: 'tk 4/8/1999 13:05'!
comeFullyUpOnReload: smartRefStream
	"Symbols have new hashes in this image."

	self rehash.
	"^ self"
! !

!DOSet methodsFor: 'removing' stamp: 'sma 5/12/2000 14:45'!
copyWithout: oldElement 
	"Answer a copy of the receiver that does not contain any
	elements equal to oldElement."

	^ self copy
		remove: oldElement ifAbsent: [];
		yourself! !

!DOSet methodsFor: 'enumerating' stamp: 'Igor.Stasenko 11/13/2009 06:37'!
do: aBlock 
	tally = 0 ifTrue: [^ self].
	1 to: array size do:
		[:index |
		| each |
		(each := array at: index) ifNotNil: [aBlock value: each enclosedSetElement]]! !

!DOSet methodsFor: 'private' stamp: 'Igor.Stasenko 3/19/2010 14:27'!
fixCollisionsFrom: start
	"The element at start has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"

	| element index |
	index := start.
	[ (element := array at: (index := index \\ array size + 1)) == nil ] whileFalse: [
		| newIndex |
		(newIndex := self scanFor: element enclosedSetElement) = index ifFalse: [
			array swap: index with: newIndex ] ]! !

!DOSet methodsFor: 'testing' stamp: ''!
includes: anObject 
	^ (array at: (self findElementOrNil: anObject)) ~~ nil! !

!DOSet methodsFor: 'testing' stamp: 'IgorStasenko 3/22/2011 15:51'!
integrityCheck
	"test that objects hashes mathing their positions stored in set's array,
	answer true if everything ok, false otherwise
	
	
	Set allSubInstances select: [:badSet |
		badSet integrityCheck not ]
	"
	

	array withIndexDo: [:elem :i |
		
		elem ifNotNil: [
			(self scanFor: elem) == i ifFalse: [ ^ false ]
			]
	].

	^ true! !

!DOSet methodsFor: 'testing' stamp: 'StephaneDucasse 5/28/2011 14:00'!
isHealthy
	"Test that object hashes match their positions stored in set's array,
	answer true if everything ok, false otherwise
	
	Set allSubInstances select: [:badSet |
		badSet isHealthy not ]
	"
	array withIndexDo: [:elem :i |
		elem ifNotNil: [
			(self scanFor: elem) == i ifFalse: [ ^ false ]
			]
	].
	^ true! !

!DOSet methodsFor: 'accessing' stamp: 'Igor.Stasenko 11/13/2009 07:15'!
like: anObject
	"Answer an object in the receiver that is equal to anObject,
	nil if no such object is found. Relies heavily on hash properties.
	Note, use #like:ifAbsent: if you need to match against nil as element"

	^ self like: anObject ifAbsent: [ nil ]! !

!DOSet methodsFor: 'accessing' stamp: 'Igor.Stasenko 11/13/2009 07:13'!
like: anObject ifAbsent: aBlock
	"Answer an object in the receiver that is equal to anObject,
	or evaluate the block if not found. Relies heavily on hash properties"
	| element |
	element := array at: (self scanFor: anObject).
	^ element ifNil: [ aBlock value ] ifNotNil: [ element enclosedSetElement ]! !

!DOSet methodsFor: 'private' stamp: 'Igor.Stasenko 3/19/2010 14:28'!
noCheckAdd: anObject
	"This method should be deprecated"
	array at: (self findElementOrNil: anObject) put: anObject asSetElement.
	tally := tally + 1! !

!DOSet methodsFor: 'private' stamp: 'HenrikSperreJohansen 9/1/2010 23:17'!
noCheckNoGrowFillFrom: anArray
	"Add the elements of anArray except nils to me assuming that I don't contain any of them, they are unique and I have more free space than they require."

	1 to: anArray size do: [ :index |
		(anArray at: index) ifNotNil: [ :object |
			array
				at: (self scanForEmptySlotFor: object)
				put: object ] ]! !

!DOSet methodsFor: 'testing' stamp: 'sma 5/12/2000 14:46'!
occurrencesOf: anObject 
	^ (self includes: anObject) ifTrue: [1] ifFalse: [0]! !

!DOSet methodsFor: 'copy' stamp: 'StephaneDucasse 5/11/2010 17:32'!
postCopy
	super postCopy.
	array := array copy! !

!DOSet methodsFor: 'private' stamp: ''!
rehash
	| newSelf |
	newSelf := self species new: self size.
	self do: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!DOSet methodsFor: 'removing' stamp: ''!
remove: oldObject ifAbsent: aBlock

	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ oldObject! !

!DOSet methodsFor: 'private' stamp: 'Igor.Stasenko 11/13/2009 06:58'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or raise an error if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	| index start |
	index := start := anObject hash \\ array size + 1.
	[ 
		| element |
		((element := array at: index) == nil or: [ element enclosedSetElement = anObject ])
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!DOSet methodsFor: 'enumerating' stamp: 'nice 5/22/2008 14:56'!
select: aBlock 
	"Use copyEmpty instead of self species new to give subclasses a chance to initialize additional inst vars."

	"Note: this code could be moved to super"
	
	| newCollection |
	newCollection := self copyEmpty.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!DOSet methodsFor: 'private' stamp: 'StephaneDucasse 2/20/2010 17:49'!
withArray: anArray
	"private -- for use only in copy"
	"I want to get a conflict"
	array := anArray! !

DOCollection subclass: #DOSequenceableCollection
	uses: TSortable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOSequenceableCollection commentStamp: '<historical>' prior: 0!
I am an abstract superclass for collections that have a well-defined order associated with their elements. Thus each element is externally-named by integers referred to as indices.!

DOSequenceableCollection class
	uses: TSortable classTrait
	instanceVariableNames: ''!

DOSequenceableCollection subclass: #DOArrayedCollection
	uses: TSortable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOArrayedCollection commentStamp: '<historical>' prior: 0!
I am an abstract collection of elements with a fixed range of integers (from 1 to n>=0) as external keys.!

DOArrayedCollection class
	uses: TSortable classTrait
	instanceVariableNames: ''!

DOArrayedCollection variableSubclass: #DOArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'TextConstants'
	category: 'DynamicOwnership-Kernel'!

!DOArray commentStamp: '<historical>' prior: 0!
I present an ArrayedCollection whose elements are objects.!

!DOArray class methodsFor: 'brace support' stamp: 'di 11/18/1999 22:53'!
braceStream: nElements
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ WriteStream basicNew braceArray: (self new: nElements)
! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:16'!
braceWith: a
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 1.
	array at: 1 put: a.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:15'!
braceWith: a with: b 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 2.
	array at: 1 put: a.
	array at: 2 put: b.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:17'!
braceWith: a with: b with: c 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 3.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:17'!
braceWith: a with: b with: c with: d
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 4.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	array at: 4 put: d.
	^ array! !

!DOArray class methodsFor: 'brace support' stamp: 'di 11/19/1999 08:16'!
braceWithNone
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ self new: 0! !

!DOArray class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOArray class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 15:35'!
empty
	"A canonicalized empty Array instance."
	<meta>
	| o |
	o := #().
	o ownerNoCheck: self thisSender.
	^o.! !

!DOArray class methodsFor: 'instance creation' stamp: 'pmaer 5/23/2012 14:38'!
new: sizeRequested 
	"Answer an instance of this class with the number of indexable
	variables specified by the argument, sizeRequested."
	<meta>
	| o |
	o := self primNew: sizeRequested.  "Exceptional conditions will be handled in basicNew:"
	o ownerNoCheck: self thisSender.
	^o.! !

!DOArray class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 17:14'!
primNew: sizeRequested 
	"Answer an instance of this class with the number of indexable
	variables specified by the argument, sizeRequested.
	
	This is a shortcut (direct call of primitive, no #initialize, for performance"

	<primitive: 71>  "This method runs primitively if successful"
	^ self basicNew: sizeRequested  "Exceptional conditions will be handled in basicNew:"
! !

!DOArray methodsFor: 'converting' stamp: 'sma 5/12/2000 17:32'!
asArray
	"Answer with the receiver itself."

	^ self! !

!DOArray methodsFor: 'accessing' stamp: 'ar 8/26/2001 22:02'!
atWrap: index 
	"Optimized to go through the primitive if possible"
	<primitive: 60>
	^ self at: index - 1 \\ self size + 1! !

!DOArray methodsFor: 'accessing' stamp: 'ar 8/26/2001 22:03'!
atWrap: index put: anObject
	"Optimized to go through the primitive if possible"
	<primitive: 61>
	^ self at: index - 1 \\ self size + 1 put: anObject! !

!DOArray methodsFor: 'copying' stamp: 'ar 2/11/2001 01:55'!
copyWithDependent: newElement
	self size = 0 ifTrue:[^DependentsArray with: newElement].
	^self copyWith: newElement! !

!DOArray methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:20'!
elementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."

	<primitive: 128>
	otherArray class == DOArray ifFalse: [^ self error: 'arg must be array'].
	self size = otherArray size ifFalse: [^ self error: 'arrays must be same size'].
	(self anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	(otherArray anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	self with: otherArray do:[:a :b| a == b ifTrue:[^self error:'can''t become yourself']].

	"Must have failed because not enough space in forwarding table (see ObjectMemory-prepareForwardingTableForBecoming:with:twoWay:).  Do GC and try again only once"
	(Smalltalk bytesLeft: true) = Smalltalk primitiveGarbageCollect
		ifTrue: [^ self primitiveFailed].
	^ self elementsExchangeIdentityWith: otherArray! !

!DOArray methodsFor: 'converting' stamp: 'di 3/28/1999 10:23'!
elementsForwardIdentityTo: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 72>
	self primitiveFailed! !

!DOArray methodsFor: 'converting' stamp: 'brp 9/26/2003 08:09'!
elementsForwardIdentityTo: otherArray copyHash: copyHash
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 249>
	self primitiveFailed! !

!DOArray methodsFor: 'private' stamp: 'pmaer 5/14/2012 14:20'!
hasLiteral: literal
	"Answer true if literal is identical to any literal in this array, even 
	if imbedded in further array structure. This method is only intended 
	for private use by CompiledMethod hasLiteralSymbol:"

	1 to: self size do: [:index |  
		| lit |
		(lit := self at: index) == literal ifTrue: [^ true].
		(lit class == DOArray and: [lit hasLiteral: literal]) ifTrue: [^ true]].
	^ false! !

!DOArray methodsFor: 'private' stamp: 'md 3/1/2006 21:09'!
hasLiteralSuchThat: testBlock
	"Answer true if testBlock returns true for any literal in this array, even if imbedded in 	further Arrays or CompiledMethods.  This method is only intended for private use by 	CompiledMethod 	hasLiteralSuchThat:"
	| lit |
	1 to: self size do: [:index |
		(testBlock value: (lit := self at: index)) ifTrue: [^ true].
		(lit hasLiteralSuchThat: testBlock) ifTrue: [^ true]].
	^ false! !

!DOArray methodsFor: 'testing' stamp: 'eem 5/8/2008 11:13'!
isArray
	^true! !

!DOArray methodsFor: 'testing' stamp: 'pmaer 5/14/2012 14:20'!
isLiteral
	^self class == DOArray and: [self allSatisfy: [:each | each isLiteral]]! !

!DOArray methodsFor: 'self evaluating' stamp: 'pmaer 5/14/2012 14:20'!
isSelfEvaluating
	^ (self allSatisfy: [:each | each isSelfEvaluating]) and: [self class == DOArray]! !

!DOArray methodsFor: 'comparing' stamp: 'ajh 2/2/2002 15:03'!
literalEqual: other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	self with: other do: [:e1 :e2 |
		(e1 literalEqual: e2) ifFalse: [^ false]].
	^ true! !

!DOArray methodsFor: 'self evaluating' stamp: 'sd 7/31/2005 21:44'!
printAsLiteralFormOn: aStream
	aStream nextPut: $#.
	self printElementsOn: aStream
! !

!DOArray methodsFor: 'self evaluating' stamp: 'nice 11/1/2009 21:48'!
printAsSelfEvaluatingFormOn: aStream

	aStream nextPut: ${.
	self do: [:el | el storeOn: aStream] separatedBy: [ aStream nextPutAll: '. '].
	aStream nextPut: $}! !

!DOArray methodsFor: 'printing' stamp: 'sd 7/31/2005 21:44'!
printOn: aStream
	self isLiteral ifTrue: [self printAsLiteralFormOn: aStream. ^ self].
	self isSelfEvaluating ifTrue: [self printAsSelfEvaluatingFormOn: aStream. ^ self].

	super printOn: aStream! !

!DOArray methodsFor: 'private' stamp: 'G.C 10/22/2008 09:59'!
refersToLiteral: literal 
	"Answer true if literal is identical to any literal in this array, even if imbedded in further array structures or closure methods"
	1 
		to: self size
		do: 
			[ :index | 
			| lit |
			(lit := self at: index) == literal ifTrue: [ ^ true ].
			(lit refersToLiteral: literal) ifTrue: [ ^ true ] ].
	^ false! !

!DOArray methodsFor: 'private' stamp: ''!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	<primitive: 105>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!DOArray methodsFor: 'converting' stamp: 'StephaneDucasse 3/28/2010 22:44'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its 
elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if 
the first element should preceed the second one. If aSortBlock is nil then <= is used for 
comparison."
	
	^self copy sort: aSortBlockOrNil! !

!DOArray methodsFor: 'printing' stamp: 'nice 10/31/2009 17:23'!
storeOn: aStream 
	"Use the literal form if possible."

	self isLiteral
		ifTrue: 
			[aStream nextPut: $#; nextPut: $(.
			self do: 
				[:element | 
				element storeOn: aStream.
				aStream space].
			aStream nextPut: $)]
		ifFalse: [super storeOn: aStream]! !

!DOArrayedCollection class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 15:33'!
new
	"Answer a new instance of me, with size = 0."
	<meta>
	| o |
	o := self new: 0.
	o ownerNoCheck: self thisSender.
	^o.! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:31'!
new: size withAll: value 
	"Answer an instance of me, with number of elements equal to size, each 
	of which refers to the argument, value."
	<meta>
	| o |
	o:= (self new: size).
	o ownerNoCheck: self thisSender.
	o atAllPut: value.

	^o.! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:31'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	<meta>
	| newArray |
	newArray := self new: aCollection size.
	newArray ownerNoCheck: self thisSender.
	1 to: aCollection size do: [:i | newArray at: i put: (aCollection at: i)].

	^ newArray

"	Array newFrom: {1. 2. 3}
	{1. 2. 3} as: Array
	{1. 2. 3} as: ByteArray
	{$c. $h. $r} as: String
	{$c. $h. $r} as: Text
"! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'ar 5/17/2001 19:50'!
newFromStream: s
	"Only meant for my subclasses that are raw bits and word-like.  For quick unpack form the disk."
	| len |

	self isPointers | self isWords not ifTrue: [^ super newFromStream: s].
		"super may cause an error, but will not be called."

	s next = 16r80 ifTrue:
		["A compressed format.  Could copy what BitMap does, or use a 
		special sound compression format.  Callers normally compress their own way."
		^ self error: 'not implemented'].
	s skip: -1.
	len := s nextInt32.
	^ s nextWordsInto: (self basicNew: len)! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:32'!
with: anObject 
	"Answer a new instance of me, containing only anObject."
	<meta>
	| newCollection |
	newCollection := self new: 1.
	newCollection ownerNoCheck: self thisSender.
	newCollection at: 1 put: anObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:32'!
with: firstObject with: secondObject 
	"Answer a new instance of me, containing firstObject and secondObject."
	<meta>
	| newCollection |
	newCollection := self new: 2.
	newCollection ownerNoCheck: self thisSender.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:32'!
with: firstObject with: secondObject with: thirdObject 
	"Answer a new instance of me, containing only the three arguments as
	elements."
	<meta>
	| newCollection |
	newCollection := self new: 3.
	newCollection ownerNoCheck: self thisSender.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:32'!
with: firstObject with: secondObject with: thirdObject with: fourthObject 
	"Answer a new instance of me, containing only the three arguments as
	elements."
	<meta>
	| newCollection |
	newCollection := self new: 4.
	newCollection ownerNoCheck: self thisSender.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	newCollection at: 4 put: fourthObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:32'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject
	"Answer a new instance of me, containing only the five arguments as
	elements."
	<meta>
	| newCollection |
	newCollection := self new: 5.
	newCollection ownerNoCheck: self thisSender.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	newCollection at: 4 put: fourthObject.
	newCollection at: 5 put: fifthObject.
	^newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:32'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject with: sixthObject
	"Answer a new instance of me, containing only the 6 arguments as elements."
	<meta>
	| newCollection |
	newCollection := self new: 6.
	newCollection ownerNoCheck: self thisSender.
	newCollection at: 1 put: firstObject.
	newCollection at: 2 put: secondObject.
	newCollection at: 3 put: thirdObject.
	newCollection at: 4 put: fourthObject.
	newCollection at: 5 put: fifthObject.
	newCollection at: 6 put: sixthObject.
	^ newCollection! !

!DOArrayedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:33'!
withAll: aCollection
	<meta>
	"Create a new collection containing all the elements from aCollection."
	| o |
	o :=  (self new: aCollection size).
	o ownerNoCheck: self thisSender.
	o replaceFrom: 1 to: aCollection size with: aCollection.
	^ o. ! !

!DOArrayedCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 14:09'!
add: newObject
	self shouldNotImplement! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'nk 3/17/2004 15:22'!
byteSize
	^self basicSize * self bytesPerBasicElement
! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'nk 3/17/2004 16:28'!
bytesPerBasicElement
	"Answer the number of bytes that each of my basic elements requires.
	In other words:
		self basicSize * self bytesPerBasicElement
	should equal the space required on disk by my variable sized representation."
	^self class isBytes ifTrue: [ 1 ] ifFalse: [ 4 ]! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'nk 3/17/2004 18:51'!
bytesPerElement
	^self class isBytes ifTrue: [ 1 ] ifFalse: [ 4 ].
! !

!DOArrayedCollection methodsFor: 'private' stamp: ''!
defaultElement

	^nil! !

!DOArrayedCollection methodsFor: 'private' stamp: 'ul 11/21/2009 01:15'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	| index |
	index := 0.
	aCollection do: [ :each |
		self at: (index := index + 1) put: (aBlock value: each) ]! !

!DOArrayedCollection methodsFor: 'filter streaming' stamp: 'sma 5/12/2000 14:20'!
flattenOnStream: aStream 
	aStream writeArrayedCollection: self! !

!DOArrayedCollection methodsFor: 'sorting' stamp: 'StephaneDucasse 4/23/2010 16:29'!
mergeFirst: first middle: middle last: last into: dst by: aBlock
	"Private. Merge the sorted ranges [first..middle] and [middle+1..last] 
	of the receiver into the range [first..last] of dst."

	| i1 i2 val1 val2 out |
	i1 := first.
	i2 := middle + 1.
	val1 := self at: i1.
	val2 := self at: i2.
	out := first - 1.  "will be pre-incremented"

	"select 'lower' half of the elements based on comparator"
	[(i1 <= middle) and: [i2 <= last]] whileTrue: [
		(aBlock
			ifNil: [val1 <= val2]
			ifNotNil: [ aBlock value: val1 value: val2])
						ifTrue: [dst at: (out := out + 1) put: val1.
								val1 := self at: (i1 := i1 + 1)]
						ifFalse: [dst at: (out := out + 1) put: val2.
								i2 := i2 + 1.
								i2 <= last ifTrue: [val2 := self at: i2]]].

	"copy the remaining elements"
	i1 <= middle
		ifTrue: [dst replaceFrom: out + 1 to: last with: self startingAt: i1]
		ifFalse: [dst replaceFrom: out + 1 to: last with: self startingAt: i2]! !

!DOArrayedCollection methodsFor: 'sorting' stamp: 'jannik.laval 5/1/2010 16:51'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self shallowCopy 
		dst: self 
		by: aBlock! !

!DOArrayedCollection methodsFor: 'removing' stamp: 'klub 9/14/2009 16:27'!
removeAll

	self shouldNotImplement! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'StephaneDucasse 3/17/2010 20:52'!
restoreEndianness
	"This word object was just read in from a stream.  It was stored in Big Endian (Mac) format.  Reverse the byte order if the current machine is Little Endian.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."

	self class isPointers | self class isWords not ifTrue: [^self].
	Smalltalk isLittleEndian 
		ifTrue: 
			[Bitmap 
				swapBytesIn: self
				from: 1
				to: self basicSize]! !

!DOArrayedCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:36'!
size
	"Answer how many elements the receiver contains."

	<primitive: 62>
	^ self basicSize! !

!DOArrayedCollection methodsFor: 'private' stamp: ''!
storeElementsFrom: firstIndex to: lastIndex on: aStream

	| noneYet defaultElement arrayElement |
	noneYet := true.
	defaultElement := self defaultElement.
	firstIndex to: lastIndex do: 
		[:index | 
		arrayElement := self at: index.
		arrayElement = defaultElement
			ifFalse: 
				[noneYet
					ifTrue: [noneYet := false]
					ifFalse: [aStream nextPut: $;].
				aStream nextPutAll: ' at: '.
				aStream store: index.
				aStream nextPutAll: ' put: '.
				aStream store: arrayElement]].
	^noneYet! !

!DOArrayedCollection methodsFor: 'printing' stamp: ''!
storeOn: aStream

	aStream nextPutAll: '(('.
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' new: '.
	aStream store: self size.
	aStream nextPut: $).
	(self storeElementsFrom: 1 to: self size on: aStream)
		ifFalse: [aStream nextPutAll: '; yourself'].
	aStream nextPut: $)! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'tk 3/7/2001 17:36'!
swapHalves
		"A normal switch in endianness (byte order in words) reverses the order of 4 bytes.  That is not correct for SoundBuffers, which use 2-bytes units.  If a normal switch has be done, this method corrects it further by swapping the two halves of the long word.
	This method is only used for 16-bit quanities in SoundBuffer, ShortIntegerArray, etc."

	| hack blt |
	"The implementation is a hack, but fast for large ranges"
	hack := Form new hackBits: self.
	blt := (BitBlt toForm: hack) sourceForm: hack.
	blt combinationRule: Form reverse.  "XOR"
	blt sourceY: 0; destY: 0; height: self size; width: 2.
	blt sourceX: 0; destX: 2; copyBits.  "Exchange bytes 0&1 with 2&3"
	blt sourceX: 2; destX: 0; copyBits.
	blt sourceX: 0; destX: 2; copyBits.! !

!DOArrayedCollection methodsFor: 'objects from disk' stamp: 'jb 4/30/2010 17:26'!
writeOn: aStream 
	"Store the array of bits onto the argument, aStream.  (leading byte ~= 16r80) identifies this as raw bits (uncompressed).  Always store in Big Endian (Mac) byte order.  Do the writing at BitBlt speeds. We only intend this for non-pointer arrays.  Do nothing if I contain pointers."
	(self class isPointers or: [ self class isWords not ]) ifTrue: [^ self ].
	aStream nextInt32Put: self basicSize.
	aStream nextWordsPutAll: self.! !

DOSequenceableCollection subclass: #DOOrderedCollection
	uses: TSortable
	instanceVariableNames: 'array firstIndex lastIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Kernel'!

!DOOrderedCollection commentStamp: '<historical>' prior: 0!
I represent a collection of objects ordered by the collector.!

DOOrderedCollection class
	uses: TSortable classTrait
	instanceVariableNames: ''!

!DOOrderedCollection class methodsFor: 'private' stamp: 'pmaer 5/14/2012 14:21'!
arrayType
	^ DOArray! !

!DOOrderedCollection class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/23/2012 14:33'!
new
	<meta>
	| o |
	o := self new: 10.
	o ownerNoCheck: self thisSender.
	^o.! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/23/2012 15:51'!
new: anInteger 
	<meta>
	 | o array |
	o:= self basicNew.
	o ownerNoCheck: self thisSender.
	array :=  (self arrayType new: anInteger).
	array ownerNoCheck: o.
	o setCollection: array.
	^o.! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/23/2012 15:52'!
new: anInteger withAll: anObject
	<meta>
	| o array |
	o:= self basicNew.
	o ownerNoCheck: self thisSender.
	array:= (self arrayType new: anInteger withAll: anObject).
	array ownerNoCheck: o.
	o setContents: array.
	o array ownerNoCheck: o.
	^o.! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:34'!
newFrom: aCollection 
	"Answer an instance of me containing the same elements as aCollection."
	<meta>
	| newCollection |
	newCollection := self new: aCollection size.
	newCollection ownerNoCheck: self thisSender.
	newCollection addAll: aCollection.
	^newCollection

"	OrderedCollection newFrom: {1. 2. 3}
	{1. 2. 3} as: OrderedCollection
	{4. 2. 7} as: SortedCollection
"! !

!DOOrderedCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 16:34'!
ofSize: n
	"Create a new collection of size n with nil as its elements.
	This method exists because OrderedCollection new: n creates an
	empty collection,  not one of size n."
	<meta>
	| collection |
	collection := self new: n.
	collection ownerNoCheck: self thisSender.
	collection setContents: (collection collector).
	^ collection
! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
add: newObject

	^self addLast: newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
add: newObject after: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just succeeding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index + 1.
	^newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'CamilloBruni 4/12/2011 13:52'!
add: newObject afterIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just after index. Answer newObject."
	(index between: 0 and: self size) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index.
	^ newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
add: newObject before: oldObject 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just preceding oldObject. Answer newObject."
	
	| index |
	index := self find: oldObject.
	self insert: newObject before: index.
	^newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'ar 7/15/2008 23:05'!
add: newObject beforeIndex: index 
	"Add the argument, newObject, as an element of the receiver. Put it in 
	the sequence just before index. Answer newObject."
	(index between: 1 and: self size+1) ifFalse:[^self errorSubscriptBounds: index].
	self insert: newObject before: firstIndex + index - 1.
	^ newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'sma 5/12/2000 11:26'!
addAll: aCollection 
	"Add each element of aCollection at my end. Answer	aCollection."

	^ self addAllLast: aCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
addAllFirst: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the 
	receiver. Answer anOrderedCollection."

	anOrderedCollection reverseDo: [:each | self addFirst: each].
	^anOrderedCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'sw 3/1/2001 11:03'!
addAllFirstUnlessAlreadyPresent: anOrderedCollection 
	"Add each element of anOrderedCollection at the beginning of the receiver, preserving the order, but do not add any items that are already in the receiver.  Answer anOrderedCollection."

	anOrderedCollection reverseDo:
		[:each | (self includes: each) ifFalse: [self addFirst: each]].
	^ anOrderedCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'StephaneDucasse 12/25/2009 12:13'!
addAllLast: aCollection 
	"Add each element of aCollection at the end of the receiver. 
	Answer aCollection."

	aCollection do: [:each | self addLast: each].
	^aCollection! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
addFirst: newObject 
	"Add newObject to the beginning of the receiver. Answer newObject."

	firstIndex = 1 ifTrue: [self makeRoomAtFirst].
	firstIndex := firstIndex - 1.
	array at: firstIndex put: newObject.
	^ newObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!DOOrderedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 22:19'!
array
	^array! !

!DOOrderedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 23:46'!
array: anObject
	array:= anObject! !

!DOOrderedCollection methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:21'!
asArray
	^ (DOArray new: self size) replaceFrom: 1 to: self size with: array startingAt: firstIndex.! !

!DOOrderedCollection methodsFor: 'converting' stamp: 'pmaer 5/7/2012 00:35'!
asDOArray
	^ (DOArray new: self size) replaceFrom: 1 to: self size with: array startingAt: firstIndex.! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'CamilloBruni 4/11/2011 15:36'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"

	self ensureBoundsFrom: anInteger to: anInteger.
	^ array at: anInteger + firstIndex - 1! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'ajh 5/22/2003 12:03'!
at: index ifAbsentPut: block
	"Return value at index, however, if value does not exist (nil or out of bounds) then add block's value at index (growing self if necessary)"

	| v |
	index <= self size ifTrue: [
		^ (v := self at: index)
			ifNotNil: [v]
			ifNil: [self at: index put: block value]
	].
	[self size < index] whileTrue: [self add: nil].
	^ self at: index put: block value! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'CamilloBruni 4/11/2011 15:39'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."
	self ensureBoundsFrom: anInteger to: anInteger.
	^array at: anInteger + firstIndex - 1 put: anObject! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:42'!
capacity
	"Answer the current capacity of the receiver."

	^ array size! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'sma 2/5/2000 15:22'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'CamilloBruni 4/11/2011 15:34'!
collect: aBlock from: fromIndex to: toIndex
	"Override superclass in order to use addLast:, not at:put:."
	| result |
	self ensureBoundsFrom: fromIndex to: toIndex.
	result := self species new: toIndex - fromIndex + 1.
	firstIndex + fromIndex - 1 to: firstIndex + toIndex - 1 do:
		[:index | result addLast: (aBlock value: (array at: index))].
	^ result
! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'hfm 2/12/2009 13:28'!
collect: collectBlock thenSelect: selectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection."

    | newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[: index | 
		| newElement |
		newElement := collectBlock value: ( array at: index ).
		( selectBlock value: newElement ) 
			ifTrue:[ newCollection addLast: newElement. ]
    ].
    ^ newCollection! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
collector  "Private"
	^ array! !

!DOOrderedCollection methodsFor: 'copying' stamp: ''!
copyEmpty
	"Answer a copy of the receiver that contains no elements."

	^self species new! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'nice 10/5/2009 10:18'!
copyFrom: startIndex to: endIndex 
	"Answer a copy of the receiver that contains elements from position
	startIndex to endIndex."

	^self shallowCopy postCopyFrom: startIndex to: endIndex! !

!DOOrderedCollection methodsFor: 'copying' stamp: ''!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver with replacementCollection's elements in
	place of the receiver's start'th to stop'th elements. This does not expect
	a 1-1 map from replacementCollection to the start to stop elements, so it
	will do an insert or append."

	| newOrderedCollection delta startIndex stopIndex |
	"if start is less than 1, ignore stop and assume this is inserting at the front. 
	if start greater than self size, ignore stop and assume this is appending. 
	otherwise, it is replacing part of me and start and stop have to be within my 
	bounds. "
	delta := 0.
	startIndex := start.
	stopIndex := stop.
	start < 1
		ifTrue: [startIndex := stopIndex := 0]
		ifFalse: [startIndex > self size
				ifTrue: [startIndex := stopIndex := self size + 1]
				ifFalse: 
					[(stopIndex < (startIndex - 1) or: [stopIndex > self size])
						ifTrue: [self errorOutOfBounds].
					delta := stopIndex - startIndex + 1]].
	newOrderedCollection := 
		self species new: self size + replacementCollection size - delta.
	1 to: startIndex - 1 do: [:index | newOrderedCollection add: (self at: index)].
	1 to: replacementCollection size do: 
		[:index | newOrderedCollection add: (replacementCollection at: index)].
	stopIndex + 1 to: self size do: [:index | newOrderedCollection add: (self at: index)].
	^newOrderedCollection! !

!DOOrderedCollection methodsFor: 'copying' stamp: ''!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and 
	includes the argument, newElement, at the end."

	| newCollection |
	newCollection := self copy.
	newCollection add: newElement.
	^newCollection! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index + 1]! !

!DOOrderedCollection methodsFor: 'testing' stamp: 'CamilloBruni 4/11/2011 15:34'!
ensureBoundsFrom: fromIndex to: toIndex
	(fromIndex < 1)
		ifTrue: [^self errorSubscriptBounds: fromIndex].
	(toIndex + firstIndex - 1 > lastIndex)
		ifTrue: [^self errorSubscriptBounds: toIndex].! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
errorConditionNotSatisfied

	self error: 'no element satisfies condition'! !

!DOOrderedCollection methodsFor: 'private' stamp: 'BG 1/9/2004 12:26'!
find: oldObject
  "  This method answers an index in the range firstIndex .. lastIndex, which is meant for internal use only.
     Never use this method in your code, the methods for public use are:
        #indexOf:
        #indexOf:ifAbsent: "

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue:
			[(array at: index) = oldObject ifTrue: [^ index].
			index := index + 1].
	self errorNotFound: oldObject! !

!DOOrderedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 22:24'!
firstIndex
	^ firstIndex! !

!DOOrderedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 22:24'!
firstIndex: anObject
	firstIndex := anObject! !

!DOOrderedCollection methodsFor: 'adding' stamp: 'MarcusDenker 8/8/2011 17:47'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray :=  self class arrayType new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!DOOrderedCollection methodsFor: 'private' stamp: 'cmm 10/25/2010 22:27'!
growAtFirst
	"Add new empty slots to the front of array, while keeping the empty slots at the end."

	| newArray newFirstIndex newLastIndex |
	newArray := self class arrayType new: (array size * 2 max: 1).
	newFirstIndex := newArray size - array size + firstIndex.
	newLastIndex := newFirstIndex + lastIndex - firstIndex.
	newArray 
		replaceFrom: newFirstIndex
		to: newLastIndex
		with: array
		startingAt: firstIndex.
	array := newArray.
	firstIndex := newFirstIndex.
	lastIndex := newLastIndex! !

!DOOrderedCollection methodsFor: 'private' stamp: 'cmm 10/25/2010 22:27'!
growAtLast
	"Add new empty slots to the end of array, while keeping the empty slots at the front."

	| newArray |
	newArray := self class arrayType new: (array size * 2 max: 1).
	newArray 
		replaceFrom: firstIndex
		to: lastIndex
		with: array
		startingAt: firstIndex.
	array := newArray! !

!DOOrderedCollection methodsFor: 'adding' stamp: ''!
growSize
	^ array size max: 2! !

!DOOrderedCollection methodsFor: 'testing' stamp: 'md 8/13/2008 21:40'!
hasContentsInExplorer

	^self notEmpty! !

!DOOrderedCollection methodsFor: 'private' stamp: 'BG 1/9/2004 12:29'!
insert: anObject before: spot

  "  spot is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection. 
     Never use this method in your code, it is meant for private use by OrderedCollection only.
     The methods for use are:
        #add:before:   to insert an object before another object
        #add:beforeIndex:   to insert an object before a given position. "
	| "index" delta spotIndex|
	spotIndex := spot.
	delta := spotIndex - firstIndex.
	firstIndex = 1
		ifTrue: 
			[self makeRoomAtFirst.
			spotIndex := firstIndex + delta].
	firstIndex := firstIndex - 1.
	array
		replaceFrom: firstIndex
		to: spotIndex - 2
		with: array
		startingAt: firstIndex + 1.
	array at: spotIndex - 1 put: anObject.
"	index := firstIndex := firstIndex - 1.
	[index < (spotIndex - 1)]
		whileTrue: 
			[array at: index put: (array at: index + 1).
			index := index + 1].
	array at: index put: anObject."
	^ anObject! !

!DOOrderedCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 19:44'!
join: aCollection 
	| result |
	result := self class new.
	aCollection
		do: [:each | each appendTo: result]
		separatedBy: [self appendTo: result].
	^ result! !

!DOOrderedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 22:24'!
lastIndex
	^ lastIndex! !

!DOOrderedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 22:24'!
lastIndex: anObject
	lastIndex := anObject! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
makeRoomAtFirst
	| delta index |
	delta := array size - self size.
	delta = 0 ifTrue: 
			[self grow.
			delta := array size - self size].
	lastIndex = array size ifTrue: [^ self]. "just in case we got lucky"
	index := array size.
	[index > delta]
		whileTrue: 
			[array at: index put: (array at: index - delta + firstIndex - 1).
			array at: index - delta + firstIndex - 1 put: nil.
			index := index - 1].
	firstIndex := delta + 1.
	lastIndex := array size! !

!DOOrderedCollection methodsFor: 'private' stamp: ''!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!DOOrderedCollection methodsFor: 'sorting' stamp: 'jannik.laval 5/1/2010 16:20'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self copy 
		dst: self 
		by: aBlock! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'nice 10/5/2009 08:50'!
postCopy
	array := array copy! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'nice 5/28/2008 21:02'!
postCopyFrom: startIndex to: endIndex 
	"finish copying the array in a certain range."

	endIndex < startIndex ifFalse: [
		"Because actual size of the array may be greater than used size,
		postCopyFrom:to: may fail to fail and answer an incorrect result
		if this sanity check were not applied"
		(startIndex between: 1 and: self size) ifFalse: [^self error: 'startIndex is out of bounds'].
		(endIndex between: 1 and: self size) ifFalse: [^self error: 'endIndex is out of bounds']].
	
	"Add a protection that lacks in Array>>postcopy"
	array := array copyFrom: startIndex + firstIndex - 1 to: (endIndex max: startIndex - 1) + firstIndex - 1.
	firstIndex := 1.
	lastIndex := array size! !

!DOOrderedCollection methodsFor: 'removing' stamp: ''!
remove: oldObject ifAbsent: absentBlock

	| index |
	index := firstIndex.
	[index <= lastIndex]
		whileTrue: 
			[oldObject = (array at: index)
				ifTrue: 
					[self removeIndex: index.
					^ oldObject]
				ifFalse: [index := index + 1]].
	^ absentBlock value! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'cmm 10/25/2010 22:26'!
removeAll
	"remove all the elements from this collection.
	Keep same amount of storage"
	
	self setCollection: (self class arrayType new: array size)! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'StephaneDucasse 10/18/2010 14:51'!
removeAllSuchThat: aBlock 
	"Remove each element of the receiver for which aBlock evaluates to true.
	The method in Collection is O(N^2), this is O(N)."

	| n |
	n := firstIndex.
	firstIndex to: lastIndex do: [:index |
	    (aBlock value: (array at: index)) ifFalse: [
			array at: n put: (array at: index).
			n := n + 1]].
	array from: n to: lastIndex put: nil.
	lastIndex := n - 1! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'ar 5/22/2000 12:19'!
removeAt: index
	| removed |
	removed := self at: index.
	self removeIndex: index + firstIndex - 1.
	^removed! !

!DOOrderedCollection methodsFor: 'removing' stamp: ''!
removeFirst
	"Remove the first element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| firstObject |
	self emptyCheck.
	firstObject := array at: firstIndex.
	array at: firstIndex put: nil.
	firstIndex := firstIndex + 1.
	^ firstObject! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'cmm 10/25/2010 22:26'!
removeFirst: n 
	"Remove first n object into an array"
	| list |
	list := self class arrayType new: n.
	1
		to: n
		do:
			[ : i | list
				at: i
				put: self removeFirst ].
	^ list! !

!DOOrderedCollection methodsFor: 'private' stamp: 'BG 1/9/2004 12:28'!
removeIndex: removedIndex
  "  removedIndex is an index in the range firstIndex .. lastIndex, such an index is not known from outside the collection.
    Never use this method in your code, it is meant for private use by OrderedCollection only.
     The method for public use is:
        #removeAt: "

	array 
		replaceFrom: removedIndex 
		to: lastIndex - 1 
		with: array 
		startingAt: removedIndex+1.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.! !

!DOOrderedCollection methodsFor: 'removing' stamp: ''!
removeLast
	"Remove the last element of the receiver and answer it. If the receiver is 
	empty, create an error notification."
	| lastObject |
	self emptyCheck.
	lastObject := array at: lastIndex.
	array at: lastIndex put: nil.
	lastIndex := lastIndex - 1.
	^ lastObject! !

!DOOrderedCollection methodsFor: 'removing' stamp: 'cmm 10/25/2010 22:26'!
removeLast: n 
	"Remove last n object into an array with last in last position"
	| list |
	list := self class arrayType new: n.
	n
		to: 1
		by: -1
		do:
			[ : i | list
				at: i
				put: self removeLast ].
	^ list! !

!DOOrderedCollection methodsFor: 'private' stamp: 'di 11/14/97 12:54'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!DOOrderedCollection methodsFor: 'private' stamp: 'ar 4/16/1999 07:59'!
resetTo: index
	firstIndex := index.
	lastIndex := firstIndex - 1! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: ''!
reverseDo: aBlock 
	"Override the superclass for performance reasons."
	| index |
	index := lastIndex.
	[index >= firstIndex]
		whileTrue: 
			[aBlock value: (array at: index).
			index := index - 1]! !

!DOOrderedCollection methodsFor: 'copying' stamp: 'sw 1/26/96'!
reversed
	"Answer a copy of the receiver with element order reversed.  "
	| newCol |
	newCol := self species new.
	self reverseDo:
		[:elem | newCol addLast: elem].
	^ newCol

"#(2 3 4 'fred') reversed"! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'sma 2/5/2000 15:13'!
select: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect into
	a new collection like the receiver, only those elements for which aBlock
	evaluates to true."

	| newCollection element |
	newCollection := self copyEmpty.
	firstIndex to: lastIndex do:
		[:index |
		(aBlock value: (element := array at: index))
			ifTrue: [newCollection addLast: element]].
	^ newCollection! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'hfm 2/12/2009 13:30'!
select: selectBlock thenCollect: collectBlock
    " Utility method to improve readability.
	Do not create the intermediate collection. "

	| newCollection |

    newCollection := self copyEmpty.
    firstIndex to: lastIndex do:[:index |
		| element |
		element := array at: index.
		( selectBlock value: element ) 
			ifTrue:[ newCollection addLast: ( collectBlock value: element ) ]
    ].
    ^ newCollection! !

!DOOrderedCollection methodsFor: 'private' stamp: 'di 11/14/97 12:54'!
setCollection: anArray
	array := anArray.
	self reset! !

!DOOrderedCollection methodsFor: 'private' stamp: 'apb 10/15/2000 18:10'!
setContents: anArray
	array := anArray.
	firstIndex := 1.
	lastIndex := array size.! !

!DOOrderedCollection methodsFor: '*dynamicownership' stamp: 'pmaer 5/20/2012 22:29'!
shallowCopy
	| t |
	<meta>
	t := DOOrderedCollection new: self size.
	t array: (DOArray withAll: self array).
	t array ownerNoCheck: t.
	t firstIndex: self firstIndex.
	t lastIndex: self lastIndex.
	^t.! !

!DOOrderedCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:39'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 12/23/2009 21:28'!
sort
	"Sort the receiver into ascending order using the '<=' operator."

	self sort: [:a :b | a <= b]! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'pmm 3/13/2010 11:33'!
sort: aSortBlock 
	"Sort this array using aSortBlock. The block should take two arguments
	and return true if the first element should preceed the second one."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	array
		mergeSortFrom: firstIndex
		to: lastIndex 
		src: array shallowCopy 
		dst: array 
		by: aSortBlock! !

!DOOrderedCollection methodsFor: 'sorting' stamp: 'StephaneDucasse 3/28/2010 22:40'!
sorted: aSortBlockOrNil
	"Return a new sequenceable collection which contains the same elements as self but its elements are sorted by aSortBlockOrNil. The block should take two arguments and return true if the first element should preceed the second one. If aSortBlock is nil then <= is used for comparison."
	
	^self copy sort: aSortBlockOrNil! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'di 8/31/1999 13:13'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with 
	corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result := self species new: self size.
	1 to: self size do:
		[:index | result addLast: (twoArgBlock value: (self at: index)
									value: (otherCollection at: index))].
	^ result! !

!DOOrderedCollection methodsFor: 'enumerating' stamp: 'bf 5/16/2000 16:30'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (elementAndIndexBlock
			value: (array at: index)
			value: index - firstIndex + 1)].
	^ newCollection! !

!DOSequenceableCollection class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/23/2012 15:23'!
compilerClass
	^OwnershipCompiler3 ! !

!DOSequenceableCollection class methodsFor: 'stream creation' stamp: 'pmaer 5/23/2012 15:38'!
new: newSize streamContents: blockWithArg
	<meta>
	| stream streamArray return |
	streamArray:= (self new: newSize).
	stream := WriteStream on: streamArray.
	streamArray ownerNoCheck: stream.
	blockWithArg value: stream.
	stream position = newSize
		ifTrue: [ return:= stream originalContents ]
		ifFalse: [ return:= stream contents ].
	return ownerNoCheck: self thisSender.
	^return.! !

!DOSequenceableCollection class methodsFor: 'instance creation' stamp: 'pmaer 5/22/2012 15:48'!
ofSize: n
	"Create a new collection of size n with nil as its elements.
	This method exists because OrderedCollection new: n creates an
	empty collection,  not one of size n."
	<meta>
	| o |
	o:= self new: n.
	o ownerNoCheck: self thisSender.
	^o.! !

!DOSequenceableCollection class methodsFor: 'stream creation' stamp: 'StephaneDucasse 12/25/2009 12:32'!
streamContents: blockWithArg

	^self new: 100 streamContents: blockWithArg! !

!DOSequenceableCollection class methodsFor: 'stream creation' stamp: 'di 6/20/97 09:07'!
streamContents: blockWithArg limitedTo: sizeLimit
	| stream |
	stream := LimitedWriteStream on: (self new: (100 min: sizeLimit)).
	stream setLimit: sizeLimit limitBlock: [^ stream contents].
	blockWithArg value: stream.
	^ stream contents
"
String streamContents: [:s | 1000 timesRepeat: [s nextPutAll: 'Junk']] limitedTo: 25
 'JunkJunkJunkJunkJunkJunkJ'
"! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'md 7/14/2006 12:11'!
, otherCollection 
	"Concatenate two Strings or Collections."
	
	^ self copyReplaceFrom: self size + 1
		  to: self size
		  with: otherCollection
"
#(2 4 6 8) , #(who do we appreciate)
((2989 storeStringBase: 16) copyFrom: 4 to: 6) , ' boy!!'
"! !

!DOSequenceableCollection methodsFor: 'comparing' stamp: 'sma 5/12/2000 14:04'!
= otherCollection 
	"Answer true if the receiver is equivalent to the otherCollection.
	First test for identity, then rule out different species and sizes of
	collections. As a last resort, examine each element of the receiver
	and the otherCollection."

	self == otherCollection ifTrue: [^ true].
	self species == otherCollection species ifFalse: [^ false].
	^ self hasEqualElements: otherCollection! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'TAG 11/6/1998 15:55'!
@ aCollection 
	^ self with: aCollection collect: [:a :b | a @ b]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 18:00'!
after: target
	"Answer the element after target.  Raise an error if target is not
	in the receiver, or if there are no elements after it."

	^ self after: target ifAbsent: [self errorNotFound: target]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 4/19/2011 00:07'!
after: target ifAbsent: exceptionBlock
	"Answer the element after target.  Answer the result of evaluation
	the exceptionBlock if target is not in the receiver, or if there are 
	no elements after it."

	| index |
	index := self indexOf: target.
	^ (index = 0 or: [index = self size])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index + 1]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:34'!
allButFirst
	"Answer a copy of the receiver containing all but the first
	element. Raise an error if there are not enough elements."

	^ self allButFirst: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:35'!
allButFirst: n
	"Answer a copy of the receiver containing all but the first n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: n + 1 to: self size! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:03'!
allButFirstDo: block

	2 to: self size do:
		[:index | block value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:35'!
allButLast
	"Answer a copy of the receiver containing all but the last
	element. Raise an error if there are not enough elements."

	^ self allButLast: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:35'!
allButLast: n
	"Answer a copy of the receiver containing all but the last n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: self size - n! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:01'!
allButLastDo: block

	1 to: self size - 1 do:
		[:index | block value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 1/13/2010 22:02'!
allPairsDo: aBinaryBlock
	"
	Iterate over all the pairs of the receiver and apply the binaryBlock
	to each pair. 
	
	| res | 
	res := OrderedCollection new. 
	#(0 1 2 3) allPairsDo: [:first :second | res add: {first . second} ].
	res 
	 an OrderedCollection(#(0 0) #(0 1) #(0 2) #(0 3) #(1 0) #(1 1) #(1 2) #(1 3) #(2 0) #(2 1) #(2 2) #(2 3) #(3 0) #(3 1) #(3 2) #(3 3))
	"
	
	self do: [:first| self do: [:second| aBinaryBlock value: first value: second]]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 11:33'!
anyOne
	^ self first! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
appendTo: aCollection
	"double dispatch for join:"
	^ aCollection addAllLast: self! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:21'!
asArray
	"Answer an Array whose elements are the elements of the receiver."

	^ DOArray withAll: self! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'sma 5/12/2000 17:36'!
asByteArray
	"Answer a ByteArray whose elements are the elements of the receiver."

	^ ByteArray withAll: self! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'tk 7/30/97 12:42'!
asDigitsAt: anInteger in: aCollection do: aBlock
	"(0 to: 1) asDigitsToPower: 4 do: [:each | Transcript cr; show: each printString]"

	self do: 
		[:each | 
		aCollection at: anInteger put: each.
		anInteger = aCollection size 
			ifTrue: [aBlock value: aCollection]
			ifFalse: [self asDigitsAt: anInteger + 1 in: aCollection do: aBlock]].! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 5/14/2012 14:21'!
asDigitsToPower: anInteger do: aBlock
	"Repeatedly value aBlock with a single Array.  Adjust the collection
	so that aBlock is presented all (self size raisedTo: anInteger) possible 
	combinations of the receiver's elements taken as digits of an anInteger long number."
	"(0 to: 1) asDigitsToPower: 4 do: [:each | Transcript cr; show: each printString]"

	| aCollection |
	aCollection := DOArray new: anInteger.
	self asDigitsAt: 1 in: aCollection do: aBlock! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'ar 9/14/1998 23:47'!
asFloatArray
	"Answer a FloatArray whose elements are the elements of the receiver, in 
	the same order."

	| floatArray |
	floatArray := FloatArray new: self size.
	1 to: self size do:[:i| floatArray at: i put: (self at: i) asFloat ].
	^floatArray! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'ar 10/10/1998 16:19'!
asIntegerArray
	"Answer an IntegerArray whose elements are the elements of the receiver, in 
	the same order."

	| intArray |
	intArray := IntegerArray new: self size.
	1 to: self size do:[:i| intArray at: i put: (self at: i)].
	^intArray! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'PeterHugossonMiller 9/3/2009 11:11'!
asStringWithCr
	"Convert to a string with returns between items.  Elements are
usually strings.
	 Useful for labels for PopUpMenus."
	| labelStream |
	labelStream := (String new: 200) writeStream.
	self do: [:each |
		each isString
			ifTrue: [labelStream nextPutAll: each; cr]
			ifFalse: [each printOn: labelStream. labelStream cr]].
	self size > 0 ifTrue: [labelStream skip: -1].
	^ labelStream contents! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'ar 10/10/1998 16:20'!
asWordArray
	"Answer a WordArray whose elements are the elements of the receiver, in 
	the same order."

	| wordArray |
	wordArray := WordArray new: self size.
	1 to: self size do:[:i| wordArray at: i put: (self at: i)].
	^wordArray! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:11'!
at: index ifAbsent: exceptionBlock 
	"Answer the element at my position index. If I do not contain an element 
	at index, answer the result of evaluating the argument, exceptionBlock."

	(index between: 1 and: self size) ifTrue: [^ self at: index].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'raok 11/22/2002 12:34'!
at: index incrementBy: value
	^self at: index put: (self at: index) + value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'apb 11/4/2000 22:51'!
atAll: indexArray
	"Answer a new collection like the receiver which contains all elements
	of the receiver at the indices of indexArray."
	"#('one' 'two' 'three' 'four') atAll: #(3 2 4)"

	| newCollection |
	newCollection := self species ofSize: indexArray size.
	1 to: indexArray size do:
		[:index |
		newCollection at: index put: (self at: (indexArray at: index))].
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:17'!
atAll: aCollection put: anObject 
	"Put anObject at every index specified by the elements of aCollection."

	aCollection do: [:index | self at: index put: anObject].
	^ anObject! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:18'!
atAll: indexArray putAll: valueArray
	"Store the elements of valueArray into the slots
	of this collection selected by indexArray."

	indexArray with: valueArray do: [:index :value | self at: index put: value].
	^ valueArray! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 4/22/2000 17:45'!
atAllPut: anObject 
	"Put anObject at every one of the receiver's indices."

	| size |
	(size := self size) > 26 "first method faster from 27 accesses and on"
		ifTrue: [self from: 1 to: size put: anObject]
		ifFalse: [1 to: size do: [:index | self at: index put: anObject]]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nk 6/12/2004 17:06'!
atLast: indexFromEnd
	"Return element at indexFromEnd from the last position.
	 atLast: 1, returns the last element"

	^ self atLast: indexFromEnd ifAbsent: [self error: 'index out of range']! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 17:52'!
atLast: indexFromEnd ifAbsent: block
	"Return element at indexFromEnd from the last position.
	 atLast: 1 ifAbsent: [] returns the last element"

	^ self at: self size + 1 - indexFromEnd ifAbsent: block! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 18:10'!
atLast: indexFromEnd put: obj
	"Set the element at indexFromEnd from the last position.
	 atLast: 1 put: obj, sets the last element"

	^ self at: self size + 1 - indexFromEnd put: obj! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'di 11/6/1998 14:32'!
atPin: index 
	"Return the index'th element of me if possible.
	Return the first or last element if index is out of bounds."

	index < 1 ifTrue: [^ self first].
	index > self size ifTrue: [^ self last].
	^ self at: index! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 12:50'!
atRandom: aGenerator
	"Answer a random element of the receiver.  Uses aGenerator which
	should be kept by the user in a variable and used every time. Use
	this instead of #atRandom for better uniformity of random numbers 
	because only you use the generator.  Causes an error if self has no 
	elements."

	^ self at: (aGenerator nextInt: self size)! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 13:51'!
atWrap: index 
	"Answer the index'th element of the receiver.  If index is out of bounds,
	let it wrap around from the end to the beginning until it is in bounds."

	^ self at: index - 1 \\ self size + 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 13:52'!
atWrap: index put: value
	"Store value into the index'th element of the receiver.  If index is out
	of bounds, let it wrap around from the end to the beginning until it 
	is in bounds. Answer value."

	^ self at: index  - 1 \\ self size + 1 put: value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 5/12/2000 18:04'!
before: target
	"Answer the receiver's element immediately before target. Raise an
	error if target is not an element of the receiver, or if there are no 
	elements before it (i.e. it is the first element)."

	^ self before: target ifAbsent: [self errorNotFound: target]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'StephaneDucasse 5/28/2011 13:41'!
before: target ifAbsent: exceptionBlock
	"Answer the receiver's element immediately before target. Answer
	the result of evaluating the exceptionBlock if target is not an element
	of the receiver, or if there are no elements before it."

	| index |
	index := self indexOf: target.
	^ (index = 0 or: [index = 1])
		ifTrue: [exceptionBlock value]
		ifFalse: [self at: index - 1]! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:01'!
beginsWith: aSequenceableCollection
	"Answer true if the receiver starts with the argument collection"
	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	aSequenceableCollection withIndexDo: [:each :index | (self at: index) ~= each ifTrue: [^false]].
	^true! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:07'!
beginsWithAnyOf: aCollection
	"Return true if the receiver starts with any of the elements in aCollection."
	^aCollection anySatisfy:[:prefix| self beginsWith: prefix]! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'sma 5/12/2000 13:57'!
checkedAt: index
	index > self size ifTrue: [self error: 'not enough elements'].
	^ self at: index! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:46'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new: self size.
	1 to: self size do:
		[:index |
		newCollection at: index put: (aBlock value: (self at: index))].
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 6/1/2000 11:47'!
collect: aBlock from: firstIndex to: lastIndex
	"Refer to the comment in Collection|collect:."

	| size result j |
	size := lastIndex - firstIndex + 1.
	result := self species new: size.
	j := firstIndex.
	1 to: size do: [:i | result at: i put: (aBlock value: (self at: j)). j := j + 1].
	^ result! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 7/13/97 09:44'!
collectWithIndex: elementAndIndexBlock
	"Use the new version with consistent naming"
	^ self withIndexCollect: elementAndIndexBlock! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 5/14/2012 14:21'!
combinations: kk atATimeDo: aBlock
	"Take the items in the receiver, kk at a time, and evaluate the block for each combination.  Hand in an array of elements of self as the block argument.  Each combination only occurs once, and order of the elements does not matter.  There are (self size take: kk) combinations."
	" 'abcde' combinations: 3 atATimeDo: [:each | Transcript cr; show: each printString]"

	| aCollection |
	aCollection := DOArray new: kk.
	self combinationsAt: 1 in: aCollection after: 0 do: aBlock! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'tk 7/30/97 12:42'!
combinationsAt: jj in: aCollection after: nn do: aBlock
	"Choose k of N items and put in aCollection.  jj-1 already chosen.  Indexes of items are in numerical order, to avoid the same combo being used twice.  In this slot, we are allowed to use items in self indexed by nn+1 to self size.  nn is the index used for position jj-1."
	"(1 to: 6) combinationsSize: 3 do: [:each | Transcript cr; show: each printString]"

nn+1 to: self size do: [:index | 
		aCollection at: jj put: (self at: index).
		jj = aCollection size 
			ifTrue: [aBlock value: aCollection]
			ifFalse: [self combinationsAt: jj + 1 in: aCollection after: index do: aBlock]].! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'pmaer 5/14/2012 14:21'!
concatenation
	|result index|

	result := DOArray new: (self inject: 0 into: [:sum :each | sum + each size]).
	index := 0.
	self do: [:each | each do: [:item | result at: (index := index+1) put: item]].
	^result! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:05'!
copyAfter: anElement
	"Answer a copy of the receiver from after the first occurence
	of anElement up to the end. If no such element exists, answer 
	an empty copy."

	^ self allButFirst: (self indexOf: anElement ifAbsent: [^ self copyEmpty])! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:05'!
copyAfterLast: anElement
	"Answer a copy of the receiver from after the last occurence
	of anElement up to the end. If no such element exists, answer 
	an empty copy."

	^ self allButFirst: (self lastIndexOf: anElement ifAbsent: [^ self copyEmpty])! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:07'!
copyEmpty
	^ self species new: 0! !

!DOSequenceableCollection methodsFor: 'copying' stamp: ''!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize |
	newSize := stop - start + 1.
	^(self species new: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:06'!
copyLast: num
	"Deprecated. Use #last:"

	^ self last: num! !

!DOSequenceableCollection methodsFor: 'copying' stamp: ''!
copyReplaceAll: oldSubstring with: newSubstring 
	"Default is not to do token matching.
	See also String copyReplaceTokens:with:"
	^ self copyReplaceAll: oldSubstring with: newSubstring asTokens: false
	"'How now brown cow?' copyReplaceAll: 'ow' with: 'ello'"
	"'File asFile Files File''s File' copyReplaceTokens: 'File' with: 'Pile'"! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'yo 9/2/2002 18:22'!
copyReplaceAll: oldSubstring with: newSubstring asTokens: ifTokens
	"Answer a copy of the receiver in which all occurrences of
	oldSubstring have been replaced by newSubstring.
	ifTokens (valid for Strings only) specifies that the characters
	surrounding the recplacement must not be alphanumeric.
		Bruce Simth,  must be incremented by 1 and not 
	newSubstring if ifTokens is true.  See example below. "

	| aString startSearch currentIndex endIndex |
	(ifTokens and: [(self isString) not])
		ifTrue: [(self isKindOf: Text) ifFalse: [
			self error: 'Token replacement only valid for Strings']].
	aString := self.
	startSearch := 1.
	[(currentIndex := aString indexOfSubCollection: oldSubstring startingAt: startSearch)
			 > 0]
		whileTrue: 
		[endIndex := currentIndex + oldSubstring size - 1.
		(ifTokens not
			or: [(currentIndex = 1
					or: [(aString at: currentIndex-1) isAlphaNumeric not])
				and: [endIndex = aString size
					or: [(aString at: endIndex+1) isAlphaNumeric not]]])
			ifTrue: [aString := aString
					copyReplaceFrom: currentIndex
					to: endIndex
					with: newSubstring.
				startSearch := currentIndex + newSubstring size]
			ifFalse: [
				ifTokens 
					ifTrue: [startSearch := currentIndex + 1]
					ifFalse: [startSearch := currentIndex + newSubstring size]]].
	^ aString

"Test case:
	'test te string' copyReplaceAll: 'te' with: 'longone' asTokens: true   "
! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'ar 10/16/2001 19:03'!
copyReplaceFrom: start to: stop with: replacementCollection 
	"Answer a copy of the receiver satisfying the following conditions: If 
	stop is less than start, then this is an insertion; stop should be exactly 
	start-1, start = 1 means insert before the first character, start = size+1 
	means append after last character. Otherwise, this is a replacement; start 
	and stop have to be within the receiver's bounds."

	| newSequenceableCollection newSize endReplacement |
	newSize := self size - (stop - start + 1) + replacementCollection size.
	endReplacement := start - 1 + replacementCollection size.
	newSequenceableCollection := self species new: newSize.
	start > 1 ifTrue:[
		newSequenceableCollection
			replaceFrom: 1
			to: start - 1
			with: self
			startingAt: 1].
	start <= endReplacement ifTrue:[
		newSequenceableCollection
			replaceFrom: start
			to: endReplacement
			with: replacementCollection
			startingAt: 1].
	endReplacement < newSize ifTrue:[
		newSequenceableCollection
			replaceFrom: endReplacement + 1
			to: newSize
			with: self
			startingAt: stop + 1].
	^newSequenceableCollection! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'MarcusDenker 12/20/2010 16:00'!
copyUpThrough: anElement
    "Answer all elements up to and including anObject. If there
     is no such object, answer a copy of the receiver."

	^self first: (self indexOf: anElement ifAbsent: [^ self copy])! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:00'!
copyUpTo: anElement 
	"Answer all elements up to but not including anObject. If there
	is no such object, answer a copy of the receiver."

	^ self first: (self indexOf: anElement ifAbsent: [^ self copy]) - 1! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 16:02'!
copyUpToLast: anElement
	"Answer a copy of the receiver from index 1 to the last occurrence of 
	anElement, not including anElement."

	^ self first: (self lastIndexOf: anElement ifAbsent: [^ self copy]) - 1! !

!DOSequenceableCollection methodsFor: 'copying' stamp: ''!
copyWith: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and has 
	newElement at the last element."

	| newIC |
	newIC := self species new: self size + 1.
	newIC 
		replaceFrom: 1
		to: self size
		with: self
		startingAt: 1.
	newIC at: newIC size put: newElement.
	^newIC! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/27/2002 12:09'!
copyWithFirst: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver with newElement as the first element."

	| newIC |
	newIC := self species ofSize: self size + 1.
	newIC 
		replaceFrom: 2
		to: self size + 1
		with: self
		startingAt: 1.
	newIC at: 1 put: newElement.
	^ newIC! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'sma 6/1/2000 15:38'!
copyWithoutFirst
	"Deprecatd. Return a copy of the receiver which doesn't include
	the first element."

	^ self allButFirst! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'rhi 12/6/2001 14:04'!
copyWithoutIndex: index
	"Return a copy containing all elements except the index-th."

	| copy |
	copy := self species ofSize: self size - 1.
	copy replaceFrom: 1 to: index-1 with: self startingAt: 1.
	copy replaceFrom: index to: copy size with: self startingAt: index+1.
	^ copy! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | aBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 11:56'!
do: elementBlock separatedBy: separatorBlock
	"Evaluate the elementBlock for all elements in the receiver,
	and evaluate the separatorBlock between."

	1 to: self size do:
		[:index |
		index = 1 ifFalse: [separatorBlock value].
		elementBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ar 5/1/1999 05:01'!
do: aBlock without: anItem
	"Enumerate all elements in the receiver.
	Execute aBlock for those elements that are not equal to the given item"
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | anItem = (self at: index) ifFalse:[aBlock value: (self at: index)]]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 7/13/97 09:43'!
doWithIndex: elementAndIndexBlock
	"Use the new version with consistent naming"
	^ self withIndexDo: elementAndIndexBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
eighth
	"Answer the eighth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 8! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:01'!
endsWith: aSequenceableCollection
	"Answer true if the receiver ends with the argument collection"
	
	| start |
	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	start := self size - aSequenceableCollection size.
	aSequenceableCollection withIndexDo: [:each :index | (self at: start + index) ~= each ifTrue: [^false]].
	^true! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'StephaneDucasse 3/28/2010 21:06'!
endsWithAnyOf: aCollection
	"Return true if the receiver ends with any of the elements in aCollection."
	^aCollection anySatisfy:[:suffix| self endsWith: suffix]! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'sma 5/12/2000 18:06'!
errorFirstObject: anObject
	self error: 'specified object is first object'! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'sma 5/12/2000 18:03'!
errorLastObject: anObject
	self error: 'specified object is last object'! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/21/2011 13:02'!
errorOutOfBounds

	SubscriptOutOfBounds signal! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
fifth
	"Answer the fifth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 5! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'jmv 5/10/2010 14:05'!
findBinary: aBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, raise an error.
	Examples:
		#(1 3 5 7 11 15 23) findBinary: [ :arg | 11 - arg ]
	"
	^self findBinary: aBlock do: [ :found | found ] ifNone: [ self errorNotFound: aBlock ]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'JuanVuletich 10/11/2010 20:21'!
findBinary: aBlock do: actionBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If found, evaluate actionBlock with the found element as argument
	If no matching element is found, evaluate exceptionBlock,
	with the  'bounding' elements (or nil) as arguments.
	Examples:
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 11 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 12 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 0.5 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinary: [ :arg | 25 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ',{a. b} printString) print]
	"
	^ self
		findBinaryIndex: aBlock
		do: [ :foundIndex |
			actionBlock value: (self at: foundIndex) ]
		ifNone: [ :prevIndex :nextIndex |
			exceptionBlock
				value:
					(prevIndex > 0 ifTrue: [ self at: prevIndex ])
				value:
					(nextIndex <= self size ifTrue: [ self at: nextIndex ]) ].
! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ar 6/3/2000 15:52'!
findBinary: aBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, evaluate exceptionBlock."
	| index low high test item |
	low := 1.
	high := self size.
	[index := high + low // 2.
	low > high] whileFalse:[
		test := aBlock value: (item := self at: index).
		test = 0 
			ifTrue:[^item]
			ifFalse:[test > 0
				ifTrue: [low := index + 1]
				ifFalse: [high := index - 1]]].
	^exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'jmv 5/10/2010 14:03'!
findBinaryIndex: aBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, raise an error.
	Examples:
		#(1 3 5 7 11 15 23) findBinaryIndex: [ :arg | 11 - arg ]
	"
	^self findBinaryIndex: aBlock do: [ :found | found ] ifNone: [ self errorNotFound: aBlock]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'JuanVuletich 10/11/2010 20:22'!
findBinaryIndex: aBlock do: actionBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If found, evaluate actionBlock with the index as argument
	If no matching element is found, evaluate exceptionBlock,
	with the indexes of the  'bounding' elements as arguments.
	Warning: Might give invalid indexes, see examples below
	Examples:
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 11 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 12 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 0.5 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ', {a. b} printString) print]
		#(1 3 5 7 11 15 23)
			findBinaryIndex: [ :arg | 25 - arg ]
			do: [ :found | found print ]
			ifNone: [ :a :b | ('between: ',{a. b} printString) print]
	"
	| index low high test |
	low := 1.
	high := self size.
	[
		index := high + low // 2.
		low > high ] whileFalse: [
		test := aBlock value: (self at: index).
		test = 0 
			ifTrue: [ ^actionBlock value: index ]
			ifFalse: [ test > 0
				ifTrue: [ low := index + 1 ]
				ifFalse: [ high := index - 1 ]]].
	^exceptionBlock valueWithPossibleArgs: {high. low}! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ar 6/3/2000 15:54'!
findBinaryIndex: aBlock ifNone: exceptionBlock
	"Search for an element in the receiver using binary search.
	The argument aBlock is a one-element block returning
		0 	- if the element is the one searched for
		<0	- if the search should continue in the first half
		>0	- if the search should continue in the second half
	If no matching element is found, evaluate exceptionBlock."
	| index low high test |
	low := 1.
	high := self size.
	[index := high + low // 2.
	low > high] whileFalse:[
		test := aBlock value: (self at: index).
		test = 0 
			ifTrue:[^index]
			ifFalse:[test > 0
				ifTrue: [low := index + 1]
				ifFalse: [high := index - 1]]].
	^exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
findFirst: aBlock
	"Return the index of my first element for which aBlock evaluates as true."

	| index |
	index := 0.
	[(index := index + 1) <= self size] whileTrue:
		[(aBlock value: (self at: index)) ifTrue: [^index]].
	^ 0! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
findLast: aBlock
	"Return the index of my last element for which aBlock evaluates as true."

	| index |
	index := self size + 1.
	[(index := index - 1) >= 1] whileTrue:
		[(aBlock value: (self at: index)) ifTrue: [^index]].
	^ 0! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'md 1/19/2006 09:57'!
first
	"Answer the first element of the receiver"

	^ self at: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:31'!
first: n
	"Answer the first n elements of the receiver.
	Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: n! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'nice 2/26/2009 11:48'!
forceTo: length paddingStartWith: elem 
	"Force the length of the collection to length, padding  
	the beginning of the result if necessary with elem.  
	Note that this makes a copy."
	| newCollection padLen |
	newCollection := self species ofSize: length.
	padLen := length - self size max: 0.
	newCollection
		from: 1
		to: padLen
		put: elem.
	newCollection
		replaceFrom: padLen + 1
		to: ((padLen + self size) min: length)
		with: self
		startingAt:  1.
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'nice 2/24/2009 11:33'!
forceTo: length paddingWith: elem
	"Force the length of the collection to length, padding
	if necessary with elem.  Note that this makes a copy."

	| newCollection |
	newCollection := self species new: length withAll: elem.
	newCollection replaceFrom: 1 to: (self size min: length) with: self startingAt: 1.
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
fourth
	"Answer the fourth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 4! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 18:11'!
from: start to: stop do: aBlock
	"Evaluate aBlock for all elements between start and stop (inclusive)."

	start to: stop do: [:index | aBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'SqR 10/30/2000 22:06'!
from: startIndex to: endIndex put: anObject
	"Put anObject in all indexes between startIndex 
	and endIndex. Very fast. Faster than to:do: for
	more than 26 positions. Answer anObject"

	| written toWrite thisWrite |

	startIndex > endIndex ifTrue: [^self].
	self at: startIndex put: anObject.
	written := 1.
	toWrite := endIndex - startIndex + 1.
	[written < toWrite] whileTrue:
		[
			thisWrite := written min: toWrite - written.
			self 
				replaceFrom: startIndex + written
				to: startIndex + written + thisWrite - 1
				with: self startingAt: startIndex.
			written := written + thisWrite
		].
	^anObject! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
groupsOf: n atATimeCollect: aBlock 
	"Evaluate aBlock with my elements taken n at a time. Ignore any 
	leftovers at the end. 
	Allows use of a flattened  
	array for things that naturally group into groups of n. 
	If aBlock has a single argument, pass it an array of n items, 
	otherwise, pass the items as separate arguments. 
	See also pairsDo:"
	| passArray |
	passArray := aBlock numArgs = 1.
	^(n
		to: self size
		by: n)
		collect: [:index | | args | 
			args := (self copyFrom: index - n + 1 to: index) asArray.
			passArray
				ifTrue: [aBlock value: args]
				ifFalse: [aBlock valueWithArguments: args]]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nice 1/5/2010 15:59'!
groupsOf: n atATimeDo: aBlock 
	"Evaluate aBlock with my elements taken n at a time. Ignore any leftovers at the end.
	Allows use of a flattened 
	array for things that naturally group into groups of n.
	If aBlock has a single argument, pass it an array of n items,
	otherwise, pass the items as separate arguments.
	See also pairsDo:"
	| passArray |
	passArray := (aBlock numArgs = 1).
	n
		to: self size
		by: n
		do: [:index | | args | 
			args := (self copyFrom: index - n + 1 to: index) asArray.
			passArray ifTrue: [ aBlock value: args ]
				ifFalse: [ aBlock valueWithArguments: args ]].! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'nice 2/26/2009 11:26'!
grownBy: length
	"Answer a copy of receiver collection with size grown by length"

	| newCollection |
	newCollection := self species ofSize: self size + length.
	newCollection replaceFrom: 1 to: self size with: self startingAt: 1.
	^ newCollection! !

!DOSequenceableCollection methodsFor: 'comparing' stamp: 'pmaer 5/14/2012 14:07'!
hasEqualElements: otherCollection
	"Answer whether the receiver's size is the same as otherCollection's
	size, and each of the receiver's elements equal the corresponding 
	element of otherCollection.
	This should probably replace the current definition of #= ."

	| size |
	(otherCollection isKindOf: DOSequenceableCollection) ifFalse: [^ false].
	(size := self size) = otherCollection size ifFalse: [^ false].
	1 to: size do:
		[:index |
		(self at: index) = (otherCollection at: index) ifFalse: [^ false]].
	^ true! !

!DOSequenceableCollection methodsFor: 'comparing' stamp: 'SqR 8/3/2000 13:39'!
hash
	| hash |

	hash := self species hash.
	1 to: self size do: [:i | hash := (hash + (self at: i) hash) hashMultiply].
	^hash! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 8/14/1998 21:20'!
identityIndexOf: anElement 
	"Answer the index of anElement within the receiver. If the receiver does 
	not contain anElement, answer 0."

	^self identityIndexOf: anElement ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 8/14/1998 21:21'!
identityIndexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of anElement within the receiver. If the receiver does 
	not contain anElement, answer the result of evaluating the argument, 
	exceptionBlock."
	1 to: self size do:
		[:i | (self at: i) == anElement ifTrue: [^ i]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'testing' stamp: 'sma 5/12/2000 14:08'!
includes: anObject
	"Answer whether anObject is one of the receiver's elements."

	^ (self indexOf: anObject) ~= 0! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:46'!
indexOf: anElement
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer 0."

	^ self indexOf: anElement ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:47'!
indexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the 
	result of evaluating the argument, exceptionBlock."

	^ self indexOf: anElement startingAt: 1 ifAbsent: exceptionBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'StephaneDucasse 9/18/2010 21:18'!
indexOf: anElement startingAt: start
       "Answer the index of the first occurence of anElement after start within the receiver. If the receiver does not contain anElement, answer 0."

	^self indexOf: anElement startingAt: start ifAbsent: 0! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:47'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement after start
	within the receiver. If the receiver does not contain anElement, 
	answer the 	result of evaluating the argument, exceptionBlock."

	start to: self size do:
		[:index |
		(self at: index) = anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:55'!
indexOfAnyOf: aCollection
	"Answer the index of the first occurence of any element included in aCollection within the receiver.
	If the receiver does not contain anElement, answer zero, which is an invalid index."

	^self indexOfAnyOf: aCollection startingAt: 1 ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:55'!
indexOfAnyOf: aCollection ifAbsent: exceptionBlock
	"Answer the index of the first occurence of any element included in aCollection within the receiver.
	If the receiver does not contain anElement, answer the result of evaluating the argument, exceptionBlock."

	^self indexOfAnyOf: aCollection startingAt: 1 ifAbsent: exceptionBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:54'!
indexOfAnyOf: aCollection startingAt: start
	"Answer the index of the first occurence of any element included in aCollection after start within the receiver.
	If the receiver does not contain anElement, answer zero, which is an invalid index."

	^self indexOfAnyOf: aCollection startingAt: start ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 12/9/2009 14:57'!
indexOfAnyOf: aCollection startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of any element included in aCollection after start within the receiver.
	If the receiver does not contain anElement, answer the result of evaluating the argument, exceptionBlock.
	Note: it is user responsibility to provide aCollection that behaves relatevily fast when asked for includes: (like a Set)"

	start to: self size do:
		[:index |
		(aCollection includes: (self at: index)) ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
indexOfSubCollection: aSubCollection startingAt: anIndex 
	"Answer the index of the receiver's first element, such that that element 
	equals the first element of aSubCollection, and the next elements equal 
	the rest of the elements of aSubCollection. Begin the search at element 
	anIndex of the receiver. If no such match is found, answer 0."

	^self
		indexOfSubCollection: aSubCollection
		startingAt: anIndex
		ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
indexOfSubCollection: sub startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the receiver's first element, such that that element 
	equals the first element of sub, and the next elements equal 
	the rest of the elements of sub. Begin the search at element 
	start of the receiver. If no such match is found, answer the result of 
	evaluating argument, exceptionBlock."
	| first index |
	sub isEmpty ifTrue: [^ exceptionBlock value].
	first := sub first.
	start to: self size - sub size + 1 do:
		[:startIndex |
		(self at: startIndex) = first ifTrue:
			[index := 1.
			[(self at: startIndex+index-1) = (sub at: index)]
				whileTrue:
				[index = sub size ifTrue: [^startIndex].
				index := index+1]]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 3/3/2001 22:43'!
integerAt: index
	"Return the integer at the given index"
	^self at: index! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 3/3/2001 22:43'!
integerAt: index put: value
	"Return the integer at the given index"
	^self at: index put: value! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'di 11/6/1998 09:35'!
isSequenceable
	^ true! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 20:19'!
join: aCollection
	"NB: this implementation only works for Array, since WriteStreams only work for Arrays and Strings. (!!)
	Overridden in OrderedCollection and SortedCollection."
	^ self class
		streamContents: [:stream | aCollection
				do: [:each | each joinTo: stream]
				separatedBy: [stream nextPutAll: self]]! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 19:58'!
joinTo: stream
	"double dispatch for join:"
	^ stream nextPutAll: self! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/10/2009 22:53'!
joinUsing: joiner
	"joiner - character, string or sequenceable collection
	returns collection of the same collection class as 'joiner', or a String"
	^ joiner join: self! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'pmaer 5/14/2012 14:21'!
joinUsing: joiner last: last 
	"#(1 2 3 4) joinUsing: ', ' last: 'and'. => '1, 2, 3 and 4"
	^ last join: (DOArray
				with: (joiner join: self allButLast)
				with: self last)! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'sma 5/12/2000 18:13'!
keysAndValuesDo: aBlock 
	"Enumerate the receiver with all the keys (aka indices) and values."

	1 to: self size do: [:index | aBlock value: index value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'md 1/19/2006 09:56'!
last
	"Answer the last element of the receiver"

	^ self at: self size! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'sma 6/1/2000 15:30'!
last: n
	"Answer the last n elements of the receiver.  
	Raise an error if there are not enough elements."

	| size |
	size := self size.
	^ self copyFrom: size - n + 1 to: size! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 12/16/2001 01:06'!
lastIndexOf: anElement
	"Answer the index of the last occurence of anElement within the 
	receiver. If the receiver does not contain anElement, answer 0."

	^ self lastIndexOf: anElement startingAt: self size ifAbsent: [0]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 12/16/2001 01:06'!
lastIndexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the last occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the
	result of evaluating the argument, exceptionBlock."
	^self lastIndexOf: anElement startingAt: self size ifAbsent: exceptionBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 12/16/2001 01:05'!
lastIndexOf: anElement startingAt: lastIndex ifAbsent: exceptionBlock
	"Answer the index of the last occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the
	result of evaluating the argument, exceptionBlock."

	lastIndex to: 1 by: -1 do:
		[:index |
		(self at: index) = anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'nice 11/16/2009 10:31'!
lastIndexOfAnyOf: aCollection startingAt: lastIndex ifAbsent: exceptionBlock
	"Answer the index of the last occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the
	result of evaluating the argument, exceptionBlock."

	lastIndex to: 1 by: -1 do:
		[:index |
		(aCollection includes: (self at: index)) ifTrue: [^ index]].
	^ exceptionBlock value! !

!DOSequenceableCollection methodsFor: 'sorting' stamp: 'jannik.laval 5/1/2010 16:27'!
mergeSortFrom: startIndex to: stopIndex by: aBlock
	"Sort the given range of indices using the mergesort algorithm.
	Mergesort is a worst-case O(N log N) sorting algorithm that usually
	does only half as many comparisons as heapsort or quicksort."

	"Details: recursively split the range to be sorted into two halves,
	mergesort each half, then merge the two halves together. An extra 
	copy of the data is used as temporary storage and successive merge 
	phases copy data back and forth between the receiver and this copy.
	The recursion is set up so that the final merge is performed into the
	receiver, resulting in the receiver being completely sorted."

	self size <= 1 ifTrue: [^ self].  "nothing to do"
	startIndex = stopIndex ifTrue: [^ self].
	[startIndex >= 1 and: [startIndex < stopIndex]] assert. "bad start index"
	[stopIndex <= self size] assert. "bad stop index"
	self
		mergeSortFrom: startIndex
		to: stopIndex 
		src: self copy 
		dst: self 
		by: aBlock! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'md 1/19/2006 09:56'!
middle
	"Answer the middle element of the receiver."
	^ self at: self size // 2 + 1! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 8/23/2003 10:42'!
nextToLast
	^self at: self size - 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
ninth
	"Answer the ninth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 9! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'StephaneDucasse 3/1/2011 14:22'!
overlappingPairsCollect: aBlock 
	"Answer the result of evaluating aBlock with all of the overlapping pairs of my elements."
	| retval |
	retval := self species ofSize: self size - 1.
	1 to: self size - 1
		do: [:i | retval at: i put: (aBlock value: (self at: i) value: (self at: i + 1)) ].
	^retval! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 7/17/2003 17:55'!
overlappingPairsDo: aBlock 
	"Emit overlapping pairs of my elements into aBlock"

	1 to: self size - 1
		do: [:i | aBlock value: (self at: i) value: (self at: i + 1)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 7/17/2003 17:54'!
overlappingPairsWithIndexDo: aBlock 
	"Emit overlapping pairs of my elements into aBlock, along with an index."

	1 to: self size - 1
		do: [:i | aBlock value: (self at: i) value: (self at: i + 1) value: i ]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'nk 3/30/2002 12:45'!
paddedWith: otherCollection do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection.
	Missing elements from either will be passed as nil."
	1 to: (self size max: otherCollection size) do:
		[:index | twoArgBlock value: (self at: index ifAbsent: [])
				value: (otherCollection at: index ifAbsent: [])]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 11/12/1998 15:01'!
pairsCollect: aBlock 
	"Evaluate aBlock with my elements taken two at a time, and return an Array with the results"

	^ (1 to: self size // 2) collect:
		[:index | aBlock value: (self at: 2 * index - 1) value: (self at: 2 * index)]
"
#(1 'fred' 2 'charlie' 3 'elmer') pairsCollect:
	[:a :b | b, ' is number ', a printString]
"! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 11/12/1998 15:01'!
pairsDo: aBlock 
	"Evaluate aBlock with my elements taken two at a time.  If there's an odd number of items, ignore the last one.  Allows use of a flattened array for things that naturally group into pairs.  See also pairsCollect:"

	1 to: self size // 2 do:
		[:index | aBlock value: (self at: 2 * index - 1) value: (self at: 2 * index)]
"
#(1 'fred' 2 'charlie' 3 'elmer') pairsDo:
	[:a :b | Transcript cr; show: b, ' is number ', a printString]
"! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ward 7/28/97 09:41'!
permutationsDo: aBlock
	"Repeatly value aBlock with a single copy of the receiver. Reorder the copy
	so that aBlock is presented all (self size factorial) possible permutations."
	"(1 to: 4) permutationsDo: [:each | Transcript cr; show: each printString]"

	self shallowCopy permutationsStartingAt: 1 do: aBlock! !

!DOSequenceableCollection methodsFor: 'private' stamp: 'ward 7/28/97 09:38'!
permutationsStartingAt: anInteger do: aBlock
	"#(1 2 3 4) permutationsDo: [:each | Transcript cr; show: each printString]"

	anInteger > self size ifTrue: [^self].
	anInteger = self size ifTrue: [^aBlock value: self].
	anInteger to: self size do:
		[:i | self swap: anInteger with: i.
		self permutationsStartingAt: anInteger + 1 do: aBlock.
		self swap: anInteger with: i]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'tk 12/27/2000 09:53'!
polynomialEval: thisX
	| sum valToPower |
	"Treat myself as the coeficients of a polynomial in X.  Evaluate it with thisX.  First element is the constant and last is the coeficient for the highest power."
	"  #(1 2 3) polynomialEval: 2   "   "is 3*X^2 + 2*X + 1 with X = 2"

	sum := self first.
	valToPower := thisX.
	2 to: self size do: [:ind | 
		sum := sum + ((self at: ind) * valToPower).
		valToPower := valToPower * thisX].
	^ sum! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'sma 5/12/2000 12:51'!
readStream
	^ ReadStream on: self! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'LukasRenggli 5/10/2010 12:59'!
reduce: aBlock
	^ self reduceLeft: aBlock! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 5/14/2012 14:21'!
reduceLeft: aBlock
	"Fold the result of the receiver from left to right into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceLeft: [ :a :b | a - b ].
		--> ((1 - 2) - 3) = -4
	#(1 + 3 - 5) reduceLeft: [ :a :op :b | a perform: op with: b ].
		--> ((1 + 3) - 5) = -1"

	| arguments |
	self emptyCheck.
	arguments := DOArray new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: 1 put: self first.
	2 to: self size by: arguments size - 1 do: [ :index |
		arguments
			replaceFrom: 2 to: arguments size with: self startingAt: index;
			at: 1 put: (aBlock valueWithArguments: arguments) ].
	^ arguments first! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'pmaer 5/14/2012 14:21'!
reduceRight: aBlock
	"Fold the result of the receiver from right to left into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceRight: [ :a :b | a - b ].
		--> (1 - (2 - 3)) = 2
	#(1 + 3 - 5) reduceRight: [ :a :op :b | a perform: op with: b ].
		--> (1 + (3 - 5)) = -1"

	| arguments |
	self emptyCheck.
	arguments := DOArray new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: arguments size put: self last.
	self size - arguments size + 1 to: 1 by: 1 - arguments size do: [ :index |
		arguments
			replaceFrom: 1 to: aBlock argumentCount - 1 with: self startingAt: index;
			at: arguments size put: (aBlock valueWithArguments: arguments) ].
	^ arguments last! !

!DOSequenceableCollection methodsFor: 'removing' stamp: ''!
remove: oldObject ifAbsent: anExceptionBlock 
	"SequencableCollections cannot implement removing."

	self shouldNotImplement! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'ul 11/11/2009 19:38'!
replace: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into self."

	1 to: self size do: [ :index |
		self at: index put: (aBlock value: (self at: index)) ]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'ar 1/20/98 16:22'!
replaceAll: oldObject with: newObject 
	"Replace all occurences of oldObject with newObject"
	| index |
	index := self
				indexOf: oldObject
				startingAt: 1
				ifAbsent: [0].
	[index = 0]
		whileFalse: 
			[self at: index put: newObject.
			index := self
						indexOf: oldObject
						startingAt: index + 1
						ifAbsent: [0]]! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
replaceFrom: start to: stop with: replacement 
	"This destructively replaces elements from start to stop in the receiver. 
	Answer the receiver itself. Use copyReplaceFrom:to:with: for 
	insertion/deletion which may alter the size of the result."

	replacement size = (stop - start + 1)
		ifFalse: [self error: 'Size of replacement doesnt match'].
	^self replaceFrom: start to: stop with: replacement startingAt: 1! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	| index repOff |
	repOff := repStart - start.
	index := start - 1.
	[(index := index + 1) <= stop]
		whileTrue: [self at: index put: (replacement at: repOff + index)]! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'lr 5/13/2010 16:25'!
reverse
	"Answer a copy of the receiver with element order reversed, as expected by ANSI."

	^ self reversed! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
reverseDo: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument, 
	starting with the last element and taking each in sequence up to the 
	first. For SequenceableCollections, this is the reverse of the enumeration 
	for do:."

	self size to: 1 by: -1 do: [:index | aBlock value: (self at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: ''!
reverseWith: aSequenceableCollection do: aBlock 
	"Evaluate aBlock with each of the receiver's elements, in reverse order, 
	along with the  
	corresponding element, also in reverse order, from 
	aSequencableCollection. "

	self size ~= aSequenceableCollection size ifTrue: [^ self errorNoMatch].
	self size
		to: 1
		by: -1
		do: [:index | aBlock value: (self at: index)
				value: (aSequenceableCollection at: index)]! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'jm 4/27/98 04:09'!
reversed
	"Answer a copy of the receiver with element order reversed."
	"Example: 'frog' reversed"

	| n result src |
	n := self size.
	result := self species new: n.
	src := n + 1.
	1 to: n do: [:i | result at: i put: (self at: (src := src - 1))].
	^ result
! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
second
	"Answer the second element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 2! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'PeterHugossonMiller 9/3/2009 11:20'!
select: aBlock 
	"Refer to the comment in Collection|select:."
	| aStream |
	aStream := (self species new: self size) writeStream.
	1 to: self size do: 
		[:index |
		(aBlock value: (self at: index))
			ifTrue: [aStream nextPut: (self at: index)]].
	^ aStream contents! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:21'!
seventh
	"Answer the seventh element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 7! !

!DOSequenceableCollection methodsFor: 'shuffling' stamp: 'pmaer 5/14/2012 14:06'!
shuffle

	^self shuffleBy: DOCollection randomForPicking! !

!DOSequenceableCollection methodsFor: 'shuffling' stamp: 'StephaneDucasse 7/10/2010 18:26'!
shuffleBy: aRandom
	"Durstenfeld's version of the Fisher-Yates shuffle"

	self size to: 2 by: -1 do: [ :i | 
		self swap: i with: (aRandom nextInt: i) ]! !

!DOSequenceableCollection methodsFor: 'copying' stamp: 'pmaer 5/14/2012 14:06'!
shuffled
	^ self shuffledBy: DOCollection randomForPicking

"Examples:
	($A to: $Z) shuffled
"! !

!DOSequenceableCollection methodsFor: 'shuffling' stamp: 'StephaneDucasse 7/10/2010 18:26'!
shuffledBy: aRandom
	"Durstenfeld's version of the Fisher-Yates shuffle"

	^self copy shuffleBy: aRandom! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:22'!
sixth
	"Answer the sixth element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 6! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'pmaer 5/14/2012 14:23'!
split: aSequencableCollection
	| result position oldPosition |
	result := DOOrderedCollection new.
	position := 1.
	oldPosition := position.
	position := aSequencableCollection indexOfSubCollection: self startingAt: position.
	[ position > 0 ] whileTrue: [
		result add: (aSequencableCollection copyFrom: oldPosition to: position - 1).
		position := position + self size.
		oldPosition := position.
		position := aSequencableCollection indexOfSubCollection: self startingAt: position.
	].
	result add: (aSequencableCollection copyFrom: oldPosition to: aSequencableCollection size).
	^ result

! !

!DOSequenceableCollection methodsFor: 'splitjoin' stamp: 'onierstrasz 4/12/2009 20:20'!
splitOn: splitter 
	"splitter - can be a subsequence, a Block or a Regex (String receiver only).
	Any other object used as a splitter is treated as an Array containing that object."
	^ splitter split: self! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: ''!
swap: oneIndex with: anotherIndex 
	"Move the element at oneIndex to anotherIndex, and vice-versa."

	| element |
	element := self at: oneIndex.
	self at: oneIndex put: (self at: anotherIndex).
	self at: anotherIndex put: element! !

!DOSequenceableCollection methodsFor: 'accessing' stamp: 'JMM 10/30/2005 09:22'!
third
	"Answer the third element of the receiver.
	Raise an error if there are not enough elements."

	^ self at: 3! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 8/31/1999 13:13'!
with: otherCollection collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with corresponding elements from this collection and otherCollection."
	| result |
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	result := self species new: self size.
	1 to: self size do:
		[:index | result at: index put:
		(twoArgBlock
			value: (self at: index)
			value: (otherCollection at: index))].
	^ result! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 8/3/1999 15:26'!
with: otherCollection do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection."
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do:
		[:index |
		twoArgBlock value: (self at: index)
				value: (otherCollection at: index)]! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 5/17/1998 13:34'!
withIndexCollect: elementAndIndexBlock 
	"Just like with:collect: except that the iteration index supplies the second argument to the block."
	| result |
	result := self species new: self size.
	1 to: self size do:
		[:index | result at: index put:
		(elementAndIndexBlock
			value: (self at: index)
			value: index)].
	^ result! !

!DOSequenceableCollection methodsFor: 'enumerating' stamp: 'di 7/13/97 09:35'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

!DOSequenceableCollection methodsFor: 'converting' stamp: 'sma 5/12/2000 12:52'!
writeStream
	^ WriteStream on: self! !

OwnedObject3 subclass: #Hotel
	uses: TNoOwernship
	instanceVariableNames: 'room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

Hotel class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!Hotel class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:17'!
compilerClass 
	^ OwnershipCompiler3! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:13'!
anyRoom
	<unsafe>
	^room.! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:12'!
inFilters
	^ { #public }! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:21'!
initialize 
	room := Room newOwned: self.! !

!Hotel methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

OwnedObject3 subclass: #HotelTester
	uses: TNoOwernship
	instanceVariableNames: 'hotel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

HotelTester class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!HotelTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
compilerClass 
	^OwnershipCompiler3 ! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#none}! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:19'!
initialize 
	hotel := Hotel new.! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
testContent
	^ hotel anyRoom safe content.  ! !

!HotelTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
testStatus
	^ hotel anyRoom safe status.  ! !

OwnedObject3 subclass: #OComponent
	uses: TDefensiveCopyOwernship
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OComponent class
	uses: TDefensiveCopyOwernship classTrait
	instanceVariableNames: ''!

!OComponent class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:50'!
compilerClass
	^OwnershipCompiler3! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:57'!
addItem: anItem
	items addFirst: anItem. ! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:31'!
doNotCrossBoundary: anObject
	| clone |
	( self selectedCopyClass includes: anObject class ) ifTrue: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') copied by ', self printString ) ; cr.
			"The handler is subject t ownership (no meta pragma), so the owner of the new list is the boundary."
			clone := anObject class new.
			clone addAll: anObject.  
			clone owner: WorldOwner getInstance.
			^ clone. 
	]	ifFalse: [
			Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
			OwnershipViolation signal: 'Boundary crossed'    
	]
! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:05'!
initialize 
	items := OLinkedList new.! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:56'!
items
	^ items ! !

!OComponent methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:52'!
selectedCopyClass 
	^ { OLinkedList }! !

OwnedObject3 subclass: #OComponentTester
	uses: TNoOwernship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OComponentTester class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!OComponentTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:52'!
compilerClass 
	^OwnershipCompiler3 ! !

!OComponentTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:34'!
testReturnCopy
	| comp items1 items2 |
	comp := OComponent  new.
	comp addItem: '1'. 
	comp addItem: '2'. 
	items1 := comp items. 
	items2 := comp items. 
	^items1 == items2. ! !

OwnedObject3 subclass: #OIterator
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OIterator class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:18'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:03'!
current
	^ current! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:03'!
current: v
	 current := v ! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:31'!
hasNext
	<iteration>
	^ (self current = nil ) not. ! !

!OIterator methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:31'!
next
	<iteration>
	| v |
	v := self current content.
	self current: self current next. 
	^ v.! !

OwnedObject3 subclass: #OLinkedList
	uses: TSelectiveOwernship
	instanceVariableNames: 'head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OLinkedList class
	uses: TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!OLinkedList class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:18'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:59'!
addAll: aList
	| it |
	it := aList iterator.
	[ it hasNext ] whileTrue: [ self addFirst: it next. ] ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'pmaer 5/22/2012 14:42'!
addFirst: value
	| node |
	node := ONode new content: value ; next: self head. 
	self head: node. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:06'!
first
	^ self head content. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
head
	^ head! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
head: h
	head := h.! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#iteration}! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
initialize 
	self head: nil. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:41'!
iterator 
	^ ( OIterator newOwned: self ) current: self head. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:04'!
removeFirst
	self head: self head next. ! !

!OLinkedList methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:30'!
selectedClasses 
	^ { OIterator }! !

OwnedObject3 subclass: #OLinkedListTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OLinkedListTester class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:20'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/22/2012 14:41'!
buildList
	| list |
	 list := OLinkedList new.
	list addFirst: #1. 
	list addFirst: #2. 
	^ list.! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testAddRemoveFirst
	| list |
	list := self buildList .
	list removeFirst. 
	^ list first. ! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testIterator
	| list it |
	list := self buildList .
  	it := list iterator. 
	it next.
	^ it next! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testLeakAddRemoveFirst
	| list |
	list := self buildList .
	list first .
	list first .
	^ list head. "should fail"! !

!OLinkedListTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:37'!
testLeakIterator
	| list it |
	list := self buildList .
  	it := list iterator. 
	it next.
	it next. 
	^ it current. "should fail"! !

OwnedObject3 subclass: #ONode
	instanceVariableNames: 'value next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!ONode class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 15:18'!
compilerClass 
	^ OwnershipCompiler3  ! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 15:00'!
content
	^ value.! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 15:10'!
content: val
	value := val.! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 14:59'!
next
	^ next! !

!ONode methodsFor: 'accessing' stamp: 'ewe 4/26/2012 14:59'!
next: anObject
	next := anObject! !

OwnedObject3 subclass: #OSecureTree
	uses: TNoOwernship
	instanceVariableNames: 'left content right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OSecureTree class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!OSecureTree class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:42'!
compilerClass 
	^ OwnershipCompiler3  ! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:23'!
content
	<traversal>
 	^content..! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:23'!
content: val
	content:= val.! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:31'!
do: aBlock

^aBlock value. ! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:30'!
expandLeft
	^ left := OTree newOwned: self .! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:30'!
expandRight
	^ right := OTree newOwned: self .! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:26'!
inFilters
	^ {#traversal}! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:21'!
left
	<traversal>
	^left.! !

!OSecureTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:21'!
right
	<traversal>
	^ right.! !

OSecureTree subclass: #OTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:27'!
freeze
	self owner: (OTreeSandbox newOwned: self owner ). ! !

!OTree methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:27'!
inFilters 
	^{ #all}! !

OwnedObject3 subclass: #OTreeSandbox
	uses: TSelectiveOwernship
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

OTreeSandbox class
	uses: TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!OTreeSandbox methodsFor: 'as yet unclassified' stamp: 'pmaer 5/22/2012 14:44'!
acceptOwnee: anOwnee
	"TODO how could we make the sandbox more transparent? "
	^( anOwnee class name = #OTree)! !

!OTreeSandbox methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!OTreeSandbox methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:42'!
inFilters
	^ {#traversal}! !

!OTreeSandbox methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:24'!
selectedClasses 
	^ {OTree}! !

OwnedObject3 subclass: #OTreeTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-UseCases'!

!OTreeTester class methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:46'!
compilerClass 
	^OwnershipCompiler3  ! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 17:02'!
acceptOwnee: anOwnee
	"TODO how could we make the sandbox more transparent? "
	^( anOwnee class name = #OTree or: [ anOwnee class name = #OTreeSandbox ])! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:19'!
buildSandboxedTree
	| tree sandbox |
	tree := OTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left content: '2a'. 
	
	tree expandRight.  
	tree right content: '2b'. 
	
	tree left expandLeft.  
	tree left left content: '3a'. 
	
	sandbox := OTreeSandbox new. 
	tree owner: sandbox. 
	^ tree.
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:49'!
testCreation
	| tree |
	tree := OTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left content: '2a'. 
	
	tree expandRight.  
	tree right content: '2b'. 
	
	tree left expandLeft.  
	tree left left content: '3a'. ! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:28'!
testCreationFreeze
	| tree |
	tree := OTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left content: '2a'. 
	
	tree expandRight.  
	tree right content: '2b'. 
	
	tree left expandLeft.  
	tree left left content: '3a'. 
	
	tree freeze.
	tree left left content: 'new'.! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:19'!
testSandboxCreation
	| tree  |
	tree := self buildSandboxedTree .
	
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:19'!
testSandboxMutation
	| tree  |
	tree := self buildSandboxedTree .
	tree content: 'new'.
	
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 14:20'!
testSandboxTraversal
	| tree  |
	tree := self buildSandboxedTree .
	tree content.
	
	
	! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:43'!
testSecureCreationBorrow
	| tree |
	tree := OSecureTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	self borrow: tree left do: [ :node | node content: '2a' ]. "write is ok if borrowed"! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:43'!
testSecureCreationFail
	| tree |
	tree := OSecureTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree left  content: '2a' . "can only read otherwise"! !

!OTreeTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 13:43'!
testSecureCreationImpersonate
	| tree |
	tree := OSecureTree newOwned: self. 
	tree content: '1'.
	
	tree expandLeft. 
	tree do: [ tree left content: '2a' ]. "the sender of message in the block is still self, so it fails. "! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 5/2/2012 16:45'!
borrow: anObject do: aBlock
	| oldOwner |
	oldOwner := anObject owner. 
	anObject owner: self. 
	[
	  ^aBlock value: anObject. 
	] ensure: [
		anObject owner: oldOwner. 
	]! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/20/2012 11:20'!
canNotSend: selector to: receiver
	[ self canSend: selector to: receiver ] on: MessageFiltered do: [ ^ true ]. 
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'testing' stamp: 'ewe 4/19/2012 16:10'!
canSend: selector to: receiver
	"Tests whether the object can send the message to the receiver"
	self checkValidSend3: receiver message: selector block: [:t | ^ true] arguments: {}.
	^ false. 
	
! !

!OwnedObject3 methodsFor: 'transfer' stamp: 'ewe 5/9/2012 16:31'!
owner: newOwner
	Transcript show: ( 'Ownership for ' , self printString , ' changed to ', newOwner printString ) ; cr .
	(newOwner acceptOwnee: self ) ifTrue: [
		super owner: newOwner.
	] ifFalse: [ 
		TransferError signal
	 ].
	"TODO the method does not return itself, as this might create violations"
	 ^nil. ! !

OwnedObject3 subclass: #OwnershipCompilerTester
	uses: TNoOwernship
	instanceVariableNames: 'value myself'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

OwnershipCompilerTester class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!OwnershipCompilerTester class methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 15:58'!
compilerClass 
	^ OwnershipCompiler3 ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
doFirst
	value := value * 5. ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:29'!
doSecond: dontCare
	value := value + 1.! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
initialize 
	myself := self.  ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:25'!
multiply: n by: factor 
	^ n * factor.
	 ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:25'!
sum: n with: m
	^ n + m.  ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/8/2012 09:21'!
testArray
	^{1. 2. 3}   ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 5/8/2012 09:22'!
testArrayAndLiteralArray
	^{1. 2+3. #(2+3 {3+4}). 4}. ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 11:47'!
testArrayRecursion
	^{ 1. 1+2. 3. {5. 1 } }. ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:06'!
testCascade
	Transcript show: 'Hello' ; show: 'World' ; cr.  
  ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:07'!
testException

	^ 'Hello' , 4 ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:08'!
testExceptionSignal
	Error signal: 'Test'. ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:12'!
testExperssionAsArguments
	| a b c |
	a := 1.
	b := 2.
	c := 3. 
	^ myself sum: (a+b) with: (b+c) "8"! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:45'!
testLiteralArray
	^#(1 2 3) ! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:58'!
testLiteralArrayRecursion
	^#(1 2 (3 4) 5 #(6 7)).! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:13'!
testObjectAsArguments
	| a b  |
	a := 1.
	b := 2.
	^ myself sum: a with: b. "3"! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
testOrderOfEvaluation
	value := 1. 
	"doFirst multiplies by 5. doSecond adds 1"
	myself doSecond: ( myself doFirst ).
	^ value.! !

!OwnershipCompilerTester methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 15:26'!
testOrderOfEvaluation2
	"doFirst multiplies by 5. doSecond adds 1"
	^ myself sum: ( myself multiply: 1 by: 5 ) with: 1.   ! !

OwnedObject3 subclass: #Room
	uses: TNoOwernship
	instanceVariableNames: 'safe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

Room class
	uses: TNoOwernship classTrait
	instanceVariableNames: ''!

!Room class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:17'!
compilerClass 
	^ OwnershipCompiler3! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:54'!
inFilters
	^ {#unsafe}! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:22'!
initialize 
	safe := Safe newOwned: self.! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!Room methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:16'!
safe
	<public>
	^safe.! !

OwnedObject3 subclass: #Safe
	instanceVariableNames: 'content status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

!Safe class methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:17'!
compilerClass 
	^ OwnershipCompiler3! !

!Safe methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:08'!
content
	<safe>
	^content
	! !

!Safe methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 10:08'!
initialize 
	status := #locked.
	content := #jewels.! !

!Safe methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 16:13'!
status
	<unsafe> <public>
	^status
	 ! !

OwnedObject3 subclass: #SecureBank
	uses: TDeepOwernship
	instanceVariableNames: 'acronym customers suspicousFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

SecureBank class
	uses: TDeepOwernship classTrait
	instanceVariableNames: ''!

SecureBank subclass: #LessSecureBank
	uses: TSelectiveOwernship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel-Test'!

LessSecureBank class
	uses: TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#anonym.}! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ {#all}
	! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:57'!
selectedClasses 
	^ { Customer }! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferFrom: donator to: receiver

	receiver credit: donator amount.
	donator amount: 0.
	 
	" self tansferFrom: donator to: receiver amount: donator amount "! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferFrom: donator to: receiver amount: amount 
	receiver credit: amount . 
	donator withdraw: amount. ! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferFromX: donator to: receiver amount: amount
  	"to be fixed"
	| ra da |
	ra := receiver amount.
	da := donator amount.
	receiver amount: ( ra + amount ).
	donator amount: ( da - amount ).! !

!LessSecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:25'!
transferToPartnerOf: client 

	self transferFrom: client to: 	client partner  ! !

!SecureBank class methodsFor: 'as yet unclassified' stamp: 'ewe 4/26/2012 11:56'!
compilerClass 
	^ OwnershipCompiler3! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:18'!
acquireBank: aBank
	aBank customers do: [ :each |  self acquireCustomer: each ].! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 14:36'!
acronym: a
	acronym := a. ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 11:28'!
amountOf: aCustomer
	^ aCustomer amount. ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 14:57'!
customers
	^ customers. ! !

!SecureBank methodsFor: 'violation' stamp: 'ewe 5/2/2012 15:13'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/24/2012 16:56'!
hasMoreCustomerThan: aBank 
	"^ customers size > aBank customers size "
	 aBank customers ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 15:51'!
hasSuspiciousCustomers
	^ ( customers select: suspicousFilter ) size > 0 
	! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 11:28'!
identifierOf: aCustomer
	^ aCustomer identifier. ! !

!SecureBank methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:17'!
inFilters
	^ {#anonym.}! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 5/10/2012 15:08'!
initialize
	customers := DOOrderedCollection newOwned: self. 
	suspicousFilter := [ :customer | customer amount > 10 ].! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/23/2012 14:54'!
newCustomer
	| c|
	c := Customer newOwned: self.
	customers add: c.
	^ c. 
	! !

!SecureBank methodsFor: 'filters' stamp: 'ewe 5/1/2012 13:15'!
outFilters
	^ { #all }
	! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/20/2012 14:38'!
printString
	^ acronym. ! !

!SecureBank methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 16:46'!
promoteCustomer:  aCustomer 
	( aCustomer type = #premium) ifFalse: [
		aCustomer type: #premium.
	].! !

OwnedObject3 subclass: #WebMessage
	uses: TNoOwernship + TWebUtils
	instanceVariableNames: 'stream protocol headers content'
	classVariableNames: 'StatusCodes'
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebMessage commentStamp: 'ar 2/23/2010 10:37' prior: 0!
A common base class for WebRequest and WebResponse.!

WebMessage class
	uses: TWebUtils classTrait + TNoOwernship classTrait
	instanceVariableNames: ''!

!WebMessage class methodsFor: 'utilities' stamp: 'pmaer 6/5/2012 14:24'!
compilerClass 
		^ OwnershipCompiler3 
! !

!WebMessage class methodsFor: 'class initialization' stamp: 'pmaer 6/5/2012 14:24'!
initialize
	"self initialize"

	StatusCodes := DODictionary newFromPairs:{
		"1xx: Meta status codes"
		100. 	'Continue'.
		101. 	'Switching Protocols'.
		102.	'Processing'.
		"2xx: Success status codes"
		200.	'OK'.
		201.	'Created'.
		202.	'Accepted'.
		203. 	'Non-Authoritative Information'.
		204.	'No Content'.
		205. 	'Reset Content'.
		206.	'Partial Content'.
		207.	'Multi-Status'. 				"WebDav RFC: 2518"
		"3xx: Redirection status codes"
		300.	'Multiple Choices'.
		301.	'Moved Permanently'.
		302.	'Moved Temporarily'.
		303.	'See Other'.
		304.	'Not Modified'.
		305.	'Use Proxy'.
		307.	'Temporary Redirect'.
		"4xx: Client-Side Error status code"
		400.	'Bad Request'.
		401.	'Unauthorized'.
		402.	'Payment Required'.
		403.	'Forbidden'.
		404.	'Not Found'.
		405.	'Method Not Allowed'.
		406.	'Not Acceptable'.
		407.	'Proxy Authentication Required'.
		408.	'Request Timeout'.
		409.	'Conflict'.
		410.	'Gone'.
		411.	'Lenght Required'.
		412.	'Precondition Failed'.
		413.	'Request Entity Too Large'.
		414.	'Request-URI Too Long'.
		415.	'Unsupported Media Type'.
		416.	'Requested Range Not Satisfiable'.
		417.	'Expectation Failed'.
		422.	'Unprocessable Entity'. 		"WebDav RFC: 2518"
		423.	'Locked'. 					"WebDav RFC: 2518"
		424.	'Failed Dependency'. 		"WebDav RFC: 2518"
		"5xx: Server-Side Error status codes"
		500.	'Internal Server Error'.
		501.	'Not Implemented'.
		502.	'Bad Gateway'.
		503.	'Service Unavailable'.
		504.	'Gateway Timeout'.
		505.	'HTTP Version Not Supported'.
		507.	'Insufficient Storage'. 		"WebDav RFC: 2518"
	}.! !

!WebMessage class methodsFor: 'utilities' stamp: 'pmaer 6/5/2012 14:24'!
statusCodeAt: code
	"Return the textual description of a status code"

	^StatusCodes at: code! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
addHeader: key value: value
	"Adds an ADDITIONAL header for the given key"

	headers add: key -> value.! !

!WebMessage methodsFor: 'converting' stamp: 'pmaer 6/5/2012 14:24'!
asString
	"Prints the receiver"

	^String streamContents:[:s| self writeOn: s].! !

!WebMessage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
canCrossBoundary: anObject
	<meta> 
	^ true.! !

!WebMessage methodsFor: 'streaming' stamp: 'pmaer 6/5/2012 14:24'!
chunkFrom: srcStream to: dstStream progress: progressBlock
	"Stream the content of srcStream to dstStream.
	Use chunked transfer-encoding."

	| chunkSize firstLine buffer totalRead |
	totalRead := 0.
	buffer := (srcStream isBinary ifTrue:[ByteArray] ifFalse:[String]) new.
	[firstLine := srcStream nextLine asString.
	chunkSize := ('16r',firstLine asUppercase) asNumber.
	chunkSize = 0] whileFalse:[
		progressBlock ifNotNil:[progressBlock value: nil value: totalRead].
		buffer size = chunkSize ifFalse:[buffer := buffer class new: chunkSize].
		buffer := srcStream next: chunkSize into: buffer startingAt: 1.
		dstStream nextPutAll: buffer.
		srcStream skip: 2. "CRLF"
		totalRead := totalRead + chunkSize.
	].
	srcStream skip: 2. "CRLF"
	dstStream flush.
	progressBlock ifNotNil:[progressBlock value: nil value: totalRead].! !

!WebMessage methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
close
	"Always closes regardless of connection header"

	stream ifNotNil:[stream close].! !

!WebMessage methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
closeIfTransient
	"Close the underlying connection if it's not persistent"

	self isPersistent ifFalse:[self close].
! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
content
	"Reads and caches available content and returns it."

	^content ifNil:[content := self getContent].
! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
content: aString
	"Sets content for a response"

	content := aString.! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
contentLength
	"Answers the numeric value of the Content-Length header, or nil if no header exist"

	^(self headerAt: 'Content-Length' ifAbsent:[^nil]) asInteger! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
contentLength: aNumber
	"Sets the numeric value of the Content-Length header"

	^self headerAt: 'Content-Length' put: aNumber! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
contentStream
	"Answers a stream for the conent."

	^stream! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
contentType
	"Answer the content type for the receiver"

	^self headerAt: 'Content-Type' ifAbsent:['application/octet-stream']
! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
contentType: aString
	"Sets the content type for the receiver"

	^self headerAt: 'Content-Type' put: aString! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
contentWithProgress: progressBlock
	"Reads and caches available content and returns it."

	^content ifNil:[	| length |
		length := self contentLength.
		content := (stream isBinary ifTrue:[ByteArray] ifFalse:[ByteString]) 
			new: (length ifNil:[1000])
			streamContents:[:s| self streamFrom: stream to: s size: length progress: progressBlock]].! !

!WebMessage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
decodeMultipartForm: aStream boundary: boundary do: aBlock
	"Parse the contents of a multipart/form-data submission.

	Evaluate aBlock with three parts: The headers, the (parsed) form-data
	arguments and the (undecoded) contents of the part. The sender is
	expected to take care of other issues such as content-transfer-encoding
	and similar headers."

	| skip headers content disposition index params |
	aStream upToAll: '--', boundary.
	[aStream atEnd or:[(skip := aStream next: 2) = '--']] whileFalse:[
		skip = String crlf ifFalse:[self error: 'Error decoding multipart/form-data fields'].
		headers := DODictionary new.
		(self readHeadersFrom: aStream) do:[:hdr| headers add: hdr].
		content := aStream upToAll: String crlf, '--', boundary.
		params := DODictionary new.
		disposition := headers at: 'content-disposition' ifAbsent:[''].
		#(name filename) do:[:arg| | len val |
			len := arg size + 2.
			index := disposition findString: arg,'='.
			index > 0 ifTrue:[
				val := disposition copyFrom: index + len to: (disposition indexOf: $" startingAt: index+len) - 1.
				params at: arg put: val.
			].
		].
		aBlock value: headers value: params value: content.
	].! !

!WebMessage methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
destroy
	"Destroys the underlying stream"

	stream ifNotNil:[stream destroy].! !

!WebMessage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!WebMessage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
doNotCrossBoundary: anObject
	<meta> 
	Error signal: 'All objects should pass through'. ! !

!WebMessage methodsFor: 'private' stamp: 'pmaer 6/5/2012 14:24'!
getContent
	"Reads available content and returns it."

	| length size buffer |
	length := self contentLength.
	size := length ifNil:[1000].
	buffer := ((stream isBinary ifTrue:[ByteArray] ifFalse:[ByteString]) 
		new: size) writeStream.
	self streamFrom: stream to: buffer size: length progress: nil.
	^buffer position = size
		ifTrue: [ buffer originalContents ]
		ifFalse: [ buffer contents ]! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
headerAt: key
	"Answers a single value for the given http header. 
	Do not use for headers that may appear multiple times, such at www-authenticate."

	^self headerAt: key ifAbsent:[''].! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
headerAt: key ifAbsent: aBlock
	"Answers a single value for the given http header. 
	Do not use for headers that may appear multiple times, such at www-authenticate."

	self headersAt: key do:[:value| ^value].
	^aBlock value! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
headerAt: key put: value
	"Sets the value of a header, adding if necessary"

	headers do:[:assoc|
		(assoc key sameAs: key) ifTrue:[
			assoc value: value.
			^self
		].
	].
	self addHeader: key value: value.! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
headersAt: key
	"Answers a collection of values for the given http header. 
	Use for headers that may appear multiple times, such at www-authenticate."

	^self headersAt: key ifAbsent:[#()].! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
headersAt: aKey do: aBlock
	"Evaluate aBlock with all the headers matching aKey"

	self headersDo:[:key :value|
		(aKey sameAs: key) ifTrue:[ aBlock value: value].
	].! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
headersAt: key ifAbsent: aBlock
	"Answers a collection of values for the given http header. 
	Use for headers that may appear multiple times, such at www-authenticate."

	| hdrs |
	hdrs := DOOrderedCollection new.
	self headersAt: key do:[:value| hdrs add: value].
	^hdrs asArray ifEmpty:[aBlock value]
! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
headersDo: aBlock
	"Evaluate aBlock with all of the headers key-value pairs"

	headers do:[:assoc|
		aBlock value: assoc key value: assoc value.
	].! !

!WebMessage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
inFilters
	^ {#all}! !

!WebMessage methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isPersistent
	"Return true if this is a persistent connection"

	"Check for explicit connection headers"
	((self headerAt:'Connection') sameAs: 'close') ifTrue:[^false].
	((self headerAt:'Connection') sameAs: 'keep-alive') ifTrue:[^true].

	"Defaults for various versions"
	(self protocol = 'HTTP/1.0') ifTrue:[^false].
	(self protocol = 'HTTP/1.1') ifTrue:[^true].

	"Assume that later HTTP versions are compatible with 1.1"
	^true! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
multipartBoundary
	"Answer the boundary of a multipart/form-data message"

	| header |
	header := self headerAt: 'Content-Type' ifAbsent:[^nil].
	(header beginsWith: 'multipart/form-data') ifFalse:[^nil].
	^(header copyFrom: (header findString: 'boundary=') + 9 to: header size)! !

!WebMessage methodsFor: 'streaming' stamp: 'pmaer 6/5/2012 14:24'!
nextChunk
	"Answer the next chunk from a message using chunked transfer encoding."

	| chunkSize chunk |
	chunkSize := Integer readFrom: (stream upToAll: String crlf) asString base: 16.
	chunkSize = 0 ifFalse:[chunk := stream next: chunkSize].
	stream skip: 2. "CrLf"
	^chunk! !

!WebMessage methodsFor: 'streaming' stamp: 'pmaer 6/5/2012 14:24'!
nextChunkPut: chunk
	"Send the next chunk of a message using chunked transfer encoding.

	Note: This method does not allow to send empty chunks to avoid accidentally
	terminating the chunked transfer. Ending the transfer is part of the chunked
	request/response protocol (see #httpPostChunked:encoded:content:type:do:
	as well as #sendResponse:chunked:do:)"

	chunk ifNotEmpty:[
		stream nextPutAll: (chunk size printStringBase: 16); crlf.
		stream nextPutAll: chunk; crlf; flush.
	].! !

!WebMessage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
outFilters
	^ {#all}
	! !

!WebMessage methodsFor: 'printing' stamp: 'pmaer 6/5/2012 14:24'!
printOn: aStream
	"Prints the receiver"

	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	self writeOn: aStream.
	aStream nextPut: $).! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
protocol
	"Returns the requested protocol"

	^protocol! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
protocol: aString
	"Returns the requested protocol"

	protocol := aString! !

!WebMessage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
readHeadersFrom: aStream
	"Parse http headers and answer a collection of key -> value pairs."

	| headers nextLine existing |
	headers := DOOrderedCollection new.
	[nextLine := aStream upToAll: String crlf.
	nextLine isEmpty] whileFalse:[
		nextLine first isSeparator ifTrue:["Continuation as per HTTP 1.1 spec"
			existing := headers last.
			existing value: (existing value, String space, nextLine withBlanksTrimmed).
		] ifFalse:["Regular header"
			headers add: 
				(nextLine copyUpTo: $:) asLowercase ->
					(nextLine copyAfter: $:) withBlanksTrimmed.
		].
	].
	^headers! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
remoteHost
	"Return the name of the remote host"

	(stream isKindOf: SocketStream) ifFalse:[^nil]. "don't have it"

	^String streamContents:[:s|
		stream socket remoteAddress
			do:[:b| s print: b] separatedBy:[s nextPut: $.]].! !

!WebMessage methodsFor: 'headers' stamp: 'pmaer 6/5/2012 14:24'!
removeHeader: key
	"Removes ALL headers with the given key"

	headers := headers reject:[:assoc| assoc key sameAs: key].
! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
stream
	"Answers the underlying TCP stream"

	^stream! !

!WebMessage methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
stream: aStream
	"Sets the underlying TCP stream"

	stream := aStream! !

!WebMessage methodsFor: 'streaming' stamp: 'pmaer 6/5/2012 14:24'!
streamFrom: srcStream size: size progress: aBlock
	"Stream the given source stream to the message's socket stream.
	Outbound. Can be used on both request/response depending on
	whether it is utilized by WebClient or WebServer."

	^self streamFrom: srcStream to: stream size: size progress: aBlock! !

!WebMessage methodsFor: 'streaming' stamp: 'pmaer 6/5/2012 14:24'!
streamFrom: srcStream to: dstStream size: sizeOrNil progress: progressBlock
	"Stream the content of srcStream to dstStream.
	If a size is given, stream that many elements, otherwise stream up to the end."

	| buffer totalRead remaining size |
	(self headerAt: 'transfer-encoding') ifNotEmpty:[:encoding|
		encoding = 'chunked' 
			ifTrue:[^self chunkFrom: srcStream to: dstStream progress: progressBlock]
			ifFalse:[self error: 'Unknown transfer-encoding: ', encoding]].

	sizeOrNil = 0 ifTrue:[^self].

	buffer := (srcStream isBinary ifTrue:[ByteArray] ifFalse:[String]) new: 4096.
	totalRead := 0.
	size := sizeOrNil ifNil:[0].
	[(sizeOrNil == nil and:[stream atEnd not]) or:[totalRead < size]] whileTrue:[
		progressBlock ifNotNil:[progressBlock value: sizeOrNil value: totalRead].
		remaining := sizeOrNil ifNil:[99999] ifNotNil:[sizeOrNil - totalRead].
		remaining > buffer size ifTrue:[remaining := buffer size].
		buffer := srcStream next: remaining into: buffer startingAt: 1.
		dstStream nextPutAll: (remaining < buffer size  
			ifTrue:[(buffer copyFrom: 1 to: remaining)]
			ifFalse:[buffer]).
		totalRead := totalRead + buffer size.
	].
	dstStream flush.
	progressBlock ifNotNil:[progressBlock value: sizeOrNil value: totalRead].! !

!WebMessage methodsFor: 'streaming' stamp: 'pmaer 6/5/2012 14:24'!
streamTo: dstStream size: size progress: aBlock
	"Stream from the receiver's socket stream to the given destination stream.
	Inbound. Can be used on both request/response depending on
	whether it is utilized by WebClient or WebServer."
	content ifNil:[
		self streamFrom: stream to: dstStream size: size progress: aBlock
	] ifNotNil:[
		self streamFrom: content readStream to: dstStream size: size progress: aBlock
	].! !

!WebMessage methodsFor: 'printing' stamp: 'pmaer 6/5/2012 14:24'!
writeHeadersOn: aStream
	"Write the request"

	self headersDo:[:key :value| aStream nextPutAll: key, ': ', value asString; crlf].
! !

!WebMessage methodsFor: 'printing' stamp: 'pmaer 6/5/2012 14:24'!
writeOn: aStream
	"Write the request"

	self writeHeadersOn: aStream.
	aStream crlf.
! !

WebMessage subclass: #WebRequest
	instanceVariableNames: 'method request rawUrl server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebRequest commentStamp: 'ar 2/23/2010 10:38' prior: 0!
Represents an HTTP request for WebClient/WebServer.!

!WebRequest class methodsFor: 'instance creation' stamp: 'pmaer 6/5/2012 14:24'!
readFrom: aStream
	"Create a WebRequest from a given stream"

	^self new readFrom: aStream! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
acceptsCookie: aCookie from: webClient
	"Returns true if this cookie is applicable to this request"

	aCookie domain ifNotNil:[:domain|
		(webClient serverName endsWith: domain) ifFalse:[^false].
	].
	aCookie path ifNotNil:[:path|
		(self url beginsWith: path) ifFalse:[^false].
	].
	aCookie secure ifNotNil:[:secure|
		secure ifTrue:[webClient scheme = 'https' ifFalse:[^false]].
	].
	aCookie expiry ifNotNil:[:expiry|
		aCookie isExpired ifTrue:[^false].
	].
	^true! !

!WebRequest methodsFor: 'converting' stamp: 'pmaer 6/5/2012 14:24'!
asWebSocket
	"Convert this request into a WebSocket"

	"Figure out the version of the protocol"
	| field version |
	version := self headerAt: 'Sec-WebSocket-Version' ifAbsent:[nil].
	version ifNil:[
		field := self headerAt: 'Sec-WebSocket-Key1' ifAbsent:[nil].
		field 
			ifNil:[^self asWebSocket68] 
			ifNotNil:[^self asWebSocket00].
	].

	"Attempt WebSocket07 conversion"
	^self asWebSocket07
! !

!WebRequest methodsFor: 'converting' stamp: 'pmaer 6/5/2012 14:24'!
asWebSocket00
	"Convert this request into a WebSocket"

	| field key1 key2 bytes resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: 101.
	resp status: 'HTTP/1.1 101 Web Socket Protocol Handshake'.

	"Chrome 4/5 is *VERY* sensitive to the order of the fields"
	resp headerAt: 'Upgrade' put: 'WebSocket'.
	resp headerAt: 'Connection' put: 'Upgrade'.

	field := self headerAt: 'Sec-WebSocket-Key1'.
	key1 := WebUtils extractWebSocketKey: field.
	field := self headerAt: 'Sec-WebSocket-Key2'.
	key2 := WebUtils extractWebSocketKey: field.
	bytes := WebUtils webSocketHandshake: key1 with: key2 with: (stream next: 8).

	resp headerAt: 'Sec-WebSocket-Origin' put: (self headerAt: 'Origin').
	resp headerAt: 'Sec-WebSocket-Location' put: ('ws://', (self headerAt: 'host'), self rawUrl).
	(self headerAt: 'Sec-WebSocket-Protocol' ifAbsent:[nil]) ifNotNil:[:hdr|
		resp headerAt: 'Sec-WebSocket-Protocol' put: hdr.
	].

	resp writeOn: stream.
	bytes ifNotNil:[stream nextPutAll: bytes].
	stream flush.
	^WebSocket00 on: stream.
! !

!WebRequest methodsFor: 'converting' stamp: 'pmaer 6/5/2012 14:24'!
asWebSocket07
	"Convert this request into a WebSocket"

	| resp hash nonce |
	resp := self newResponse protocol: 'HTTP/1.1' code: 101.
	resp status: 'HTTP/1.1 101 Web Socket Protocol Handshake'.

	"Chrome 4/5 is *VERY* sensitive to the order of the fields"
	resp headerAt: 'Upgrade' put: 'WebSocket'.
	resp headerAt: 'Connection' put: 'Upgrade'.

	nonce := self headerAt: 'Sec-WebSocket-Key'.
	hash := WebUtils webSocketHash07: nonce.

	resp headerAt: 'Sec-WebSocket-Accept' put: hash.
	(self headerAt: 'Sec-WebSocket-Origin' ifAbsent: [self headerAt: 'Origin']) 
		ifNotNil: [ :origin | resp headerAt: 'Sec-WebSocket-Origin' put: origin ].
	resp headerAt: 'Sec-WebSocket-Location' put: ('ws://', (self headerAt: 'host'), self rawUrl).
	(self headerAt: 'Sec-WebSocket-Protocol' ifAbsent:[nil]) ifNotNil:[:hdr|
		resp headerAt: 'Sec-WebSocket-Protocol' put: hdr.
	].

	resp writeOn: stream.
	stream flush.
	^WebSocket07 on: stream.! !

!WebRequest methodsFor: 'converting' stamp: 'pmaer 6/5/2012 14:24'!
asWebSocket68
	"Convert this request into a WebSocket"

	| resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: 101.
	resp status: 'HTTP/1.1 101 Web Socket Protocol Handshake'.

	"Chrome 4/5 is *VERY* sensitive to the order of the fields"
	resp headerAt: 'Upgrade' put: 'WebSocket'.
	resp headerAt: 'Connection' put: 'Upgrade'.

	resp headerAt: 'WebSocket-Origin' put: (self headerAt: 'Origin').
	resp headerAt: 'WebSocket-Location' put: ('ws://', (self headerAt: 'host'), self rawUrl).
	(self headerAt: 'WebSocket-Protocol' ifAbsent:[nil]) ifNotNil:[:hdr|
		resp headerAt: 'WebSocket-Protocol' put: hdr.
	].
	resp writeOn: stream.
	stream flush.
	^WebSocket00 on: stream.! !

!WebRequest methodsFor: 'sending' stamp: 'pmaer 6/5/2012 14:24'!
closeIfTransient: resp after: aBlock
	"Evaluate aBlock. Close the connection if it is transient.
	Inserts Connection: close header if needed."

	| close |
	close := self isPersistent not.
	close 
		ifTrue: [
			"Always be explicit and insert the Connection: close header"
			resp headerAt: 'Connection' put: 'close' ]
		ifFalse: [
			"We should tell the client that we keep this connection alive."
			resp headerAt: 'Connection' put: 'Keep-Alive' ].
	aBlock value.
	stream flush.
	close  ifTrue:[self close].
! !

!WebRequest methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
cookieAt: aString
	"Answer the value for a cookie with the given name"

	^self cookieAt: aString ifAbsent:['']! !

!WebRequest methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
cookieAt: aString ifAbsent: aBlock
	"Answer the value for a cookie with the given name"

	self cookiesDo:[:name :value| name = aString ifTrue:[^value]].
	^aBlock value! !

!WebRequest methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
cookies
	"Answer all the cookies defined in the request"

	| cookies |
	cookies := DODictionary new.
	self cookiesDo:[:name :value| cookies at: name put: value].
	^cookies! !

!WebRequest methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
cookiesDo: aBlock
	"Parse the cookie headers and evaluate aBlock with name / value pairs"

	self headersAt: 'Cookie' do:[:hdr|
		(hdr findTokens: ';,') do:[:token|
			aBlock 
				value: (token copyUpTo: $=) withBlanksTrimmed 
				value: (token copyAfter: $=) withBlanksTrimmed]].! !

!WebRequest methodsFor: 'fields' stamp: 'pmaer 6/5/2012 14:24'!
fields
	<request>
	"Answer the fields for the given request."

	| fields |
	fields := DODictionary new.
	self getFields associationsDo:[:a| fields add: a].
	self postFields associationsDo:[:a| fields add: a].
	self multipartFields associationsDo:[:a| fields add: a].
	fields owner: WorldOwner getInstance. 
	^fields
! !

!WebRequest methodsFor: 'fields' stamp: 'pmaer 6/5/2012 14:24'!
getFields
	"Decodes the fields embedded in the url ?var1=val1&var2=val2"

	| args |
	args := (rawUrl copyAfter: $?) ifEmpty:[^DODictionary new].
	^WebUtils decodeUrlEncodedForm: args multipleValues: false
! !

!WebRequest methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
initialize
	"Initialize the receiver"

	super initialize.
	method := 'GET'.
	protocol := 'HTTP/1.1'.
	headers := DOOrderedCollection new.! !

!WebRequest methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
initializeFromUrl: urlString
	"Initialize the client from a http url or string"

	| urlStream |
	urlStream := urlString readStream.
	"Skip past scheme if present"
	urlStream upToAll: '://'.
	urlStream atEnd 
		ifTrue:[rawUrl := urlString]
		ifFalse:[rawUrl := urlStream upTo: $/; upToEnd].
	(rawUrl beginsWith: '/') ifFalse:[rawUrl := '/', rawUrl].
! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isDeleteRequest
	"Returns true if this is an HTTP DELETE request"

	^self method = 'DELETE'! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isGetRequest
	<request>
	"Returns true if this is an HTTP GET request"

	^self method = 'GET'! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isHeadRequest
	"Returns true if this is an HTTP HEAD request"

	^self method = 'HEAD'! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isOptionsRequest
	"Returns true if this is an HTTP OPTIONS request"

	^self method = 'OPTIONS'! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isPostRequest
	<request>
	"Returns true if this is an HTTP POST request"

	^self method = 'POST'! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isPutRequest
	"Returns true if this is an HTTP PUT request"

	^self method = 'PUT'! !

!WebRequest methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isTraceRequest
	"Returns true if this is an HTTP TRACE request"

	^self method = 'TRACE'! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
method
	"The request method (GET, POST etc)"

	^method! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
method: aString
	"The request method (GET, POST etc)"

	method := aString! !

!WebRequest methodsFor: 'fields' stamp: 'pmaer 6/5/2012 14:24'!
multipartFields
	"Answers the multipart fields of a post request"

	| fields |
	fields := DODictionary new.
	self multipartFieldsDo:[:hdrs :params :cntnt|
		params at: 'name' ifPresent:[:fieldName| fields at: fieldName put: cntnt].
	].
	^fields! !

!WebRequest methodsFor: 'fields' stamp: 'pmaer 6/5/2012 14:24'!
multipartFieldsDo: aBlock
	"Evaluate aBlock with the multipart fields of a post request.
	The block is expected to take three arguments:
		* The headers from the part being processed
		* The parameters from the content-disposition header
		* The content from the part being processed
	"

	^(self isPostRequest and: [
		self contentType beginsWith: 'multipart/form-data'])
			ifTrue: [self decodeMultipartForm: self content readStream boundary: self multipartBoundary do: aBlock]
			ifFalse: [Dictionary new]! !

!WebRequest methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
newResponse
	"Create a new response entitiy.
	Subclasses can override this method to provide a different response class"

	^(WebResponse new)
		request: self;
		yourself! !

!WebRequest methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
newWebSocketOn: aStream
	"Create a new socket entitiy.
	Subclasses can override this method to provide a different response class"

	^WebSocket on: aStream! !

!WebRequest methodsFor: 'fields' stamp: 'pmaer 6/5/2012 14:24'!
postFields
	"Answers the multipart fields of a post request"

	^(self isPostRequest and: [
		self contentType beginsWith: 'application/x-www-form-urlencoded'])
			ifTrue: [WebUtils decodeUrlEncodedForm: self content multipleValues: true]
			ifFalse: [Dictionary new]! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
rawUrl
	"The raw (unparsed) url"

	^rawUrl! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
rawUrl: aString
	"The raw (unparsed) url"

	rawUrl := aString
! !

!WebRequest methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
readFrom: aStream
	"Initialize the receiver initialized from an existing socket stream 
	This method will block until the headers have been parsed."

	| tokens |
	stream := aStream.
	stream isBinary ifTrue:[stream ascii].
	"Parse request header"
	request := stream upToAll: String crlf.
	tokens := request findTokens: ' '.
	tokens size < 2 ifTrue:[^self error: 'Invalid HTTP request: ', request].
	method := tokens first.
	rawUrl := tokens second.
	tokens size > 2 
		ifTrue:[protocol := tokens third]
		ifFalse:[protocol := 'HTTP/1.0'].

	"Parse HTTP header"
	headers := self readHeadersFrom: stream.
! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
requestLine
	"The actual request line as sent by the client"

	^request ifNil:[self method, ' ', self rawUrl, ' ', self protocol]! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send200Response: aString
	<request>
	"Send a 200 OK response"

	^self 
		send200Response: (aString convertToWithConverter: UTF8TextConverter new) 
		contentType: 'text/plain; charset=utf-8'.! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send200Response: aString contentType: contentType
	<request>
	"Send a 200 OK response"

	^self send200Response: aString contentType: contentType do:[:resp]! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send200Response: aString contentType: contentType do: aBlock
	"Send a 200 OK response"

	| resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: 200.
	resp headerAt: 'Content-Type' put: contentType.
	aBlock value: resp.
	^self sendResponse: resp content: aString.! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send301Response: location
	"Send a 301 permanent redirect response"

	^self send301Response: location do:[:resp].! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send301Response: location do: aBlock
	"Send a 301 permanent redirect response"

	^self send3xxResponse: location code: 301 do: aBlock! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send302Response: location
	<request>
	"Send a 302 temporary redirect response"

	^self send302Response: location do:[:resp].! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send302Response: location do: aBlock
	"Send a 302 temporary redirect response"

	^self send3xxResponse: location code: 302 do: aBlock! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send3xxResponse: location code: statusCode
	"Send a 3xx redirect response"

	^self send3xxResponse: location code: statusCode do:[:resp].! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send3xxResponse: location code: statusCode do: aBlock
	"Send a 3xx redirect response"

	| resp url |
	"If the redirect is not to an absolute url, prefix it with the host if we have one"
	url := location.
	(location findString: '://') > 0 ifFalse:[
		(self headerAt: 'host') ifNotEmpty:[:host| url := 'http://', host, location]].

	resp := self newResponse protocol: 'HTTP/1.1' code: statusCode.
	resp headerAt: 'Location' put: url.
	aBlock value: resp.
	^self sendResponse: resp content: ''.
! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send400Response
	"Send a 400 bad request response"

	| message |
	message := '<html><head><title>400 Bad Request</title></head><body>',
		'<h1>Bad Request</h1>
		<p>The server encountered a request it did not understand.
		</body></html>'.
	
	self sendResponseCode: 400 
		content: message squeakToUtf8
		type: 'text/plain; charset=utf-8'
		close: true! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send404Response
	"Send a 404 not found response"

	^self send404Response: '<html><head><title>404 Not Found</title></head><body><h1>404 Not Found</h1><p>The requested URL ',self rawUrl,' was not found on this server.</p></body></html>'.
! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send404Response: body
	"Send a 404 not found response"

	^self 
		send404Response: (body convertToWithConverter: UTF8TextConverter new) 
		do: [ :resp | resp headerAt: 'Content-Type' put: 'text/html; charset=utf-8' ]! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send404Response: body do: aBlock
	"Send a 404 not found response"

	| resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: 404.
	resp headerAt: 'Content-Type' put: 'text/html; charset=utf-8'.
	aBlock value: resp.
	^self sendResponse: resp content: body.
! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send405Response: allowed
	"Send a 405 method not allowed response"

	^self send405Response: allowed content: '<html><head><title>405 Method Not Allowed</title></head><body><h1>405 Method Not Allowed</h1><p>The requested method ',self method,' is not allowed for the URL', self rawUrl, '</p></body></html>'.! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send405Response: allowed content: body
	"Send a 405 method not allowed response"
	| resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: 405.
	resp headerAt: 'Content-Type' put: 'text/html; charset=utf-8'.
	resp headerAt: 'allow' put: (String streamContents:[:s|
		allowed do:[:m| s nextPutAll: m] separatedBy:[s nextPut: $,]
	]).
	^self sendResponse: resp content: body.! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
send500Response: errReport
	"Send a 500 internal server error response"

	| errLog |
	errLog := '<html><head><title>500 Internal Server Error</title></head><body>',
		'<h1>Internal Server Error</h1><pre>',
		(errReport  copyReplaceAll: String cr with: String crlf),
		'</pre></body></html>'.

	self sendResponseCode: 500
				content: errLog squeakToUtf8
				type: 'text/html; charset=utf-8'
				close: true.
! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
sendOptionsResponse: allowed
	"Send a 200 OK response for an OPTIONS request"

	^self send200Response: '' contentType: 'application/octet-stream' do:[:resp|
		resp headerAt: 'allow' put: (String streamContents:[:s|
			allowed do:[:m| s nextPutAll: m] separatedBy:[s nextPut: $,]
		]).
	].! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
sendResponse: code chunked: chunkBlock
	"Send a chunked response"

	^self sendResponse: code chunked: chunkBlock do:[:resp]! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
sendResponse: code chunked: chunkBlock do: hdrBlock
	"Send a chunked response"

	| resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: code.
	resp headerAt: 'Transfer-Encoding' put: 'chunked'.
	hdrBlock value: resp.
	^self sendResponse: resp contentBlock:[:aStream|
		"Set the stream in the request and pass it in the chunk block"
		resp stream: aStream.
		chunkBlock value: resp.
		"send termination chunk"
		aStream nextPutAll: '0'; crlf; crlf; flush.
	].
! !

!WebRequest methodsFor: 'sending' stamp: 'pmaer 6/5/2012 14:24'!
sendResponse: resp content: aString
	"Send a WebResponse with content."

	^self sendResponse: resp contentStream: aString readStream size: aString size! !

!WebRequest methodsFor: 'sending' stamp: 'pmaer 6/5/2012 14:24'!
sendResponse: resp contentBlock: contentBlock
	"Sends a WebResponse, streaming its contents from aStream.
	If a size is provided, insert a Content-Length header, otherwise
	ensure that the connection is transient."

	"Add Date and Server headers"
	resp headerAt: 'Date' put: (server ifNil:[WebServer]) serverDate.
	resp headerAt: 'Server' put: (server ifNil:[WebServer]) serverString.

	self closeIfTransient: resp after:[
		"Ignore all network errors while sending the response"
		[resp writeOn: stream.
		stream flush.
		self isHeadRequest ifFalse:[contentBlock value: stream].
		] on: NetworkError do:["ignore"].

		"Make sure we log before closing the connection"
		server ifNotNil:[server logRequest: self response: resp].
	].! !

!WebRequest methodsFor: 'sending' stamp: 'pmaer 6/5/2012 14:24'!
sendResponse: resp contentStream: aStream size: streamSize
	"Sends a WebResponse, streaming its contents from aStream.
	If a size is provided, insert a Content-Length header, otherwise
	ensure that the connection is transient."

	streamSize 
		ifNil:[self headerAt: 'Connection' put: 'close'] "mark transient"
		ifNotNil:[resp headerAt: 'Content-Length' put: streamSize].

	^self sendResponse: resp contentBlock:[:sockStream|
		resp streamFrom: aStream to: sockStream size: streamSize progress: nil
	]! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
sendResponseCode: code content: aString type: contentType close: aBool
	"Send a 500 Internal server error response"

	^self sendResponseCode: code content: aString type: contentType do:[:hdr|
		aBool ifTrue:[hdr headerAt: 'Connection' put: 'close'].
	].! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
sendResponseCode: code content: aString type: contentType do: aBlock
	"Send a 500 Internal server error response"

	| resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: code.
	contentType ifNotNil:[resp headerAt: 'Content-Type' put: contentType].
	aBlock value: resp.
	^self sendResponse: resp content: aString.! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
sendXmlResponse: xmlString
	"Send an a-ok 200 xml-ish response"

	^self send200Response: xmlString contentType: 'application/xml'! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
server
	"If non-nil, the WebServer instance associated with the request."

	^server! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
server: aWebServer
	"If non-nil, the WebServer instance associated with the request."

	server := aWebServer! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
stream200Response: aStream
	"Stream a 200 OK response"

	^self stream200Response: aStream size: aStream size! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
stream200Response: aStream size: streamSize
	"Stream a 200 OK response"

	^self stream200Response: aStream size: streamSize type: 'application/octet-stream'! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
stream200Response: aStream size: streamSize type: contentType
	"Stream a 200 OK response"

	^self stream200Response: aStream size: streamSize type: contentType do:[:resp].! !

!WebRequest methodsFor: 'responses' stamp: 'pmaer 6/5/2012 14:24'!
stream200Response: aStream size: streamSize type: contentType do: aBlock
	"Stream a 200 OK response"

	| resp |
	resp := self newResponse protocol: 'HTTP/1.1' code: 200.
	resp headerAt: 'Content-Type' put: contentType.
	aBlock value: resp.
	^self sendResponse: resp contentStream: aStream size: streamSize.! !

!WebRequest methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
url
	<request>
	"The url without fragment or arguments"

	^((rawUrl copyUpTo: $#) copyUpTo: $?) unescapePercentsWithTextEncoding: nil! !

!WebRequest methodsFor: 'printing' stamp: 'pmaer 6/5/2012 14:24'!
writeOn: aStream
	"Write the request"

	self writeRequestOn: aStream.
	super writeOn: aStream! !

!WebRequest methodsFor: 'printing' stamp: 'pmaer 6/5/2012 14:24'!
writeRequestOn: aStream
	"Write the request"

	aStream nextPutAll: method; space; nextPutAll: rawUrl; space; nextPutAll: protocol; crlf.
! !

WebMessage subclass: #WebResponse
	instanceVariableNames: 'request status code url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebResponse commentStamp: 'ar 2/23/2010 10:39' prior: 0!
Represents an HTTP response for WebClient/WebServer.!

!WebResponse class methodsFor: 'instance creation' stamp: 'pmaer 6/5/2012 14:24'!
protocol: protocol code: code
	"Create a response using the given protocol / code"

	^self new protocol: protocol code: code! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
code
	"The HTTP response code"

	^code! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
content
	"Reimplemented to close the socket if the request is transient"

	content ifNil:[
		content := self getContent.
		self closeIfTransient.
	].
	^content! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
contentStream
	"Answers a stream for the conent."

	(self headerAt: 'transfer-encoding') = 'chunked' ifTrue:[
		^WebChunkedStream on: stream.
	].
	^super contentStream! !

!WebResponse methodsFor: 'private' stamp: 'pmaer 6/5/2012 14:24'!
getContent
	"Do not read any content if this was a HEAD request"

	request method = 'HEAD' ifTrue:[^''].
	^super getContent! !

!WebResponse methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isInformational
	"Is this a 1xx response?"

	^self code between: 100 and: 199
! !

!WebResponse methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isRedirect
	"Is this a redirect response?"

	^self code between: 300 and: 399
! !

!WebResponse methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:24'!
isSuccess
	"Is this a successful response?"

	^self code between: 200 and: 299
! !

!WebResponse methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
protocol: respProtocol code: respCode
	"Initialize a response from protocol and code"

	code := respCode.
	protocol := respProtocol.
	status := protocol, ' ', code asString, ' ', (self class statusCodeAt: code).
	headers := DOOrderedCollection new.! !

!WebResponse methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:24'!
readFrom: aStream
	"Parse an HTTP response from the given stream"

	| tokens |
	stream := aStream.
	status := stream upToAll: String crlf.
	tokens := status findTokens: ' '.
	tokens size < 2 ifTrue:[^self error:'Invalid response: ', status].
	protocol := tokens first.
	code := tokens second asNumber.
	headers := self readHeadersFrom: stream.
! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
request
	"The original request for this response"

	^request! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
request: aRequest
	"The original request for this response"

	request := aRequest! !

!WebResponse methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
setCookie: aCookie
	"Adds a DOSet-Cookie header"

	^self addHeader: 'Set-Cookie' value: aCookie asString! !

!WebResponse methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
setCookie: name value: value path: path 
	"Adds a DOSet-Cookie header"

	^self setCookie: ((WebCookie new)
			name: name;
			value: value;
			path: path;
		yourself)! !

!WebResponse methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
setCookie: name value: value path: path expires: date domain: domain secure: aBool
	"Adds a DOSet-Cookie header"

	^self setCookie: ((WebCookie new)
			name: name;
			value: value;
			path: path;
			expiry: date;
			domain: domain;
			secure: aBool;
		yourself)! !

!WebResponse methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
setCookieAt: key
	"Evaluate aBlock with all the cookies deined in the request"

	self setCookiesDo:[:cookie|
		cookie name = key ifTrue:[^cookie].
	].
	^nil! !

!WebResponse methodsFor: 'cookies' stamp: 'pmaer 6/5/2012 14:24'!
setCookiesDo: aBlock
	"Evaluate aBlock with all the cookies deined in the request"

	self headersAt: 'Set-Cookie' do:[:hdr|
		aBlock value: (WebCookie new readFrom: hdr readStream)
	].
! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
status
	"The status line from the response"

	^status! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
status: aString
	"The status line from the response"

	status := aString! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
url
	"The url of the resource at which a request was terminated after a series
	of redirects. Without redirects, this will be the same as the request url."

	^url! !

!WebResponse methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:24'!
url: urlString
	"The url of the resource at which a request was terminated after a series
	of redirects. Without redirects, this will be the same as the request url."

	url := urlString! !

!WebResponse methodsFor: 'printing' stamp: 'pmaer 6/5/2012 14:24'!
writeOn: aStream
	"Store this response on aStream"

	self writeStatusOn: aStream.
	super writeOn: aStream.
! !

!WebResponse methodsFor: 'printing' stamp: 'pmaer 6/5/2012 14:24'!
writeStatusOn: aStream
	"Store this response on aStream"

	aStream nextPutAll: status; crlf.
! !

OwnedObject3 subclass: #WebPage
	uses: TSelectiveOwernship
	instanceVariableNames: 'name content children parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

WebPage class
	uses: TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!WebPage class methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
compilerClass
	^OwnershipCompiler3 ! !

!WebPage class methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
newPage: n parent: p
	| page |
	page := self new.
	page name: n parent: p.
	page owner: self thisSender. 
	^page. ! !

!WebPage class methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
newRoot: rootName
	| page |
	page := self new.
	page name: rootName.  
	page owner: self thisSender. 
	^page. ! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
canCrossBoundary: anObject
	<meta> 
	^ self selectedClasses includes: anObject class. ! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
content: html
     <content>
	content:= html.! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!WebPage methodsFor: 'content' stamp: 'pmaer 6/5/2012 14:24'!
editUrl
	<content>
	^ self url , '?action=edit'.! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
inFilters
	^ {#content}! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
initialize 
	children := DOOrderedCollection new.
	parent:=nil.! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
locatePage: path
	| matchName matchPages |
	matchName := path removeFirst. 
	matchPages := children select: [ :child | child name = matchName ].
	( matchPages size > 0 ) ifTrue: [
		(path size > 0 ) ifTrue: [
			^ matchPages first locatePage: path.
		] ifFalse: [
			^ matchPages first.
		]
	] ifFalse: [
		Error signal.
	]
	! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
name
	^name! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
name: n 
	name := n.! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
name: n parent: p 
	name := n.
	parent := p. ! !

!WebPage methodsFor: 'content' stamp: 'pmaer 6/5/2012 14:24'!
newPage: n
	<content>
	| page |
	page := self class newPage: n parent: self.
	children add: page.
	^page. 

	! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
outFilters
	^ {#all}
	! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
parent 
	^parent ! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
renderActions: aStream
	| html |
	html := HtmlWriter new stream: aStream.
	html link: 'view' url: self viewUrl ;
		 link: 'edit' url: self editUrl ;
		 horizontalLine.
	
	! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
renderContent: aStream
	| html |
	html := HtmlWriter new stream: aStream.
	html raw: content .
		 
	
	! !

!WebPage methodsFor: 'content' stamp: 'pmaer 6/5/2012 14:24'!
renderEdit: aStream
	<content>
	self renderActions: aStream.
	self renderEditContent: aStream.
	self renderFooter: aStream.! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
renderEditContent: aStream
	| html |
	html := HtmlWriter new stream: aStream. 
	html postForm: self editUrl do: [
		html textArea: content id: 'content' .
		html submit.
	] 
		 
	
	! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
renderFooter: aStream
	| html |
	html := HtmlWriter new stream: aStream.
	html horizontalLine .
	self root renderSiteMap: aStream selected: name. 
		 
	
	! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
renderSiteMap: aStream selected: selectedName
	| html |
	html := HtmlWriter new stream: aStream.
	( name = selectedName ) ifTrue: [
		html open: '<b>' do: [ html link: name url: self viewUrl ] close: '</b>'.
	] ifFalse: [
		html link: name url: self viewUrl
	].
	html open: '<lu>' do: [
		children do: [ :child |
				html open: '<li>' do: [ 
					child renderSiteMap: aStream selected: selectedName 
				] close: '</li>'.
			]
	] close: '</lu>'.! !

!WebPage methodsFor: 'content' stamp: 'pmaer 6/5/2012 14:24'!
renderView: aStream
	<content>
	self renderActions: aStream.
	self renderViewContent: aStream.
	self renderFooter: aStream.! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
renderViewContent: aStream
	| html |
	html := HtmlWriter new stream: aStream.
	html raw: content .
		 
	
	! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
root
	( parent = nil ) ifTrue: [ ^ self ] ifFalse: [ ^ parent root ]! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
selectedClasses 
	^ { WebPage }! !

!WebPage methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:24'!
url
	
	| current url |
	url := name. 
	current := parent.
	[ current = nil ] whileFalse: [
		url := current name , '/' , url. 
		current := current parent. 
	].
	^ '/' , url .! !

!WebPage methodsFor: 'content' stamp: 'pmaer 6/5/2012 14:24'!
viewUrl
	<content>
	^ self url , '?action=view'.! !

OwnedObject3 subclass: #WebServer
	uses: TSelectiveOwernship + TWebUtils
	instanceVariableNames: 'listenerSocket listenerProcess interface port mutex connections entryPoints vault logAction nonceCache sessions serverString errorHandler accessLog certName siteUrl'
	classVariableNames: 'Default Registry'
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebServer commentStamp: 'ar 5/4/2010 13:17' prior: 0!
WebClient provides a simple yet complete HTTP server implementation.

To view the documentation evaluate:

	HelpBrowser openOn: WebServerHelp.
!

WebServer class
	uses: TWebUtils classTrait + TSelectiveOwernship classTrait
	instanceVariableNames: ''!

!WebServer class methodsFor: 'benchmarks' stamp: 'pmaer 6/5/2012 14:23'!
benchmark
	"Runs a WebClient/WebServer streaming benchmark to measure throughput"

	"
		WebServer benchmark
		MessageTally spyOn:[WebServer benchmark]
	"

	| amount time resp port |
	port := 8888.
	amount := 128 * 1024 * 1024.
	WebServer reset default listenOn: port.
	WebServer default addService: '/streaming' action:[:req|
		req stream200Response: NullStream new size: amount.
	].
	time := [
		resp := WebClient httpGet: 'http://localhost:', port, '/streaming'.
		resp isSuccess ifFalse:[self error: resp status].
		resp streamTo: NullStream new size: resp contentLength progress: nil.
		resp close.
	] timeToRun.
	WebServer reset.
	^(amount  * 1000 // time) asStringWithCommas, ' bytes/sec'
! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
browseDir: directory request: request
	"Responds with a directory listing back to the original request"

	| entries listing url |
	url := request url.
	(url endsWith: '/') ifTrue:[url := url allButLast].

	entries := directory entries sort:[:e1 :e2|
		e1 isDirectory = e2 isDirectory 
			ifTrue:[e1 name <= e2 name]
			ifFalse:[e2 isDirectory]].

	listing := String streamContents:[:s|
		s nextPutAll:'<html><head><title>Index of ', request url,'</title></head><body>'.
		s nextPutAll:'<h1>Index of ', request url,'</h1>'.
		s nextPutAll:'<pre>      Name                      Last modified      Size  Description<hr>'.
		s nextPutAll: '[up]  <a href="', (url copyUpToLast: $/),'">parent</a>'; crlf.
		entries do:[:e|
			s nextPutAll:(e isDirectory ifTrue:['[dir] '] ifFalse:['      ']).
			s nextPutAll: '<a href="', url, '/', e name, '">'.
			s nextPutAll: (e name truncateTo: 30).
			s nextPutAll: '</a>'.
			e name size < 30 ifTrue:[s nextPutAll: (String new: 30 - e name size withAll: $ )].
			s nextPutAll: (e modificationDateAndTime asString padded: #right to: 20 with: $ ).
			s nextPutAll: (e fileSize asString padded: #right to: 20 with: $ ).
			s crlf.
		].
 	].

	request 
		send200Response: (listing convertToWithConverter: UTF8TextConverter new) 
		contentType: 'text/html; charset=utf-8'.

! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
browseFile: file request: request
	"Responds with a file back to the original request"

	| fileSize mimeTypes resp |
	file binary.
	fileSize := file size.
	mimeTypes := file mimeTypes ifNil:[#('application/octet-stream')].
	resp := request newResponse protocol: 'HTTP/1.1' code: 200.
	resp headerAt: 'Content-Type' put: mimeTypes first.
	request sendResponse: resp contentStream: file size: fileSize.! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
browseRequest: request
	"Handle an HTTP request for browsing some resource"

	| path fd entry file |

	"Extract the file path from the request"
	path := request url findTokens: '/'.
	path ifEmpty:[^self browseDir: FileDirectory default request: request.].

	"Find the directory entry for the resource"
	fd := path allButLast inject: FileDirectory default into:[:dir :part| dir directoryNamed: part].
	entry := fd entryAt: path last ifAbsent:[^request send404Response].

	"Reply with the proper resource"
	entry isDirectory ifTrue:[
		"Send file listing. We handle this synchronously for simplicity."
		self browseDir: (fd directoryNamed: entry name) request: request.
	] ifFalse:[
		"Send file content. Since files can be large, we fork this off.
		However, since we forked it, we need to handle two different
		possible conditions:
			- closing the file in case of error
			- handling errors when sending it
		This makes the code below a bit ugly"
		[[
			file := fd readOnlyFileNamed: entry name.
			[self browseFile: file request: request.] 
				ensure:[file close] 	"close file even in case of error"
		] on: Error do:[]				"ignore errors altogether"
		] fork. 						"fork it"
	].
! !

!WebServer class methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
compilerClass 
	^ OwnershipCompiler3 ! !

!WebServer class methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
default
	"A default WebServer instance. Mostly for the examples."

	^Default ifNil:[Default := self new].! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
exampleAuth		"WebServer exampleAuth"
	"Simple example requiring basic auth"

	| server port realm |
	port := 9999.
	server := WebServer reset default.
	
	"The realm to use for the server"
	realm := 'Example Realm'.

	"Add a sample user (note: password is hashed, not stored verbatim)"
	server passwordAt: 'squeak' realm: realm put: 'squeak'.

	server listenOn: port.
	server addService: '/' action:[:req| 
		server 
			authenticate: req 
			realm: realm
			methods: #(digest basic) 
			do:[self browseRequest: req]].
! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
exampleBrowse	"WebServer exampleBrowse"
	"This example implements a simple http server allowing to view 
	and download files (like browsing ftp sites etc)."

	| server port |
	port := 9999.
	server := WebServer reset default.
	server listenOn: port.
	server addService: '/' action:[:req| self browseRequest: req].
! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
exampleDoIt		"WebServer exampleDoIt"
	"This example executes doIts from a POST request.
	It's the simplest possible RPC interface to Squeak."

	| server port |
	port := 9999.
	server := WebServer reset default.
	server listenOn: port.
	server addService: '/' action:[:req| 
		| data result |
		req isPostRequest ifTrue:[
			"We fetch all of the data instead of streaming it"
			data := req content.
			"Compute the result"
			result := [Compiler evaluate: data] on: Error do:[:ex| ex return: ex asString].
			req send200Response: result asString 
		] ifFalse:[req send404Response].
	].
! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
exampleSSL: certName

	"This example implements a simple https server allowing to view 
	and download files (like browsing ftp sites etc):

		WebServer exampleSSL: 'Internet Widgits Pty'.
		WebServer exampleSSL: '/home/andreas/certs/testcert.pem'.

	"

	| server port |
	port := 8443.
	server := WebServer reset default.
	server accessLog: Transcript.
	server certName: certName.
	server listenOn: port.
	server addService: '/' action:[:req| self browseRequest: req].
! !

!WebServer class methodsFor: 'examples' stamp: 'pmaer 6/5/2012 14:23'!
exampleSession		"WebServer exampleSession"
	"This example uses a simple session cookie to avoid 
	authentication for every request."

	| server port realm |
	realm := 'Example Realm'.	"authentication realm"
	port := 9999.
	server := WebServer reset default.
	server listenOn: port.

	"Add a sample user (note: password is hashed, not stored verbatim)"
	server passwordAt: 'squeak' realm: realm put: 'squeak'.

	"Register the login service (sets cookie when successful)"
	server addService: '/login' action:[:req| 
		server  authenticate: req  realm: realm methods: #(digest)  do:[ | id |
			"Set the cookie and redirect back to /"
			server sessionAt: (id := UUID new hex) put: ''.
			req send302Response: (req fields at: 'url' ifAbsent:['/'])
				do:[:resp| resp setCookie: 'session' value: id path: '/']]].

	"Register the normal browse service"
	server addService: '/' action:[:req|
		"Check if we have a valid session cookie. If not redirect to login."
		(server sessionAt: (req cookieAt: 'session')) notNil
			ifTrue:[self browseRequest: req]
			ifFalse:[req send302Response: '/login?url=', req url encodeForHTTP]].
! !

!WebServer class methodsFor: 'registry' stamp: 'pmaer 6/5/2012 14:23'!
forUrl: urlString
	"Answer the WebServer registered for a given URL string."

	^self forUrl: urlString ifAbsent:[self newForUrl: urlString]! !

!WebServer class methodsFor: 'registry' stamp: 'pmaer 6/5/2012 14:23'!
forUrl: urlString ifAbsent: aBlock
	"Answer the WebServer registered for a given URL string.
	If no WebServer is registered, evaluate aBlock."

	^self registry at: urlString ifAbsent: aBlock! !

!WebServer class methodsFor: 'registry' stamp: 'pmaer 6/5/2012 14:23'!
newForUrl: urlString
	"Create a new WebServer instance registered for a given URL string."

	| server |
	"Out with the old ...."
	server := self removeUrl: urlString.
	server ifNotNil:[server destroy].

	"... and in with the new."
	server := self new.
	server siteUrl: urlString.
	self registry at: urlString put: server.
	^server
! !

!WebServer class methodsFor: 'registry' stamp: 'pmaer 6/5/2012 14:23'!
registry
	"Answer the WebServer site registry"

	^Registry ifNil:[Registry := DODictionary new]! !

!WebServer class methodsFor: 'registry' stamp: 'pmaer 6/5/2012 14:23'!
removeUrl: urlString
	"Remove and answer the WebServer registered for a given URL string.
	If no WebServer was registered, return nil."

	^self removeUrl: urlString ifAbsent:[nil]! !

!WebServer class methodsFor: 'registry' stamp: 'pmaer 6/5/2012 14:23'!
removeUrl: urlString ifAbsent: aBlock
	"Remove and answer the WebServer registered for a given URL string."

	^self registry removeKey: urlString ifAbsent: aBlock! !

!WebServer class methodsFor: 'benchmarks' stamp: 'pmaer 6/5/2012 14:23'!
requestBenchmark: persistent
	"Runs a WebClient/WebServer benchmark to measure request handling speed.
	Uses a persistent connection if requested."

	"
		WebServer requestBenchmark: false.
		WebServer requestBenchmark: true.
		MessageTally spyOn:[WebServer requestBenchmark: true]
	"

	| port |
	port := 8888.
	WebServer reset default listenOn: port.
	WebServer default addService: '/benchmark' action:[:req|
		req send200Response: ''.
	].
	^[WebClient 
		requestBenchmark: 'http://localhost:', port, '/benchmark'
		persistent: persistent] ensure:[WebServer reset].
! !

!WebServer class methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
reset		"WebServer reset"
	"Reset the default WebServer instance."

	Default ifNotNil:[
		Default destroy.
		Default := nil.
	].! !

!WebServer class methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
serverDate
	"Returns the date string to be used in responses"

	| date |
	^String streamContents:[:s|
		date := DateAndTime now asUTC.
		s nextPutAll: date dayOfWeekAbbreviation, ', '.
		date asDate printOn: s format: #(1 2 3 $  2 1 2 ).
		s space; nextPutAll: (Time seconds: date asSeconds) print24.
		s nextPutAll: ' GMT'.
	].! !

!WebServer class methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
serverString
	"Returns the server string to be used in responses"

	^'WebServer/1.5 (', 
		WebUtils mcVersion, '; ', 
		SystemVersion current version,'-', 
		SystemVersion current highestUpdate printString, '; ', 
		WebUtils platformName,')'.
! !

!WebServer methodsFor: 'logging' stamp: 'pmaer 6/5/2012 14:23'!
accessLog
	"The standard access log. Can be either a stream or a string; if the access log
	is a string then the string is assumed to be a file name and the file will be opened 
	and closed for each request."

	^accessLog! !

!WebServer methodsFor: 'logging' stamp: 'pmaer 6/5/2012 14:23'!
accessLog: aStreamOrFilename
	"The standard access log. Can be either a stream or a string; if the access log
	is a string then the string is assumed to be a file name and the file will be opened 
	and closed for each request."

	accessLog := aStreamOrFilename! !

!WebServer methodsFor: 'services' stamp: 'pmaer 6/5/2012 14:23'!
addService: entryPoint action: aBlockOrMessage
	"Add a service to the web server. The service is specified by an entryPoint, 
	denoting the url under which the service can be requested 
	(such as /my/great/service) and an action which is a message 
	send taking a single argument, the WebRequest."

	^self addService: entryPoint 
		action: aBlockOrMessage 
		methods: self defaultHttpMethods.! !

!WebServer methodsFor: 'services' stamp: 'pmaer 6/5/2012 14:23'!
addService: entryPoint action: aBlockOrMessage methods: methods
	"Add a service to the web server. The service is specified by an entryPoint, 
	denoting the url under which the service can be requested 
	(such as /my/great/service) and an action which is a message 
	send taking a single argument, the WebRequest.
	
	The list of methods describes what HTTP methods the given url supports."

	mutex critical:[
		entryPoints at: entryPoint asLowercase put: {methods. aBlockOrMessage}.
	].! !

!WebServer methodsFor: 'handling' stamp: 'pmaer 6/5/2012 14:23'!
asyncHandleConnectionFrom: aSocket
	"Handle an incoming connection asynchronously to avoid blocking the listener."

	| handlerProcess |
	handlerProcess := [[
		[self handleConnectionFrom: aSocket] on: Error do:[:ex| aSocket destroy].
		mutex critical:[connections remove: Processor activeProcess ifAbsent:[]].
	] ensure:[aSocket destroy]] newProcess.

	mutex critical:[connections add: handlerProcess].

	handlerProcess resume.
! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
authAccept: method request: request realm: realm header: authHeader
	"Performs the requested authentication method. 
	Returns true if successfully authenticated.
	Subclasses can extend this method to support more auth methods."

	^method asLowercase caseOf: {
		['basic'] 	-> [self basicAuth: request realm: realm header: authHeader].
		['digest'] 	-> [self digestAuth: request realm: realm header: authHeader].
	} otherwise:[false].
! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
authHeader: method request: request realm: realm
	"Answer the authentication header for the given method.
	Subclasses can extend this method to support more auth methods."

	^method asLowercase caseOf: {
		['basic'] 	-> ['Basic realm="', realm,'"'].
		['digest'] 	-> ['Digest realm="', realm,'", nonce="', self newNonce,'", qop="auth"'].
	} otherwise:[nil].
	
	! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
authenticate: request realm: realm methods: accepted do: aBlock
	"Authenticates an incoming request using one of the accepted methods.

	Evaluates aBlock upon successful authentication. Responds with a 401
	(Unauthorized) if the authentication fails."

	| method resp |
	request headersAt: 'Authorization' do:[:authHeader|
		method := authHeader copyUpTo: Character space.
		(accepted anySatisfy:[:auth| auth sameAs: method]) ifTrue:[
			(self authAccept: method request: request realm: realm header: authHeader)
				ifTrue:[^aBlock value].
		].
	].

	"Send a 401 (unauthorized) response"
	resp := request newResponse protocol: 'HTTP/1.1' code: 401.
	resp headerAt: 'Content-Type' put: 'text/html; charset=utf-8'.
	accepted do:[:auth| | hdr |
		hdr := self authHeader: auth request: request realm: realm.
		hdr ifNotNil:[resp addHeader: 'WWW-Authenticate' value: hdr].
	].
	request sendResponse: resp content: '<html><head><title>401 Unauthorized</title></head><body><h1>401 Unauthorized</h1><p>You are not authorized to access the requested URL</p></body></html>'.
! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
basicAuth: request realm: realm header: authHeader
	"Perform Basic auth for the given request"

	| data user pass hash |
	data := (authHeader copyAfter: $ ) base64Decoded.
	user := data copyUpTo: $:.
	pass := data copyAfter: $:.
	data atAllPut: $*. data := nil.

	hash := self hashUser: user password: pass realm: realm.
	pass atAllPut: $*. pass := nil.

	^(self passwordHashAt: user, ':', realm) = hash
! !

!WebServer methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:23'!
builtinHttpMethods
	"Returns the list of HTTP methods that the server handles built-in,
	i.e., without passing them to the registered service."

	^#('HEAD' 'TRACE' 'OPTIONS')! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
canCrossBoundary: anObject
	<meta> 
	^ self selectedClasses includes: anObject class. ! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
certName
	"The cert name to use for a secure (SSL/TLS) web server."

	^certName! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
certName: aString
	"The cert name to use for a secure (SSL/TLS) web server."

	certName := aString.! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
connections
	"The active connection processes. Can only be examined after aquiring
	the WebServer's mutex."

	^connections! !

!WebServer methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:23'!
critical: aBlock
	"Evaluate aBlock protected byt the server's mutex.
	Necessary if code needs to manipulate internal server state."

	^mutex critical: aBlock
! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
decodeMultipartForm: aStream boundary: boundary do: aBlock
	"Parse the contents of a multipart/form-data submission.

	Evaluate aBlock with three parts: The headers, the (parsed) form-data
	arguments and the (undecoded) contents of the part. The sender is
	expected to take care of other issues such as content-transfer-encoding
	and similar headers."

	| skip headers content disposition index params |
	aStream upToAll: '--', boundary.
	[aStream atEnd or:[(skip := aStream next: 2) = '--']] whileFalse:[
		skip = String crlf ifFalse:[self error: 'Error decoding multipart/form-data fields'].
		headers := DODictionary new.
		(self readHeadersFrom: aStream) do:[:hdr| headers add: hdr].
		content := aStream upToAll: String crlf, '--', boundary.
		params := DODictionary new.
		disposition := headers at: 'content-disposition' ifAbsent:[''].
		#(name filename) do:[:arg| | len val |
			len := arg size + 2.
			index := disposition findString: arg,'='.
			index > 0 ifTrue:[
				val := disposition copyFrom: index + len to: (disposition indexOf: $" startingAt: index+len) - 1.
				params at: arg put: val.
			].
		].
		aBlock value: headers value: params value: content.
	].! !

!WebServer methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:23'!
defaultHttpMethods
	"Answer the list of HTTP methods that should be be supported by default.
	The methods must be implemented by the request handler."

	^#('GET' 'POST')! !

!WebServer methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:23'!
destroy
	"Destroys the receiver"

	self stopListener.
	self destroyConnections.
	listenerSocket ifNotNil:[listenerSocket destroy].

	"De-register the WebServer"
	(self class forUrl: self siteUrl ifAbsent:[self]) == self 
		ifTrue:[self class removeUrl: siteUrl]
! !

!WebServer methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:23'!
destroyConnections
	"Destroy all current connections."

	mutex critical:[
		connections do:[:p| p terminate].
		connections removeAll.
	].
! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
digestAuth: request realm: realm header: authHeader
	"Authenticates an incoming request using Digest auth."

	| user nonce uri response ha1 ha2 md5 qop nc cnonce 
	  nonceData nonceCounter nonceTimeout params |

	params := WebUtils parseAuthParams: authHeader.

	"Flush the nonce cache randomly about every 100 auth attempts"
	100 atRandom = 42 ifTrue:[self flushNonceCache].

	user := params at: 'username' ifAbsent:[''].
	nonce := params at: 'nonce' ifAbsent:[''].
	uri := params at: 'uri' ifAbsent:[request url].
	response := params at: 'response' ifAbsent:[''].
	
	qop := params at: 'qop' ifAbsent:[''].
	qop = 'auth' ifFalse:[^false]. "we require qop=auth"

	nc := params at: 'nc' ifAbsent:[''].
	cnonce := params at: 'cnonce' ifAbsent:[''].
	
	"Verify that this is a nonce that we have handed out, that it isn't expired
	and that the nc counter has increased from the last use."
	mutex critical:[
		nonceData := nonceCache at: nonce ifAbsent:[^false].
	].
	nonceCounter := nonceData first.		"last used nc"
	nonceTimeout := nonceData second.	"timeout for nonce"
	nc <= nonceCounter ifTrue:[^false]. 	"nc must increase"
	Time totalSeconds > nonceTimeout ifTrue:[^false]. "nonce expired"
	nonceData at: 1 put: nc.

	ha1 := self passwordHashAt: user, ':', realm.
	ha2 := WebUtils md5Digest: request method, ':', uri.
	md5 := WebUtils md5Digest: ha1, ':', nonce, ':', nc, ':', cnonce, ':', qop, ':', ha2.
	^md5 = response
! !

!WebServer methodsFor: 'handling' stamp: 'pmaer 6/5/2012 14:23'!
dispatchRequest: request
	"Look up the handler for a given request and dispatch to it"

	^self dispatchRequest: request url: request url! !

!WebServer methodsFor: 'handling' stamp: 'pmaer 6/5/2012 14:23'!
dispatchRequest: request url: dispatchUrl
	"Look up the handler for a given url and dispatch to it"

	| entryUrl action |
	"Handle TRACE requests right away"
	request method = 'TRACE' ifTrue:[
		^request send200Response: request asString contentType: 'message/http'.
	].

	"Look up the entry point for the request"
	action := nil.
	entryUrl := dispatchUrl asLowercase.
	(entryUrl beginsWith: '/') ifFalse:[entryUrl := '/', entryUrl].
	mutex critical:[
		[entryUrl notEmpty and:[action == nil]] whileTrue: [
			action := entryPoints at: entryUrl ifAbsent:[nil].
			entryUrl := entryUrl copyUpToLast: $/.
		].
		action ifNil:[action := entryPoints at: '/' ifAbsent:[nil]].
	].

	"Handle OPTIONS requests"
	request method = 'OPTIONS' ifTrue:[
		"HEAD, TRACE, and OPTIONS are always supported"
		request sendOptionsResponse: self builtinHttpMethods,
			(action ifNil:[self defaultHttpMethods] ifNotNil:[action first])
	].

	"Handle 404 not found"
	action ifNil:[^request send404Response].

	"Handle 405 method not allowed"
	(request method = 'HEAD' "builtin" 
		or:[(action at: 1) includes: request method]) ifFalse:[
			^request send405Response: self builtinHttpMethods, action first.
		].

	^[self invokeAction: (action at: 2) request: request] 
		on: Error do:[:ex|
			errorHandler 
				ifNil:[self handleError: ex request: request]
				ifNotNil:[errorHandler value: ex value: request]
		].
! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
doCrossBoundary: anObject
	<meta> 
	^ anObject. ! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
errorHandler
	"The user-supplied error handler. If present the handler takes two arguments:
		* The error being caught by WebServer
		* The request the error occurred in.
	The user-supplied error handler can do whatever it wants, including calling
	WebServer's #handleError:request: method which is the default."

	^errorHandler! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
errorHandler: aBlock
	"The user-supplied error handler. If present the handler takes two arguments:
		* The error being caught by WebServer
		* The request the error occurred in.
	The user-supplied error handler can do whatever it wants, including calling
	WebServer's #handleError:request: method which is the default."

	errorHandler := aBlock.! !

!WebServer methodsFor: 'errors' stamp: 'pmaer 6/5/2012 14:23'!
errorReportFor: anError
	"Provide a report for an error that's been caught during processing"

	^[
		String streamContents:[:s| 
			self errorReportFor: anError 
				stack: ([anError signalerContext stackOfSize: 2000] 
							on: Error do:[:ex| ex return: #()])
				on: s
		].
	] on: Error do: [:ex| ex pass. 'error reporting failed'].! !

!WebServer methodsFor: 'errors' stamp: 'pmaer 6/5/2012 14:23'!
errorReportFor: anError stack: preStack on: strm
	"Provide a report for an error that's been caught during processing"

	self errorStackFor: anError stack: preStack on: strm.
	strm cr; nextPutAll: '-----------------------------------------------------------------'; cr; cr.
	self systemInfoOn: strm.
! !

!WebServer methodsFor: 'errors' stamp: 'pmaer 6/5/2012 14:23'!
errorStackFor: anError stack: preStack on: strm
	"Provide a report for an error that's been caught during processing"

	| cnt |
	cnt := 0.
	(preStack copyFrom: 1 to: (5 min: preStack size)) do:[:ctx|
		ctx printDetails: strm.	"variable values"
		strm cr.
	].

	strm cr; nextPutAll: '--- The full stack ---'; cr.
	cnt := 0.

	preStack do:[:ctx|
		cnt := cnt + 1.
		cnt = 5 ifTrue: [
			strm nextPutAll: ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'; cr].
		strm print: ctx; cr.  "just class>>selector"
	].
! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
flushNonceCache
	"Flushes expired nonces from the cache"

	| deadline |
	deadline := Time totalSeconds.
	mutex critical:[
		nonceCache := nonceCache reject:[:nonceData| deadline > nonceData second]
	].
! !

!WebServer methodsFor: 'handling' stamp: 'pmaer 6/5/2012 14:23'!
handleConnectionFrom: aSocket
	"Synchronously handle an incoming socket connection."

	| stream request |

	"Give the process a pretty name"
	Processor activeProcess name: (String streamContents:[:s|
		aSocket remoteAddress do:[:b| s print: b] separatedBy:[s nextPut: $.].
		s nextPut: $:; print: aSocket remotePort.
		s nextPutAll: ' - ', self class name, ' request handler'.
	]).

	"Read the request from the socket, and dispatch it.
	Since we've been forked already it's okay to block."
	[
		certName ifNil:["Regular request"
			stream := SocketStream on: aSocket.
		] ifNotNil:["SSL/TLS"
			| ssl |
			ssl := Smalltalk at: #SqueakSSL ifAbsent:[self error: 'SqueakSSL not installed'].
			stream := ssl secureSocketStream on: aSocket.
			[stream sslAccept: certName] on: Error do:[^stream destroy].
		].

		[aSocket isConnected] whileTrue:[

			"Read the next request from the connection. If the connection is closed,
			or if a network error occurs, or the read times out, just close the connection
			without further ado (rather than logging an error). Any other error resulting
			from parsing the input is treated as a 400 bad request."

			stream peek ifNil:[^aSocket destroy].
			request := self newRequest.
			[request readFrom: stream] on: Error do:[:ex| 
				(ex isKindOf: NetworkError) ifFalse:[
					[request send400Response] on: Error do:[:ignore].
				].
				^aSocket destroy].

			self dispatchRequest: request.
		].
	] on: Error do:[:ex|
		(ex isKindOf: NetworkError) ifFalse:[
			self log: 'Error in request handling: ', ex description.
			self log: (self errorReportFor: ex).
		].
	].! !

!WebServer methodsFor: 'errors' stamp: 'pmaer 6/5/2012 14:23'!
handleError: ex request: aRequest
	"The default error handling during processing. Sends a 500 response."

	| errLabel errReport |
	errLabel := [ex description] on: Error do:[:ex2| 
		ex2 return: ex class name
	].
	errReport := [self errorReportFor: ex] on: Error do:[:ex2|
		ex2 return: '<error report failed>'.
	].
	[self log: errLabel] on: Error do:[:ex2| ex return].
	[self log: String cr, errReport] on: Error do:[:ex2| ex return].
	aRequest send500Response: errReport. ! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
hashUser: user password: pass realm: realm
	"Creates a hash for the given username password pair.
	This method is the ha1 part of digest auth and can be used for both digest
	as well as basic auth."

	^WebUtils md5Digest: user, ':', realm, ':', pass! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
inFilters
	^ {#request}! !

!WebServer methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:23'!
initialize
	"Initialize the receiver"

	mutex := DOMutex new.
	entryPoints := DODictionary new.
	connections := IdentitySet new.
	vault := DODictionary new.
	nonceCache := DODictionary new.
	sessions := DODictionary new.
	self logAction:[:aString| Transcript cr; show: aString].
! !

!WebServer methodsFor: 'handling' stamp: 'pmaer 6/5/2012 14:23'!
invokeAction: action request: request
	"Invokes the given action. Subclasses can override this method to serialize
	actions if necessary. At this point, the request header has been read from
	the network, but not its content."
	| params |
	params := {request}. 
	params owner: WorldOwner getInstance. 
	^action valueWithArguments: params.
! !

!WebServer methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:23'!
isRunning
	"Is the server still running?"

	^self isStopped not! !

!WebServer methodsFor: 'testing' stamp: 'pmaer 6/5/2012 14:23'!
isStopped
	"Is the server still running?"

	^listenerProcess == nil or:[listenerProcess isTerminated]! !

!WebServer methodsFor: 'listening' stamp: 'pmaer 6/5/2012 14:23'!
listenOn: aPort
	"Starts the server listening on the given port"

	^self listenOn: aPort interface: nil! !

!WebServer methodsFor: 'listening' stamp: 'pmaer 6/5/2012 14:23'!
listenOn: aPort interface: anInterface
	"Starts the server listening on the given port / network interface"

	^self listenOn: aPort interface: anInterface backlogSize: 8! !

!WebServer methodsFor: 'listening' stamp: 'pmaer 6/5/2012 14:23'!
listenOn: aPort interface: anInterface backlogSize: backlog
	"Starts the server listening on the given port / network interface"
	
	| ipString |
	interface := anInterface.
	port := aPort.
	ipString := interface ifNil:['*'] ifNotNil:[
		String streamContents:[:s| interface do:[:b| s print: b] separatedBy:[s nextPut:$.]]].
	self log: 'listener starting (interface: ', ipString, ' port: ', port asString, ')'.
	listenerSocket := Socket newTCP.
	interface 
		ifNil:[listenerSocket listenOn: port backlogSize: backlog]
		ifNotNil:[listenerSocket listenOn: port backlogSize: backlog interface: interface].
	listenerSocket isWaitingForConnection ifFalse:[
		self error: 'Failed to listen(interface: ', interface printString, ' port: ', aPort printString,' )'.
	].
	self startListener.! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
listenerInterface
	"Returns the listener interface for the server"

	^interface! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
listenerPort
	"Returns the listener port for the server"

	^port! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
listenerProcess
	"Returns the socket listener process for the server."

	^listenerProcess! !

!WebServer methodsFor: 'listening' stamp: 'pmaer 6/5/2012 14:23'!
listenerProcessPriority
	"The priority at which the listener process should run"

	^Processor lowIOPriority! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
listenerSocket
	"Returns the listener socket for the server."

	^listenerSocket! !

!WebServer methodsFor: 'initialize' stamp: 'pmaer 6/5/2012 14:23'!
log: aString
	"Log the given information."

	logAction ifNotNil:[logAction valueWithArguments: {aString}].
! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
logAction
	"The current log action (a block or message)"

	^logAction! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
logAction: aBlockOrMessage
	"The current log action (a block or message).
	Example:
		WebServer new logAction: [:aString| Transcript show: aString].
		WebServer new logAction: (MessageSend receiver: Transcript selector: #show).
	"

	logAction := aBlockOrMessage! !

!WebServer methodsFor: 'logging' stamp: 'pmaer 6/5/2012 14:23'!
logRequest: request response: response
	"Log a request after it has been successfully processed"

	accessLog ifNil:[^self].

	"Do not use the standard exception handler for errors logging; 
	it would possibly send a 500 response. Really this should be handled
	by a different process with its own error handler."

	[WebUtils logRequest: request response: response on: accessLog]
		on: Error do:[:ex| self log: 'Error in logging: ', ex description].
! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
newNonce
	"Create a new nonce to be used for a client authentication session"

	| nonce |
	nonce := UUID new hex.
	mutex critical:[
		nonceCache at: nonce put: {''. Time totalSeconds + self nonceDeadline}.
	].
	^nonce! !

!WebServer methodsFor: 'handling' stamp: 'pmaer 6/5/2012 14:23'!
newRequest
	"Answer a new request.
	Subclasses should override this method to use a different request class."

	^(WebRequest new)
		server: self;
		yourself! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
nonceDeadline
	"Answer the number of seconds a nonce is considered valid for digest auth
	by the server. After this period, the client will have to reauthenticate.
	The default is 30 minutes."

	^30*60 ! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
outFilters
	^ {#all}
	! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
passwordAt: username realm: realm put: password
	"Store the password hash for the key."

	| hash |
	hash := self hashUser: username password: password realm: realm.
	self passwordHashAt: (username,':',realm) put: hash! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
passwordHashAt: key
	"Answer the password hash for the given key"

	^vault at: key ifAbsent:['']! !

!WebServer methodsFor: 'authentication' stamp: 'pmaer 6/5/2012 14:23'!
passwordHashAt: key put: hash
	"Store the password hash for the key."

	^vault at: key put: hash! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
readHeadersFrom: aStream
	"Parse http headers and answer a collection of key -> value pairs."

	| headers nextLine existing |
	headers := DOOrderedCollection new.
	[nextLine := aStream upToAll: String crlf.
	nextLine isEmpty] whileFalse:[
		nextLine first isSeparator ifTrue:["Continuation as per HTTP 1.1 spec"
			existing := headers last.
			existing value: (existing value, String space, nextLine withBlanksTrimmed).
		] ifFalse:["Regular header"
			headers add: 
				(nextLine copyUpTo: $:) asLowercase ->
					(nextLine copyAfter: $:) withBlanksTrimmed.
		].
	].
	^headers! !

!WebServer methodsFor: 'services' stamp: 'pmaer 6/5/2012 14:23'!
removeService: entryPoint 
	"Remove a service from the HTTP service provider.  See #addService:action:"

	mutex critical:[
		entryPoints removeKey: entryPoint asLowercase ifAbsent: [].
	].! !

!WebServer methodsFor: 'listening' stamp: 'pmaer 6/5/2012 14:23'!
runListener
	"Runs the server's listener loop. 
	Accepts incoming connections and handles them asynchronously"

	| connectionSocket |
	[[[listenerSocket notNil and:[listenerSocket isValid]] whileTrue:[
		"Waiting for five seconds means that WebServer will be
		back up after roughly five seconds when the system restarts."
		connectionSocket := listenerSocket waitForAcceptFor: 5.
		"Fork this off since or else errors in acceptClient: kill the listener"
		connectionSocket ifNotNil:[self asyncHandleConnectionFrom: connectionSocket].
	]] ensure:[
		"Logging here is only for the purpose of catching sockets going randomly bad"
		self log: 'listener terminating, socket: ', (listenerSocket ifNotNil:[:s| s statusString]).

		"Try to restart the listener"
		(listenerSocket notNil and:[listenerSocket isValid not]) ifTrue:[
			listenerSocket destroy.
			listenerProcess := nil.
			"Wait a little before retrying"
			(Delay forSeconds: 2) wait.
			^self listenOn: port interface: interface
		].
	]] on: Error do:[:ex| self log: ex].
! !

!WebServer methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
selectedClasses 
	^ { WebRequest }! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
serverDate
	"Returns the date string to be used in responses"

	^self class serverDate! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
serverString
	"Returns the server string to be used in responses.
	The response is cached for efficiency."

	^serverString ifNil:[serverString := self class serverString].! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
serverString: aString
	"Set the server string to be used in responses"

	^serverString := aString! !

!WebServer methodsFor: 'sessions' stamp: 'pmaer 6/5/2012 14:23'!
sessionAt: key
	"Answer the session associated with the given key"

	^mutex critical:[sessions at: key ifAbsent:[nil]].! !

!WebServer methodsFor: 'sessions' stamp: 'pmaer 6/5/2012 14:23'!
sessionAt: key ifAbsentPut: session
	"Answer the session associated with the given key"

	^mutex critical:[sessions at: key ifAbsentPut:[session]].! !

!WebServer methodsFor: 'sessions' stamp: 'pmaer 6/5/2012 14:23'!
sessionAt: key put: session
	"Store the session associated with the given key"

	^mutex critical:[sessions at: key put: session].! !

!WebServer methodsFor: 'sessions' stamp: 'pmaer 6/5/2012 14:23'!
sessions
	"The sessions associated with the WebServer. These are not used by the server
	directly but rather provided so that client code has a convenient place to store
	session data."
	
	^sessions! !

!WebServer methodsFor: 'sessions' stamp: 'pmaer 6/5/2012 14:23'!
sessions: aDictionary
	"The sessions associated with the WebServer. These are not used by the server
	directly but rather provided so that client code has a convenient place to store
	session data."
	
	sessions := aDictionary! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
siteUrl
	"The site URL for WebServer, i.e., http://www.mysite.com or http://www.mysite.com/server (when used in a proxied environment) or https://www.mysite.com (when using SSL). Used to allow a client to derive the 'correct' full URL for a running server instance."

	^siteUrl! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
siteUrl: aString
	"The site URL for WebServer, i.e., http://www.mysite.com or http://www.mysite.com/server (when used in a proxied environment) or https://www.mysite.com (when using SSL). Used to allow a client to derive the 'correct' full URL for a running server instance."

	siteUrl := aString! !

!WebServer methodsFor: 'listening' stamp: 'pmaer 6/5/2012 14:23'!
startListener
	"Starts the server's listener process"

	self stopListener.
	listenerProcess := [self runListener] newProcess.
	listenerProcess priority: self listenerProcessPriority.
	listenerProcess name: self class name, '''s listener process'.
	listenerProcess resume.
! !

!WebServer methodsFor: 'listening' stamp: 'pmaer 6/5/2012 14:23'!
stopListener
	"Stops the server's listener process"

	listenerProcess ifNotNil:[listenerProcess terminate].
	listenerProcess := nil.! !

!WebServer methodsFor: 'errors' stamp: 'pmaer 6/5/2012 14:23'!
systemInfoOn: strm
	"Provides system information for a server error report"

	strm nextPutAll: 'VM: ';
		nextPutAll:  WebUtils platformName;
		nextPutAll: ' - ';
		nextPutAll: WebUtils vmVersion;
		cr.

	strm nextPutAll: 'Image: ';
		nextPutAll:  SystemVersion current version asString;
		nextPutAll: ' [';
		nextPutAll: SmalltalkImage current lastUpdateString asString;
		nextPutAll: ']';
		cr.

	strm cr.

	SecurityManager default printStateOn: strm.

	"Additional info available from the windows VM"
	WebUtils platformName = 'Win32' ifTrue:[
		10001 to: 10003 do:[:i| | info |
			info := (SmalltalkImage current getSystemAttribute: i) ifNil:[''].
			info := info copyReplaceAll: String lf with: String cr.
			info isEmpty ifFalse:[strm cr; nextPutAll: info]]].
! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
vault
	"The vault used for storing password hashes."

	^vault! !

!WebServer methodsFor: 'accessing' stamp: 'pmaer 6/5/2012 14:23'!
vault: anObject
	"The vault used for storing password hashes.

	Clients can provide their own storage mechanism. 
	Subclasses can also override the lookup and authentication mechanism."

	vault := anObject! !

OwnedObject3 subclass: #Wiki
	uses: TDeepOwernship
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

Wiki class
	uses: TDeepOwernship classTrait
	instanceVariableNames: ''!

!Wiki class methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
compilerClass 
	^OwnershipCompiler3 ! !

!Wiki methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
buildSampleWiki
	| page |

	root := WebPage newRoot: 'example'.
	root content: 'Root'.
	page := root newPage: 'first'.
	page content: 'First child'.
	page := root newPage: 'second'. 
	page content: 'Second child'.
	^root! !

!Wiki methodsFor: 'violation' stamp: 'pmaer 6/5/2012 14:23'!
canCrossBoundary: anObject
	<meta> 
	^ false! !

!Wiki methodsFor: 'violation' stamp: 'pmaer 6/5/2012 14:23'!
doCrossBoundary: anObject
	<meta> 
	Error signal: 'No object should pass through'. ! !

!Wiki methodsFor: 'violation' stamp: 'pmaer 6/5/2012 14:23'!
doNotCrossBoundary: anObject
	<meta> 
	Transcript show: ( 'Object ', anObject printString, ' (owned by ', anObject owner printString , ') crossed ', self printString ) ; cr.
	OwnershipViolation signal: 'Boundary crossed'    ! !

!Wiki methodsFor: 'filters' stamp: 'pmaer 6/5/2012 14:23'!
inFilters
	^ {#none}! !

!Wiki methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
locatePage: url root: root
	| path rootName |
	path :=  url splitOn: '/'. 
	path removeFirst .
	rootName := path removeFirst .
	( rootName = root name ) ifTrue: [
		(path size > 0 ) ifTrue: [
			^ root locatePage: path.
		] ifFalse: [
			^ root. 
		]
	] ifFalse: [
		Error signal.
	].
! !

!Wiki methodsFor: 'filters' stamp: 'pmaer 6/5/2012 14:23'!
outFilters
	^ {#all}
	! !

!Wiki methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
process: request 

	| render page action | 
	
	Transcript show: ' ==== Start processing request ====' ; cr.
	
	page := self locatePage: request url root: root. 
	action := request fields at: 'action'.

	render:= String streamContents:[:s|
		( request isPostRequest ) ifTrue: [
			( action = 'view' ) ifTrue: [ Error signal ].
			( action = 'edit' ) ifTrue: [ 
				page content: (request fields at: 'content').
				^request send302Response: page viewUrl ].
		].
		( request isGetRequest ) ifTrue: [
			( action = 'view' ) ifTrue: [ page renderView: s. ].
			( action = 'edit' ) ifTrue: [ page renderEdit: s. ].
		].
 	].

	request 
		send200Response: (render convertToWithConverter: UTF8TextConverter new) 
		contentType: 'text/html; charset=utf-8'.
		
	Transcript show: ' ==== End processing request ====' ; cr.! !

!Wiki methodsFor: 'as yet unclassified' stamp: 'pmaer 6/5/2012 14:23'!
run 	"WebServer exampleWiki"

	| server port |
	port := 9999.
	server := WebServer reset default.
	server listenOn: port.
	server addService: '/' action:[:req| self process: req ].
! !

Object subclass: #SnakesAndLadders
	instanceVariableNames: 'players squares turn die over'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Examples-SnakesAndLadders'!

!SnakesAndLadders commentStamp: 'on 3/14/2006 19:05' prior: 0!
SnakesAndLadders example playToEnd

A simple board game in which players roll a die to move from the starting square to the end. A square may contain a snake (moves you back) or a ladder (moves you up). If youland on a square already occupied, you go back to the start. If you move past the end, you reverse direction the remaining number of moves.

See http://en.wikipedia.org/wiki/Snakes_and_ladders for the rules of the game

SnakesAndLadders has the following responsibilities:
- enable scripting of an initial configuration of squares and players
- keep track of the rules of the game
- keep track whose turn it is to play
- initiate a move
- play a game to the end
- report on moves and intermediate game states
- stop when the game is over

Typical usage (see the example):
- Instantiate a new SnakesAndLadders
- Add squares, snakes and ladders to build the game board 
- Join players
- Play single moves or PlayToEnd!

!SnakesAndLadders class methodsFor: 'as yet unclassified' stamp: 'pmaer 3/26/2012 19:19'!
compilerClass
^ OwnershipCompiler2_2! !

!SnakesAndLadders class methodsFor: 'documentation' stamp: 'pmaer 2/14/2012 00:11'!
example
	"self example playToEnd"

	^ (self new)
		add: FirstSquare new;
		add: (LadderSquare forward: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		add: BoardSquare new;
		add: BoardSquare new;
		add: (LadderSquare forward: 2);
		add: BoardSquare new;
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 6);
		add: BoardSquare new;
		join: (GamePlayer named: 'Jack');
		join: (GamePlayer named: 'Jill');
		yourself! !

!SnakesAndLadders class methodsFor: 'documentation' stamp: 'pmaer 2/14/2012 00:30'!
example2
	"self example2 playToEnd"

	^ (self new)
		add: FirstSquare new;
		add: BoardSquare new;
		add: (LadderSquare forward: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 2);
		add: BoardSquare new;
		add: (LadderSquare forward: 3);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		join: (GamePlayer named: 'Jack');
		join: (GamePlayer named: 'Jill');
		yourself! !

!SnakesAndLadders class methodsFor: 'documentation' stamp: 'pmaer 2/15/2012 13:19'!
example3 
	"self example2 playToEnd"
	| temp |
	temp:= self new.
	self halt.
	^ (temp)
		add: FirstSquare new;
		add: BoardSquare new;
		add: (LadderSquare forward: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 2);
		add: BoardSquare new;
		add: (LadderSquare forward: 3);
		add: BoardSquare new;
		add: BoardSquare new;
		add: (SnakeSquare back: 4);
		add: BoardSquare new;
		add: BoardSquare new;
		join: (GamePlayer named: 'Jack');
		join: (GamePlayer named: 'Jill');
		yourself! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'on 3/18/2006 15:13'!
add: aSquare 
	squares add: aSquare.
	aSquare setPosition: squares size board: self! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:30'!
at: position
	^ squares at: position! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 3/14/2006 17:10'!
checkResult
	^ self currentPlayer position = self lastPosition
		ifTrue: [
			over := true.
			' -- ', self currentPlayer asString, ' wins!!'
			]
		ifFalse: [ '' ]! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:54'!
currentPlayer
	^ players at: turn! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:43'!
firstSquare
	^ squares first! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
initialize
	super initialize.
	die := Die new.
	squares := OrderedCollection  new.
	players := OrderedCollection new.
	turn := 1.
	over := false.! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'pmaer 2/27/2012 12:12'!
invariant
	"Should also check that snakes and ladders lead to ordinary squares, and do not bounce
	past the beginning or end of the board."
	^ squares size > 1
		and: [[players size > 1]
		and: [[turn >= 1]
		and: [[turn <= players size]]]]! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'pmaer 2/3/2012 15:14'!
isNotOver 
	^ self isOver not! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/18/2006 15:04'!
isOver
	^ over! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'on 3/18/2006 12:10'!
join: aPlayer
	players add: aPlayer.
	aPlayer moveTo: self firstSquare.
! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:59'!
lastPosition
	^ squares size! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 5/17/2006 16:49'!
playOneMove
	| result |
	self assert: self invariant.
	^ self isOver 
		ifTrue: ['The game is over!!']
		ifFalse: 
			[result := (self currentPlayer moveWith: die) , self checkResult.
			self upDateTurn.
			result]! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 3/18/2006 15:01'!
playToEnd
	"SnakesAndLadders example playToEnd"

	Transcript closeAllViews.
	Transcript open.
	Transcript
		show: self asString;
		cr;
		cr.
	[self isNotOver] whileTrue: 
			[Transcript
				show: self playOneMove asString;
				cr.
			Transcript
				show: self asString;
				cr;
				cr]! !

!SnakesAndLadders methodsFor: 'accessors' stamp: 'on 3/15/2006 15:01'!
players
	"needed for testing"
	^ players! !

!SnakesAndLadders methodsFor: 'printing' stamp: 'on 3/16/2006 18:06'!
printOn: aStream
	squares do: [:each | each printOn: aStream].! !

!SnakesAndLadders methodsFor: 'initialize-release' stamp: 'on 3/16/2006 11:30'!
reset
	die := Die new.
	turn := 1.
	over := false.
	players do: [:each | each moveTo: self firstSquare ].
	self assert: self invariant.! !

!SnakesAndLadders methodsFor: 'accessors' stamp: 'on 3/15/2006 13:29'!
setDie: aDie
	"For testing only. Can play the game with a loaded die."
	die := aDie.! !

!SnakesAndLadders methodsFor: 'testing' stamp: 'on 3/14/2006 16:22'!
turn
	^ turn! !

!SnakesAndLadders methodsFor: 'playing' stamp: 'on 3/14/2006 16:21'!
upDateTurn
	turn := 1 + (turn\\players size).! !

Object subclass: #TestA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

!TestA methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:12'!
randomStuff
	| a b c |
	a := TestA new.
	b := TestB new.
	c := TestC new.! !

Object subclass: #TestAST
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-FirstModel'!

!TestAST class methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2011 11:41'!
compilerClass 
^ DebugCompiler! !

!TestAST methodsFor: 'as yet unclassified' stamp: 'ewe 11/22/2011 11:39'!
objectNameTransformed
^ self checkValidSend: [ self name ].! !

!TestAST methodsFor: 'as yet unclassified' stamp: 'pmaer 5/7/2012 13:26'!
testArrayCompilation
	| a |
	
	DOArray withAll: #(1 2 (3 4) 5 #(6 7)).
	
	a do: { 1. 1+2. 3. {5. 1 } }.! !

Object subclass: #TestB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

!TestB methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:13'!
moreRandomStuff
	| a b c d |
	a := TestA new.
	b := TestB new.
	c := TestC new.
	d := TestD new.! !

Object subclass: #TestC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

!TestC methodsFor: 'as yet unclassified' stamp: 'pmaer 2/1/2012 16:13'!
randomrandom
	| c d e |
	c := TestC new.
	d := TestD new.
	e := TestE new.! !

Object subclass: #TestD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

Object subclass: #TestE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-TestStuff'!

!TestE class methodsFor: 'as yet unclassified' stamp: 'pmaer 5/11/2012 17:17'!
bla
	| t |
	t:= DOOrderedCollection new.! !

!TestE methodsFor: 'as yet unclassified' stamp: 'pmaer 5/11/2012 17:17'!
blub
	^DOArray new.! !

Object subclass: #VariableNameCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Util'!

VariableNameCounter class
	instanceVariableNames: 'counter'!

VariableNameCounter class
	instanceVariableNames: 'counter'!

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 16:46'!
counter
	(counter = nil) ifTrue: [ self resetCounter ].
	^counter! !

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 16:46'!
increment
	counter := counter + 1.! !

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'ewe 4/25/2012 14:28'!
nextVariableName
	VariableNameCounter increment.
	^ 'r', self counter asString .! !

!VariableNameCounter class methodsFor: 'as yet unclassified' stamp: 'pmaer 12/5/2011 16:45'!
resetCounter
	counter := 0.! !

Object subclass: #WebClient
	instanceVariableNames: 'flags server scheme timeout stream cookies proxyServer lastScheme lastServer lastPort maxRedirect redirections userAgent authParams proxyParams accessLog debugLog'
	classVariableNames: 'DebugLog FlagAcceptCookies FlagAllowAuth FlagAllowRedirect ProxyHandler'
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebClient commentStamp: 'ar 5/4/2010 13:17' prior: 0!
WebClient provides a simple yet complete HTTP client implementation.

To view the documentation evaluate:

	HelpBrowser openOn: WebClientHelp.
!

!WebClient class methodsFor: 'accessing' stamp: 'ar 8/12/2010 21:20'!
debugLog
	"The default debugLog, if any:
		WebClient debugLog: Transcript.
		WebClient debugLog: nil.
	"

	^DebugLog! !

!WebClient class methodsFor: 'accessing' stamp: 'ar 8/12/2010 21:20'!
debugLog: aStream
	"The default debugLog, if any:
		WebClient debugLog: Transcript.
		WebClient debugLog: nil.
	"

	DebugLog := aStream.! !

!WebClient class methodsFor: 'utilities' stamp: 'ar 6/1/2010 20:24'!
htmlSubmit: urlString fields: fieldMap
	"A utility method for html submit operations. The fieldMap can be EITHER
	an array of associations OR a Dictionary of key value pairs (the former is
	useful for providing multiple fields and/or specifying the order of fields).

		WebClient 
			htmlSubmit: 'http://www.google.com/search'
			fields: {
				'hl' -> 'en'.
				'q' -> 'Squeak'
			}
	"
	^self htmlSubmit: urlString 
			fields: fieldMap
			method: 'GET'
! !

!WebClient class methodsFor: 'utilities' stamp: 'ar 6/1/2010 20:24'!
htmlSubmit: urlString fields: fieldMap method: method
	"A utility method for html submit operations. The fieldMap can be EITHER
	an array of associations OR a Dictionary of key value pairs (the former is
	useful for providing multiple fields and/or specifying the order of fields).

		WebClient 
			htmlSubmit: 'http://www.google.com/search'
			fields: {
				'hl' -> 'en'.
				'q' -> 'Squeak'
			} method: 'GET'
	"
	^self htmlSubmit: urlString 
			fields: fieldMap
			method: method
			encoding: 'application/x-www-form-urlencoded'
! !

!WebClient class methodsFor: 'utilities' stamp: 'ar 7/20/2010 20:10'!
htmlSubmit: urlString fields: fields method: method encoding: encoding
	"A utility method for html submit operations. The fieldMap can be EITHER
	an array of associations OR a Dictionary of key value pairs (the former is
	useful for providing multiple fields and/or specifying the order of fields).

		WebClient 
			htmlSubmit: 'http://www.google.com/search'
			fields: {
				'hl' -> 'en'.
				'q' -> 'Squeak'
			} method: 'GET'
			encoding: 'application/x-www-form-urlencoded'
	"

	method = 'GET' ifTrue:[
		"GET only supports url encoded requests"
		encoding = 'application/x-www-form-urlencoded' 
			ifFalse:[^self error: 'Unsupported encoding: ', encoding].
		^self httpGet: urlString, '?', (WebUtils encodeUrlEncodedForm: fields).
	].

	method = 'POST' ifTrue:[
		"Dispatch on encoding type"
		encoding caseOf: {
			[ 'application/x-www-form-urlencoded'] -> [
				^self httpPost: urlString
					content: (WebUtils encodeUrlEncodedForm: fields)
					type: encoding.
			].
			['multipart/form-data'] -> [
				^self httpPost: urlString multipartFields: fields
			].
		} otherwise:[]
	].

	self error: 'Unsupported method: ', method.
! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:30'!
httpDelete: urlString
	"Sends a DELETE request"
	"WebClient httpDelete: 'http://ftp.squeak.org/trunk'"

	^self httpDo:[:client| client httpDelete: urlString].
! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:29'!
httpDo: aBlock
	"Simplified wrapper for running various methods"

	| client response |
	client := self new.
	response := WebUtils handleAuth: [aBlock value: client].
	response content; close.
	^response! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:30'!
httpGet: urlString
	"Get the response from the given url"
	"(WebClient httpGet: 'http://www.squeak.org') content"

	^self httpDo:[:client| client httpGet: urlString].! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:31'!
httpHead: urlString
	"Sends a HEAD request"
	"WebClient httpHead: 'http://ftp.squeak.org/trunk'"

	^self httpDo:[:client| client httpHead: urlString].
! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:31'!
httpOptions: urlString
	"Sends an OPTIONS request"
	"WebClient httpOptions: 'http://ftp.squeak.org/*'"
	"WebClient httpOptions: 'http://ftp.squeak.org/4.1/Squeak4.1.zip'"

	^self httpDo:[:client| client httpOptions: urlString]
! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:31'!
httpPost: urlString content: postData type: contentType
	"Fire off an HTTP post request"

	^self httpDo:[:client| client httpPost: urlString content: postData type: contentType]
! !

!WebClient class methodsFor: 'utilities' stamp: 'ar 7/20/2010 20:09'!
httpPost: url multipartFields: fieldMap
	"Make a form submission using multipart/form-data POST.

	The fieldMap may contain MIMEDocument instances to indicate the presence
	of a file to upload to the server. If the MIMEDocument is present, its
	content type and file name will be used for the upload.

	The fieldMap can be EITHER an array of associations OR a Dictionary of 
	key value pairs (the former is useful for providing multiple fields and/or 
	specifying the order of fields)."

	| boundary |
	boundary := WebUtils multipartBoundary.

	^self httpPost: url 
		content: (WebUtils encodeMultipartForm: fieldMap boundary: boundary) 
		type: 'multipart/form-data; boundary=', boundary! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:31'!
httpPostChunked: urlString content: chunkBlock type: contentType
	"POST the data to the given url using chunked transfer-encoding.
	The chunkBlock takes a request and can be fed using #nextChunkPut:
	until all the data has been sent.

	Chunked encoding can be used for long-lasting connections to a server,
	but care must be taken to ensure that the client isn't running afoul of
	the server expecting to read the full response (i.e., you should use this
	only if you have control over both ends).

	However, it is a great way to send output from commands that take awhile
	and other time-consuming operations if authentication has been handled."

	^self httpDo:[:client| 
		client httpPostChunked: urlString content: chunkBlock type: contentType]
! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:32'!
httpPut: urlString content: postData type: contentType
	"Fire off an HTTP PUT request"

	^self httpDo:[:client| client httpPut: urlString content: postData type: contentType]! !

!WebClient class methodsFor: 'httpsocket' stamp: 'ar 2/10/2012 13:33'!
httpRequest: method url: urlString headers: hdrs content: contentOrNil response: responseBlock

	"Sends an HTTP request to the server. Returns a MIMEDocument if successful,
	a string indicating the error otherwise. If a response block is provided, the
	response is fed into into so that the sender can see all the headers."

	| client request response content |
	client := self new.
	client initializeFromUrl: urlString.
	client userAgent: HTTPSocket userAgentString.

	request := client requestWithUrl: urlString.
	request method: method.

	"Set up headers for the request"
	(WebUtils readHeadersFrom: hdrs readStream) 
		do:[:hdr| request addHeader: hdr key value: hdr value].

	WebUtils handleAuth:[
		response := client sendRequest: request 
			content: (contentOrNil ifNotNil:[contentOrNil readStream])
			size: (contentOrNil ifNil:[0] ifNotNil:[contentOrNil size]).
	].

	content := response contentWithProgress:[:total :amount|
		(HTTPProgress new) total: total; amount: amount; signal: 'Downloading...'.
	].
	client close.

	responseBlock ifNotNil:[responseBlock value: response asString].

	^(response isSuccess) 
		ifTrue:[MIMEDocument contentType: response contentType 
				content: content url: urlString]
		ifFalse:[response asString, content].
! !

!WebClient class methodsFor: 'methods' stamp: 'ar 2/10/2012 13:32'!
httpTrace: urlString
	"Sends a TRACE request"
	"(WebClient httpTrace: 'http://lists.squeakfoundation.org') content"
	"(WebClient httpTrace: 'http://ftp.squeak.org/trunk') content"

	^self httpDo:[:client| client httpTrace: urlString]! !

!WebClient class methodsFor: 'class initialization' stamp: 'ar 2/10/2012 13:33'!
initialize
	"WebClient initialize"

	FlagAcceptCookies := 1.
	FlagAllowAuth := 2.
	FlagAllowRedirect := 4.

	"Default proxy handler"
	ProxyHandler := WebUtils.

	self registerHttpSocketRequestHandler.
! !

!WebClient class methodsFor: 'accessing' stamp: 'ar 2/23/2010 22:26'!
proxyHandler
	"The currently registered proxy handler"

	^ProxyHandler! !

!WebClient class methodsFor: 'accessing' stamp: 'ar 2/23/2010 22:26'!
proxyHandler: anObject
	"The currently registered proxy handler"

	ProxyHandler := anObject! !

!WebClient class methodsFor: 'httpsocket' stamp: 'ar 7/10/2010 13:37'!
registerHttpSocketRequestHandler
	"Register WebClient as an HTTPSocket request handler"

	(HTTPSocket respondsTo: #httpRequestHandler:) ifFalse:[^self].

	"Be polite and only register if no other handler was registered."
	HTTPSocket httpRequestHandler == HTTPSocket
		ifTrue:[HTTPSocket httpRequestHandler: self].
! !

!WebClient class methodsFor: 'benchmark' stamp: 'ar 6/2/2010 10:32'!
requestBenchmark: url persistent: aBool
	"Run a WebClient benchmark to measure request handling speed.
	Try using a persistent connection if requested.

	1) Launch WebServer  (or Seaside, or whatever):
	
		(WebServer reset default)
			listenOn: 8888;
			addService: '/' action:[:r| r send200Response: ''].

	2) Run the benchmark:

		MessageTally spyOn:[
			WebClient requestBenchmark: 'http://localhost:8888/' persistent: true.
		]
	"

	| time resp startTime endTime count client |
	count := 0.
	client := WebClient new.
	startTime := Time millisecondClockValue.
	[endTime := Time millisecondClockValue.
	(time := Time milliseconds: endTime since: startTime) < 5000] whileTrue:[
		resp := client httpGet: url.
		resp isSuccess ifFalse:[self error: resp status].
		resp content.
		aBool ifFalse:[resp close].
		count := count + 1.
	].
	^(count  * 1000 // time) asStringWithCommas, ' requests/sec'
! !

!WebClient class methodsFor: 'class initialization' stamp: 'ar 7/10/2010 13:38'!
unload
	"Unregister WebClient as http socket handler when unloaded"

	self unregisterHttpSocketRequestHandler.
! !

!WebClient class methodsFor: 'httpsocket' stamp: 'ar 7/10/2010 13:37'!
unregisterHttpSocketRequestHandler
	"Unregister WebClient as an HTTPSocket request handler"

	(HTTPSocket respondsTo: #httpRequestHandler:) ifFalse:[^self].

	HTTPSocket httpRequestHandler == self
		ifTrue:[HTTPSocket httpRequestHandler: nil].
! !

!WebClient class methodsFor: 'websockets' stamp: 'ar 9/26/2011 10:39'!
webSocket00: serverUrl protocol: protocol
	"Attempt to connect to the given server url using the WebSocket api"

	| key1 key2 bytes hash client req resp |
	"Fixed keys from spec"
	key1 := 155712099.
	key2 := 173347027.
	bytes := ByteArray new: 8.
	(1 to: bytes size) do:[:i| bytes at: i put: (256 atRandom - 1)].
	hash := WebUtils webSocketHandshake: key1 with: key2 with: bytes.

	client := self new.
	client initializeFromUrl: serverUrl.
	req := client requestWithUrl: serverUrl.
	req method: 'GET'.
	req headerAt: 'Upgrade' put: 'WebSocket'.
	req headerAt: 'Connection' put: 'Upgrade'.
	req headerAt: 'Origin' put: 'null'.
	protocol ifNotNil:[req headerAt: 'Sec-WebSocket-Protocol' put: protocol].
	req headerAt: 'Sec-WebSocket-Key1' put: '18x 6]8vM;54 *(5:  {   U1]8  z [  8'.
	req headerAt: 'Sec-WebSocket-Key2' put: '1_ tx7X d  <  nw  334J702) 7]o}` 0'.
	resp := client sendRequest: req content: bytes readStream size: bytes size.
	resp code = 101 ifFalse:[client close. ^nil].
	(resp stream next: 16) asByteArray = hash ifFalse:[client close. ^nil].

	"Close of stream is left to caller"
	^WebSocket00 on: resp stream.
! !

!WebClient class methodsFor: 'websockets' stamp: 'ar 9/26/2011 10:39'!
webSocket07: serverUrl protocol: protocol
	"Attempt to connect to the given server url using the WebSocket api"
	"http://tools.ietf.org/html/draft-ietf-hybi-thewebsocketprotocol-07"

	| hash client req resp nonce |
	nonce := ByteArray new: 16.
	(1 to: nonce size) collect:[:i| nonce at: i put: (256 atRandom - 1)].
	nonce := nonce base64Encoded.

	client := self new.
	client initializeFromUrl: serverUrl.
	req := client requestWithUrl: serverUrl.
	req method: 'GET'.
	req headerAt: 'Upgrade' put: 'WebSocket'.
	req headerAt: 'Connection' put: 'Upgrade'.
	req headerAt: 'Sec-WebSocket-Origin' put: 'null'.
	protocol ifNotNil:[req headerAt: 'Sec-WebSocket-Protocol' put: protocol].
	req headerAt: 'Sec-WebSocket-Key' put: nonce.
	req headerAt: 'Sec-WebSocket-Version' put: '7'.

	resp := client sendRequest: req.
	resp code = 101 ifFalse:[client close. ^nil].

	"Verify WebSocket hash"
	hash := WebUtils webSocketHash07: nonce.
	hash = (resp headerAt: 'Sec-WebSocket-Accept') ifFalse:[client close. ^nil].

	"Close of stream is left to caller"
	^WebSocket07 on: resp stream.
! !

!WebClient class methodsFor: 'websockets' stamp: 'ar 9/26/2011 10:39'!
webSocket68: serverUrl protocol: protocol
	"Attempt to connect to the given server url using the WebSocket api"

	| client req resp |
	client := self new.
	client initializeFromUrl: serverUrl.
	req := client requestWithUrl: serverUrl.
	req method: 'GET'.
	req headerAt: 'Upgrade' put: 'WebSocket'.
	req headerAt: 'Connection' put: 'Upgrade'.
	req headerAt: 'Origin' put: 'null'.
	protocol ifNotNil:[req headerAt: 'WebSocket-Protocol' put: protocol].
	resp := client sendRequest: req.
	resp code = 101 ifFalse:[client close. ^nil].

	"Close of stream is left to caller"
	^WebSocket00 on: resp stream.
! !

!WebClient class methodsFor: 'websockets' stamp: 'ar 7/9/2010 00:37'!
webSocketTo: serverUrl
	"Attempt to connect to the given server url using the WebSocket api"

	"Testing:

		1) Launch WebSocket example.
		2) Run the following code:
		
		| ws |
		ws := WebClient webSocketTo: 'http://localhost:8080/broadcast'.
		ws onMessage:[:data| Transcript cr; show: data].
		ws fork.
		ws send: 'This is the first message'.
		ws send: 'This is the last message'.
		ws close.

	"

	^self webSocketTo: serverUrl protocol: nil! !

!WebClient class methodsFor: 'websockets' stamp: 'ar 7/9/2010 00:31'!
webSocketTo: serverUrl protocol: protocol
	"Attempt to connect to the given server url using the WebSocket api"

	^self webSocket00: serverUrl protocol: protocol! !

!WebClient methodsFor: 'cookies' stamp: 'ar 8/12/2010 21:40'!
acceptCookie: aCookie host: reqHost path: path
	"Accept a cookie from a prior response"

	self acceptCookies ifTrue:[
		"Set the defaults per RFC 2109 section 4.3.1 "
	
		"Ensure the cookie domain is set"
		aCookie domain ifNil:[aCookie domain: reqHost].

		"Ensure the cookie path is set"
		aCookie path ifNil:[aCookie path: path].

		"Reject the cookie per RFC 2109 section 4.3.2"
		(path beginsWith: aCookie path) ifFalse:[^false].

		aCookie domain = reqHost ifFalse:[ | domain |
			domain := aCookie domain.
			"For misconfigured servers, insert the leading dot into the domain"
			domain first = $. ifFalse:[aCookie domain: (domain := '.', domain)].
			((domain count:[:ch| ch = $.]) >= 2) ifFalse:[^false].
			(reqHost endsWith: domain) ifFalse:[^false].
			((reqHost allButLast: domain size) includes: $.) ifTrue:[^false].
		].
	
		"Remove any old cookies"
		cookies := cookies reject:[:any| any = aCookie].
		
		"Remember the cookie if not expired"
		(aCookie expiry == nil or:[aCookie expiry > DateAndTime now])  ifTrue:[
			cookies add: aCookie.
			^true
		].
	].
	^false! !

!WebClient methodsFor: 'cookies' stamp: 'ar 4/1/2010 18:04'!
acceptCookies
	"Whether we should accept cookies"

	^flags anyMask: FlagAcceptCookies! !

!WebClient methodsFor: 'cookies' stamp: 'ar 4/1/2010 18:05'!
acceptCookies: aBool
	"Whether we should accept cookies"

	flags := aBool ifTrue:[flags bitOr: FlagAcceptCookies] ifFalse:[flags bitClear: FlagAcceptCookies].
! !

!WebClient methodsFor: 'accessing' stamp: 'ar 7/28/2010 20:49'!
accessLog
	"The standard access log. Can be either a stream or a string; if the access log
	is a string then the string is assumed to be a file name and the file will be opened 
	and closed for each request."

	^accessLog! !

!WebClient methodsFor: 'accessing' stamp: 'ar 7/28/2010 20:49'!
accessLog: aStreamOrFilename
	"The standard access log. Can be either a stream or a string; if the access log
	is a string then the string is assumed to be a file name and the file will be opened 
	and closed for each request."

	accessLog := aStreamOrFilename! !

!WebClient methodsFor: 'accessing' stamp: 'ar 4/1/2010 18:03'!
allowAuth
	"If true, WebClient will attempt to handle authorization requests"

	^flags anyMask: FlagAllowAuth! !

!WebClient methodsFor: 'accessing' stamp: 'ar 4/1/2010 18:02'!
allowAuth: aBool
	"If true, WebClient will attempt to handle authorization requests"

	flags := aBool ifTrue:[flags bitOr: FlagAllowAuth] ifFalse:[flags bitClear: FlagAllowAuth].
! !

!WebClient methodsFor: 'accessing' stamp: 'ar 4/1/2010 18:01'!
allowRedirect
	"If true, WebClient will attempt to handle redirect responses"

	^flags anyMask: FlagAllowRedirect! !

!WebClient methodsFor: 'accessing' stamp: 'ar 4/1/2010 18:02'!
allowRedirect: aBool
	"If true, WebClient will attempt to handle redirect responses"

	flags := aBool ifTrue:[flags bitOr: FlagAllowRedirect] ifFalse:[flags bitClear: FlagAllowRedirect].
! !

!WebClient methodsFor: 'authentication' stamp: 'ar 3/30/2010 20:45'!
authDispatch: request from: response header: authHeader params: params
	"Dispatch on an authentication method. 
	Subclasses can extend this method to support more auth methods."

	(authHeader copyUpTo: Character space) caseOf: {
		['Basic'] -> [self basicAuth: request from: response 
							header: authHeader params: params].
		['Digest'] -> [self digestAuth: request from: response 
							header: authHeader  params: params].
	} otherwise:["ignore"].
! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/10/2012 13:13'!
authParams
	"The authentication parameters"

	^authParams! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/10/2012 13:13'!
authParams: aDictionary
	"The authentication parameters"

	authParams := aDictionary! !

!WebClient methodsFor: 'sending' stamp: 'ar 2/10/2012 13:12'!
authenticate: request from: response
	"Authenticate after having received a 401/407 response.
	Returns true if we should retry, false if we fail here."

	"NOTE: The first time through we do NOT ask for credentials right away.
	Some authentication mechanisms (NTLM/Negotiate) can use the credentials
	of the currently logged on user. Consequently we only ask for credentials
	if we're unable to do so without asking. Methods that require credentials
	(basic, digest) test for their existence explicitly."

	| headers authHeader params |

	"Pick the right set of parameters"
	response code = 401 ifTrue:[
		params := authParams.
		headers := response headersAt: 'WWW-Authenticate'.
		"If the connection was closed, we need to flush the
		proxy params or we won't pick up prior credentials."
		self isConnected 
			ifFalse:[self flushAuthState: proxyParams].
	] ifFalse:[
		params := proxyParams.
		headers := response headersAt: 'Proxy-Authenticate'.
	].

	"Remove any old response"
	params removeKey: #authResponse ifAbsent:[].

	"Process the authentication header(s)"
	1 to: headers size do:[:i|
		authHeader := headers at: i.
		self authDispatch: request from: response header: authHeader params: params.
		"If we generated an authentication response for the header use it"
		params at: #authResponse ifPresent:[:resp|
			request headerAt: (response code = 401 
								ifTrue:['Authorization'] 
								ifFalse:['Proxy-Authorization'])
					put: (params at: #authMethod), ' ', resp.
			^true].
	].

	"If we fall through here this can have two reasons: One is that we don't have
	a suitable authentication method. Check for that first."
	params at: #authMethod ifAbsent:[^false].

	"The other possibility is that the credentials are wrong. 
	Clean out the previous auth state and go ask for credentials."
	self flushAuthState: params.

	"Clean out old authentication headers"
	response code = 401 
		ifTrue:[request removeHeader: 'Authorization'].
	"Always clean out the proxy auth header since we don't support pre-authentication"
	request removeHeader: 'Proxy-Authorization'.

	"Signal WebAuthRequired"
	(WebAuthRequired client: self request: request response: response)
		signal == true ifFalse:[^false].

	"And retry with the new credentials"
	^self authenticate: request from: response! !

!WebClient methodsFor: 'authentication' stamp: 'ar 3/27/2010 01:49'!
basicAuth: request from: response header: header params: params
	"Provide basic authentication for the request"

	| user pass args |
	authParams at: #authMethod ifPresent:[:method| ^self]. "do not retry repeatedly"
	authParams at: #authMethod put: 'Basic'.

	args := WebUtils parseAuthParams: header.
	args at: 'realm' ifPresent:[:realm| authParams at: #authRealm put: realm].
	
	user := (params at: #username ifAbsent:[nil]) ifNil:[^self].
	pass := (params at: #password ifAbsent:[nil]) ifNil:[^self].
	authParams at: #authResponse put:  (user, ':', pass value) base64Encoded.
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 2/20/2010 11:06'!
close
	"Close the client's stream"

	stream ifNotNil:[
		stream close.
		stream := nil.
	].
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 8/26/2010 07:48'!
connect
	"Connect the client to a web server. Returns nil if successful,
	a WebResponse if a proxy CONNECT request fails."

	| actualServer actualPort |

	"Determine which server to connect to (proxy or real)"
	proxyServer ifNil:[
		actualServer := self serverName.
		actualPort := self serverPort.
	] ifNotNil:[
		actualServer := self proxyServerName.
		actualPort := self proxyServerPort.
	].

	"Check if we can use the same stream or if we need to reconnect"
	(stream notNil
		and:[stream isConnected
		and:[lastServer = actualServer
		and:[lastPort = actualPort
		and:[lastScheme = scheme]]]]) ifTrue:[^nil].

	self close.
	lastServer := actualServer.
	lastPort := actualPort.
	lastScheme := scheme.
	stream := SocketStream openConnectionToHostNamed: lastServer port: lastPort.
	stream timeout: timeout.
	"Perform ssl initialization if necessary"
	scheme = 'https' ifTrue:[^self sslConnect].
	^nil! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/23/2010 10:31'!
cookies
	"The cookies that have been set for this session"

	^cookies! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/23/2010 10:31'!
cookies: aCollection
	"The cookies that have been set for this session"

	cookies := aCollection.! !

!WebClient methodsFor: 'accessing' stamp: 'ar 8/12/2010 21:16'!
debugLog
	"If provided, WebClient will print all requests and responses to the debugLog,
	except from the content of the message. The debug log must be a stream of
	some sort; file names (like for the accessLog are not supported)."

	^debugLog! !

!WebClient methodsFor: 'accessing' stamp: 'ar 8/12/2010 21:17'!
debugLog: aStream
	"If provided, WebClient will print all requests and responses to the debugLog,
	except from the content of the message. The debug log must be a stream of
	some sort; file names (like for the accessLog are not supported)."

	debugLog := aStream! !

!WebClient methodsFor: 'initialize' stamp: 'ar 7/21/2010 21:12'!
defaultPort
	"Return the default port to use if no port was specified.
	Since we only support https and http, default to port 80 unless https."

	^scheme = 'https' 
		ifTrue:[443]
		ifFalse:[80]! !

!WebClient methodsFor: 'initialize' stamp: 'ar 2/12/2012 21:03'!
defaultUserAgent
	"Answer the default User-Agent string to use for WebClient"

	^'WebClient/1.5 (', 
		WebUtils mcVersion, '; ', 
		SystemVersion current version,'-', 
		SystemVersion current highestUpdate printString, '; ', 
		WebUtils platformName,')'.
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 2/23/2010 06:20'!
destroy
	"Destroys the client"

	stream ifNotNil:[
		stream socket ifNotNil:[:s| s destroy].
		stream := nil.
	].
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 3/27/2010 11:59'!
detectProxyServer
	"Automatically detect the proxy server to use"

	proxyServer := ProxyHandler proxyServerFor: self server.
! !

!WebClient methodsFor: 'authentication' stamp: 'ar 8/26/2010 07:48'!
digestAuth: request from: response header: authHeader params: params
	"Perform digest authentication"

	| realm nonce ha1 ha2 nc cnonce qop header uri md5 key args user pass |
	params at: #authMethod ifPresent:[:method| ^self]. "do not retry repeatedly"
	params at: #authMethod put: 'Digest'.

	args := WebUtils parseAuthParams: authHeader.
	realm := args at: 'realm'.
	authParams at: #authRealm put: realm.

	user := (params at: #username ifAbsent:[nil]) ifNil:[^self].
	pass := (params at: #password ifAbsent:[nil]) ifNil:[^self].

	nonce := args at: 'nonce'.
	uri := request rawUrl.

	"VERY IMPORTANT NOTE: Some servers fail horribly if the nonce count
	isn't precisely eight digits and without quotes."
	nc := args at: 'nc' put: (args at: 'nc' ifAbsent:[0]) + 1.
	nc := nc asString padded: #left to: 8 with: $0.
	
	key := user, ':', realm, ':', pass value.
	ha1 := WebUtils md5Digest: key.
	ha2 := WebUtils md5Digest: request method, ':', uri.
	cnonce := UUID new hex.

	(args includesKey: 'qop') ifTrue:["use qop"
		qop := 'auth'. "the only qop we support"
		md5 := WebUtils md5Digest: ha1, ':', nonce, ':', nc, ':', cnonce, ':', qop, ':', ha2.
		header :=
			'username="', user, '"',
			', realm="', realm, '"',
			', nonce="', nonce, '"',
			', uri="', uri, '"',
			', response="', md5, '"',
			', qop="', qop,'"',
			', nc="', nc, '"',
			', cnonce="', cnonce, '"'.
	] ifFalse:["ignore qop"
		md5 := WebUtils md5Digest: ha1, ':', nonce, ':', ha2.
		header :=
			'username="', user, '"',
			', realm="', realm, '"',
			', nonce="', nonce, '"',
			', uri="', uri, '"',
			', response="', md5, '"'.
	].
	args at: 'opaque' ifPresent: [:opaque | 
		header := header, ', opaque="', opaque, '"'
	].
	params at: #authResponse put: header.! !

!WebClient methodsFor: 'initialize' stamp: 'ar 4/1/2010 18:51'!
flushAuthState
	"Flush all the auth state"

	self flushAuthState: authParams.
	self flushAuthState: proxyParams.! !

!WebClient methodsFor: 'authentication' stamp: 'ar 3/30/2010 20:46'!
flushAuthState: params
	"Fliush authentication state that should not been preserved 
	inbetween failed attempts to authenticate. 
	Subclasses can extend this method to support more auth methods."

	params removeKey: #authMethod ifAbsent:[].
! !

!WebClient methodsFor: 'methods' stamp: 'ar 5/11/2010 20:04'!
httpDelete: urlString
	"Sends an DELETE request"

	^self httpDelete: urlString do:[:req]
! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:06'!
httpDelete: urlString do: aBlock
	"Sends a DELETE request"

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'DELETE'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	^self sendRequest: request.! !

!WebClient methodsFor: 'methods' stamp: 'ar 2/23/2010 08:57'!
httpGet: urlString
	"GET the response from the given url"
	"(WebClient httpGet: 'http://www.squeak.org') content"

	^self httpGet: urlString do:[:req]
! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:06'!
httpGet: urlString do: aBlock
	"GET the response from the given url"
	"(WebClient httpGet: 'http://www.squeak.org') content"

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'GET'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	^self sendRequest: request
! !

!WebClient methodsFor: 'methods' stamp: 'ar 5/11/2010 20:05'!
httpHead: urlString
	"Sends a HEAD request"

	^self httpHead: urlString do:[:req]
! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:06'!
httpHead: urlString do: aBlock
	"Sends a HEAD request"

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'HEAD'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	^self sendRequest: request.! !

!WebClient methodsFor: 'methods' stamp: 'ar 5/11/2010 20:05'!
httpOptions: urlString
	"Sends an OPTIONS request"

	^self httpOptions: urlString do:[:req]
! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:06'!
httpOptions: urlString do: aBlock
	"Sends an OPTIONS request"

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'OPTIONS'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	^self sendRequest: request
! !

!WebClient methodsFor: 'methods' stamp: 'ar 2/23/2010 08:56'!
httpPost: urlString content: postData type: contentType
	"POST the data to the given url"

	^self httpPost: urlString content: postData type: contentType do:[:req]! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:07'!
httpPost: urlString content: postData type: contentType do: aBlock
	"POST the data to the given url"

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'POST'.
	contentType ifNotNil:[request headerAt: 'Content-Type' put: contentType].
	request headerAt: 'Content-Length' put: postData size.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	^self sendRequest: request content: postData readStream size: postData size! !

!WebClient methodsFor: 'methods' stamp: 'ar 8/31/2010 22:54'!
httpPostChunked: urlString content: chunkBlock type: contentType
	"POST the data to the given url using chunked transfer-encoding.
	The chunkBlock takes a request and can be fed using #nextChunkPut:
	until all the data has been sent.

	Chunked encoding can be used for long-lasting connections to a server,
	but care must be taken to ensure that the client isn't running afoul of
	the server expecting to read the full response (i.e., you should use this
	only if you have control over both ends).

	However, it is a great way to send output from commands that take awhile
	and other time-consuming operations if authentication has been handled."

	^self httpPostChunked: urlString content: chunkBlock type: contentType do: [:req]! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:07'!
httpPostChunked: urlString content: chunkBlock type: contentType do: aBlock
	"POST the data to the given url using chunked transfer-encoding. 
	The chunkBlock takes a request and can be fed using #nextChunkPut:
	until all the data has been sent. 

	Chunked encoding can be used for long-lasting connections to a server,
	but care must be taken to ensure that the client isn't running afoul of
	the server expecting to read the full response (i.e., you should use this
	only if you have control over both ends).

	However, it is a great way to send output from commands that take awhile
	and other time-consuming operations if authentication has been handled."

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'POST'.
	contentType ifNotNil:[request headerAt: 'Content-Type' put: contentType].
	request headerAt: 'Transfer-Encoding' put: 'chunked'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	"Send the chunked data"
	^self sendRequest: request contentBlock:[:aStream| 
		"Set the stream in the request and pass it in the chunk block"
		request stream: aStream.
		chunkBlock value: request.
		"send termination chunk"
		aStream nextPutAll: '0'; crlf; crlf; flush.
	].
! !

!WebClient methodsFor: 'methods' stamp: 'ar 2/23/2010 08:57'!
httpPut: urlString content: postData type: contentType
	"PUT the data to the given url"

	^self httpPut: urlString content: postData type: contentType do:[:req]! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:07'!
httpPut: urlString content: postData type: contentType do: aBlock
	"PUT the data to the given url"

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'PUT'.
	contentType ifNotNil:[request headerAt: 'Content-Type' put: contentType].
	request headerAt: 'Content-Length' put: postData size.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	^self sendRequest: request content: postData readStream size: postData size! !

!WebClient methodsFor: 'methods' stamp: 'ar 5/11/2010 20:05'!
httpTrace: urlString
	"Sends a TRACE request"

	^self httpTrace: urlString do:[:req]
! !

!WebClient methodsFor: 'methods' stamp: 'ar 9/4/2010 11:08'!
httpTrace: urlString do: aBlock
	"Sends a TRACE request"

	| request |
	self initializeFromUrl: urlString.
	request := self requestWithUrl: urlString.
	request method: 'TRACE'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	aBlock value: request.
	^self sendRequest: request
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 2/10/2012 13:33'!
initialize
	"Initializes the receiver"
	flags := 0.
	super initialize.

	self allowAuth: true.
	self allowRedirect: true.
	self acceptCookies: true.

	timeout := Socket standardTimeout.
	cookies := OrderedCollection new.
	redirections := Dictionary new.
	maxRedirect := 10.
	userAgent := self defaultUserAgent.
	authParams := IdentityDictionary new.
	proxyParams := IdentityDictionary new.

	"Use the default debug log"
	debugLog := DebugLog.
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 7/25/2010 15:36'!
initializeFromUrl: urlString
	"Initialize the client from a url string"

	| urlStream serverAndPort userAndPass |
	urlStream := urlString readStream.
	scheme := (urlStream upToAll: '://') asLowercase.
	(scheme = 'http' or:[scheme = 'https'])
		ifFalse:[self error: 'Unsupported scheme: ', scheme].
	serverAndPort := urlStream upTo: $/.

	userAndPass := serverAndPort copyUpTo: $@.
	userAndPass = serverAndPort ifFalse:[
		serverAndPort := serverAndPort copyAfter: $@.
		self username: (userAndPass copyUpTo: $:).
		self password: (userAndPass copyAfter: $:).
	].

	self server: serverAndPort.
	self detectProxyServer.! !

!WebClient methodsFor: 'testing' stamp: 'ar 3/30/2010 19:18'!
isConnected
	"Returns true if the client is still connected"

	^stream notNil and:[stream isConnected]! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/22/2010 03:12'!
maxRedirect
	"The max. number of redirects we allow for the SAME SITE before giving up.
	Redirects can happen for any number of reasons between any number of sites
	and we give up if we have seen the SAME SITE maxRedirect number of times."

	^maxRedirect! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/22/2010 03:12'!
maxRedirect: aNumber
	"The max. number of redirects we allow for the SAME SITE before giving up.
	Redirects can happen for any number of reasons between any number of sites
	and we give up if we have seen the SAME SITE maxRedirect number of times."

	maxRedirect := aNumber! !

!WebClient methodsFor: 'initialize' stamp: 'ar 8/9/2010 08:30'!
newRequest
	"Create an return a new WebRequest.
	Subclasses can use this method to override the default request class."

	^WebRequest new! !

!WebClient methodsFor: 'accessing' stamp: 'ar 3/27/2010 12:01'!
password
	"The password for remote authentication.
	The password should generally not be a plain-text
	version but rather a block that can retrieve the password
	when required."

	^authParams at: #password ifAbsent:[nil]! !

!WebClient methodsFor: 'accessing' stamp: 'ar 3/27/2010 01:32'!
password: aStringOrValuable
	"The password for remote authentication.
	The password should generally not be a plain-text
	version but rather a block that can retrieve the password
	when required."

	^authParams at: #password put: aStringOrValuable! !

!WebClient methodsFor: 'printing' stamp: 'ar 8/9/2010 08:50'!
printOn: aStream
	"Print the receiver on aStream"

	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	(stream notNil and:[stream isConnected]) ifTrue:[
		aStream nextPutAll: 'Connected: '.
	].
	scheme ifNotNil:[aStream nextPutAll: scheme, '://'].
	server ifNotNil:[aStream nextPutAll: server].
	aStream nextPut:$).
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 8/12/2010 21:12'!
proxyConnect
	"Send a proxy CONNECT request to connect to a remote host via the chosen proxy server"

	| uri request repeatAuth response |
	uri := self serverName,':', self serverPort.
	request := self newRequest.
	request method: 'CONNECT'.
	request rawUrl: uri.

	[repeatAuth := false.

	"The proxy response may use Connection: Close; reconnect when that happens"
	self isConnected ifFalse:[
		stream := SocketStream openConnectionToHostNamed: lastServer port: lastPort.
		stream timeout: timeout.
	].

	debugLog ifNotNil:[
		request writeOn: debugLog.
		debugLog flush.
	].

	"Don't use 'self writeRequestOn:' since this will insert both cookies
	as well as modify the url target when a proxy is present"
	request writeOn: stream.
	stream flush.

	response := request newResponse readFrom: stream.

	debugLog ifNotNil:[
		response writeOn: debugLog.
		debugLog flush.
	].

	"Handle authentication if needed"
	(self allowAuth and:[response code = 407]) ifTrue:[
		"Eat up the content of the previous response"
		response content.
		repeatAuth := self authenticate: request from: response.
	].
	repeatAuth] whileTrue.

	^response! !

!WebClient methodsFor: 'proxy' stamp: 'ar 2/10/2012 13:12'!
proxyParams
	"The proxy authentication parameters"

	^proxyParams! !

!WebClient methodsFor: 'proxy' stamp: 'ar 2/10/2012 13:12'!
proxyParams: aDictionary
	"The proxy authentication parameters"

	proxyParams := aDictionary! !

!WebClient methodsFor: 'proxy' stamp: 'ar 3/24/2010 16:04'!
proxyPass
	"The password for an authenticating proxy.
	The password should generally not be a plain-text
	version but rather a block that can retrieve the password
	when required."

	^proxyParams at: #password! !

!WebClient methodsFor: 'proxy' stamp: 'ar 3/24/2010 16:04'!
proxyPass: aStringOrValuable
	"The password for an authenticating proxy.
	The password should generally not be a plain-text
	version but rather a block that can retrieve the password
	when required."

	proxyParams at: #password put: aStringOrValuable! !

!WebClient methodsFor: 'proxy' stamp: 'ar 2/20/2010 19:17'!
proxyServer
	"The proxy server to use for connections.
	The server should be specified as server:port if the proxy
	port to be used is different from the desitation port."

	^proxyServer! !

!WebClient methodsFor: 'proxy' stamp: 'ar 2/20/2010 19:17'!
proxyServer: aString
	"The proxy server to use for connections.
	The server should be specified as server:port if the proxy
	port to be used is different from the desitation port."

	proxyServer := aString! !

!WebClient methodsFor: 'proxy' stamp: 'ar 2/20/2010 19:22'!
proxyServerName
	"Returns the name part of the server:port description"

	^proxyServer copyUpTo: $:! !

!WebClient methodsFor: 'proxy' stamp: 'ar 2/20/2010 19:21'!
proxyServerPort
	"Returns the port of the proxyServer:port description"

	^(proxyServer copyAfter: $:) 
		ifEmpty:[self serverPort]
		ifNotEmpty:[:portString| portString asInteger].
! !

!WebClient methodsFor: 'proxy' stamp: 'ar 3/24/2010 16:02'!
proxyUser
	"The user name for an authenticating proxy"

	^proxyParams at: #username ifAbsent:[nil]! !

!WebClient methodsFor: 'proxy' stamp: 'ar 3/24/2010 16:02'!
proxyUser: aString
	"The user name for an authenticating proxy"

	proxyParams at: #username put: aString! !

!WebClient methodsFor: 'sending' stamp: 'ar 9/4/2010 11:10'!
redirect: request from: response
	"Handle a 3xx redirect response"

	| location max |
	
	"Check if we handle the specific type of redirect here"
	(#(	301 
		302 "Found" 
		303 "See Other" 
		307 "Temporary Redirect")
			includes: response code) ifFalse:[^false].

	"RFC 2616 states that requests other than HEAD and GET MUST NOT be auto
	redirected for 302 and 307 responses"
	(request method = 'GET' or:[request method = 'HEAD']) ifFalse:[
		(response code = 302 or:[response code = 307]) ifTrue:[^false].
	].

	"Find the new location"
	location := response headerAt: 'location'.

	"Check if we've exceeded max redirections"
	max := redirections at: location ifAbsent:[0].
	max > self maxRedirect ifTrue:[^false].
	redirections at: location put: max+1.

	"Do the actual redirect, i.e., set us up for the new url"
	(location findString: '://') > 0 "do we have a scheme:// url?"
		ifTrue:[self initializeFromUrl: location].

	request initializeFromUrl: location.

	^true! !

!WebClient methodsFor: 'initialize' stamp: 'ar 9/4/2010 11:10'!
requestWithUrl: urlString
	"Create and return a new WebRequest initialized with the given url."

	^self  newRequest initializeFromUrl: urlString! !

!WebClient methodsFor: 'accessing' stamp: 'ar 8/5/2010 19:50'!
scheme
	"The scheme used for the request (usually http or https)"

	^scheme! !

!WebClient methodsFor: 'accessing' stamp: 'ar 8/5/2010 19:50'!
scheme: aString
	"The scheme used for the request (usually http or https)"

	scheme := aString! !

!WebClient methodsFor: 'sending' stamp: 'ar 2/25/2010 22:16'!
sendRequest: request
	"Send an http request"

	^self sendRequest: request content: nil size: 0! !

!WebClient methodsFor: 'sending' stamp: 'ar 8/31/2010 21:19'!
sendRequest: request content: contentStream size: streamSize
	"Send an http request"

	^self sendRequest: request contentBlock:[:aStream|
		contentStream ifNotNil:[
			"Upload content if provided"
			contentStream position: 0.
			request streamFrom: contentStream to: aStream size: streamSize 
				progress:[:total :amount|
					(HTTPProgress new) 
						total: total; 
						amount: amount;
						signal: 'Uploading...']]].
! !

!WebClient methodsFor: 'sending' stamp: 'ar 9/16/2010 21:52'!
sendRequest: request contentBlock: contentBlock
	"Send an http request"

	|  response repeatRedirect repeatAuth |

	"XXXX: Fixme. Pre-authenticate the request if we have valid auth credentials"

	redirections := Dictionary new.
	
	["The outer loop handles redirections"
	repeatRedirect := false.

	"Always update the host header due to redirect"
	request headerAt: 'Host' put: server.

		["The inner loop handles authentication"
		repeatAuth := false.

		"Connect can fail if SSL proxy CONNECT is involved"
		self connect ifNotNil:[:resp| ^resp].
		
		"Write the request to the debugLog if present"
		debugLog ifNotNil:[self writeRequest: request on: debugLog].

		"Send the request itself"
		self writeRequest: request on: stream.
		contentBlock value: stream.

		response := request newResponse readFrom: stream.
		response url: (scheme, '://', server, request rawUrl).

		debugLog ifNotNil:[
			response writeOn: debugLog.
			debugLog flush.
		].
		response setCookiesDo:[:cookie| 
			self acceptCookie: cookie host: self serverName path: request url.
		].
		accessLog ifNotNil:[
			WebUtils logRequest: request response: response on: accessLog
		].
		"Handle authentication if needed"
		(self allowAuth and:[response code = 401 or:[response code = 407]]) ifTrue:[
			"Eat up the content of the previous response"
			response content.
			repeatAuth := self authenticate: request from: response.
		].

		repeatAuth] whileTrue.

	"Flush previous authState.
	XXXX: Fixme. authState must be preserved for pre-authentication of requests."
	self flushAuthState.

	"Handle redirect if needed"
	(self allowRedirect and:[response isRedirect]) ifTrue:[
		"Eat up the content of the previous response"
		response content.
		repeatRedirect := self redirect: request from: response.
	].
	repeatRedirect] whileTrue:[
		"When redirecting, remove authentication headers"
		request removeHeader: 'Authorization'.
		request removeHeader: 'Proxy-Authorization'.
	].

	"If the response is not a success, eat up its content"
	(response isSuccess or:[response isInformational]) ifFalse:[response content].

	^response! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/21/2010 09:50'!
server
	"The server to use for connections.
	The server is specified as server:port if needed"

	^server! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/21/2010 09:50'!
server: aString
	"The server to use for connections.
	The server should be specified as server:port if needed"

	server := aString
! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/20/2010 19:22'!
serverName
	"Returns the name part of the server:port description"

	^server copyUpTo: $:! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/20/2010 19:21'!
serverPort
	"Returns the port of the server:port description"

	^(server copyAfter: $:) 
		ifEmpty:[self defaultPort]
		ifNotEmpty:[:portString| portString asInteger].
! !

!WebClient methodsFor: 'initialize' stamp: 'ar 7/25/2010 16:05'!
sslConnect
	"Connect the client to a web server"

	| sqSSL |
	proxyServer ifNotNil:[ | resp |
		"If we have a proxy server, do the proxy connect"
		resp := self proxyConnect.
		resp isSuccess ifFalse:[^resp].
	].

	sqSSL := Smalltalk at: #SqueakSSL ifAbsent:[self error: 'SqueakSSL is missing'].
	"Convert the stream to a secure stream"
	stream := sqSSL secureSocketStream on: stream socket.
	stream timeout: timeout.
	"Do the SSL handshake"
	stream sslConnect.
	"And cert verification"
	stream verifyCert: self serverName.
	^nil "indicating success"
! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:12'!
timeout
	"Timeout for the http operations"

	^timeout! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:12'!
timeout: aNumber
	"Timeout for the http operations"

	timeout := aNumber! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/22/2010 03:16'!
userAgent
	"The User-Agent string sent to the server"

	^userAgent! !

!WebClient methodsFor: 'accessing' stamp: 'ar 2/22/2010 03:17'!
userAgent: aString
	"The User-Agent string sent to the server. 
	If no user agent should be sent, this value can be set to nil"

	userAgent := aString! !

!WebClient methodsFor: 'accessing' stamp: 'ar 3/24/2010 16:05'!
username
	"The username for remote authentication"

	^authParams at: #username ifAbsent:[nil]! !

!WebClient methodsFor: 'accessing' stamp: 'ar 3/24/2010 16:05'!
username: aString
	"The username for remote authentication"

	authParams at: #username put: aString! !

!WebClient methodsFor: 'sending' stamp: 'ar 8/12/2010 21:37'!
writeCookiesFor: request on: stream
	"Write the cookies for a particular request"

	(cookies select:[:ck| (request acceptsCookie: ck from: self )]) ifNotEmpty:[:ckset|
		stream nextPutAll: 'Cookie: '.
		ckset 
			do:[:ck| stream nextPutAll: ck name,'=', ck value]
			separatedBy:[stream  nextPutAll:'; '].
		stream crlf.
	].
! !

!WebClient methodsFor: 'sending' stamp: 'SvenVanCaekenberghe 6/14/2010 15:54'!
writeHeadersFor: request on: aStream
	"Write all the headers for the given request on aStream"

	request headersDo:[:key :value| aStream nextPutAll: key, ': ', value asString; crlf].
! !

!WebClient methodsFor: 'sending' stamp: 'ar 8/12/2010 21:06'!
writeRequest: request on: aStream
	"Write all the request headers on the given stream"

	self writeRequestLine: request on: aStream.
	self writeHeadersFor: request on: aStream.
	self writeCookiesFor: request on: aStream.
	aStream crlf.
	aStream flush.
! !

!WebClient methodsFor: 'sending' stamp: 'ar 9/23/2010 18:47'!
writeRequestLine: request on: aStream
	"Write the HTTP request line on the given stream"

	aStream nextPutAll: request method; space.

	"https proxy support is transparent via CONNECT"
	(proxyServer notNil and:[scheme ~= 'https']) ifTrue:[
		"http://www.ietf.org/rfc/rfc2616.txt 
		5.1.2 Request-URI:
			...
		The absoluteURI form is REQUIRED when the request is being made to a
		proxy. The proxy is requested to forward the request or service it
		from a valid cache, and return the response. Note that the proxy MAY
		forward the request on to another proxy or directly to the server"
		aStream nextPutAll: scheme, '://', self server.

		"XXXX: This is a hack. Indicate that we want the proxy connection 
		to be persistent. This should NOT be necessary; the proxy should
		know that from the HTTP/1.1 request but apparently, squid will fail 
		NTLM and Negotiate authentication unless explicitly instructed to 
		keep the proxy connection alive."
		request headerAt: 'Proxy-Connection' put: 'keep-alive'.
	].

	aStream nextPutAll: request rawUrl; space; nextPutAll: request protocol; crlf.! !

Object subclass: #WebCookie
	instanceVariableNames: 'name value path domain expiry version secure httpOnly comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebCookie commentStamp: 'ar 2/22/2010 05:28' prior: 0!
WebCookie represents an http cookie for use by WebClient.!

!WebCookie methodsFor: 'comparing' stamp: 'ar 5/11/2010 08:58'!
= aCookie
	"Compare the receiver with aCookie"

	^aCookie class == self class 
		and:[aCookie name = self name
		and:[aCookie domain = self domain
		and:[aCookie path = self path]]].! !

!WebCookie methodsFor: 'converting' stamp: 'ar 2/20/2010 11:06'!
asString
	"Create the string representation for this cookie"

	^String streamContents:[:s| self printOn: s].! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 8/5/2010 18:22'!
comment
	"Cookie comment"

	^comment! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 8/5/2010 18:22'!
comment: aString
	"Cookie comment"

	comment := aString! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
domain
	"Cookie domain"

	^domain! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
domain: aString
	"Cookie domain"

	domain := aString.! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 5/11/2010 20:06'!
expiry
	"The expiry DateAndTime"

	^expiry! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 5/11/2010 20:06'!
expiry: aDateAndTime
	"The expiry DateAndTime"

	expiry := aDateAndTime ifNotNil:[:dt| dt asUTC].! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 8/5/2010 18:21'!
expirySeconds: maxAge
	"Compute the cookie's expiry age from the given number of seconds"

	maxAge = 0 ifTrue:[self expiry: DateAndTime new].
	self expiry: DateAndTime now + maxAge seconds.! !

!WebCookie methodsFor: 'comparing' stamp: 'ar 5/11/2010 08:59'!
hash
	"Hash is re-implemented because #= is re-implemented"

	^name hash + domain hash + path hash.! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 3/31/2010 08:38'!
httpOnly
	"If the cookie should be httpOnly (not scriptable).
	See http://msdn2.microsoft.com/en-us/library/ms533046.aspx"

	^httpOnly! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 3/31/2010 08:38'!
httpOnly: aBool
	"If the cookie should be httpOnly (not scriptable).
	See http://msdn2.microsoft.com/en-us/library/ms533046.aspx"

	httpOnly := aBool! !

!WebCookie methodsFor: 'initialize' stamp: 'ar 3/31/2010 08:40'!
initialize
	"Initializes the receiver"
	super initialize.
	secure := false.
	httpOnly := false.
! !

!WebCookie methodsFor: 'testing' stamp: 'ar 5/11/2010 20:06'!
isExpired
	"Return true if this cookie is expired"
	
	expiry ifNil:[^false].
	^expiry asUTC < DateAndTime now asUTC! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
name
	"The name of the cookie"

	^name! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
name: aString
	"The name of the cookie"

	name := aString! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
path
	"Cookie path"

	^path! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
path: aString
	"Cookie path"

	path := aString! !

!WebCookie methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/14/2010 15:52'!
printOn: aStream
	"Creates the string representation for this cookie"

	aStream nextPutAll: name, '=', value asString.
	expiry ifNotNil:[ 
		aStream nextPutAll:'; expires='.
		aStream nextPutAll: expiry asDate weekday, ', '.
		expiry asDate printOn: aStream format: #(1 2 3 $- 2 2 2 ).
		aStream nextPutAll: ' ', expiry asTime print24,' GMT'.
	].
	path ifNotNil:[
		aStream nextPutAll:'; path=', (WebUtils quote: path).
	].
	domain ifNotNil:[
		aStream nextPutAll:'; domain=', (WebUtils quote: domain).
	].
	version ifNotNil:[
		aStream nextPutAll:'; version=', version asString.
	].
	secure ifTrue:[
		aStream nextPutAll: '; secure'.
	].
	httpOnly ifTrue:[
		aStream nextPutAll: '; HttpOnly'.
	].
! !

!WebCookie methodsFor: 'initialize' stamp: 'ar 8/21/2011 11:34'!
readExpiryFrom: aString
	"Read a cookie expiry date from the given string.
	The expiration date is specified in the 'Wdy, DD-Mon-YYYY HH:MM:SS GMT' format."
	
	| tokens |
	^[
		tokens := aString withBlanksTrimmed.
		(tokens copyAfterLast: Character space) = 'GMT'
			ifFalse:[^DateAndTime new].
		tokens := (tokens copyAfter: Character space) copyUpToLast: Character space.
		(DateAndTime readFrom: tokens readStream) offset: Duration zero.
	] on: Error do:[:ex| ex return: DateAndTime new].! !

!WebCookie methodsFor: 'initialize' stamp: 'ar 8/5/2010 18:22'!
readFrom: aStream
	"Read a cookie from the given stream"

	| keyval key val |
	aStream skipSeparators.
	name := (aStream upTo: $=) withBlanksTrimmed.
	value := (aStream upTo: $;) withBlanksTrimmed.
	[aStream atEnd] whileFalse:[
		keyval := aStream upTo: $;.
		key := (keyval copyUpTo: $=) withBlanksTrimmed.
		val := (keyval copyAfter: $=) withBlanksTrimmed.
		key asLowercase caseOf: {
			['expires'] 	-> [self expiry: (self readExpiryFrom: val)].
			['path']		-> [self path: (WebUtils unquote: val)].
			['domain'] 	-> [self domain: (WebUtils unquote: val)].
			['secure'] 	-> [self secure: true].
			['version'] 	-> [self version: val].
			['httponly'] 	-> [self httpOnly: true].
			['comment']	 ->[self comment: val].
			['max-age']	->[self expirySeconds: val asNumber].
		} otherwise:[Transcript show: 'Unknown cookie field: ', key].
	].! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
secure
	"Secure cookie flag"

	^secure! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
secure: aBool
	"Secure cookie flag"

	secure := aBool! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:05'!
value
	"The value of the cookie"

	^value! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:06'!
value: aString
	"The value of the cookie"

	value := aString! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:06'!
version
	"Cookie version"

	^version! !

!WebCookie methodsFor: 'accessing' stamp: 'ar 2/20/2010 11:06'!
version: aString
	"Cookie version"

	version := aString! !

Object subclass: #WebSocket
	instanceVariableNames: 'name process stream handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebSocket commentStamp: '<historical>' prior: 0!
A wrapper object for the WebSocket API.!

!WebSocket class methodsFor: 'example' stamp: 'ar 7/8/2010 21:50'!
example	"WebSocket example"

	"This is a very simple WebSocket example implementing a basic chat system.
	Each message sent by a client connection is broadcast to everyone."

	| mutex sockets |
	mutex := Mutex new.
	sockets := OrderedCollection new.
	WebServer reset default listenOn: 8080.

	WebServer default addService: '/' action:[:req|
		"Serves the main html chat page"
		req send200Response: self examplePage contentType: 'text/html'.
	].

	WebServer default addService: '/broadcast' action:[:req| | ws |
		"Implements the WebSocket broadcaster"
		ws := req asWebSocket.
		ws timeout: 300. "5 minutes timeout"
	
		Transcript cr; show: 'New ', ws.

		ws onMessage:[:data|
			mutex critical:[sockets do:[:s| s send: data]].
		].
		ws onClose:[
			Transcript cr; show: 'Closing ', ws.
			mutex critical:[sockets remove: ws ifAbsent:[]].
		].
		ws onError:[:ex|
			Transcript cr; show: ws.
			Transcript cr; show: ex description.
			Transcript cr; show: ex signalerContext longStack.
		].
		mutex critical:[sockets add: ws].

		"We don't need to #fork here, in fact we shouldn't since it ensures
		that shutting down WebServer shuts down any WebSockets, too."
		ws run.
	].! !

!WebSocket class methodsFor: 'example' stamp: 'ar 7/8/2010 21:50'!
examplePage
	"The example HTML page for WebServer"

	^'<html>
<p id="status">WebSocket: Not connected</p> 
<form> 
    <input type="text" id="chat" placeholder="type and press enter to chat" /> 
</form> 
<p>To test, open two windows with Web Socket support, type a message above and press return.</p> 
<ul id="log"></ul> 

<script>

var conn = {};
var log = document.getElementById("log");
var chat = document.getElementById("chat");
var form = chat.form;
var state = document.getElementById("status"); 
 
if (window.WebSocket === undefined) {
  state.innerHTML = "(WebSockets not supported)";
} else {
    conn = new WebSocket("ws://localhost:8080/broadcast");
    conn.onopen = function () {
      state.innerHTML = "WebSocket: Connected";
    };
 
    conn.onmessage = function (event) {
      log.innerHTML = "<li>" + event.data + "</li>" + log.innerHTML;
    };
    
    conn.onclose = function (event) {
      state.innerHTML = "WebSocket: Closed";
    };

	form.addEventListener("submit", function (event) {
		event.preventDefault();
		if (conn.readyState === 1) {
			conn.send(chat.value);      
			chat.value = "";
		}
	}, false);
};
 
</script> 

</body>
</html>'! !

!WebSocket class methodsFor: 'instance creation' stamp: 'ar 7/8/2010 18:22'!
on: aStream
	"Create a new WebSocket instance using the given SocketStream"

	^self new on: aStream! !

!WebSocket methodsFor: 'initialize' stamp: 'ar 9/26/2011 13:06'!
close
	"Request graceful close"

	^self subclassResponsibility! !

!WebSocket methodsFor: 'running' stamp: 'ar 7/8/2010 20:00'!
fork
	"Fork the WebSocket's input process."

	process := [self run] newProcess.
	process resume.
! !

!WebSocket methodsFor: 'private' stamp: 'ar 9/26/2011 11:41'!
handle: selector arguments: argList

	^self handle: selector arguments: argList ifAbsent:[nil]! !

!WebSocket methodsFor: 'private' stamp: 'ar 9/26/2011 11:41'!
handle: selector arguments: argList ifAbsent: aBlock

	^(handlers at: selector ifAbsent:[^aBlock value])
		valueWithPossibleArgs: argList.! !

!WebSocket methodsFor: 'private' stamp: 'ar 9/26/2011 10:47'!
handleClose
	"Handle a connection close"

	^self handle: 'close' arguments: (Array with: self)
! !

!WebSocket methodsFor: 'private' stamp: 'ar 9/26/2011 10:46'!
handleError: exception
	"Handle an error"

	^self handle: 'error' arguments: (Array with: exception with: self)! !

!WebSocket methodsFor: 'private' stamp: 'ar 9/26/2011 10:45'!
handleMessage: msgData type: msgType
	"Handle an incoming message of the given type"

	self handle: 'message' arguments: (Array with: msgData with: msgType with: self)! !

!WebSocket methodsFor: 'initialize' stamp: 'ar 9/27/2011 13:42'!
initialize
	super initialize.
	handlers := Dictionary new.! !

!WebSocket methodsFor: 'initialize' stamp: 'ar 9/27/2011 13:42'!
on: aStream
	"Create a new WebSocket instance using the given SocketStream"

	stream := aStream.
	name := String streamContents:[:s| 
		stream socket remoteAddress 
			do:[:b| s print: b] 
			separatedBy:[s nextPut: $.]].
	name := name, ':', stream socket remotePort.
	! !

!WebSocket methodsFor: 'running' stamp: 'ar 9/26/2011 10:46'!
onClose: aBlock
	"Set the handler block to invoke when the socket is closed"

	handlers at: 'close' put: aBlock.! !

!WebSocket methodsFor: 'running' stamp: 'ar 9/26/2011 10:45'!
onError: aBlock
	"Set the handler block to invoke when an error occurs"

	handlers at: 'error' put: aBlock.! !

!WebSocket methodsFor: 'running' stamp: 'ar 9/26/2011 10:45'!
onMessage: aBlock
	"Set the handler block to invoke when a message is received"

	handlers at: 'message' put: aBlock.
! !

!WebSocket methodsFor: 'private' stamp: 'ar 7/8/2010 21:48'!
printOn: aStream
	"Print the receiver"

	aStream nextPutAll: self class name.
	aStream nextPutAll: '(', name, ')'.! !

!WebSocket methodsFor: 'running' stamp: 'ar 9/26/2011 10:41'!
run
	"Run the WebSocket's input process."

	^self subclassResponsibility! !

!WebSocket methodsFor: 'read/write' stamp: 'ar 9/26/2011 10:42'!
send: aString
	"Writes one frame worth of data"

	^self subclassResponsibility! !

!WebSocket methodsFor: 'accessing' stamp: 'ar 7/8/2010 21:39'!
timeout
	"The underlying stream timeout"

	^stream timeout! !

!WebSocket methodsFor: 'accessing' stamp: 'ar 7/8/2010 21:40'!
timeout: seconds
	"Sets the underlying stream timeout"

	^stream timeout: seconds! !

WebSocket subclass: #WebSocket00
	instanceVariableNames: 'frameType frameData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebSocket00 commentStamp: 'ar 7/8/2010 18:21' prior: 0!
A wrapper object for the WebSocket API.!

!WebSocket00 methodsFor: 'running' stamp: 'ar 9/26/2011 13:05'!
close
	"Request graceful close"

	stream isConnected ifTrue:[
		stream nextPut: (Character value: 255).
		stream nextPutAll: (Character value: 0).
		stream flush.
	].
! !

!WebSocket00 methodsFor: 'read/write' stamp: 'ar 7/9/2010 11:33'!
readMessage
	"Reads one frame worth of data"

	| byte length |
	byte := stream next ifNil:[
		frameType := 255.
		^nil].
	frameType := byte asInteger.
	frameType < 128 ifTrue:[
		"Frame type < 128: UTF-8 encoded text with 0xFF frame delimiter"
		frameData := (stream upTo: 255 asCharacter) utf8ToSqueak.
	] ifFalse:[
		"Frame type >= 128: Binary data with length prefix"
		length := 0.
		[byte := stream next asInteger.
		length := (length * 128) + (byte bitClear: 128).
		byte >= 128] whileTrue.
		frameData := ByteArray new: length.
		stream nextInto: frameData.
	].
! !

!WebSocket00 methodsFor: 'running' stamp: 'ar 7/8/2010 21:49'!
run
	"Run the WebSocket's input process."

	[[[stream isConnected] whileTrue:[
		self readMessage.
		"XXXX: Should this be moved into handleMessage:type: ???"
		frameType = 255 ifTrue:[stream close. ^self].
		self handleMessage: frameData type: frameType.
	]] on: Error do:[:ex| self handleError: ex]] ensure:[
		[stream socket destroy] on: Error do:[:ex|].
		self handleClose.
	].
! !

!WebSocket00 methodsFor: 'read/write' stamp: 'ar 9/26/2011 12:03'!
send: aString
	"Writes one frame worth of data"

	^self send: aString type: 0! !

!WebSocket00 methodsFor: 'read/write' stamp: 'ar 7/9/2010 11:31'!
send: data type: type
	"Writes one frame worth of data using the given frame type"

	"Frame type"
	stream nextPut: (Character value: type).
	type < 128 ifTrue:[
		"Frame type < 128: UTF-8 encoded text with 0xFF frame delimiter"
		stream nextPutAll: data squeakToUtf8.
		stream nextPutAll: (Character value: 255).
	] ifFalse:[ | prefix length |
		"Frame type >= 128: Binary data with length prefix"
		prefix := ByteArray new.
		length := data size.
		[length > 127]  whileTrue:[
			prefix := prefix copyWith: prefix \\ 128.
			length := length // 128.
		].
		prefix := prefix copyWith: length.
		stream nextPutAll: prefix reversed.
		stream nextPutAll: data.
		stream flush.
	].
	stream flush.
! !

WebSocket subclass: #WebSocket07
	instanceVariableNames: 'frameType frameData closing masking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebSocket07 commentStamp: '<historical>' prior: 0!
A wrapper object for the WebSocket API.!

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 13:06'!
close
	"Send a close control request"

	closing ifFalse:[
		closing := true.
		self send: #[] code: 8.
	].! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/26/2011 12:48'!
firstFragment: aStringOrBytes
	"Writes the first fragment of data"

	aStringOrBytes isString 
		ifTrue:[^self send: aStringOrBytes squeakToUtf8 code: 1 final: false]
		ifFalse:[^self send: aStringOrBytes code: 2 final: false].! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 13:07'!
handleClose: payload
	"Close is being sent by remote in process of shutting down connection"

	closing ifFalse:[^self close].

	"We're done. We've received the close and responded to it"
	stream close.

! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 11:37'!
handleControl: payload type: opcode
	"Handle a control opcode"

	opcode caseOf: {
		[8]	-> [self handleClose: payload].
		[9]	-> [self handlePing: payload].
		[10] -> [self handlePong: payload].
	} otherwise:[self error: 'Unknown control request: ', opcode].

! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 11:41'!
handlePing: payload

	self handle: 'ping' 
		arguments: (Array with: payload with: self)
		ifAbsent:[self pong: payload].
! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 11:40'!
handlePong: payload

	self handle: 'pong' arguments: (Array with: payload with: self).! !

!WebSocket07 methodsFor: 'initialize' stamp: 'ar 9/27/2011 13:46'!
initialize

	super initialize.
	closing := false.
	masking := true. "by default, we mask"! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/26/2011 13:07'!
lastFragment: aStringOrBytes
	"Writes the last fragment of data.
	Note: Spec says that code is ZERO for final fragment."

	aStringOrBytes isString 
		ifTrue:[^self send: aStringOrBytes squeakToUtf8 code: 0 final: true]
		ifFalse:[^self send: aStringOrBytes code: 0 final: true].! !

!WebSocket07 methodsFor: 'accessing' stamp: 'ar 9/27/2011 13:47'!
masking
	"If true, outgoing frames are masked."

	^masking! !

!WebSocket07 methodsFor: 'accessing' stamp: 'ar 9/27/2011 13:47'!
masking: aBool
	"If true, outgoing frames are masked."

	masking := aBool! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/26/2011 13:08'!
nextFragment: aStringOrBytes
	"Writes the first fragment of data
	Note: Spec says that code is ZERO for intermediate fragments."

	aStringOrBytes isString 
		ifTrue:[^self send: aStringOrBytes squeakToUtf8 code: 0 final: false]
		ifFalse:[^self send: aStringOrBytes code: 0 final: false].! !

!WebSocket07 methodsFor: 'private' stamp: 'ar 10/5/2011 19:43'!
nextNumber: n from: aStream
	"Answer the next n bytes as a positive Integer or LargePositiveInteger."
	| s |
	s := 0.
	1 to: n do: 
		[:i | s := (s bitShift: 8) bitOr: aStream next asInteger].
	^ s normalize! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 12:49'!
onPing: aBlock
	"Set the handler block to invoke when a ping is received"

	handlers at: 'ping' put: aBlock.! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 12:49'!
onPong: aBlock
	"Set the handler block to invoke when a pong is received"

	handlers at: 'pong' put: aBlock.! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 12:03'!
ping: data
	"Send a ping control request"

	self send: data code: 9.! !

!WebSocket07 methodsFor: 'control requests' stamp: 'ar 9/26/2011 12:03'!
pong: data
	"Send a pong control request"

	self send: data code: 10.! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/27/2011 13:31'!
readFrame
	"Reads one frame worth of data"

	^self readFrameFrom: stream! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 10/5/2011 19:46'!
readFrameFrom: aStream
	"Reads one frame worth of data"

	| byte length final mask opcode payload |
	byte := (aStream next ifNil:[^nil]) asInteger.

	final := byte anyMask: 128.
	opcode := byte bitAnd: 15.

	byte := (aStream next ifNil:[^nil]) asInteger.
	mask := byte anyMask: 128.
	length := byte bitAnd: 127.

	length = 126 ifTrue:[
		length := self nextNumber: 2 from: aStream.
	] ifFalse:[
		length = 127 ifTrue:[length := self nextNumber: 8 from: aStream].
	].

	mask 
		ifTrue:[mask := aStream next: 4] 
		ifFalse:[mask := nil].

	payload := ByteArray new: length.
	aStream next: length into: payload.

	"Unmask payload"
	mask ifNotNil:[self xor: payload with: mask].

	"First see if this is a control frame which can be inserted into fragmented messages."
	opcode >= 8 ifTrue:[^self handleControl: payload type: opcode].

	"Now see if this is a fragmented message"
	frameType ifNil:[
		frameType := opcode.
		frameData := Array with: payload.
	] ifNotNil:[
		frameData := frameData copyWith: payload.
	].

	final ifTrue:[
		"This was the final fragment"
		frameData size = 1 ifTrue:[
			payload := frameData first
		] ifFalse:[
			payload := frameData allButFirst 
							inject: frameData first 
							into:[:each :next| each, next].
		].
		frameType = 1 ifTrue:[payload := payload asString utf8ToSqueak].
		self handleMessage: payload type: frameType.
		frameType := frameData := nil.
	].
! !

!WebSocket07 methodsFor: 'running' stamp: 'ar 9/26/2011 12:40'!
run
	"Run the WebSocket's input process."

	[[[stream isConnected] whileTrue:[
		self readFrame.
	]] on: Error do:[:ex| self handleError: ex]] ensure:[
		[stream socket destroy] on: Error do:[:ex|].
		self handleClose.
	].
! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/26/2011 11:14'!
send: aStringOrBytes
	"Writes one frame worth of data"

	aStringOrBytes isString 
		ifTrue:[^self send: aStringOrBytes squeakToUtf8 code: 1]
		ifFalse:[^self send: aStringOrBytes code: 2].! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/26/2011 12:48'!
send: data code: opcode
	"Sends unfragmented data using the given opcode"

	^self send: data code: opcode final: true! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/27/2011 13:47'!
send: data code: opcode final: isFinal
	"Sends unfragmented data using the given opcode"

	^self send: data code: opcode final: isFinal mask: self masking! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 11/17/2011 11:19'!
send: data code: opcode final: isFinal mask: doMask
	"Sends unfragmented data using the given opcode"

	| byte1 byte2 mask xLength copy |
	byte1 := opcode. "FIN = 1, RSV1=RSV2=RSV3=0"
	isFinal ifTrue:[byte1 := byte1 bitOr: 128].
	data size > 125 ifTrue:[
		data size > 16rFFFF ifTrue:[
			byte2 := 127.
			xLength := ByteArray new: 8.
			(WriteStream on: xLength) nextNumber: 8 put: data size.
		] ifFalse:[
			byte2 := 126.
			xLength := ByteArray new: 2.
			(WriteStream on: xLength) nextNumber: 2 put: data size.
		].
	] ifFalse:[
		byte2 := data size.
		xLength := #[].
	].
	doMask ifTrue:[
		byte2 := byte2 bitOr: 128. "Mask = 1"
		mask := ByteArray new: 4.
		1 to: 4 do:[:i| mask at: i put: 256 atRandom-1].
		copy := data copy.
		self xor: copy with: mask.
	] ifFalse:[
		copy := data.
	].
	stream nextPut: byte1.
	stream nextPut: byte2.
	stream nextPutAll: xLength.
	mask ifNotNil:[stream nextPutAll: mask].
	stream nextPutAll: copy.
	stream flush.! !

!WebSocket07 methodsFor: 'read/write' stamp: 'ar 9/26/2011 13:09'!
xor: data with: mask
	"XOR all the data using the given mask bytes.

	WARNING: Does inplace reversal; do not call with literal data."

	"This would be much faster w/ BitBlt but data may not be 
	4-byte aligned and so BB will barf."
	1 to: data size do:[:i|
		data byteAt: i put: ((data byteAt: i) bitXor: (mask byteAt: i-1 \\ 4 + 1)).
	].
! !

Object subclass: #WebUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DynamicOwnership-Web'!

!WebUtils commentStamp: 'ar 2/23/2010 10:39' prior: 0!
WebUtils contains a number of utility methods used by WebClient/WebServer.!

!WebUtils class methodsFor: 'decoding' stamp: 'ar 2/21/2010 09:54'!
decodeUrlEncodedForm: aString
	"Decodes the fields embedded in the url ?var1=val1&var2=val2"

	^self decodeUrlEncodedForm: aString multipleValues: false! !

!WebUtils class methodsFor: 'decoding' stamp: 'ar 7/20/2010 20:37'!
decodeUrlEncodedForm: aString do: aBlock
	"Decodes the fields embedded in the url ?var1=val1&var2=val2.
	Evaluates aBlock with the key/value pairs defined in the fields."

	| args keyval index key value |
	args := aString readStream.
	[args atEnd] whileFalse:[
		keyval := args upTo: $&.
		(index := keyval indexOf: $=) = 0 ifTrue:[
			key := keyval.
			value := ''.
		] ifFalse:[
			key := keyval copyFrom: 1 to: index-1.
			value := keyval copyFrom: index +1 to: keyval size.
		].
		key := key unescapePercentsWithTextEncoding: nil.
		value := value unescapePercentsWithTextEncoding: nil.
		aBlock value: key value: value.
	].
! !

!WebUtils class methodsFor: 'decoding' stamp: 'ar 7/20/2010 20:37'!
decodeUrlEncodedForm: aString multipleValues: aBool
	"Decodes the fields embedded in the url ?var1=val1&var2=val2"

	| fields |
	fields := Dictionary new.
	self decodeUrlEncodedForm: aString do:[:key :value|
		aBool 
			ifTrue:[fields at: key put: (fields at: key ifAbsent:['']), value]
			ifFalse:[fields at: key put: value].
	].
	^fields! !

!WebUtils class methodsFor: 'proxy' stamp: 'ar 5/10/2010 09:30'!
defaultProxyServer
	"Answer the default proxy server to use."

	HTTPSocket httpProxyServer isEmptyOrNil ifTrue:[^''].

	"Note: This is a hack since HTTPSocket is too specific for our use here."
	HTTPSocket httpProxyPort = 80 ifTrue:[
		"Assumes that port 80 means 'use default'"
		^HTTPSocket httpProxyServer ifNil:['']
	] ifFalse:[
		^HTTPSocket httpProxyServer, ':', HTTPSocket httpProxyPort
	].! !

!WebUtils class methodsFor: 'decoding' stamp: 'ar 1/17/2011 22:16'!
encodeMultipartForm: fieldMap boundary: boundary
	"Encodes the fieldMap as multipart/form-data.

	The fieldMap may contain MIMEDocument instances to indicate the presence
	of a file to upload to the server. If the MIMEDocument is present, its
	content type and file name will be used for the upload.

	The fieldMap can be EITHER an array of associations OR a Dictionary of 
	key value pairs (the former is useful for providing multiple fields and/or 
	specifying the order of fields)."

	^String streamContents:[:stream|
		(fieldMap as: Dictionary) keysAndValuesDo:[:fieldName :fieldValue | | fieldContent |
			"Write multipart boundary and common headers"
			stream nextPutAll: '--', boundary; crlf.
			stream nextPutAll: 'Content-Disposition: form-data; name="', fieldName, '"'.
			"Figure out if this is a file upload"
			(fieldValue isKindOf: MIMEDocument) ifTrue:[
				stream nextPutAll: ' filename="', fieldValue url pathForFile, '"'; crlf.
				stream nextPutAll: 'Content-Type: ', fieldValue contentType.
				fieldContent := (fieldValue content ifNil:[
					(FileStream readOnlyFileNamed: fieldValue url pathForFile) contentsOfEntireFile.
				]) asString.
			] ifFalse: [fieldContent := fieldValue].
			stream crlf; crlf.
			stream nextPutAll: fieldContent asString.
			stream crlf.
		].
		stream nextPutAll: '--', boundary, '--', String crlf.
	].
! !

!WebUtils class methodsFor: 'decoding' stamp: 'ar 6/1/2010 20:21'!
encodeUrlEncodedForm: fieldMap
	"Encodes the fieldsMap in the form of var1=val1&var2=val2.
	The fieldMap can be EITHER an array of associations OR a Dictionary of 
	key value pairs (the former is useful for providing multiple fields and/or 
	specifying the order of fields)."

	| associations |
	associations := fieldMap isDictionary ifTrue:[fieldMap associations] ifFalse:[fieldMap].
	^String streamContents:[:s|
		associations do:[:assoc|
			s nextPutAll: assoc key encodeForHTTP.
			assoc value ifNotNil:[
				s nextPutAll: '='.
				s nextPutAll: assoc value asString encodeForHTTP
			].
		] separatedBy:[s nextPutAll:'&'].
	].! !

!WebUtils class methodsFor: 'websockets' stamp: 'ar 7/20/2010 20:38'!
extractWebSocketKey: field
	"Decodes a WebSocket key:

		Sec-WebSocket-Key1: 18x 6]8vM;54 *(5:  {   U1]8  z [  8
		Sec-WebSocket-Key2: 1_ tx7X d  <  nw  334J702) 7]o}` 0

		For each of these fields, the server has to take the digits from the
		 value to obtain a number (in this case 1868545188 and 1733470270
		respectively), then divide that number by the number of spaces
		characters in the value (in this case 12 and 10) to obtain a 32-bit
		number (155712099 and 173347027).  These two resulting numbers are
		then used in the server handshake, as described below.
	"

	| digits spaces |
	digits := spaces := 0.
	field do:[:ch|
		ch isDigit ifTrue:[digits := digits * 10 + ch digitValue].
		ch = $ ifTrue:[spaces := spaces + 1].
	].
	^digits // spaces.
! !

!WebUtils class methodsFor: 'auth' stamp: 'ar 2/10/2012 13:53'!
handleAuth: aBlock
	"Utility method to handle web authentication requests interactively.

	Use like here:
		| wc |
		wc := WebClient new.
		WebUtils handleAuth:[wc httpGet: 'http://some.auth.required'].
	"

	| user pass |
	^[aBlock value] on: WebAuthRequired do:[:ex|
		"Allow outer handlers to take over authentication"
		ex isNested ifFalse:[
			user := UIManager default request:  ex message, 
				'\Please enter your user name:' withCRs initialAnswer:''.
			user ifNotEmpty:[
				"Just a little obfuscation to avoid completely plain passwords"
				pass := (UIManager default requestPassword:
					'Please enter the password for "', user,'":') base64Encoded.
				 ex username: user password: [pass base64Decoded]]].
		ex pass].! !

!WebUtils class methodsFor: 'oauth' stamp: 'ar 8/12/2010 16:24'!
hmacSha1: message key: signKey
	"Compute the SHA1 HMAC for the given message"

	| blockSize key ipad opad |
	blockSize := 64. "SHA1 block size"
	key := signKey asByteArray.
	key size > blockSize ifTrue:[key := self sha1Hash: key].
	key size < blockSize ifTrue:[key := key, (ByteArray new: blockSize - key size)].
	ipad := ByteArray new: blockSize withAll: 16r36.
	opad := ByteArray new: blockSize withAll: 16r5c.
	^self sha1Hash: 
		(key with: opad collect:[:b1 :b2| b1 bitXor: b2]), 
		(self sha1Hash: (key with: ipad collect:[:b1 :b2| b1 bitXor: b2]), message)! !

!WebUtils class methodsFor: 'json-encode' stamp: 'ar 2/10/2012 13:39'!
jsonArray: anArray on: stream
	"Encodes an array"

	stream nextPut: $[.
	anArray 
		do:[:each| self jsonObj: each on: stream]
		separatedBy:[stream nextPutAll:', '].
	stream nextPut:$].
! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:43'!
jsonArrayFrom: stream
	"Decodes a JSON [value, *] array from the stream"

	| ch result |
	(ch := stream next) = $[ ifFalse:[^self error: 'JSON Array expected'].
	stream skipSeparators.
	stream peek = $] ifTrue:[stream next. ^#()].
	result := WriteStream on: (Array new: 10).
	["Decode the next value"
	stream skipSeparators.
	result nextPut: (self jsonDecode: stream).
	stream skipSeparators.
	(ch := stream next) = $]] whileFalse:[
		ch = $, ifFalse:[^self error: 'Comma expected'].
	].

	^result contents! !

!WebUtils class methodsFor: 'json-encode' stamp: 'ar 2/10/2012 13:39'!
jsonChar: aCharacter on: stream
	"Writes a single encoded character"

	| ascii |
	ascii := aCharacter asciiValue.

	ascii < 32 ifTrue:["Control character"
		ascii caseOf: {
			[13]	-> [^stream nextPutAll: '\r'].
			[12]	-> [^stream nextPutAll: '\f'].
			[10]	-> [^stream nextPutAll: '\n'].
			[9]		-> [^stream nextPutAll: '\t'].
			[8]		-> [^stream nextPutAll: '\b'].
		} otherwise:[
			^stream nextPutAll: '\u'; nextPutAll: 
				((ascii printStringBase: 16) padded: #left to: 4 with: $0)
		].
	].

	(ascii >= 32 and:[ascii <=127]) ifTrue:["Ascii character"
		(ascii = 34 or:[ascii = 92 or:[ascii = 47]]) ifTrue:[stream nextPut: $\].
		^stream nextPut: aCharacter
	].

	"Encode other characters (control chars, accents, umlauts, unicode)"
	stream nextPutAll:  
		'\u', (((ascii bitAnd: 16rFFFF) printStringBase: 16) padded: #left to: 4 with: $0).
! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:46'!
jsonCharFrom: stream
	"Decodes a backslash-escaped character"

	| ch |
	^(ch := stream next) caseOf: {
		[$u]		->	[Unicode value: 
						(Integer readFrom: (stream next: 4) readStream base: 16)].
		[$r] 	-> 	[Character cr].
		[$n] 	-> 	[Character lf].
		[$t] 	-> 	[Character tab].
		[$b] 	->	[Character backspace].
		[$f] 	->	[Character newPage].
	} otherwise:[ch].
! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:48'!
jsonDecode: stream
	"Decodes an arbitrary JSON encoded value from the given stream"

	stream skipSeparators.
	^stream peek caseOf: {
		[$"]		->	[self jsonStringFrom: stream].
		[$t]		->	[self jsonTrueFrom: stream].
		[$f]		->	[self jsonFalseFrom: stream].
		[$n]		->	[self jsonNullFrom: stream].
		[${]		-> 	[self jsonMapFrom: stream].
		[$[]		->	[self jsonArrayFrom: stream].
	} otherwise:[self jsonNumberFrom: stream].
! !

!WebUtils class methodsFor: 'json-encode' stamp: 'ar 2/10/2012 13:41'!
jsonEncode: anObject
	"Encode the given object as JSON"

	^String streamContents:[:s| self jsonObj: anObject on: s]! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:43'!
jsonFalseFrom: stream
	"Decodes 'false' from aStream"

	((stream next: 5) = 'false' 
		and:[stream atEnd or:[stream peek isAlphaNumeric not]]) 
			ifFalse:[^self error: 'Expected ''false'''].
	^false! !

!WebUtils class methodsFor: 'json-encode' stamp: 'ar 2/10/2012 13:40'!
jsonMap: aDictionary on: stream
	"Encodes a dictionary"

	stream nextPut: ${.
	"Sorting keys ensures deterministic order"
	aDictionary keys asArray sort do:[:key|
		self jsonString: key on: stream.
		stream nextPutAll:': '.
		self jsonObj: (aDictionary at: key) on: stream.
	] separatedBy:[stream nextPutAll: ', '].
	stream nextPut: $}.! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:45'!
jsonMapFrom: stream
	"Decodes a JSON {key:value, *} object from the stream"

	| map ch key value |
	map := Dictionary new.
	(ch := stream next) = ${ ifFalse:[^self error: 'JSON Object expected'].
	stream skipSeparators.
	stream peek = $} ifTrue:[^map].

	["Decode the next key:value pair"
	stream skipSeparators.
	key := self jsonStringFrom: stream.
	stream skipSeparators.
	stream next = $: ifFalse:[^self error: 'Key-value pair expected'].
	value := self jsonDecode: stream.
	map at: key put: value.
	stream skipSeparators.
	(ch := stream next) = $}] whileFalse:[
		ch = $, ifFalse:[^self error: 'Comma expected'].
	].

	^map! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:43'!
jsonNullFrom: stream
	"Decodes 'null' from aStream"

	((stream next: 4) = 'null'
		and:[stream atEnd or:[stream peek isAlphaNumeric not]]) 
			ifFalse:[^self error: 'Expected ''null'''].
	^nil! !

!WebUtils class methodsFor: 'json-encode' stamp: 'ar 2/10/2012 13:38'!
jsonNumber: aNumber on: stream
	"Encodes a number"

	| value |
	value := aNumber.
	value isInteger ifFalse:[value := aNumber asFloat].
	stream print: aNumber.
! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:44'!
jsonNumberFrom: stream
	"Decodes a JSON number from the stream"

	| ascii integer fraction scale sign expSign exponent value ch |
	integer := fraction := 0. sign := scale := exponent := expSign := 1.
	ascii := stream next asciiValue.
	ascii = 45 "$- asciiValue" ifTrue:[
		sign := -1.
		ascii := stream next asciiValue.
	].
	"JSON requires at least one digit"
	(ascii >= 48 and:[ascii <= 57]) ifFalse:[^self error: 'Digit expected'].

	"Read the integer part"
	integer := ascii - 48.
	[ch := stream next ifNil:[^integer * sign].
	ascii := ch asciiValue.
	ascii >= 48 and:[ascii <= 57]] whileTrue:[
		integer := (integer * 10) + (ascii - 48).
	].

	ascii = 46 "$. asciiValue" ifTrue:[
		"Read the fraction part"
		[ch := stream next ifNil:[^(integer * scale + fraction * sign) asFloat / scale].
		ascii := ch asciiValue.
		ascii >= 48 and:[ascii <= 57]] whileTrue:[
			fraction := (fraction * 10) + (ascii - 48).
			scale := scale * 10.
		].
		value := (integer * scale + fraction * sign) asFloat / scale asFloat.
	] ifFalse:[value := integer * sign].

	(ascii =  69 "$E asciiValue" or:[ascii =  101 "$e asciiValue"]) ifTrue:[
		"Read exponent"
		ascii := stream next asciiValue.
		ascii = $- ifTrue:[
			expSign := -1.
			ascii := stream next asciiValue.
		] ifFalse:[ascii = $+ ifTrue:[ascii := stream next asciiValue]].
		exponent := ascii - 48.
		[ch := stream next ifNil:[^value * (10 raisedTo: expSign * exponent)].
		ascii := ch asciiValue.
		ascii >= 48 and:[ascii <= 57]] whileTrue:[
			exponent := (exponent * 10) + (ascii - 48).			
		].
		exponent := exponent * expSign.
	].

	"Skip back before last character since number might be part of a sequence
	like 1, 2, 3, 4, etc (which would eat the trailing comma)"
	ch isAlphaNumeric ifTrue:[^self error: 'Delimiter expected'].
	stream skip: -1.

	exponent = 1 ifFalse:[
		exponent < 0 ifTrue:[value := value asFloat].
		value := value * (10 raisedTo: exponent).
	].
	^value! !

!WebUtils class methodsFor: 'json-encode' stamp: 'ar 2/10/2012 13:49'!
jsonObj: anObject on: stream
	"Encode a generic object"

	anObject isString ifTrue:[^self jsonString: anObject on: stream].
	anObject isNumber ifTrue:[^self jsonNumber: anObject on: stream].
	anObject == nil ifTrue:[^stream nextPutAll: 'null'].
	anObject == true ifTrue:[^stream nextPutAll: 'true'].
	anObject == false ifTrue:[^stream nextPutAll: 'false'].
	anObject isArray ifTrue:[^self jsonArray: anObject on: stream].
	anObject isDictionary ifTrue:[^self jsonMap: anObject on: stream].

	self error: 'Cannot encode: ', anObject! !

!WebUtils class methodsFor: 'json-encode' stamp: 'ar 2/10/2012 13:39'!
jsonString: aString on: stream
	"Encodes a string"

	stream nextPut: $".
	aString do:[:ch| self jsonChar: ch on: stream].
	stream nextPut: $".
! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:46'!
jsonStringFrom: stream
	"Decodes a JSON encoded string"

	| ch result |
	(ch := stream next) = $" 
		ifFalse:[^self error: 'String expected'].
	result := WriteStream on: (String new: 20).
	[(ch := stream next) == nil] whileFalse:[
		ch = $" ifTrue:[^result contents].
		ch = $\ ifTrue:[ch := self jsonCharFrom: stream].
		result nextPut: ch.
	].
	^self error: 'Unterminated string'! !

!WebUtils class methodsFor: 'json-decode' stamp: 'ar 2/10/2012 13:46'!
jsonTrueFrom: stream
	"Decodes 'true' from aStream"

	((stream next: 4) = 'true'
		and:[stream atEnd or:[stream peek isAlphaNumeric not]]) 
			 ifFalse:[^self error: 'Expected ''true'''].
	^true! !

!WebUtils class methodsFor: 'misc' stamp: 'ar 7/28/2010 21:32'!
logEntryFor: request response: response
	"Create a log entry in common log format from the given request / response"

	| entry logdate logsize |

	"CLF prints date as [day/month/year:hour:min:sec zone]"
	logdate := String streamContents:[:s| | date |
		date := DateAndTime fromSeconds: DateAndTime totalSeconds.
		s nextPut: $[.
			date asDate printOn: s format: #( 1 2 3 $/ 2 1 2).
		s nextPut: $:.
			date asTime print24: true on: s.
		s nextPutAll:(' ',
			(date offset hours >= 0 ifTrue:['+'] ifFalse:['-']),
			(date offset hours abs asString padded: #left to: 2 with: $0),
			(date offset minutes abs asString padded: #left to: 2 with: $0)
		).
		s nextPut: $].
	].

	"CLF prints zero length as - "
	logsize := response contentLength ifNil:[0].
	logsize = 0 ifTrue:[logsize := '-'].

	entry := String streamContents:[:s|
		s 
			nextPutAll: (request remoteHost ifNil:[
				"Substitute with the host header"
				(request headerAt: 'host') copyUpTo: $:
			]);
			nextPutAll: ' -'; 	"RFC 1413 identity of client"
			nextPutAll: ' -';	"TODO: userid of authenticated user"
			nextPutAll: ' ', logdate;
			nextPutAll: ' "', request requestLine, '"';
			nextPutAll: ' ', response code;
			nextPutAll: ' ', logsize.
	].
	^entry
! !

!WebUtils class methodsFor: 'misc' stamp: 'ar 7/28/2010 20:01'!
logRequest: request response: response on: streamOrFilename
	"Log a request in common log format on the given stream / file."

	| entry stream |

	"Create the log entry for the request/response pair"
	entry := self logEntryFor: request response: response.

	"If the argument is a string, it represents the file name to log to"
	streamOrFilename isString ifTrue:[
		stream := [FileStream oldFileNamed: streamOrFilename] 
			on: FileDoesNotExistException
			do:[FileStream newFileNamed: streamOrFilename].
		stream wantsLineEndConversion: true; setToEnd.
	] ifFalse:[stream := streamOrFilename].

	stream nextPutAll: entry; cr.

	stream == streamOrFilename 
		ifTrue:[stream flush]
		ifFalse:[stream close].
! !

!WebUtils class methodsFor: 'misc' stamp: 'ar 7/21/2010 00:09'!
mcVersion
	"Answers the Monticello version of WebServer's MC package"

	| version |
	Smalltalk at: #MCWorkingCopy ifPresent:[:mc|
		mc managersForClass: self do:[:wc|
			wc ancestors ifNotEmpty:[:ancestry| version := ancestry first name]]].
	^version ifNil:[''].! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/20/2010 12:45'!
md5Digest: aStringOrByteArray
	"This creates a little endian hex string to be used with various auth methods
	This is the same as htdigest (apache) uses for its md5 digest auth db"

	^(self md5HashStream: (ReadStream on: aStringOrByteArray asByteArray)) reversed hex! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/25/2010 23:29'!
md5HashStream: aStream
	"self md5HashStream: (ReadStream on: 'foo')"

	| start buffer bytes sz n words hash |
	hash := WordArray 
		with: 16r67452301 
		with: 16rEFCDAB89 
		with: 16r98BADCFE 
		with: 16r10325476.
	words := WordArray new: 16.
	buffer := ByteArray new: 64.
	start := aStream position.
	[aStream atEnd] whileFalse: [
		bytes := aStream nextInto: buffer.
		(bytes size < 64 or:[aStream atEnd]) ifTrue:[
			sz := bytes size.
			buffer replaceFrom: 1 to: sz with: bytes startingAt: 1.
			buffer from: sz+1 to: buffer size put: 0.
			sz < 56 ifTrue:[
				buffer at: sz + 1 put: 128. "trailing bit"
			] ifFalse:[
				"not enough room for the length, so just pad this one, then..."
				sz < 64 ifTrue:[buffer at: sz + 1 put: 128].
				1 to: 16 do:[:i| words at: i put: (buffer unsignedLongAt: i*4-3 bigEndian: false)].
				self md5Transform: words hash: hash.
				"process one additional block of padding ending with the length"
				buffer atAllPut: 0.
				sz = 64 ifTrue: [buffer at: 1 put: 128].
			].
			"Fill in the final 8 bytes with the 64-bit length in bits."
			n := (aStream position - start) * 8.
			7 to: 0 by: -1 do:[:i| buffer at: (buffer size - i) put: ((n bitShift: 7 - i * -8) bitAnd: 255)].
		].
		1 to: 16 do:[:i| words at: i put: (buffer unsignedLongAt: i*4-3 bigEndian: false)].
		self md5Transform: words hash: hash.
	].
	bytes := ByteArray new: 16.
	bytes unsignedLongAt: 1 put: (hash at: 4) bigEndian: true.
	bytes unsignedLongAt: 5 put: (hash at: 3) bigEndian: true.
	bytes unsignedLongAt: 9 put: (hash at: 2) bigEndian: true.
	bytes unsignedLongAt: 13 put: (hash at: 1) bigEndian: true.
	^bytes
! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/23/2010 09:28'!
md5Transform: in hash: hash
	"This adds the incoming words to the existing hash"

	| a b c d |
	<primitive: 'primitiveMD5Transform' module: 'CroquetPlugin'>
	a := hash at: 1.
	b := hash at: 2.
	c := hash at: 3.
	d := hash at: 4.

	a := self step1: a x: b y: c z: d data: (in at:  1) add: 16rD76AA478 shift: 7.
	d := self step1: d x: a y: b z: c data: (in at:  2) add: 16rE8C7B756 shift: 12.
	c := self step1: c x: d y: a z: b data: (in at:  3) add: 16r242070DB shift: 17.
	b := self step1: b x: c y: d z: a data: (in at:  4) add: 16rC1BDCEEE shift: 22.
	a := self step1: a x: b y: c z: d data: (in at:  5) add: 16rF57C0FAF shift:  7.
	d := self step1: d x: a y: b z: c data: (in at:  6) add: 16r4787C62A shift: 12.
	c := self step1: c x: d y: a z: b data: (in at:  7) add: 16rA8304613 shift: 17.
	b := self step1: b x: c y: d z: a data: (in at:  8) add: 16rFD469501 shift: 22.
	a := self step1: a x: b y: c z: d data: (in at:  9) add: 16r698098D8 shift:  7.
	d := self step1: d x: a y: b z: c data: (in at: 10) add: 16r8B44F7AF shift: 12.
	c := self step1: c x: d y: a z: b data: (in at: 11) add: 16rFFFF5BB1 shift: 17.
	b := self step1: b x: c y: d z: a data: (in at: 12) add: 16r895CD7BE shift: 22.
	a := self step1: a x: b y: c z: d data: (in at: 13) add: 16r6B901122 shift:  7.
	d := self step1: d x: a y: b z: c data: (in at: 14) add: 16rFD987193 shift: 12.
	c := self step1: c x: d y: a z: b data: (in at: 15) add: 16rA679438E shift: 17.
	b := self step1: b x: c y: d z: a data: (in at: 16) add: 16r49B40821 shift: 22.

	a := self step2: a x: b y: c z: d data: (in at:  2) add: 16rF61E2562 shift:  5.
	d := self step2: d x: a y: b z: c data: (in at:  7) add: 16rC040B340 shift:  9.
	c := self step2: c x: d y: a z: b data: (in at: 12) add: 16r265E5A51 shift: 14.
	b := self step2: b x: c y: d z: a data: (in at:  1) add: 16rE9B6C7AA shift: 20.
	a := self step2: a x: b y: c z: d data: (in at:  6) add: 16rD62F105D shift:  5.
	d := self step2: d x: a y: b z: c data: (in at: 11) add: 16r02441453 shift:  9.
	c := self step2: c x: d y: a z: b data: (in at: 16) add: 16rD8A1E681 shift: 14.
	b := self step2: b x: c y: d z: a data: (in at:  5) add: 16rE7D3FBC8 shift: 20.
	a := self step2: a x: b y: c z: d data: (in at: 10) add: 16r21E1CDE6 shift:  5.
	d := self step2: d x: a y: b z: c data: (in at: 15) add: 16rC33707D6 shift:  9.
	c := self step2: c x: d y: a z: b data: (in at:  4) add: 16rF4D50D87 shift: 14.
	b := self step2: b x: c y: d z: a data: (in at:  9) add: 16r455A14ED shift: 20.
	a := self step2: a x: b y: c z: d data: (in at: 14) add: 16rA9E3E905 shift:  5.
	d := self step2: d x: a y: b z: c data: (in at:  3) add: 16rFCEFA3F8 shift:  9.
	c := self step2: c x: d y: a z: b data: (in at:  8) add: 16r676F02D9 shift: 14.
	b := self step2: b x: c y: d z: a data: (in at: 13) add: 16r8D2A4C8A shift: 20.

	a := self step3: a x: b y: c z: d data: (in at:  6) add: 16rFFFA3942 shift:  4.
	d := self step3: d x: a y: b z: c data: (in at:  9) add: 16r8771F681 shift: 11.
	c := self step3: c x: d y: a z: b data: (in at: 12) add: 16r6D9D6122 shift: 16.
	b := self step3: b x: c y: d z: a data: (in at: 15) add: 16rFDE5380C shift: 23.
	a := self step3: a x: b y: c z: d data: (in at:  2) add: 16rA4BEEA44 shift:  4.
	d := self step3: d x: a y: b z: c data: (in at:  5) add: 16r4BDECFA9 shift: 11.
	c := self step3: c x: d y: a z: b data: (in at:  8) add: 16rF6BB4B60 shift: 16.
	b := self step3: b x: c y: d z: a data: (in at: 11) add: 16rBEBFBC70 shift: 23.
	a := self step3: a x: b y: c z: d data: (in at: 14) add: 16r289B7EC6 shift:  4.
	d := self step3: d x: a y: b z: c data: (in at:  1) add: 16rEAA127FA shift: 11.
	c := self step3: c x: d y: a z: b data: (in at:  4) add: 16rD4EF3085 shift: 16.
	b := self step3: b x: c y: d z: a data: (in at:  7) add: 16r04881D05 shift: 23.
	a := self step3: a x: b y: c z: d data: (in at: 10) add: 16rD9D4D039 shift:  4.
	d := self step3: d x: a y: b z: c data: (in at: 13) add: 16rE6DB99E5 shift: 11.
	c := self step3: c x: d y: a z: b data: (in at: 16) add: 16r1FA27CF8 shift: 16.
	b := self step3: b x: c y: d z: a data: (in at:  3) add: 16rC4AC5665 shift: 23.

	a := self step4: a x: b y: c z: d data: (in at:  1) add: 16rF4292244 shift:  6.
	d := self step4: d x: a y: b z: c data: (in at:  8) add: 16r432AFF97 shift: 10.
	c := self step4: c x: d y: a z: b data: (in at: 15) add: 16rAB9423A7 shift: 15.
	b := self step4: b x: c y: d z: a data: (in at:  6) add: 16rFC93A039 shift: 21.
	a := self step4: a x: b y: c z: d data: (in at: 13) add: 16r655B59C3 shift:  6.
	d := self step4: d x: a y: b z: c data: (in at:  4) add: 16r8F0CCC92 shift: 10.
	c := self step4: c x: d y: a z: b data: (in at: 11) add: 16rFFEFF47D shift: 15.
	b := self step4: b x: c y: d z: a data: (in at:  2) add: 16r85845DD1 shift: 21.
	a := self step4: a x: b y: c z: d data: (in at:  9) add: 16r6FA87E4F shift:  6.
	d := self step4: d x: a y: b z: c data: (in at: 16) add: 16rFE2CE6E0 shift: 10.
	c := self step4: c x: d y: a z: b data: (in at:  7) add: 16rA3014314 shift: 15.
	b := self step4: b x: c y: d z: a data: (in at: 14) add: 16r4E0811A1 shift: 21.
	a := self step4: a x: b y: c z: d data: (in at:  5) add: 16rF7537E82 shift:  6.
	d := self step4: d x: a y: b z: c data: (in at: 12) add: 16rBD3AF235 shift: 10.
	c := self step4: c x: d y: a z: b data: (in at:  3) add: 16r2AD7D2BB shift: 15.
	b := self step4: b x: c y: d z: a data: (in at: 10) add: 16rEB86D391 shift: 21.

	a := (a + (hash at: 1)) bitAnd: 16rFFFFFFFF. hash at: 1 put: a.
	b := (b + (hash at: 2)) bitAnd: 16rFFFFFFFF. hash at: 2 put: b.
	c := (c + (hash at: 3)) bitAnd: 16rFFFFFFFF. hash at: 3 put: c.
	d := (d + (hash at: 4)) bitAnd: 16rFFFFFFFF. hash at: 4 put: d.

	^hash! !

!WebUtils class methodsFor: 'decoding' stamp: 'ar 7/20/2010 20:06'!
multipartBoundary
	"Answer a string to be used as multpart boundary in posts"

	^'----squeak-', Date today,'-', Time millisecondClockValue, '-webclient-----'.! !

!WebUtils class methodsFor: 'oauth' stamp: 'ar 8/24/2010 10:04'!
oAuthSign: webRequest url: requestUrl extra: postFields using: params
	"Sign the given webRequest using the set of oauth parameters provided"

	| epoch timestamp nonce normalized baseString query signature key header extraKeys baseUrl |

	"Allow providing an oauth_timestamp; HOWEVER this is only useful for
	tests etc. For actual API calls the timestamp *must* match real-time closely
	or else the request will be rejected".

	timestamp := params at: 'oauth_timestamp' ifAbsent:[
		"Timestamp is relative to Jan. 1st 1970 GMT"
		epoch := DateAndTime year: 1970 day: 1 hour: 0 minute: 0 second: 0 
			offset: (Duration seconds: 0).
		(DateAndTime now asUTC - epoch) asSeconds.
	].

	"Same for nonces (although nonces can be reused)"
	nonce := params at: 'oauth_nonce' ifAbsent:[UUID new hex].

	"Assemble the required parameters. Start with the (POST) body fields."
	normalized := (postFields as: Dictionary) associations asOrderedCollection.

	"If present, extract any (GET) fields from the URL"
	(requestUrl copyAfter: $?) ifNotEmpty:[:fields|
		self decodeUrlEncodedForm: fields do:[:fkey :fval| normalized add: fkey -> fval]].

	"Keep the extra argument keys so we can exclude them below"
	extraKeys := normalized collect:[:assoc| assoc key] as: Set.
	normalized add:('oauth_nonce' -> nonce).
	normalized add: ('oauth_timestamp' -> timestamp asString).
	
	normalized add: (params associationAt: 'oauth_consumer_key').
	normalized add: (params associationAt: 'oauth_signature_method').
	normalized add: (params associationAt: 'oauth_version').

	(params includesKey: 'oauth_callback') ifTrue:[
		normalized add: (params associationAt: 'oauth_callback').
	].
	(params includesKey: 'oauth_token') ifTrue:[
		normalized add: (params associationAt: 'oauth_token').
	].
	(params includesKey: 'oauth_verifier') ifTrue:[
		normalized add: (params associationAt: 'oauth_verifier').
	].

	normalized := normalized sort:[:a1 :a2| 
		a1 key = a2 key 
			ifTrue:[a1 value <= a2 value]
			ifFalse:[a1 key <= a2 key]].

	query := String streamContents:[:s|
		normalized do:[:assoc|
			s nextPutAll: assoc key.
			s nextPutAll: '='.
			s nextPutAll: assoc value encodeForHTTP.
		] separatedBy:[s nextPutAll: '&'].
	].

	baseUrl := (requestUrl copyUpTo: $?) copyUpTo: $#.
	baseString := webRequest method, 
		'&', baseUrl encodeForHTTP, 
		'&',  query encodeForHTTP.

	key := (params at: 'oauth_consumer_secret'), 
			'&', (params at: 'oauth_token_secret' ifAbsent:['']).
	(params at: 'oauth_signature_method') caseOf: {
		['HMAC-SHA1'] -> [
			signature := (WebUtils hmacSha1: baseString key: key) base64Encoded
		].
	} otherwise:[self error: 'Unsupported signature method'].

	header := String streamContents:[:s|
		s nextPutAll: 'OAuth '.
		"Even though we need to include the extra args in the computation,
		they do NOT go into the OAuth header field."
		normalized do:[:assoc|
			(extraKeys includes: assoc key) 
				ifFalse:[ s nextPutAll: assoc key, '="', assoc value encodeForHTTP, '",']].
		s nextPutAll: 'oauth_signature="', signature encodeForHTTP, '"'.
	].

	webRequest headerAt: 'Authorization' put: header.! !

!WebUtils class methodsFor: 'oauth' stamp: 'ar 8/23/2010 21:55'!
oAuthSign: webRequest url: requestUrl using: params
	"Sign the given webRequest using the set of oauth parameters provided"

	^self oAuthSign: webRequest url: requestUrl extra: #() using: params! !

!WebUtils class methodsFor: 'auth utils' stamp: 'ar 2/23/2010 11:57'!
parseAuthParams: authHeader
	"Parse the auth header to find authentication parameters"

	| authParams stream key value|
	authParams := Dictionary new.
	stream := ReadStream on: authHeader.
	authParams at: 'method' put: (stream upTo: Character space) asLowercase.
	[stream skipSeparators.
	stream atEnd] whileFalse:[
		key := stream upTo: $=.
		stream skipSeparators.
		stream peek = $" 
			ifTrue:[value := stream next; upTo: $". stream upTo: $,]
			ifFalse:[value := stream upToAnyOf: ' ,' asCharacterSet].
		authParams at: key asLowercase put: value.
	].
	^authParams! !

!WebUtils class methodsFor: 'misc' stamp: 'ar 11/17/2011 10:16'!
platformName
	"Return the name of the platform we're running on."

	^Smalltalk getSystemAttribute: 1001! !

!WebUtils class methodsFor: 'proxy' stamp: 'ar 2/22/2010 06:36'!
proxyExceptionsDo: aBlock
	"Evaluate aBlock with all registered proxy exceptions. 
	Uses the information from HTTPSocket."

	HTTPSocket httpProxyExceptions do: aBlock.! !

!WebUtils class methodsFor: 'proxy' stamp: 'ar 2/23/2010 06:20'!
proxyServerFor: serverName
	"Answer the proxy server to use for the given server:port
	Returns the proxy server:port to use or nil if no proxy is required."

	| domain |
	domain := serverName copyUpTo: $:.
	self proxyExceptionsDo:[:pattern| (pattern match: domain) ifTrue:[^nil]].
	^self defaultProxyServer ifEmpty:[nil]! !

!WebUtils class methodsFor: 'quoting' stamp: 'ar 3/31/2010 08:43'!
quote: aString
	"Quote the given string, escaping as necessary any embedded quotes"

	^'"', (aString copyReplaceAll: '"' with: '\"'), '"'
! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/23/2010 09:28'!
rotate: value by: amount
	"Rotate value left by amount"

	| lowMask highMask |
	lowMask := (1 bitShift: 32-amount) - 1.
	highMask := 16rFFFFFFFF - lowMask.
	^((value bitAnd: lowMask) bitShift: amount) + 
		((value bitAnd: highMask) bitShift: amount-32)! !

!WebUtils class methodsFor: 'oauth' stamp: 'ar 8/12/2010 16:31'!
sha1Hash: message
	"Compute the SHA1 hash for the given message. Slightly different from 
	SecureHashAlgorithm to produce fixed-length byte arrays."

	| sha hash |
	sha := SecureHashAlgorithm new hashMessage: message.
	hash := ByteArray new: 20.
	1 to: 20 do:[:i| hash at: i put: (sha digitAt: 21-i)].
	^hash
! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/23/2010 09:28'!
step1: w x: x y: y z: z data: data add: add shift: s
	"Step 1 in MD5 transformation"

	| f result |
	f := z bitXor: (x bitAnd: (y bitXor: z)).
	result := w + f + data + add.
	result := self rotate: result by: s.
	^result + x bitAnd: 16rFFFFFFFF! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/23/2010 09:28'!
step2: w x: x y: y z: z data: data add: add shift: s
	"Step 2 in MD5 transformation"

	| f result |
	f := y bitXor: (z bitAnd: (x bitXor: y)).
	result := w + f + data + add.
	result := self rotate: result by: s.
	^result + x bitAnd: 16rFFFFFFFF! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/23/2010 09:28'!
step3: w x: x y: y z: z data: data add: add shift: s
	"Step 3 in MD5 transformation"

	| f result |
	f := (x bitXor: y) bitXor: z.
	result := w + f + data + add.
	result := self rotate: result by: s.
	^result + x bitAnd: 16rFFFFFFFF! !

!WebUtils class methodsFor: 'md5' stamp: 'ar 2/23/2010 09:28'!
step4: w x: x y: y z: z data: data add: add shift: s
	"Step 4 in MD5 transformation"

	| f result |
	f := y bitXor: (x bitOr: (z  bitXor: 16rFFFFFFFF)).
	result := w + f + data + add.
	result := self rotate: result by: s.
	^result + x bitAnd: 16rFFFFFFFF! !

!WebUtils class methodsFor: 'quoting' stamp: 'ar 3/31/2010 08:45'!
unquote: aString
	"Unquote the given string, unescaping as necessary any embedded quotes"

	(aString beginsWith: '"') ifFalse:[^aString].
	(aString endsWith: '"') ifFalse:[^aString].
	^(aString copyReplaceAll: '\"' with: '"') allButFirst allButLast! !

!WebUtils class methodsFor: 'misc' stamp: 'ar 9/4/2010 11:33'!
urlEncode: urlString
	"For backwards compatibility only. Use 'urlString urlEncoded' if you can."

	^urlString asUrl asString! !

!WebUtils class methodsFor: 'misc' stamp: 'ar 11/17/2011 10:06'!
vmVersion	
	"Return a string identifying the interpreter version"

	^Smalltalk getSystemAttribute: 1004! !

!WebUtils class methodsFor: 'websockets' stamp: 'ar 7/8/2010 18:59'!
webSocketHandshake: key1 with: key2 with: data
	"Do the actual WebSocket handshake computation"

	| bytes |
	bytes := ByteArray new: 16.
	bytes longAt: 1 put: key1 bigEndian: true.
	bytes longAt: 5 put: key2 bigEndian: true.
	bytes replaceFrom: 9 to: 16 with: data.
	^(self md5HashStream: bytes readStream) reversed! !

!WebUtils class methodsFor: 'websockets' stamp: 'ar 9/26/2011 10:30'!
webSocketHash07: key
	"Do the actual WebSocket hash computation"

	| uid |
	uid := '258EAFA5-E914-47DA-95CA-C5AB0DC85B11'.
	^(ByteArray newFrom: (SecureHashAlgorithm new hashMessage: key, uid)) reversed base64Encoded! !

Object subclass: #WorldOwner
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'DynamicOwnership-ThirdModel'!

!WorldOwner class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/16/2012 11:02'!
getInstance
	"returns the Instance, if it doesn't exist yet create it"
	^Instance ifNil: [Instance := self basicNew ].! !

!WorldOwner class methodsFor: 'as yet unclassified' stamp: 'pmaer 4/16/2012 11:03'!
new
	"WorldOwner is a singleton, use getInstance instead"
	^self shouldNotImplement.! !

!WorldOwner methodsFor: 'as yet unclassified' stamp: 'ewe 5/2/2012 16:51'!
acceptOwnee: candidateOwnee
	^true.! !
WebMessage initialize!
WebClient initialize!
DOCollection initialize!
